DefInt A-Z
Option Explicit
Option Compare Text

Const R3 = 360     '720 * 360 / 720

Const x1 = (803 - 500) / 2
Const y1 = (596 - 350) / 2
Const x2 = x1 - 76.2         'Frame 3in
Const y2 = y1 - 76.2

Sub kestrel_drawing (redrawpic)
Dim i


Dim lppoints()  As pointapi_Single

ReDim lppoints(3)

Dim X As Single
Dim y As Single
Dim z As Single

Dim changed

Dim RobotCntrl As robotCNTRLtype

Dim RobNo As Integer
RobNo = EditFrmDat(GraphicsDevno).Frmno


READDATA GraphicsDevno, RobotCntrl
For i = 0 To 5
    RobotFrmDat(RobNo).F(i) = RobotCntrl.Feedback(i)
    If RobotFrmDat(RobNo).lastgfb(i) <> RobotFrmDat(RobNo).F(i) Then
        RobotFrmDat(RobNo).lastgfb(i) = RobotFrmDat(RobNo).F(i)
        changed = True
    End If
Next
If redrawpic Then changed = True

If changed = True Then
    X = RobotFrmDat(RobNo).F(0) / RobotFrmDat(RobNo).mult(0)
    y = RobotFrmDat(RobNo).F(1) / RobotFrmDat(RobNo).mult(1)
    z = RobotFrmDat(RobNo).F(2) / RobotFrmDat(RobNo).mult(2)
    
    cleardrawing (0)                                            'Clear port, draw axes elevation
    
    'drawing(0).Picture1.Line (-x1 + 45, 540)-Step(803 - 90, -76.2), colour, B   'Frame top
    
    
    lppoints(0).X = -x1 + 45: lppoints(0).y = 540
    lppoints(1).X = -x1 + 45 + 803 - 90: lppoints(1).y = 540 - 76.2
    drawrectangle 0, 0, lppoints()                'drawing 0, axis 0  Column

    
    'drawing(0).Picture1.Line (-x1, 0)-Step(45, 540), colour, B            'Leg
    
    lppoints(0).X = -x1: lppoints(0).y = 0
    lppoints(1).X = 45 - x1: lppoints(1).y = 540
    drawrectangle 0, 0, lppoints()


    'drawing(0).Picture1.Line (803 - x1, 0)-Step(-45, 540), colour, B      'Leg
    
    lppoints(0).X = 803 - x1: lppoints(0).y = 0
    lppoints(1).X = 803 - x1 - 45: lppoints(1).y = 540
    drawrectangle 0, 0, lppoints()
    
    
    'drawing(0).Picture1.Line (X - 120, 540)-Step(200, 68), colour, B

    lppoints(0).X = X - 120: lppoints(0).y = 540                'Y Slide
    lppoints(1).X = X - 120 + 200: lppoints(1).y = 540 + 68
    drawrectangle 0, 1, lppoints()
    

    'drawing(0).Picture1.Line (X - 8, z + 90)-(X + 8, 463.8), colour, B   'Z stick

    lppoints(0).X = X - 8: lppoints(0).y = z + 90                   'Z stick
    lppoints(1).X = X + 8: lppoints(1).y = 463.8
    drawrectangle 0, 2, lppoints()

    'drawing(0).Picture1.Line (X - 19, z + 35)-Step(38, 55), colour, B     'Gripper body

    lppoints(0).X = X - 19: lppoints(0).y = z + 35                   'Gripper body
    lppoints(1).X = X + 19: lppoints(1).y = z + 35 + 55
    drawrectangle 0, 3, lppoints()

    'If RobotFrmDat(RobNo).F(4) = 0 Then
    '    drawing(0).Picture1.Line (X - 10, Z + 35)-Step(-10, -35), colour    'Gripper fingers
    '    drawing(0).Picture1.Line (X + 10, Z + 35)-Step(10, -35), colour
    'Else
    '    drawing(0).Picture1.Line (X - 10, Z + 35)-Step(0, -35), colour
    '    drawing(0).Picture1.Line (X + 10, Z + 35)-Step(0, -35), colour
    'End If
    
    If RobotFrmDat(RobNo).F(4) = 1 Then
        lppoints(0).X = X - 10: lppoints(0).y = z + 35
        lppoints(1).X = X - 16: lppoints(1).y = z + 35
        lppoints(2).X = X - 16: lppoints(2).y = z
        lppoints(3).X = X - 10: lppoints(3).y = z
        drawpolygon 0, 3, lppoints()
        
        lppoints(0).X = X + 10: lppoints(0).y = z + 35
        lppoints(1).X = X + 16: lppoints(1).y = z + 35
        lppoints(2).X = X + 16: lppoints(2).y = z
        lppoints(3).X = X + 10: lppoints(3).y = z
        drawpolygon 0, 3, lppoints()
    Else
        lppoints(0).X = X - 10: lppoints(0).y = z + 35
        lppoints(1).X = X - 16: lppoints(1).y = z + 35
        lppoints(2).X = X - 26: lppoints(2).y = z
        lppoints(3).X = X - 20: lppoints(3).y = z
        drawpolygon 0, 3, lppoints()
        
        lppoints(0).X = X + 10: lppoints(0).y = z + 35
        lppoints(1).X = X + 16: lppoints(1).y = z + 35
        lppoints(2).X = X + 26: lppoints(2).y = z
        lppoints(3).X = X + 20: lppoints(3).y = z
        drawpolygon 0, 3, lppoints()
    End If


    
    displaydrawing 0
    
    
    cleardrawing (1)                                            'Clear port, draw axes plan
    
    'drawing(1).Picture1.Line (-x1, -y1)-Step(803, 596), , B         'External frame

    lppoints(0).X = -x1: lppoints(0).y = -y1
    lppoints(1).X = 803 - x1: lppoints(1).y = 596 - y1
    drawrectangle 1, 0, lppoints()
    
    'drawing(1).Picture1.Line (-x2, -y2)-Step(650.6, 443.6), , B

    lppoints(0).X = -x2: lppoints(0).y = -y2                           'Internal frame
    lppoints(1).X = 650.6 - x2: lppoints(1).y = 443.6 - y2
    drawrectangle 1, 8, lppoints()

    'drawing(1).Picture1.Line (X - 120, -y1)-Step(200, 596), , B
    lppoints(0).X = X - 120: lppoints(0).y = -y1                        'Y Slide
    lppoints(1).X = X - 120 + 200: lppoints(1).y = 596 - y1
    drawrectangle 1, 1, lppoints()

    lppoints(0).X = X - 32: lppoints(0).y = -y2                         'Y Internal
    lppoints(1).X = X + 32: lppoints(1).y = 443.6 - y2
    drawrectangle 1, 8, lppoints()








    'drawing(1).Picture1.Line (X - 57, Y - 34)-Step(114, 68), , B
    lppoints(0).X = X - 57: lppoints(0).y = y - 34                      ' Z box
    lppoints(1).X = X - 57 + 114: lppoints(1).y = y - 34 + 68
    drawrectangle 1, 2, lppoints()
    
    lppoints(0).X = X - 20: lppoints(0).y = y - 20                      '
    lppoints(1).X = X + 20: lppoints(1).y = y + 20
    drawcircle 1, 3, lppoints()
    
    displaydrawing 1

End If


End Sub

Sub Kestrel_Xyz (RobNo As Integer, redrawpic As Integer)

Dim LastPosition As xyz
Dim RobotCntrl  As robotCNTRLtype


READDATA RobotFrmDat(RobNo).DevNo, RobotCntrl
If Not redrawpic Then LastPosition = Position(RobNo)

Position(RobNo).X = Format$(RobotCntrl.Feedback(0) / RobotFrmDat(RobNo).mult(0), "##0.0")
Position(RobNo).y = Format$(RobotCntrl.Feedback(1) / RobotFrmDat(RobNo).mult(1), "##0.0")
Position(RobNo).z = Format$(RobotCntrl.Feedback(2) / RobotFrmDat(RobNo).mult(2), "##0.0")
Position(RobNo).Rot = Format$(RobotCntrl.Feedback(3) / RobotFrmDat(RobNo).mult(3), "##0")

If RobotCntrl.Feedback(4) = 0 Then Position(RobNo).Grip = "Open" Else Position(RobNo).Grip = "Shut"
    
If LastPosition.X <> Position(RobNo).X Then XYZdata(RobNo).Table1.RefreshColumn = 1
If LastPosition.y <> Position(RobNo).y Then XYZdata(RobNo).Table1.RefreshColumn = 2
If LastPosition.z <> Position(RobNo).z Then XYZdata(RobNo).Table1.RefreshColumn = 3
If LastPosition.Rot <> Position(RobNo).Rot Then XYZdata(RobNo).Table1.RefreshColumn = 5
If LastPosition.Grip <> Position(RobNo).Grip Then XYZdata(RobNo).Table1.RefreshColumn = 6


End Sub

