Option Explicit
Option Compare Text
DefInt A-Z


Type XYZtype
X As Single
y As Single
z As Single
E As Single
R As Single
G As Integer
End Type


Const r0 = 437.1    'bits per rev
Const r1 = 512      '510
Const r2 = 400      '510

Const R5 = 9           '5


Const r6 = (360 / 140) * (185 - 70)                          ' 655.7
Const R7 = 360 / 320 * 255

'Const F0 = 128      'centres
'Const F1 = 32.5 - 5 '    '37.5         '32.5
'Const F2 = 127.5



Const F6 = 127.5            '70
Const F7 = 127.5



Const L1 = 305      'lengths
Const L2 = 257
Const L3 = 188
Const Vo = 373      'Floor to axis 1 centre

Const L5 = 165#
Const L6 = 163#

Const L7 = 20
Const L8R = 70
Const L8F = 30

Const L11 = 150
Const L12 = 111
Const L13 = .1
Const L14r = 55
Const L14f = 36

Const L17 = 40
Const L18 = 73 + 40
Const L19 = 24

Const L30 = 56
Const L31 = L30 + 80
Const L32 = 42
Const L33 = 24


Const L70 = 20
Const L71 = 15
Const L72 = 13



Dim A1 As Single
Dim A2 As Single
Dim A3 As Single
Dim A5 As Single
Dim A6 As Single
Dim A7 As Single
Dim A9 As Single
Dim A10 As Single
Dim A11 As Single
Dim A16 As Single

Dim L9 As Single
Dim L10 As Single
Dim L15 As Single
Dim L16 As Single
Dim L20 As Single
Dim L21 As Single

Dim L30s As Single
Dim L31s As Single
Dim L32s As Single
Dim L33S As Single


'Dim iNITIALISED As Integer

Private Sub InitVars (robno As Integer)

'If Not iNITIALISED Then
'    iNITIALISED = True
    A1 = Atn(L8R / L6)
    A2 = Atn(L8F / L7)
    'A3 = pi / 2 - F1 * 2 * pi / R1
    A3 = pi / 2 - Position(robno).F(1) * 2 * pi / r1

    A5 = Atn(L14r / L12)
    A6 = pi / 2
    'A7 = (F2 * pi * 2) / R2
    A7 = (Position(robno).F(2) * pi * 2) / r2
    

    A9 = Atn(L19 / L17)
    A10 = Atn(L19 / L18)
    A11 = pi / 2 - (F6 * 2 * pi) / r6

    A16 = (Position(robno).F(0) * 2 * pi) / r0 + pi / 2

    L9 = Sqr(L6 * L6 + L8R * L8R)
    L10 = Sqr(L7 * L7 + L8F * L8F)

    L15 = Sqr(L12 * L12 + L14r * L14r)
    'L16 = Sqr(L13 * L13 + L14F * L14F)
    L16 = L14f
    
    L20 = Sqr(L17 * L17 + L19 * L19)
    L21 = Sqr(L18 * L18 + L19 * L19)

    L30s = L30 * L30
    L31s = L31 * L31
    L32s = L32 * L32
    L33S = L33 * L33
'End If

End Sub

Sub Mentor_Drawing (redrawpic)
'draws feedback positions

Dim lppoints()  As pointapi_Single

ReDim lppoints(3)
Dim RobotCntrl  As robotCNTRLtype

Dim changed As Integer
Dim i As Integer


Dim a4 As Single
Dim a8 As Single
Dim a12 As Single

Dim a17 As Single

Dim a30 As Single

Dim A As Single

Dim x4, x5

Dim x6  As Single
Dim x7  As Single
Dim x8 As Single
Dim x9 As Single
Dim x10 As Single

Dim x11 As Single
Dim x12 As Single
Dim X12C As Single
Dim x13  As Single
Dim x14 As Single

Dim x15 As Single
Dim x16 As Single
Dim x17 As Single
Dim x18 As Single

Dim y4 As Single
Dim y5  As Single
Dim y6 As Single
Dim y7 As Single
Dim y8  As Single
Dim y9 As Single
Dim y10 As Single
Dim y11 As Single
Dim y12 As Single
Dim y13 As Single
Dim y14 As Single
Dim y15 As Single
Dim y16 As Single
Dim y17 As Single
Dim y18  As Single

'Dim X, y, z
Dim x25
Dim y25

Dim L50T As Single
Dim L50B, L51T, L51B, L52T, L52B, L53T, L53B, l54t, l54b, l55t, l55b, l56t, l56c, l56b, l57t, l57c, l57b, L58T, L58B, L59T, L59B, L60T, L60B, L61T, L61B

Dim A50T As Single
Dim A50B As Single
Dim A51T As Single
Dim A51B As Single
Dim A52T As Single
Dim A52B As Single
Dim A53T As Single
Dim A53B As Single
Dim A54T As Single
Dim A54B As Single
Dim a55t As Single
Dim a55b As Single
Dim a56t As Single
Dim a56c As Single
Dim a56b As Single
Dim a57t As Single
Dim a57c As Single
Dim a57b As Single

Dim a58t As Single
Dim a58b As Single
Dim a59t As Single
Dim a59b As Single
Dim a60t As Single
Dim a60b As Single
Dim a61t As Single
Dim a61b As Single

Dim B50T As Single
Dim B50B As Single
Dim B51T As Single
Dim B51B As Single
Dim B52T As Single
Dim B52B As Single
Dim B53T As Single
Dim B53B As Single
Dim B54t As Single
Dim B54b As Single
Dim B55t As Single
Dim B55b As Single
Dim B56t As Single
Dim B56c As Single
Dim B56b As Single
Dim B57t As Single
Dim B57c As Single
Dim B57b As Single

Dim b58t As Single
Dim b58b As Single
Dim b59t As Single
Dim b59b As Single
Dim b60t As Single
Dim b60b As Single
Dim b61t As Single
Dim b61b As Single

Dim x50t As Single
Dim x51t As Single
Dim x52t As Single
Dim x53t As Single
Dim x50b, x51b, x52b, x53b

Dim x54t, x54b
Dim x55t, x55b
Dim x56t, x56b, x56c
Dim x57t, x57b, x57c

Dim x58t, x58b
Dim x59t, x59b
Dim x60t, x60b
Dim x61t, x61b

Dim y50t, y51t, y52t, y53t
Dim y50b, y51b, y52b, y53b

Dim y54t, y54b
Dim y55t, y55b
Dim y56t, y56b, y56c
Dim y57t, y57b, y57c
Dim y58t, y58b
Dim y59t, y59b
Dim y60t, y60b
Dim y61t, y61b

'C(0) = 127.5
'C(1) = 160
'C(2) = 127.5
'C(6) = 127.5
Dim robno As Integer
robno = EditFrmDat(GraphicsDevNo).Frmno
InitVars robno


If redrawpic Then changed = True

READDATA GraphicsDevNo, RobotCntrl
For i = 0 To 7
    RobotFrmDat(robno).F(i) = RobotCntrl.Feedback(i)
    If RobotFrmDat(robno).lastgfb(i) <> RobotFrmDat(robno).F(i) Then
	RobotFrmDat(robno).lastgfb(i) = RobotFrmDat(robno).F(i)
	changed = True
    End If
Next



If changed = True Then

    'Dim t As Long
    'Dim tcnt As Integer
    't = Timer
    'For tcnt = 0 To 99

    a4 = A3 + (RobotFrmDat(robno).F(1) * 2 * pi) / r1
    a8 = (RobotFrmDat(robno).F(2) * 2 * pi) / r2 - A7
    a12 = A11 + (RobotFrmDat(robno).F(6) * 2 * pi) / r6
    a17 = A16 - (RobotFrmDat(robno).F(0) * 2 * pi) / r0
    
    x4 = 0: y4 = -Vo
    x5 = x4 + L5 * Sin(a4): y5 = y4 + L5 * Cos(a4)
    x6 = x4 - L9 * Sin(a4 + A1): y6 = y4 - L9 * Cos(a4 + A1)
    x7 = x5 + L10 * Sin(a4 - A2): y7 = y5 + L10 * Cos(a4 - A2)
    x8 = x5 + L10 * Sin(a4 + A2): y8 = y5 + L10 * Cos(a4 + A2)
    x9 = x4 - L9 * Sin(a4 - A1): y9 = y4 - L9 * Cos(a4 - A1)
    A = a4 + a8
    x10 = x5 + L11 * Sin(A): y10 = y5 + L11 * Cos(A)
    x11 = x5 - L15 * Sin(A + A5): y11 = y5 - L15 * Cos(A + A5)
    x12 = x10 + L16 * Sin(A - A6): y12 = y10 + L16 * Cos(A - A6)
    x13 = x10 + L16 * Sin(A + A6): y13 = y10 + L16 * Cos(A + A6)
    x14 = x5 - L15 * Sin(A - A5): y14 = y5 - L15 * Cos(A - A5)
    X12C = x10 + L14f + Sin(A)
    
    A = a4 + a8 - pi / 2 + a12
    x15 = x10 + L20 * Sin(A - A9): y15 = y10 + L20 * Cos(A - A9)
    x16 = x10 + L21 * Sin(A - A10): y16 = y10 + L21 * Cos(A - A10)
    x17 = x10 + L21 * Sin(A + A10): y17 = y10 + L21 * Cos(A + A10)
    x18 = x10 + L20 * Sin(A + A9): y18 = y10 + L20 * Cos(A + A9)
    
    A = a4 + a8 - pi / 2 + a12
    x25 = x10 + L18 * Sin(A): y25 = y10 + L18 * Cos(A)
    
    L50T = Sqr(L31s + x9 * x9)
    L50B = Sqr(L31s + x6 * x6)
    L51T = Sqr(L30s + x9 * x9)
    L51B = Sqr(L30s + x6 * x6)
    L52T = Sqr(L30s + x8 * x8)
    L52B = Sqr(L30s + x7 * x7)

    L53T = Sqr(L31s + x8 * x8)
    L53B = Sqr(L31s + x7 * x7)
    l54t = Sqr(L32s + x14 * x14)
    l54b = Sqr(L32s + x11 * x11)

    l55t = l54t
    l55b = l54b
    l56t = Sqr(L32s + x13 * x13)
    l56c = Sqr(L32s + X12C * X12C)
    l56b = Sqr(L32s + x12 * x12)
    l57t = l56t
    l57c = l56c
    l57b = l56b
    
    L58T = Sqr(L33S + x18 * x18)
    L58B = Sqr(L33S + x15 * x15)
    L59T = L58T
    L59B = L58B
    L60T = Sqr(L33S + CSng(x17 * x17))
    L60B = Sqr(L33S + x16 * x16)
    L61T = L60T
    L61B = L60B
    
    B50T = pi / 2 - Atn(x9 / L31)
    B50B = pi / 2 - Atn(x6 / L31)
    B51T = pi / 2 - Atn(x9 / L30)
    B51B = pi / 2 - Atn(x6 / L30)
    B52T = pi / 2 - Atn(x8 / L30)
    B52B = pi / 2 - Atn(x7 / L30)
    B53T = pi / 2 - Atn(x8 / L31)
    A53B = Atn(x7 / L31): B53B = pi / 2 - A53B
    A54T = Atn(x14 / L32): B54t = pi / 2 - A54T
    A54B = Atn(x11 / L32): B54b = pi / 2 - A54B

    a55t = Atn(-x14 / L32): B55t = 3 * pi / 2 - a55t
    a55b = Atn(-x11 / L32): B55b = 3 * pi / 2 - a55b

    a56t = Atn(-x13 / L32): B56t = 3 * pi / 2 - a56t
    a56c = Atn(-X12C / L32): B56c = 3 * pi / 2 - a56c
    a56b = Atn(-x12 / L32): B56b = 3 * pi / 2 - a56b

    a57t = Atn(x13 / L32): B57t = pi / 2 - a57t
    a57c = Atn(X12C / L32): B57c = pi / 2 - a57c
    a57b = Atn(x12 / L32): B57b = pi / 2 - a57b

    a58t = Atn(x18 / L33): b58t = pi / 2 - a58t
    a58b = Atn(x15 / L33): b58b = pi / 2 - a58b

    a59t = Atn(-x18 / L33): b59t = 3 * pi / 2 - a59t
    a59b = Atn(-x15 / L33): b59b = 3 * pi / 2 - a59b

    a60t = Atn(-x17 / L33): b60t = 3 * pi / 2 - a60t
    a60b = Atn(-x16 / L33): b60b = 3 * pi / 2 - a60b

    a61t = Atn(x17 / L33): b61t = pi / 2 - a61t
    a61b = Atn(x16 / L33): b61b = pi / 2 - a61b
    
    x50t = L50T * Cos(B50T + a17): y50t = L50T * Sin(B50T + a17)
    x50b = L50B * Cos(B50B + a17): y50b = L50B * Sin(B50B + a17)
    
    x51t = L51T * Cos(B51T + a17): y51t = L51T * Sin(B51T + a17)
    x51b = L51B * Cos(B51B + a17): y51b = L51B * Sin(B51B + a17)

    x52t = L52T * Cos(B52T + a17): y52t = L52T * Sin(B52T + a17)
    x52b = L52B * Cos(B52B + a17): y52b = L52B * Sin(B52B + a17)

    x53t = L53T * Cos(B53T + a17): y53t = L53T * Sin(B53T + a17)
    x53b = L53B * Cos(B53B + a17): y53b = L53B * Sin(B53B + a17)
	
    x54t = l54t * Cos(B54t + a17): y54t = l54t * Sin(B54t + a17)
    x54b = l54b * Cos(B54b + a17): y54b = l54b * Sin(B54b + a17)

    x55t = l55t * Cos(B55t + a17): y55t = l55t * Sin(B55t + a17)
    x55b = l55b * Cos(B55b + a17): y55b = l55b * Sin(B55b + a17)
    
    
    x56t = l56t * Cos(B56t + a17): y56t = l56t * Sin(B56t + a17)
    x56b = l56b * Cos(B56b + a17): y56b = l56b * Sin(B56b + a17)
    x56c = l56c * Cos(B56c + a17): y56c = l56c * Sin(B56c + a17)
    
    x57t = l57t * Cos(B57t + a17): y57t = l57t * Sin(B57t + a17)
    x57b = l57b * Cos(B57b + a17): y57b = l57b * Sin(B57b + a17)
    x57c = l57c * Cos(B57c + a17): y57c = l57c * Sin(B57c + a17)


    x58t = L58T * Cos(b58t + a17): y58t = L58T * Sin(b58t + a17)
    x58b = L58B * Cos(b58b + a17): y58b = L58B * Sin(b58b + a17)
    
    x59t = L59T * Cos(b59t + a17): y59t = L59T * Sin(b59t + a17)
    x59b = L59B * Cos(b59b + a17): y59b = L59B * Sin(b59b + a17)
    
    x60t = L60T * Cos(b60t + a17): y60t = L60T * Sin(b60t + a17)
    x60b = L60B * Cos(b60b + a17): y60b = L60B * Sin(b60b + a17)
    
    x61t = L61T * Cos(b61t + a17): y61t = L61T * Sin(b61t + a17)
    x61b = L61B * Cos(b61b + a17): y61b = L61B * Sin(b61b + a17)


    
    cleardrawing (0)        'Clear port, draw axes
    
    
    'AXIS 1
    lppoints(0).X = x6: lppoints(0).y = y6
    lppoints(1).X = x7: lppoints(1).y = y7
    lppoints(2).X = x8: lppoints(2).y = y8
    lppoints(3).X = x9: lppoints(3).y = y9
    drawpolygon 0, 1, lppoints()               'drawing 0, axis 1



    'AXIS 0
    drawing(0).Picture1.ForeColor = GraphicsFrmDat.axiscol(0)
    
    lppoints(0).X = x4 - 33: lppoints(0).y = y4 - 25            'Centre column
    lppoints(1).X = x4 + 33: lppoints(1).y = y4 + 185
    drawrectangle 0, 0, lppoints()                'drawing 0, axis 0
    
    lppoints(0).X = x4 - 255: lppoints(0).y = y4 + 185            'Base
    lppoints(1).X = x4 + 50: lppoints(1).y = 0
    drawrectangle 0, 0, lppoints()                'drawing 0, axis 0
    
    'AXIS 2
    lppoints(0).X = x12: lppoints(0).y = y12
    lppoints(1).X = x11: lppoints(1).y = y11
    lppoints(2).X = x14: lppoints(2).y = y14
    lppoints(3).X = x13: lppoints(3).y = y13
    drawpolygon 0, 2, lppoints()                'drawing 0, axis 2

    lppoints(0).X = x10 - L14f: lppoints(0).y = y10 - L14f
    lppoints(1).X = x10 + L14f: lppoints(1).y = y10 + L14f
    drawcircle 0, 2, lppoints()                'drawing 0, axis 2




   'GRIPPER/WRIST
    lppoints(0).X = x15: lppoints(0).y = y15
    lppoints(1).X = x16: lppoints(1).y = y16
    lppoints(2).X = x17: lppoints(2).y = y17
    lppoints(3).X = x18: lppoints(3).y = y18
    drawpolygon 0, 5, lppoints()                'drawing 0, axis 5
    
    displaydrawing 0
    
    
    cleardrawing (1)        'Clear port, draw axes
    
    'BASE
    drawing(1).Picture1.ForeColor = GraphicsFrmDat.axiscol(0)
    
    lppoints(0).X = -116: lppoints(0).y = 48
    lppoints(1).X = 116: lppoints(1).y = -257
    drawrectangle 1, 0, lppoints()                'drawing 1, axis 0
    
    
    'AXIS 1
    Select Case SMALLEST(x6, x7, x8, x9)
	Case x6, x8
	    lppoints(0).X = x50b: lppoints(0).y = y50b
	    lppoints(1).X = x51b: lppoints(1).y = y51b
	    lppoints(2).X = x52t: lppoints(2).y = y52t
	    lppoints(3).X = x53t: lppoints(3).y = y53t

	Case x9
	    lppoints(0).X = x50t: lppoints(0).y = y50t
	    lppoints(1).X = x51t: lppoints(1).y = y51t
	    If x7 > x6 Then
		lppoints(2).X = x52b: lppoints(2).y = y52b
		lppoints(3).X = x53b: lppoints(3).y = y53b
	    Else
		lppoints(2).X = x51b: lppoints(2).y = y51b
		lppoints(3).X = x50b: lppoints(3).y = y50b
	    End If
	End Select
	drawpolygon 1, 1, lppoints()                'drawing 1, axis 1
    
    
    'AXIS 2
    lppoints(0).X = x54t: lppoints(0).y = y54t
    lppoints(1).X = x55t: lppoints(1).y = y55t
    lppoints(2).X = x56t: lppoints(2).y = y56t
    lppoints(3).X = x57t: lppoints(3).y = y57t
    drawpolygon 1, 2, lppoints()                'drawing 1, axis 2
    
    lppoints(0).X = x54b: lppoints(0).y = y54b
    lppoints(1).X = x55b: lppoints(1).y = y55b
    lppoints(2).X = x56b: lppoints(2).y = y56b
    lppoints(3).X = x57b: lppoints(3).y = y57b
    drawpolygon 1, 2, lppoints()                'drawing 1, axis 2
    
    lppoints(0).X = x54b: lppoints(0).y = y54b
    lppoints(1).X = x55b: lppoints(1).y = y55b
    lppoints(2).X = x56c: lppoints(2).y = y56c
    lppoints(3).X = x57c: lppoints(3).y = y57c
    drawpolygon 1, 2, lppoints()                'drawing 1, axis 2
    
    lppoints(0).X = x54t: lppoints(0).y = y54t
    lppoints(1).X = x55t: lppoints(1).y = y55t
    lppoints(2).X = x56c: lppoints(2).y = y56c
    lppoints(3).X = x57c: lppoints(3).y = y57c
    drawpolygon 1, 2, lppoints()                'drawing 1, axis 2
    
    'WRIST/GRIPPER
    Select Case SMALLEST(x15, x16, x17, x18)
	Case x15, x17
	    lppoints(0).X = x58b: lppoints(0).y = y58b
	    lppoints(1).X = x59b: lppoints(1).y = y59b
	    lppoints(2).X = x60t: lppoints(2).y = y60t
	    lppoints(3).X = x61t: lppoints(3).y = y61t
	Case x16, x18
	    lppoints(0).X = x58t: lppoints(0).y = y58t
	    lppoints(1).X = x59t: lppoints(1).y = y59t
	    lppoints(2).X = x60b: lppoints(2).y = y60b
	    lppoints(3).X = x61b: lppoints(3).y = y61b
	Case Else
    End Select
    drawpolygon 1, 5, lppoints()                'drawing 1, axis 5
    
    'drawing(1).Picture = drawing(1).Picture1.Image
    displaydrawing 1
    
'    xyzdata(GraphicsDevno).Position(0).Caption = Format$(x25 * Cos(A17), "##0")
'    xyzdata(GraphicsDevno).Position(1).Caption = Format$(x25 * Sin(A17), "##0")
'    xyzdata(GraphicsDevno).Position(2).Caption = Format$(Abs(y25), "##0")
'    a = (A4 + A8 - pi / 2 + A12) * 180 / pi: xyzdata(GraphicsDevno).Position(3).Caption = Format$(a, "##0")
'
'    a = (RobotFrmDat(RobNo).F(7) - F7)
'    a = a * 360 / R7  ' * 2 * pi
'    xyzdata(GraphicsDevno).Position(4).Caption = Format$(a, "##0")
'
'    If RobotFrmDat(RobNo).F(5) < 30 Then
'        xyzdata(GraphicsDevno).Position(5).Caption = "Open"
'    Else
'        xyzdata(GraphicsDevno).Position(5).Caption = "Shut"
'    End If

End If


End Sub

Function Mentor_InverseK (robno As Integer, d() As Integer, XYZ As XYZtype, Soln As Integer)

Dim i As Integer

Dim Rad As Double
Dim F As Double
Dim G As Double
Dim B As Double
Dim H As Double
Dim alpha  As Double
Dim beta   As Double

Dim Phi0 As Double
Dim Phi1 As Double
Dim Phi2 As Double
Dim Phi6 As Double

Dim A As Double

A = XYZ.E * pi / 180#                   'Wrist angle



Rad = XYZ.X ^ 2 + XYZ.y ^ 2
If Rad < 0 Then Exit Function

Select Case Soln
    Case 0, 2 'R +ve
	Rad = Sqr(Rad)
    Case 1, 3 'R -ve
	Rad = -Sqr(Rad)
End Select
    
    F = Rad - L18 * Sin(A)
    G = (XYZ.z - Vo) + L18 * Cos(A)
    B = Sqr(F ^ 2 + G ^ 2)
    
    If B > L5 + L11 Then Exit Function       'B can't be more than sum of arm lengths

    H = L5 ^ 2 - (B / 2) ^ 2

Select Case Soln
Case 0, 1
    H = Sqr(Abs(H))
Case 2, 3
    H = -Sqr(Abs(H))
End Select

alpha = Atn(2 * H / B)

beta = Atn(G / F): If F < 0 Then beta = beta + pi
Select Case beta
Case Is > pi
    beta = beta - 2 * pi
Case Is < -pi
    beta = beta + 2 * pi
End Select


Phi1 = beta + alpha
d(1) = (Position(robno).F(1) + ((Phi1 * r1) / (2 * pi))) Mod r1

Phi2 = 2 * alpha
d(2) = (Position(robno).F(2) - ((Phi2 * r2) / (2 * pi))) Mod r2

Phi6 = pi / 2 + beta - alpha - A
d(6) = F6 - ((Phi6 * r6) / (2 * pi)) Mod r6



If Rad > 0 Then
    Select Case XYZ.X
	Case 0
	    Phi0 = pi / 2
	Case Is > 0
	    Phi0 = Atn(XYZ.y / XYZ.X)
	Case Else
	    Phi0 = Atn(XYZ.y / XYZ.X) + pi
    End Select
Else
    Select Case XYZ.X
	Case 0
	    Phi0 = pi / 2 + pi
	Case Is > 0
	    Phi0 = Atn(XYZ.y / XYZ.X) + pi
	Case Else
	    Phi0 = Atn(XYZ.y / XYZ.X)
    End Select
End If

d(0) = (Position(robno).F(0) + 3000 - ((Phi0 * r0) / (2 * pi))) Mod r0



d(7) = XYZ.R * R7 / 360 + F7        'Easy one first

d(4) = d(6) + 800 - d(7)
d(3) = 2 * d(6) - d(4)


For i = 0 To 4

Select Case d(i)
    Case -1
	d(i) = 0        'Allow for +/- 1 rounding errors
    Case 256
	d(i) = 255
    Case 0 To 255
    Case Else
	Exit Function
End Select

Next



Mentor_InverseK = True


End Function

Sub Mentor_XYZ (robno As Integer, redrawpic)

Dim LastPosition As XYZ
'Dim a As Single
'Dim a4 As Single
'Dim a8 As Single
'Dim a12 As Single
'Dim a17 As Single
'
'Dim x4
'Dim y4 As Single
'
'Dim x5
'Dim y5  As Single
'
'Dim x10 As Single
'Dim y10 As Single
'
'Dim x25
'Dim y25

Dim XYZ As XYZtype

Dim RobotCntrl  As robotCNTRLtype
READDATA RobotFrmDat(robno).DevNo, RobotCntrl


'InitVars RobNo
    If Not redrawpic Then LastPosition = Position(robno)

    
    Mentor_XYZsums robno, RobotCntrl.Feedback(), XYZ
    
    'InitVars Robno
    'a4 = A3 + (Feedback(1) * 2 * pi) / R1
    'a8 = (Feedback(2) * 2 * pi) / R2 - A7
    'a12 = A11 + (Feedback(6) * 2 * pi) / R6
    'a17 = A16 - (Feedback(0) * 2 * pi) / R0
    
    'x4 = 0: y4 = -L4
    'x5 = x4 + L5 * Sin(a4): y5 = y4 + L5 * Cos(a4)
    
    'a = a4 + a8
    'x10 = x5 + L11 * Sin(a): y10 = y5 + L11 * Cos(a)
    
    'a = a4 + a8 - pi / 2 + a12
    'x25 = x10 + L18 * Sin(a): y25 = y10 + L18 * Cos(a)

    
    'Position(Robno).x = Format$(x25 * Cos(a17), "##0")
    'Position(Robno).y = Format$(x25 * Sin(a17), "##0")
    'Position(Robno).z = Format$(Abs(y25), "##0")

    Position(robno).X = Format$(XYZ.X, "##0")
    Position(robno).y = Format$(XYZ.y, "##0")
    Position(robno).z = Format$(XYZ.z, "##0")

    
    'a = (a4 + a8 - pi / 2 + a12) * 180 / pi
    'Position(Robno).Ele = Format$(a, "##0")
    Position(robno).Ele = Format$(XYZ.E, "##0")
    
    'a = (Feedback(7) - F7)
    'a = a * 360 / R7  ' * 2 * pi
    'Position(Robno).Rot = Format$(a, "##0")
    Position(robno).Rot = Format$(XYZ.R, "##0")
    
    If XYZ.G < 30 Then Position(robno).Grip = "Open" Else Position(robno).Grip = "Shut"
    
    If LastPosition.X <> Position(robno).X Then XYZdata(robno).Table1.RefreshColumn = 1
    If LastPosition.y <> Position(robno).y Then XYZdata(robno).Table1.RefreshColumn = 2
    If LastPosition.z <> Position(robno).z Then XYZdata(robno).Table1.RefreshColumn = 3
    If LastPosition.Ele <> Position(robno).Ele Then XYZdata(robno).Table1.RefreshColumn = 4
    If LastPosition.Rot <> Position(robno).Rot Then XYZdata(robno).Table1.RefreshColumn = 5
    If LastPosition.Grip <> Position(robno).Grip Then XYZdata(robno).Table1.RefreshColumn = 6

End Sub

Sub Mentor_XYZsums (robno As Integer, Feedback() As Integer, XYZ As XYZtype)

Dim a4 As Single
Dim a8 As Single
Dim a12 As Single
Dim a17          As Single
Dim x4                    As Single
Dim y4                             As Single
Dim x5 As Single
Dim y5          As Single
Dim x10 As Single
Dim y10          As Single
Dim x25 As Single
Dim y25 As Single
Dim A As Single


    InitVars robno
    a4 = A3 + (Feedback(1) * 2 * pi) / r1
    a8 = (Feedback(2) * 2 * pi) / r2 - A7
    a12 = A11 + (Feedback(6) * 2 * pi) / r6
    a17 = A16 - (Feedback(0) * 2 * pi) / r0
    
    x4 = 0: y4 = -Vo
    x5 = x4 + L5 * Sin(a4): y5 = y4 + L5 * Cos(a4)
    
    A = a4 + a8
    x10 = x5 + L11 * Sin(A): y10 = y5 + L11 * Cos(A)
    
    A = a4 + a8 - pi / 2 + a12
    x25 = x10 + L18 * Sin(A): y25 = y10 + L18 * Cos(A)
    
    XYZ.X = x25 * Cos(a17)
    XYZ.y = x25 * Sin(a17)
    XYZ.z = -y25
    XYZ.E = (a4 + a8 - pi / 2 + a12) * 180 / pi
    XYZ.R = (Feedback(7) - F7) * 360 / R7
    XYZ.G = Feedback(5)

End Sub

