DefInt A-Z
Option Explicit
Option Compare Text

Function CancelChanges ()

CancelChanges = False

If Edited Then
    Select Case MsgBox("Save Changes", mb_YESNOCANCEL Or MB_ICONQUESTION, "WALLI")
    Case idyes
        If walli_level = 1 Then
            CancelChanges = Not savegrid(True)
        Else
            CancelChanges = Not saveall(True)
        End If
    
    Case idno
        Edited = False

    Case idcancel
        CancelChanges = True
    End Select

End If


End Function

Sub loadall ()


Dim FName$
Dim Path$
Dim Dummy As Integer

Dim header As String * 3
Dim I As Integer
Dim version As Integer

screen.MousePointer = 11    'busy


OutHandle = FreeFile
Open TimerForm.CMDialog1.Filename For Binary Access Read As OutHandle
    Get #OutHandle, , header            'Load type
    Get #OutHandle, , version           'Load version
    
    If (version <> fILEVERSION) And (version <> fILEVERSION1) Then
        screen.MousePointer = 0
        MsgBox "File " + TimerForm.CMDialog1.Filename + " not valid", , "Load"
        LoadDefaultRob
    Else
        walli_level = 1

        Select Case header
        Case "WAL"
            walli_level = 2
            
            
            Definitions.EditFunc.Caption = "Load"   'Sets up control arrays
            LoadGridSize Definitions
            WalliFilename = TimerForm.CMDialog1.Filename
            Walli3.Caption = "WALLI3 - (" + WalliFilename + ")"

            
            For I = 0 To UBound(Editfrmdat)
                Select Case Editfrmdat(I).DevType
                    Case 0
                    
                    Case Xboard
                        LoadGridSize Xfrm(Editfrmdat(I).Frmno)
                    Case CNCMIll, CNCLATHE
                        
                        CNCfrmNo = Editfrmdat(I).Frmno
                        
                        On Local Error GoTo Ferr0
                        If (Dir$(CNCfrmDat(CNCfrmNo).Filename) <> "") And (CNCfrmDat(CNCfrmNo).Filename <> "") Then
                             CNCfrm(CNCfrmNo).EditFunc.Caption = "DummyLoad"
                             If Editfrmdat(I).DevType = CNCLATHE Then
                                Dummy = LoadMill("NCL")
                             Else
                                Dummy = LoadMill("NCM")
                             End If
                        Else
FerrResume0:
                        
                        On Local Error GoTo Ferr1
                        Path$ = TimerForm.CMDialog1.Filename
                        While Right$(Path$, 1) <> "\" And Right$(Path$, 1) <> ":"
                            Path$ = Left$(Path$, Len(Path$) - 1)
                        Wend
                        
                        FName$ = CNCfrmDat(CNCfrmNo).Filename
                        While InStr(FName$, "\") <> 0 Or InStr(FName$, ":") <> 0
                            FName$ = Right$(FName$, Len(FName$) - 1)
                        Wend

                        
                        If (FName$ <> "") And (Dir$(Path$ & FName$) <> "") Then
                            CNCfrmDat(CNCfrmNo).Filename = Path$ & FName$
                            CNCfrm(CNCfrmNo).EditFunc.Caption = "DummyLoad"
                             If Editfrmdat(I).DevType = CNCLATHE Then
                                Dummy = LoadMill("NCL")
                             Else
                                Dummy = LoadMill("NCM")
                             End If

                        Else
FerrResume1:
                            If version = fILEVERSION Then
                                CNCfrm(CNCfrmNo).EditFunc.Caption = "LoadOld"
                            Else
                                CNCfrm(CNCfrmNo).EditFunc.Caption = "Load"
                            End If
                        End If
                        End If
                        On Local Error GoTo 0

                        LoadGridSize CNCfrm(CNCfrmNo)
                        If Editfrmdat(I).DevType = CNCLATHE Then
                            If OptMenuChecked(4) Then LoadGridSize LatheCue
                        Else
                            If OptMenuChecked(3) Then LoadGridSize MillCue
                        End If
                    
                    Case Else
                        RobotFrm(Editfrmdat(I).Frmno).EDITFUNC.Caption = "Load"
                        LoadGridSize RobotFrm(Editfrmdat(I).Frmno)
                        If OptMenuChecked(0) Then
                            LoadGridSize Drawing(0)
                            LoadGridSize Drawing(1)
                            LoadGridSize XYZData(Editfrmdat(I).Frmno)
                        End If

                End Select
            Next
    
            Get #OutHandle, , I         'Read number of forms
            ReDim Preserve Walli_ed(I)
            ReDim WalliDat(I)
            For I = 0 To UBound(WalliDat)
                Set Walli_ed(I) = New WALLI_EDfrmtype
                Get #OutHandle, , WalliDat(I)
                If WalliDat(I).used Then
                    Walli_ed(I).Caption = WalliDat(I).name

                    Walli_ed(I).EditFunc.Caption = "Load"
                    LoadGridSize Walli_ed(I)
                Else
                '
                End If
            Next
            If OptMenuChecked(1) Then LoadGridSize statusfrm
            If OptMenuChecked(2) Then LoadGridSize WalliCue




            
        Case "DEF"
            walli_level = 2
            Definitions.EditFunc.Caption = "Load"   'Sets up control arrays
            
            WalliDat(0).name = "Main"               'load in main walli edit pane
            Walli_ed(0).Caption = WalliDat(0).name

        
        Case "MEN"
            clear_all
            newdevtype = MENTOR
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "MenAddr", -1, inifile$)
            If Devaddr = -1 Then
                devselad.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "MenAddr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"

        Case "GRY"
            clear_all
            newdevtype = GRYPHON
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "GryAddr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "GryAddr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"
        
        Case "GRS"
            clear_all
            newdevtype = GRYPHONSlide
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "GryAddr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "GryAddr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"

        Case "SE1"
            clear_all
            newdevtype = SERPENT1
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Serp1Addr", -1, inifile$)
            If Devaddr = -1 Then
                'devselad.Show 1
                turbosel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "Serp1Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"


        Case "SE2"
            clear_all
            newdevtype = SERPENT2
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Serp2Addr", -1, inifile$)
            If Devaddr = -1 Then
                'devselad.Show 1
                turbosel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "Serp2Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"

        Case "SE3"
            clear_all
            newdevtype = SerpentEc1
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "SerpEC1Addr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "SerpEC1Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"
        
        Case "SE4"
            clear_all
            newdevtype = SerpentEc2
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "SerpEC2Addr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "SerpEC2Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"

        
        Case "KES"
            clear_all
            newdevtype = KESTREL
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "KesAddr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "KesAddr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"

        Case "NE1"
            clear_all
            newdevtype = NEPTUNE1
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Nep1Addr", -1, inifile$)
            If Devaddr = -1 Then
                turbosel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "Nep1Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"

        Case "NE2"
            clear_all
            newdevtype = NEPTUNE2
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Nep2Addr", -1, inifile$)
            If Devaddr = -1 Then
                turbosel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "Nep2Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            RobotFrmDat(0).Filename = TimerForm.CMDialog1.Filename
            RobotFrm(0).EDITFUNC.Caption = "Load"

        Case "NCM"
            clear_all
            newdevtype = CNCMIll
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "MillAddr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "MillAddr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            CNCfrmDat(0).Filename = TimerForm.CMDialog1.Filename
            If version = fILEVERSION Then
                CNCfrm(0).EditFunc.Caption = "LoadOld"
            Else
                CNCfrm(0).EditFunc.Caption = "Load"
            End If

        Case "NCL"
            clear_all
            newdevtype = CNCLATHE
            WritePrivateProfileString "TurboBoard", ByVal "DefaultRob", ByVal Format$(newdevtype), inifile$
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "LatheAddr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "LatheAddr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane newdevtype, 0
            CNCfrmDat(0).Filename = TimerForm.CMDialog1.Filename
            If version = fILEVERSION Then
                CNCfrm(0).EditFunc.Caption = "LoadOld"
            Else
                CNCfrm(0).EditFunc.Caption = "Load"
            End If


        Case Else
            screen.MousePointer = 0
            MsgBox "File " + TimerForm.CMDialog1.Filename + " not valid", , "Loadall"
            LoadDefaultRob

    End Select
    End If


If walli_level = 1 Then
    Unload WalliCue
    Unload MillCue
    Unload LatheCue
    Unload statusfrm
End If


screen.MousePointer = 0
Close OutHandle



Edited = False
loading = False
redraw_devicegrid


'For i = 0 To UBound(Editfrmdat)
'    Select Case Editfrmdat(i).devtype
'        Case 0, xboard, cncmill, cnclathe
'        Case Else
 '           'RobotFrm(Editfrmdat(i).Frmno).EDITFUNC.Caption = "Newdata"
'            RobotFrm(Editfrmdat(i).Frmno).Table1.Refresh
'            'DoEvents
'    End Select
'Next


'DoEvents  WAS*********************************

For I = 0 To UBound(Editfrmdat)
    Select Case Editfrmdat(I).DevType
        Case 0
        
        Case Xboard
        
        Case CNCMIll
        
        Case CNCLATHE
        
        Case Else
            RobotFrm(Editfrmdat(I).Frmno).Timer1.Enabled = True
    End Select
Next



    Exit Sub

Ferr0:
    Resume FerrResume0


Ferr1:
    Resume FerrResume1


End Sub

Sub LoadDefaultRob ()


If forms.Count > 2 Then
    Exit Sub
End If

clear_all
walli_level = ReadWalli_Level()

If walli_level = 1 Then
    Unload WalliCue
    Unload MillCue
    Unload LatheCue
    Unload statusfrm


Select Case GetPrivateProfileINT(ByVal "TurboBoard", ByVal "DefaultRob", MENTOR, inifile$)
    
    Case MENTOR
        Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "MenAddr", -1, inifile$)
        If Devaddr = -1 Then
            devselad.Show 1
            WritePrivateProfileString "TurboBoard", ByVal "MenAddr", ByVal Format$(Devaddr), inifile$
        End If
        makeeditpane MENTOR, 0
    
    Case GRYPHON
        Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "GryAddr", -1, inifile$)
        If Devaddr = -1 Then
            rj45sel.Show 1
            WritePrivateProfileString "TurboBoard", ByVal "GryAddr", ByVal Format$(Devaddr), inifile$
        End If
        makeeditpane GRYPHON, 0
    
    Case GRYPHONSlide
        Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "GryAddr", -1, inifile$)
        If Devaddr = -1 Then
            rj45sel.Show 1
            WritePrivateProfileString "TurboBoard", ByVal "GryAddr", ByVal Format$(Devaddr), inifile$
        End If
        makeeditpane GRYPHONSlide, 0
        
    Case KESTREL
        Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "KesAddr", -1, inifile$)
        If Devaddr = -1 Then
            rj45sel.Show 1
            WritePrivateProfileString "TurboBoard", ByVal "KesAddr", ByVal Format$(Devaddr), inifile$
        End If
        makeeditpane KESTREL, 0
        
    Case SERPENT1
        Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Serp1Addr", -1, inifile$)
        If Devaddr = -1 Then
            devselad.Show 1
            WritePrivateProfileString "TurboBoard", ByVal "Serp1Addr", ByVal Format$(Devaddr), inifile$
        End If
        makeeditpane SERPENT1, 0
        
        Case SERPENT2
        
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Serp2Addr", -1, inifile$)
            If Devaddr = -1 Then
                devselad.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "Serp2Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane SERPENT2, 0
        
        Case NEPTUNE1
        
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Nep1Addr", -1, inifile$)
            If Devaddr = -1 Then
                turbosel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "Nep1Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane NEPTUNE1, 0
        
        Case NEPTUNE2
        
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Nep2Addr", -1, inifile$)
            If Devaddr = -1 Then
                turbosel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "Nep1Addr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane NEPTUNE2, 0
        
        Case CNCMIll
        
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "MillAddr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "MillAddr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane CNCMIll, 0
        
        Case CNCLATHE
        
            Devaddr = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "LatheAddr", -1, inifile$)
            If Devaddr = -1 Then
                rj45sel.Show 1
                WritePrivateProfileString "TurboBoard", ByVal "LatheAddr", ByVal Format$(Devaddr), inifile$
            End If
            makeeditpane CNCLATHE, 0
        
        End Select
Else
            'walli_level = 2
            WalliDat(0).name = "Main"               'load in main walli edit pane
            Walli_ed(0).Caption = WalliDat(0).name
            redraw_devicegrid
        
End If

End Sub

Sub loadgrid ()

Dim Dummy As Integer
Dim version As Integer
Dim header As String * 3
Dim DefaultHeader As String * 3

    If TypeOf Walli3.ActiveForm Is RobotFrmType Then
        Select Case RobotFrmDat(RobotFrmNo).DevType
            Case MENTOR
                TimerForm.CMDialog1.DialogTitle = "Load Mentor File"
                TimerForm.CMDialog1.Filter = "Mentor|*.men"
                DefaultHeader = "MEN"
            Case GRYPHON
                TimerForm.CMDialog1.DialogTitle = "Load Gryphon File"
                TimerForm.CMDialog1.Filter = "Gryphon|*.gry"
                DefaultHeader = "GRY"
            
            Case GRYPHONSlide
                TimerForm.CMDialog1.DialogTitle = "Load Gryphon+ File"
                TimerForm.CMDialog1.Filter = "Gryphon+|*.grs"
                DefaultHeader = "GRS"
            
            
            Case KESTREL
                TimerForm.CMDialog1.DialogTitle = "Load Mentor File"
                TimerForm.CMDialog1.Filter = "Kestrel|*.kes"
                DefaultHeader = "KES"
            Case SERPENT1
                TimerForm.CMDialog1.DialogTitle = "Load Serpent I File"
                TimerForm.CMDialog1.Filter = "Serpent I|*.se1"
                DefaultHeader = "SE1"
            Case SerpentEc1
                TimerForm.CMDialog1.DialogTitle = "Load Serpent I EC File"
                TimerForm.CMDialog1.Filter = "Serpent I EC|*.se3"
                DefaultHeader = "SE3"

            Case SERPENT2
                TimerForm.CMDialog1.DialogTitle = "Load Serpent II File"
                TimerForm.CMDialog1.Filter = "Serpent II|*.se2"
                DefaultHeader = "SE2"
            Case SerpentEc2
                TimerForm.CMDialog1.DialogTitle = "Load Serpent II EC File"
                TimerForm.CMDialog1.Filter = "Serpent II EC|*.se4"
                DefaultHeader = "SE4"

            Case NEPTUNE1
                TimerForm.CMDialog1.DialogTitle = "Load Neptune I File"
                TimerForm.CMDialog1.Filter = "Neptune I|*.ne1"
                DefaultHeader = "NE1"
            Case NEPTUNE2
                TimerForm.CMDialog1.DialogTitle = "Load Neptune II File"
                TimerForm.CMDialog1.Filter = "Neptune II|*.ne2"
                DefaultHeader = "NE2"
        End Select
        
        TimerForm.CMDialog1.DefaultExt = DefaultHeader
        TimerForm.CMDialog1.Filename = RobotFrmDat(RobotFrmNo).Filename
        TimerForm.CMDialog1.Flags = &H400& Or &H1000& Or &H4& Or &H800&
        On Local Error GoTo Loadgrid_cancel
        TimerForm.CMDialog1.Action = 1
        On Local Error GoTo 0
        
            RobotFrmDat(RobotFrmNo).Filename = TimerForm.CMDialog1.Filename
            screen.MousePointer = 11    'busy
            OutHandle = FreeFile
            Open RobotFrmDat(RobotFrmNo).Filename For Binary Access Read As OutHandle
            Get #OutHandle, , header            'Save version
            Get #OutHandle, , version
            
            If (header = DefaultHeader) And ((version = fILEVERSION) Or (version = fILEVERSION1)) Then
                RobotFrm(RobotFrmNo).EDITFUNC.Caption = "Load"
                'DoEvents
                'RobotFrm(RobotFrmNo).EDITFUNC.Caption = "NewPos"
            Else
                MsgBox "File " + TimerForm.CMDialog1.Filename + " not valid", , "Loadgrid"
            End If
            Close OutHandle
    
    ElseIf TypeOf Walli3.ActiveForm Is MillFormType Then
        Select Case CNCfrmDat(CNCfrmNo).DevType
        Case CNCMIll
            TimerForm.CMDialog1.DialogTitle = "Load Cyber Mill File"
            DefaultHeader = "NCM"
            TimerForm.CMDialog1.Filter = "Cyber Mill|*.NCM"
        
        Case CNCLATHE
            TimerForm.CMDialog1.DialogTitle = "Load Cyber Lathe File"
            DefaultHeader = "NCL"
            TimerForm.CMDialog1.Filter = "Cyber Lathe|*.NCL"
        End Select
        
        TimerForm.CMDialog1.DefaultExt = DefaultHeader
        TimerForm.CMDialog1.Filename = CNCfrmDat(CNCfrmNo).Filename
        TimerForm.CMDialog1.Flags = &H400& Or &H1000& Or &H4& Or &H800&
        On Local Error GoTo Loadgrid_cancel
        TimerForm.CMDialog1.Action = 1
        On Local Error GoTo 0
        CNCfrmDat(CNCfrmNo).Filename = TimerForm.CMDialog1.Filename
        Dummy = LoadMill(DefaultHeader)

    ElseIf Walli3.ActiveForm Is Definitions Then
        TimerForm.CMDialog1.DialogTitle = "Load Cell Definition"
        TimerForm.CMDialog1.DefaultExt = "DEF"
        TimerForm.CMDialog1.Filter = "Cell Definition|*.DEF"
        TimerForm.CMDialog1.Filename = ""
        
        TimerForm.CMDialog1.Flags = &H400& Or &H1000& Or &H4& Or &H800&
        
        On Local Error GoTo Loadgrid_cancel
        TimerForm.CMDialog1.Action = 1
        
        On Local Error GoTo 0
        screen.MousePointer = 11    'busy
        OutHandle = FreeFile
        
        Open TimerForm.CMDialog1.Filename For Binary Access Read As OutHandle
        header = TimerForm.CMDialog1.DefaultExt
        Get #OutHandle, , header            'Save version
        Get #OutHandle, , version
        
        If (header = TimerForm.CMDialog1.DefaultExt) And ((version = fILEVERSION) Or (version = fILEVERSION1)) Then
            Definitions.EditFunc.Caption = "Load"
        Else
            MsgBox "File " + TimerForm.CMDialog1.Filename + " not valid", , "Loadgrid"
        End If
        
        Close OutHandle


    Else
        MsgBox "An error has occurred Loading your program"

    End If
    



Loadgrid_cancel:
     screen.MousePointer = 0
     Exit Sub


End Sub

Sub LoadGridSize (frm As Form)

Dim I As Integer
Dim x As Single
Dim y As Single
Dim cx As Single
Dim cy As Single

    
    Get #OutHandle, , I
    x = I * Walli3.ScaleWidth / 100
    Get #OutHandle, , I
    y = I * Walli3.ScaleHeight / 100
    Get #OutHandle, , I
    cx = I * Walli3.ScaleWidth / 100
    Get #OutHandle, , I
    cy = I * Walli3.ScaleHeight / 100
    
    If x = 0 Then
        frm.WindowState = 1      'Minimized
    Else
        frm.WindowState = 0      'Normal
    End If
    If frm.WindowState = 0 Then frm.Move x, y, cx, cy


End Sub

Function LoadMill (DefaultHeader As String)
    
Dim header As String * 3
Dim version As Integer
Dim LastOutHandle As Integer


    
    LastOutHandle = OutHandle

    screen.MousePointer = 11    'busy
    OutHandle = FreeFile
    Open CNCfrmDat(CNCfrmNo).Filename For Binary Access Read As OutHandle
    Get #OutHandle, , header            'GET version
    Get #OutHandle, , version
    If (header = DefaultHeader) And (version = fILEVERSION) Then
        CNCfrm(CNCfrmNo).EditFunc.Caption = "LoadOld"
        LoadMill = True
    ElseIf (header = DefaultHeader) And (version = fILEVERSION1) Then
        CNCfrm(CNCfrmNo).EditFunc.Caption = "Load"
        LoadMill = True
    Else
        MsgBox "File " + CNCfrmDat(CNCfrmNo).Filename + " not valid", , "Loadmill"
        LoadMill = False
    End If
    Close OutHandle
    screen.MousePointer = 0


      OutHandle = LastOutHandle
End Function

Sub openwalli (getname As Integer)

Dim DefaultHeader$

    If Not getname Then
        On Local Error GoTo Patherror
        If Dir$(WalliFilename) = "" Then getname = True
        If WalliFilename = "" Then getname = True
        On Local Error GoTo 0
    End If
    If Not CancelChanges() Then
        TimerForm.CMDialog1.Filename = WalliFilename
        If getname Then
            TimerForm.CMDialog1.DefaultExt = "WAL"
            TimerForm.CMDialog1.Flags = &H400& Or &H1000& Or &H4& Or &H800&
            If ReadWalli_Level() = 1 Then
                Select Case GetPrivateProfileINT(ByVal "TurboBoard", ByVal "DefaultRob", MENTOR, inifile$)
                    Case MENTOR
                        TimerForm.CMDialog1.DialogTitle = "Load Mentor File"
                        TimerForm.CMDialog1.Filter = "Mentor|*.men"
                    Case GRYPHON
                        TimerForm.CMDialog1.DialogTitle = "Load Gryphon File"
                        TimerForm.CMDialog1.Filter = "Gryphon|*.gry"
                    Case GRYPHONSlide
                        TimerForm.CMDialog1.DialogTitle = "Load Gryphon+ File"
                        TimerForm.CMDialog1.Filter = "Gryphon|*.grs"
                    Case KESTREL
                        TimerForm.CMDialog1.DialogTitle = "Load Mentor File"
                        TimerForm.CMDialog1.Filter = "Kestrel|*.kes"
                    Case SERPENT1
                        TimerForm.CMDialog1.DialogTitle = "Load Serpent I File"
                        TimerForm.CMDialog1.Filter = "Serpent I|*.se1"
                    Case SERPENT2
                        TimerForm.CMDialog1.DialogTitle = "Load Serpent II File"
                        TimerForm.CMDialog1.Filter = "Serpent II|*.se2"
                    Case SerpentEc1
                        TimerForm.CMDialog1.DialogTitle = "Load Serpent I EC File"
                        TimerForm.CMDialog1.Filter = "Serpent I EC|*.se3"
                    Case SerpentEc2
                        TimerForm.CMDialog1.DialogTitle = "Load Serpent II EC File"
                        TimerForm.CMDialog1.Filter = "Serpent II EC|*.se4"
                    Case NEPTUNE1
                        TimerForm.CMDialog1.DialogTitle = "Load Neptune I File"
                        TimerForm.CMDialog1.Filter = "Neptune I|*.ne1"
                    Case NEPTUNE2
                        TimerForm.CMDialog1.DialogTitle = "Load Neptune II File"
                        TimerForm.CMDialog1.Filter = "Neptune II|*.ne2"
                    Case CNCMIll
                        TimerForm.CMDialog1.DialogTitle = "Load Cyber Mill File"
                        TimerForm.CMDialog1.Filter = "Cyber Mill|*.ncm"
                    Case CNCLATHE
                        TimerForm.CMDialog1.DialogTitle = "Load Cyber Lathe File"
                        TimerForm.CMDialog1.Filter = "Cyber Lathe|*.ncl"
                End Select
            Else
                TimerForm.CMDialog1.DialogTitle = "Load Walli File"
                TimerForm.CMDialog1.Filter = "WALLI|*.wal|Mentor|*.men|Gryphon|*.gry|Kestrel|*.kes|Serpent I|*.se1|Serpent II|*.se2|Serpent I EC|*.se3|Serpent II EC|*.se4|Neptune1|*.ne1|Neptune2|*.ne2|Cyber Mill|*.NCM|Cyber Lathe|*.NCL|Cell Definition|*.Def"
                TimerForm.CMDialog1.FilterIndex = 1
            End If
            
            On Local Error GoTo openewalli_cancel
            TimerForm.CMDialog1.Action = 1
            On Local Error GoTo 0
        End If
        WalliFilename = TimerForm.CMDialog1.Filename
        Walli3.Caption = "WALLI3 - (" + WalliFilename + ")"
        Load LOADWAL
        LOADWAL.Caption = "Loading " + WalliFilename
        LOADWAL.Show 1
        Unload LOADWAL
        set_editfocus
    End If
    
    Exit Sub

openewalli_cancel:
    On Local Error GoTo 0
    
    loading = False
    LoadDefaultRob
    set_editfocus
    
    Exit Sub

Patherror:
    getname = True
    Resume Next



End Sub

Function ReadWalli_Level ()
Dim I As Integer
    
    I = GetPrivateProfileINT(ByVal "TurboBoard", ByVal "Level", 2, inifile$)
    If I < 1 Then I = 1
    If I > 2 Then I = 2
    ReadWalli_Level = I
End Function

Function saveall (getfile)

Dim header As String * 3
Dim version As Integer
Dim I As Integer
Dim j As Integer

    saveall = False
    
    
    If getfile Or WalliFilename = "" Then
        TimerForm.CMDialog1.Filename = WalliFilename
        TimerForm.CMDialog1.Flags = &H4& Or &H2& Or &H800&
        TimerForm.CMDialog1.DefaultExt = "WAL"
        TimerForm.CMDialog1.Filter = "WALLI|*.wal"
        TimerForm.CMDialog1.DialogTitle = "Save Walli Project"
        
        On Local Error GoTo Saveall_Cancel
        TimerForm.CMDialog1.Action = 2
        On Local Error GoTo 0
        WalliFilename = TimerForm.CMDialog1.Filename
        Walli3.Caption = "WALLI3 - (" + WalliFilename + ")"
    End If


If Not BusyKillAndOpen(WalliFilename) Then Exit Function

header = "WAL"
Put #OutHandle, , header            'Save version
version = fILEVERSION1
Put #OutHandle, , version

Definitions.EditFunc.Caption = "Save"   'Save Cell
SaveGridSize Definitions


'DoEvents
For I = 0 To UBound(Editfrmdat)
    Select Case Editfrmdat(I).DevType
        Case 0
        Case Xboard
            SaveGridSize Xfrm(Editfrmdat(I).Frmno)
        Case CNCMIll
            CNCfrm(Editfrmdat(I).Frmno).EditFunc.Caption = "Save"
            SaveGridSize CNCfrm(Editfrmdat(I).Frmno)
            If OptMenuChecked(3) Then SaveGridSize MillCue
        Case CNCLATHE
            CNCfrm(Editfrmdat(I).Frmno).EditFunc.Caption = "Save"
            SaveGridSize CNCfrm(Editfrmdat(I).Frmno)
            If OptMenuChecked(4) Then SaveGridSize LatheCue

        Case Else
            RobotFrm(Editfrmdat(I).Frmno).EDITFUNC.Caption = "Save"
            SaveGridSize RobotFrm(Editfrmdat(I).Frmno)
            If OptMenuChecked(0) Then
                SaveGridSize Drawing(0)
                SaveGridSize Drawing(1)
                SaveGridSize XYZData(Editfrmdat(I).Frmno)
            End If
    End Select
Next

I = UBound(WalliDat)
Put #OutHandle, , I             'Save number of forms
For I = 0 To UBound(WalliDat)
    Put #OutHandle, , WalliDat(I)        'Save name
    If WalliDat(I).used Then
        Walli_ed(I).EditFunc.Caption = "Save"
        SaveGridSize Walli_ed(I)
    End If
Next
If OptMenuChecked(1) Then SaveGridSize statusfrm
If OptMenuChecked(2) Then SaveGridSize WalliCue

Close OutHandle
Edited = False
saveall = True


Saveall_Cancel:

screen.MousePointer = 0
Exit Function




End Function

Function Savegrid (getfile As Integer)

Dim version As Integer
Dim DefaultHeader As String * 3
Dim f$

    Savegrid = False
    version = fILEVERSION1
    
    If TypeOf Walli3.ActiveForm Is RobotFrmType Then
        Select Case RobotFrmDat(RobotFrmNo).DevType
            Case MENTOR
                TimerForm.CMDialog1.Filter = "Mentor|*.men"
                TimerForm.CMDialog1.DialogTitle = "Save Mentor File"
                DefaultHeader = "MEN"
            Case GRYPHON
                TimerForm.CMDialog1.Filter = "Gryphon|*.gry"
                TimerForm.CMDialog1.DialogTitle = "Save Gryphon File"
                DefaultHeader = "GRY"
            Case GRYPHONSlide
                TimerForm.CMDialog1.Filter = "Gryphon|*.gry"
                TimerForm.CMDialog1.DialogTitle = "Save Gryphon+ File"
                DefaultHeader = "GRS"
            Case KESTREL
                TimerForm.CMDialog1.Filter = "Kestrel|*.kes"
                TimerForm.CMDialog1.DialogTitle = "Save Kestrel File"
                DefaultHeader = "KES"
            Case SERPENT1
                TimerForm.CMDialog1.Filter = "Serpent I|*.se1"
                TimerForm.CMDialog1.DialogTitle = "Save Serpent I File"
                DefaultHeader = "SE1"
            Case SERPENT2
                TimerForm.CMDialog1.Filter = "Serpent II|*.se2"
                TimerForm.CMDialog1.DialogTitle = "Save Serpent II File"
                DefaultHeader = "SE2"
            Case SerpentEc1
                TimerForm.CMDialog1.Filter = "Serpent I EC|*.se3"
                TimerForm.CMDialog1.DialogTitle = "Save Serpent I EC File"
                DefaultHeader = "SE3"
            Case SerpentEc2
                TimerForm.CMDialog1.Filter = "Serpent II EC|*.se3"
                TimerForm.CMDialog1.DialogTitle = "Save Serpent II EC File"
                DefaultHeader = "SE4"

            Case NEPTUNE1
                TimerForm.CMDialog1.Filter = "Neptune1|*.ne1"
                TimerForm.CMDialog1.DialogTitle = "Save Neptune I File"
                DefaultHeader = "NE1"
            Case NEPTUNE2
                TimerForm.CMDialog1.Filter = "Neptune2|*.ne2"
                TimerForm.CMDialog1.DialogTitle = "Save Neptune II File"
                DefaultHeader = "NE2"
        End Select
        
        If getfile Or RobotFrmDat(RobotFrmNo).Filename = "" Then
            TimerForm.CMDialog1.DefaultExt = DefaultHeader
            TimerForm.CMDialog1.Filename = RobotFrmDat(RobotFrmNo).Filename
            TimerForm.CMDialog1.Flags = &H4& Or &H2& Or &H800&
            On Local Error GoTo Savegrid_cancel
            TimerForm.CMDialog1.Action = 2
            On Local Error GoTo 0
            RobotFrmDat(RobotFrmNo).Filename = TimerForm.CMDialog1.Filename
        End If
        
        If Not BusyKillAndOpen(RobotFrmDat(RobotFrmNo).Filename) Then Exit Function
            
            Put #OutHandle, , DefaultHeader            'Save version
            Put #OutHandle, , version
            RobotFrm(RobotFrmNo).EDITFUNC.Caption = "Save"
        Close OutHandle

    
    ElseIf TypeOf Walli3.ActiveForm Is MillFormType Then
        Select Case CNCfrmDat(CNCfrmNo).DevType
            Case CNCMIll
                TimerForm.CMDialog1.Filter = "Cyber Mill|*.NCM"
                TimerForm.CMDialog1.DialogTitle = "Save Cyber Mill File"
                DefaultHeader = "NCM"
            Case CNCLATHE
                TimerForm.CMDialog1.Filter = "Cyber Lathe|*.NCL"
                TimerForm.CMDialog1.DialogTitle = "Save Cyber Lathe File"
                DefaultHeader = "NCL"
        End Select
        
        If getfile Or CNCfrmDat(CNCfrmNo).Filename = "" Then
            TimerForm.CMDialog1.DefaultExt = DefaultHeader
            TimerForm.CMDialog1.Filename = CNCfrmDat(CNCfrmNo).Filename
            TimerForm.CMDialog1.Flags = &H4& Or &H2& Or &H800&
            On Local Error GoTo Savegrid_cancel
            TimerForm.CMDialog1.Action = 2
            On Local Error GoTo 0
            CNCfrmDat(CNCfrmNo).Filename = TimerForm.CMDialog1.Filename
        End If
        
        If Not BusyKillAndOpen(CNCfrmDat(CNCfrmNo).Filename) Then Exit Function

        Put #OutHandle, , DefaultHeader            'Save version
        Put #OutHandle, , version
        CNCfrm(CNCfrmNo).EditFunc.Caption = "Save"
        Close OutHandle
    
    ElseIf Walli3.ActiveForm Is Definitions Then
        TimerForm.CMDialog1.DialogTitle = "Save Cell Definition"
        DefaultHeader = "DEF"
        TimerForm.CMDialog1.Filter = "Cell Definition|*.DEF"
        
        TimerForm.CMDialog1.Filename = ""
        TimerForm.CMDialog1.Flags = &H4& Or &H2& Or &H800&
        
        TimerForm.CMDialog1.DefaultExt = DefaultHeader
        On Local Error GoTo Savegrid_cancel
        TimerForm.CMDialog1.Action = 2
        
        On Local Error GoTo 0
        f$ = TimerForm.CMDialog1.Filename
        If Not BusyKillAndOpen(f$) Then Exit Function
        
        Put #OutHandle, , DefaultHeader            'Save version
        Put #OutHandle, , version
        Definitions.EditFunc.Caption = "Save"
        Close OutHandle

    Else
        MsgBox "An error has occurred Saving your program"

    End If
    Savegrid = True

Savegrid_cancel:
    screen.MousePointer = 0
     Exit Function



End Function

Sub SaveGridSize (frm As Form)

Dim I As Integer
    
    If frm.WindowState = 0 Then
        I = (frm.Left / Walli3.ScaleWidth * 100)
        Put #OutHandle, , I
        I = (frm.Top / Walli3.ScaleHeight * 100)
        Put #OutHandle, , I
        I = (frm.Width / Walli3.ScaleWidth * 100)
        Put #OutHandle, , I
        I = (frm.Height / Walli3.ScaleHeight * 100)
        Put #OutHandle, , I
    Else
        I = 0
        Put #OutHandle, , I
        Put #OutHandle, , I
        Put #OutHandle, , I
        Put #OutHandle, , I
    End If


End Sub

