DefInt A-Z
Option Explicit
Option Compare Text

Function devcaption$ (r_no As Integer)
    Dim a$
    Dim i        As Integer
    Dim mentors  As Integer
    Dim gryphons As Integer
    Dim kestrels As Integer
    Dim Serp1    As Integer
    Dim Serp2    As Integer
    Dim Serp1ec  As Integer
    Dim Serp2ec  As Integer

    Dim nep1     As Integer
    Dim nep2     As Integer
    Dim mills    As Integer
    Dim lathes   As Integer
    Dim xbs      As Integer

    mentors = 1
    gryphons = 1
    kestrels = 1
    Serp1 = 1
    Serp2 = 1
    Serp1ec = 1
    Serp2ec = 1
    nep1 = 1
    nep2 = 1
    mills = 1
    lathes = 1
    xbs = 1

    For i = 0 To UBound(EditFrmDat)
        a$ = ""
        Select Case EditFrmDat(i).DevType
            Case Mentor
                a$ = "MENTOR"
                If mentors > 1 Then a$ = a$ + Str$(mentors)
                mentors = mentors + 1
            Case Gryphon
                a$ = "GRYPHON"
                If gryphons > 1 Then a$ = a$ + Str$(gryphons)
                gryphons = gryphons + 1
            
            Case GryphonSlide
                a$ = "GRYPHON+"
                If gryphons > 1 Then a$ = a$ + Str$(gryphons)
                gryphons = gryphons + 1


            Case Kestrel
                a$ = "KESTREL"
                If kestrels > 1 Then a$ = a$ + Str$(kestrels)
                kestrels = kestrels + 1
            
            Case serpent1
                a$ = "SERPENT I"
                If Serp1 > 1 Then a$ = a$ + Str$(Serp1)
                Serp1 = Serp1 + 1
            Case SerpentEc1
                a$ = "SERPENT I EC"
                If Serp1ec > 1 Then a$ = a$ + Str$(Serp1ec)
                Serp1ec = Serp1ec + 1
            
            Case serpent2
                a$ = "SERPENT II"
                If Serp2 > 1 Then a$ = a$ + Str$(Serp2)
                Serp2 = Serp2 + 1
            Case SerpentEc2
                a$ = "SERPENT II EC"
                If Serp2ec > 1 Then a$ = a$ + Str$(Serp2ec)
                Serp2ec = Serp2ec + 1
            
            Case Neptune1
                a$ = "NEPTUNE I"
                If nep1 > 1 Then a$ = a$ + Str$(nep1)
                nep1 = nep1 + 1
            Case Neptune2
                a$ = "NEPTUNE II"
                If nep2 > 1 Then a$ = a$ + Str$(nep2)
                nep2 = nep2 + 1
            Case CncMill
                a$ = "CYBER MILL"
                If mills > 1 Then a$ = a$ + Str$(mills)
                mills = mills + 1
            Case CncLathe
                a$ = "CYBER LATHE"
                If lathes > 1 Then a$ = a$ + Str$(lathes)
                lathes = lathes + 1
            Case xboard
                a$ = "EXPANDER"
                If xbs > 1 Then a$ = a$ + Str$(xbs)
                xbs = xbs + 1
        End Select
        If i = r_no Then
            Exit For
        End If
    Next
    devcaption$ = a$
    
End Function

Function highdevcaption$ (r_no As Integer)
highdevcaption$ = "&" + Format$(r_no + 1) + " " + EditFrmDat(r_no).name
End Function

Sub InstallCNC (Frmno As Integer)



Dim LCalib As LatheCalibType
Dim section$

Dim EditFrm As Integer
Dim notcal As Integer
Dim returnedstring$
Dim dummy As Integer
Dim xcal
Dim ycal
Dim zcal

    
    EditFrm = CNCFrmDat(Frmno).DevNo
    Select Case CNCFrmDat(Frmno).DevType
    Case CncMill
        notcal = False
        returnedstring$ = Space$(10)
        
        dummy = GetPrivateProfileString(CNCFrmDat(Frmno).name, ByVal "CALX", "", returnedstring$, Len(returnedstring$), inifile$)
        If dummy = 0 Then notcal = True
        xcal = Val(returnedstring$)
        
        dummy = GetPrivateProfileString(CNCFrmDat(Frmno).name, ByVal "CALY", "", returnedstring$, Len(returnedstring$), inifile$)
        If dummy = 0 Then notcal = True
        ycal = Val(returnedstring$)
        
        dummy = GetPrivateProfileString(CNCFrmDat(Frmno).name, ByVal "CALZ", "", returnedstring$, Len(returnedstring$), inifile$)
        If dummy = 0 Then notcal = True
        zcal = Val(returnedstring$)

        'If notcal Then MsgBox CNCFrmDat(Frmno).name + " is not calibrated", 64
        
        setcalib EditFrm, xcal, ycal, zcal, notcal

        dummy = GetPrivateProfileString(CNCFrmDat(Frmno).name, ByVal "BackX", "15", returnedstring$, Len(returnedstring$), inifile$)
        xcal = Val(returnedstring$)
        dummy = GetPrivateProfileString(CNCFrmDat(Frmno).name, ByVal "BackY", "15", returnedstring$, Len(returnedstring$), inifile$)
        ycal = Val(returnedstring$)
        dummy = GetPrivateProfileString(CNCFrmDat(Frmno).name, ByVal "BackZ", "15", returnedstring$, Len(returnedstring$), inifile$)
        zcal = Val(returnedstring$)
        setbacklash EditFrm, xcal, ycal, zcal
        
        'CNCfrmDat(FrmNo).devtype = robtype
        'CNCfrmDat(FrmNo).address = devaddr
    Case CncLathe
        section$ = CNCFrmDat(Frmno).name
        
        LCalib.Tool_x(1) = readini(section$, "T1X", 9303)
        LCalib.Tool_x(2) = readini(section$, "T2X", 6059)
        LCalib.Tool_x(3) = readini(section$, "T3X", 2212)
        LCalib.Tool_x(4) = readini(section$, "T4X", 41 * mmtosteps)
        
        LCalib.Tool_z(1) = readini(section$, "T1Z", 8064)
        LCalib.Tool_z(2) = readini(section$, "T2Z", 13165)
        LCalib.Tool_z(3) = readini(section$, "T3Z", 19892)
        LCalib.Tool_z(4) = readini(section$, "T4Z", 79 * mmtosteps)

        LCalib.Back_X = readini(section$, "BackX", 15)
        LCalib.Back_Z = readini(section$, "BackZ", 15)
        
        LCalib.Sendcal = 0
        LCalib.Calibrated = 0
        
        SetLatheCalib EditFrm, LCalib
    End Select
    
    setdevtype EditFrm, CNCFrmDat(Frmno).DevType, CNCFrmDat(Frmno).address
    Load CNCFrm(Frmno)


End Sub

Sub InstallROB (Frmno As Integer)

Dim EditFrm As Integer
Dim returnedstring$
Dim i
Dim dummy
Dim Serpcalib As SerpentCalibType
Dim Nepcalib As NeptuneCalibType



    EditFrm = RobotFrmDat(Frmno).DevNo
        Select Case RobotFrmDat(Frmno).DevType
        
            Case Kestrel
                RobotFrmDat(Frmno).mult(0) = 50          '100 steps/mm - DLL sends double
                RobotFrmDat(Frmno).mult(1) = 50
                RobotFrmDat(Frmno).mult(2) = 160         '160 steps/mm
                RobotFrmDat(Frmno).mult(3) = 400 / 360   '400 steps/rev  was .9?

            Case serpent1, serpent2
                returnedstring$ = Space$(10)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "M1", "2000", returnedstring$, Len(returnedstring$), inifile$): Serpcalib.cal_m(0) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "M2", "2000", returnedstring$, Len(returnedstring$), inifile$): Serpcalib.cal_m(1) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "M3", "2000", returnedstring$, Len(returnedstring$), inifile$): Serpcalib.cal_m(2) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "C1", "4096", returnedstring$, Len(returnedstring$), inifile$): Serpcalib.cal_c(0) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "C2", "4096", returnedstring$, Len(returnedstring$), inifile$): Serpcalib.cal_c(1) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "C3", "4096", returnedstring$, Len(returnedstring$), inifile$): Serpcalib.cal_c(2) = Val(returnedstring$)
                setserpentcalib EditFrm, Serpcalib
            Case Neptune1
                returnedstring$ = Space$(10)
                For i = 0 To 4
                    dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "M" + Format$(i), "1000", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_m(i) = Val(returnedstring$)
                    dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "C" + Format$(i), "0", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_c(i) = Val(returnedstring$)
                    dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "W" + Format$(i), "10", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_w(i) = Val(returnedstring$)
                Next
                setNeptunecalib EditFrm, Nepcalib

            Case Neptune2
                returnedstring$ = Space$(10)
                For i = 0 To 5
                    dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "M" + Format$(i), "1000", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_m(i) = Val(returnedstring$)
                    dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "C" + Format$(i), "0", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_c(i) = Val(returnedstring$)
                    dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "W" + Format$(i), "10", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_w(i) = Val(returnedstring$)
                Next
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncFast0", "512", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncFast(0) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncFast1", "512", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncFast(1) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncFast2", "512", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncFast(2) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncFast3", "512", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncFast(3) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncFast4", "1024", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncFast(4) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncFast5", "1024", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncFast(5) = Val(returnedstring$)
                
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncSlow0", "50", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncSlow(0) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncSlow1", "50", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncSlow(1) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncSlow2", "60", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncSlow(2) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncSlow3", "130", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncSlow(3) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncSlow4", "150", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncSlow(4) = Val(returnedstring$)
                dummy = GetPrivateProfileString(EditFrmDat(EditFrm).name, ByVal "IncSlow5", "150", returnedstring$, Len(returnedstring$), inifile$): Nepcalib.cal_IncSlow(5) = Val(returnedstring$)
                
                setNeptunecalib EditFrm, Nepcalib

        End Select
        
        setdevtype EditFrm, RobotFrmDat(Frmno).DevType, RobotFrmDat(Frmno).address
        
        

End Sub

Sub makeeditpane (ByVal robtype As Integer, EditFrm As Integer)

Dim notcal As Integer
Dim returnedstring$
Dim dummy As Integer
Dim i As Integer
Dim picwidth As Integer
Dim picheight As Integer
Dim LOADED As Integer

Dim Frmno As Integer


Dim xcal
Dim ycal
Dim zcal

'Note Device address is passed by Global Devaddr

    
    
screen.MousePointer = 11    'busy

Select Case devaddr
    Case 0 To 15
        If turbo_baseseg = 0 Then findturbo_if.Show 1
    
    Case Else
        If io_baseseg = 0 Then findrj45_if.Show 1
End Select



If EditFrm = -1 Then
    Do                      'Find a device number
        EditFrm = EditFrm + 1
        If EditFrm > UBound(EditFrmDat) Then
            ReDim Preserve EditFrmDat(EditFrm): EditFrmDat(EditFrm).DevType = 0
        End If
    Loop Until EditFrmDat(EditFrm).DevType = 0
Else    'Form number is being forced
        If EditFrm > UBound(EditFrmDat) Then
            ReDim Preserve EditFrmDat(EditFrm): EditFrmDat(EditFrm).DevType = 0
        Else
            'If EditFrmDat(EditFrm).devtype <> 0 Then
                'MsgBox "OOPS!, just deleted device" + Chr$(13) + "Please report"
                'EditFrmDat(EditFrm).devtype = 0
            'End If
        End If
End If

EditFrmDat(EditFrm).DevType = robtype
EditFrmDat(EditFrm).name = devcaption$(EditFrm)
EditFrmDat(EditFrm).address = devaddr


Select Case robtype
    Case Mentor, Gryphon, GryphonSlide, serpent1, serpent2, Kestrel, Neptune1, Neptune2, SerpentEc1, SerpentEc2
        EDITED = True
        Frmno = -1
        Do                      'Find a device number
            Frmno = Frmno + 1
            If Frmno > UBound(RobotFrmDat) Then
                ReDim Preserve RobotFrm(Frmno): Set RobotFrm(Frmno) = New RobotFrmType
                ReDim Preserve RobotFrmDat(Frmno): RobotFrmDat(Frmno).free = True
                ReDim Preserve XYZdata(Frmno): Set XYZdata(Frmno) = New xyzdataType
                ReDim Preserve Position(Frmno)
            End If
        Loop Until RobotFrmDat(Frmno).free = True
        RobotFrmDat(Frmno).free = False         'Mark in use
        RobotFrmDat(Frmno).DevType = robtype
        RobotFrmDat(Frmno).teachmode = keyboard    'Default teach mode is keyboard
        RobotFrmDat(Frmno).address = devaddr

        RobotFrmDat(Frmno).DevNo = EditFrm
        RobotFrmDat(Frmno).name = EditFrmDat(EditFrm).name
        For i = 0 To 8
            RobotFrmDat(Frmno).mult(i) = 1
        Next
        

        InstallROB Frmno

        If OptMenuChecked(0) = True Then
            Load drawing(0)
            Load drawing(1)
        End If
        
        Load RobotFrm(Frmno)
        RobotFrm(Frmno).Timer1.Enabled = True

    
    Case CncMill, CncLathe
        EDITED = True
        Frmno = -1
        Do                      'Find a device number
            Frmno = Frmno + 1
            If Frmno > UBound(CNCFrmDat) Then
                ReDim Preserve CNCFrm(Frmno): Set CNCFrm(Frmno) = New MillFormType
                ReDim Preserve CNCFrmDat(Frmno): CNCFrmDat(Frmno).free = True
                

            End If
        Loop Until CNCFrmDat(Frmno).free = True
        CNCFrmDat(Frmno).free = False          'Mark in use
        CNCFrmDat(Frmno).DevType = robtype
        CNCFrmDat(Frmno).address = devaddr
        
        CNCFrmDat(Frmno).name = EditFrmDat(EditFrm).name
        CNCFrmDat(Frmno).DevNo = EditFrm

        InstallCNC Frmno

'        notcal = False
'        returnedstring$ = Space$(10)
'
'        dummy = GetPrivateProfileString(CNCfrmDat(FrmNo).name, ByVal "CALX", "", returnedstring$, Len(returnedstring$), inifile$)
 '       If dummy = 0 Then notcal = True
'        xcal = Val(returnedstring$)
'
'        dummy = GetPrivateProfileString(CNCfrmDat(FrmNo).name, ByVal "CALY", "", returnedstring$, Len(returnedstring$), inifile$)
 '       If dummy = 0 Then notcal = True
 '       ycal = Val(returnedstring$)
 '
 ''       dummy = GetPrivateProfileString(CNCfrmDat(FrmNo).name, ByVal "CALZ", "", returnedstring$, Len(returnedstring$), inifile$)
 '       If dummy = 0 Then notcal = True
 '       zcal = Val(returnedstring$)
  '
  ''      'If notcal Then MsgBox CNCFrmDat(Frmno).name + " is not calibrated", 64
  '
  '      setcalib EditFrm, xcal, ycal, zcal, notcal
  '
   '     dummy = GetPrivateProfileString(CNCfrmDat(FrmNo).name, ByVal "BackX", "15", returnedstring$, Len(returnedstring$), inifile$)
  '      xcal = Val(returnedstring$)
  '      dummy = GetPrivateProfileString(CNCfrmDat(FrmNo).name, ByVal "BackY", "15", returnedstring$, Len(returnedstring$), inifile$)
  '      ycal = Val(returnedstring$)
  '      dummy = GetPrivateProfileString(CNCfrmDat(FrmNo).name, ByVal "BackZ", "15", returnedstring$, Len(returnedstring$), inifile$)
  '      zcal = Val(returnedstring$)
  '      setbacklash EditFrm, xcal, ycal, zcal
  '
  '      setdevtype EditFrm, robtype, devaddr
  '      Load CNCfrm(FrmNo)
    
    Case xboard
        EDITED = True
        Frmno = -1
        Do                      'Find a device number
            Frmno = Frmno + 1
            If Frmno > UBound(Xfrmdat) Then
                ReDim Preserve Xfrm(Frmno): Set Xfrm(Frmno) = New XboardformType
                ReDim Preserve Xfrmdat(Frmno): Xfrmdat(Frmno).free = True
            End If
        Loop Until Xfrmdat(Frmno).free = True
        
        Xfrmdat(Frmno).free = False          'Mark in use
        Xfrmdat(Frmno).DevType = robtype
        Xfrmdat(Frmno).address = devaddr
        
        Xfrmdat(Frmno).name = EditFrmDat(EditFrm).name
        Xfrmdat(Frmno).DevNo = EditFrm

        setdevtype EditFrm, robtype, devaddr
        Load Xfrm(Frmno)
        
    Case Else
        MsgBox "Attempt to install Device type" + Str$(robtype) + Chr$(13) + "Please report"

End Select

EditFrmDat(EditFrm).Frmno = Frmno     'Keep pointer to edit form



screen.MousePointer = 0


End Sub

Sub SetEditDevices (Frm As Form)

Dim i As Integer

If Definitions.Table1.Rows = 0 Then
    For i = 12 To 21
        Frm.Cellmenu(i).Visible = False       'Nothing to Edit or Delete
    Next
    For i = 0 To 3
        Frm.CellEditMenu(i).Visible = False       'Nothing to Edit or Delete
    Next

Else
    For i = 12 To 21
        Frm.Cellmenu(i).Visible = True
    Next
    
    Definitions.Table1.ReferenceRow = Definitions.Table1.RowIndex
    While Definitions.Table1.ColumnText(1) = ""
        Definitions.Table1.ReferenceRow = Definitions.Table1.ReferenceRow - 1
    Wend

    If TypeOf Frm Is RobotFrmType Then

    ElseIf TypeOf Frm Is MillFormType Then

    ElseIf TypeOf Frm Is XboardformType Then

    Else
        Frm.CellEditMenu(0).Visible = True
        Frm.CellEditMenu(1).Visible = True
        
        Frm.CellEditMenu(1).Caption = "&Delete " + Definitions.Table1.ColumnText(1)
        Frm.CellEditMenu(2).Caption = "&Edit " + Definitions.Table1.ColumnText(1)
        If devref(Definitions.Table1.RowIndex) < 128 Then
            Frm.CellEditMenu(2).Visible = False     'Can't edit devices
        Else
            Frm.CellEditMenu(2).Visible = True
        End If
    End If


End If

End Sub

