Option Explicit
Option Compare Text
DefInt A-Z


Dim LocalDesX As Integer
Dim LocalDesY As Integer

Dim LocalI As Integer
Dim LocalJ As Integer


Dim UseZcopy


Dim buffer As String

Dim LineNum As Long


Dim Quit
Dim dirbyte

Dim tmpptr As Integer
Dim tmpfile() As Integer

Dim er

Dim xs
Dim xm
Dim xdir

Dim ys
Dim ym
Dim ydir


'Dim cz

Dim radius As Single
Dim radsqr As Single
Dim sector
Dim arcdir

Dim progend

Dim rev

'Dim absolute
Dim firstcut

Dim CurrentFeed As Integer

Private Function arctest ()
	 
	 Dim dx
	 Dim dif As Integer
	 
	 arctest = True
	 
	 
	 
	 
	 If xs < xm And LocalDesX > xm Then
		dif = Abs(LocalDesX - xm)        'Correct for any rounding errors
		If dif > 10 Then arctest = False
	 End If
	 If xs > xm And LocalDesX < xm Then
		dif = Abs(LocalDesX - xm)        'Correct for any rounding errors
		If dif > 10 Then arctest = False
	 End If
	 If ys < ym And LocalDesY > ym Then
		dif = Abs(LocalDesY - ym)        'Correct for any rounding errors
		If dif > 10 Then arctest = False
	 End If
	 If ys > ym And LocalDesY < ym Then
		dif = Abs(LocalDesY - ym)        'Correct for any rounding errors
		If dif > 10 Then arctest = False
	 End If
	 
	 dx = Abs(xs - xm) - Abs(LocalDesX - xm)
	 If dx * sector * arcdir < 0 Then
		arctest = False
	 End If
End Function

Private Sub CNC_gcodes ()
    
Dim dz As Integer

LocalDesX = DesX
LocalDesY = DesY
LocalI = CNC_gcode.i
LocalJ = CNC_gcode.j

    
    'printer.Print "*"; CNC_gcode.g, DesX, DesY
    
    
    Select Case CNC_gcode.G
	Case 0, 92                   'Fast position
	    g0
	
	Case 1                    'Linear Interpolation
	    g1
	
	Case 2                    'CW Interpolation
	    If Not UseZcopy Then DesZ = z_down            'bodge z cut
	    dz = DesZ - LastDesZ
	    If dz <> 0 Then                     'Move Z first
		SetDirection 0, 0, dz
		send_z dz
	    End If
	    g2
	
	Case 3                    'CCW Interpolation
	    If Not UseZcopy Then DesZ = z_down            'bodge z cut
	    dz = DesZ - LastDesZ
	    If dz <> 0 Then                     'Move Z first
		SetDirection 0, 0, dz
		send_z dz
	    End If
	    g3
	
	Case 4                    'Dwell
	    g4
	
	Case 36                   'Facemill
	    g36
	
	Case 38
	    g38
	
	Case 39
	    g39

	Case 73     'Loop
	    'loopcnt = CNC_gcode.x
	    'LoopLine = Linenum
    
	Case 6
	    'If LoopPtr <> -1 Then
	    '    Loopvar(LoopPtr).Count = Loopvar(LoopPtr).Count - 1
	    '    If Loopvar(LoopPtr).Count > 0 Then
	    '        LineNum = Loopvar(LoopPtr).LineNum
	    '    Else
	    '        LoopPtr = LoopPtr - 1
	    '    End If
	    'End If

	Case 81                   'Drill cycle
	    g81 False, False

	Case 82                   'Drill cycle with dwell
	    g81 False, True

	Case 83                   'Peck cycle with dwell
	    g81 True, True
	
	
    End Select
End Sub

Private Sub compileline ()
   
Dim i As Long
Dim j As Long
	
	
	'printer.Print Linenum; LOF(outhandle)
	
	SaveByte (&HE0): SaveByte (16): saveword (LineNum)  '(CNC_gcode.n)
	
'    If Mcopy(low(linenum),high(linenum)).t <> noset Then
'        savebyte 128 + 64 + 32
'        savebyte 11
'        savebyte Mcopy(low(linenum),high(linenum)).t
'    End If
	
	'If Mcopy(low(LineNum), high(LineNum)).F <> notset Then                     'Set feedrate
	'    FeedRate Mcopy(low(LineNum), high(LineNum)).F
	'End If

	If CurrentFeed <> CNC_gcode.F Then FeedRate

	
	mcodes
	If Not progend Then CNC_gcodes
	PurgeBuffer
End Sub

Private Sub do_arc ()

Dim incx As Integer
Dim incy As Integer
Dim b As Integer

Dim deltax As Integer
Dim deltay As Integer

Dim dx As Integer
Dim dy As Integer
Dim a$
	 
	 If Abs(radius - Sqr((xm - LocalDesX) ^ 2 + (ym - LocalDesY) ^ 2)) > 16 Then
	    MsgBox "Arc not possible"
	    Quit = True
	    Exit Sub
	 End If
	 
	 If Not arctest() Then
	    MsgBox "Arc not possible "
	    Quit = True
	    Exit Sub
	 End If


	 b = 128
	 If xdir = 1 Then b = b Or 4
	 If ydir = 1 Then b = b Or 2
	 SaveByte (b)
	 
	 deltay = Abs(LocalDesY - LastDesY)          'total change for LocalDesY
	 deltax = Abs(LocalDesX - LastDesX)          'total change for LocalDesX

	 Do
	  dy = Abs(ys - LastDesY)   'change from start pos to current
	  dx = Abs(xs - LastDesX)
	  If Abs(LastDesX - xm) > Abs(LastDesY - ym) Then
		   'set LocalDesY increment, calculate LocalDesX
		   If deltay - dy < 8 Then incy = deltay - dy Else incy = 8
		   LastDesY = LastDesY + incy * ydir

		   'guiding equat  SQR((XM - LocalDesX) ^ 2 + (YM - LocalDesY) ^ 2) =radsqr
		   incx = Fix(Abs((Sqr(radsqr - (ym - LastDesY) ^ 2) + (LastDesX - xm) * xdir)))
		   If incx > 8 Then incx = 8
		   If incx > Fix(Abs(deltax - dx)) Then incx = Fix(Abs(deltax - dx))
		   LastDesX = LastDesX + incx * xdir
	  Else
		   'set LocalDesX increment, calculate LocalDesY
		   If deltax - dx < 8 Then incx = deltax - dx Else incx = 8
		   LastDesX = LastDesX + incx * xdir
		   
		   incy = Fix(Abs((Sqr(radsqr - (xm - LastDesX) ^ 2) - (LastDesY - ym) * ydir)))
		   If incy > 8 Then incy = 8
		   If incy > Fix(Abs(deltay - dy)) Then incy = Fix(Abs(deltay - dy))
		   LastDesY = LastDesY + incy * ydir
	  End If
	 
	  If incx <> 0 Or incy <> 0 Then
	    SaveByte (0)
	    front (incx)
	    front (incy)
	  End If
	 
	 Loop Until incx = 0 And incy = 0
	 'LastDesX = LocalDesX
	 'LastDesY = LocalDesY
End Sub

Sub FeedRate ()
	
Dim i As Long
	
	CurrentFeed = CNC_gcode.F

	SaveByte (128 + 64 + 32)
	SaveByte (7)
	
	If Not UseZcopy Then CurrentFeed = UBound(mill_feedrates)   'Always draw at fastest speed
	
	If CurrentFeed > UBound(mill_feedrates) Then CurrentFeed = UBound(mill_feedrates)
	
	SaveByte (mill_feedrates(CurrentFeed) Mod 256)
	SaveByte (Fix(mill_feedrates(CurrentFeed) / 256))
	
	i = 65551 - (600000 * Sqr(2) / (100 * (CurrentFeed + 1)))
	
	SaveByte (i Mod 256)
	SaveByte (Fix(i / 256))
	
End Sub

Private Sub front (k)
	 'save number with k 1's in front justified
	 Select Case k
	  Case 0
		   SaveByte (0)
	  Case 1
		   SaveByte (&H80)
	  Case 2
		   SaveByte (&H88)
	  Case 3
		   SaveByte (&HA4)
	  Case 4
		   SaveByte (&HAA)
	  Case 5
		   SaveByte (&HEA)
	  Case 6
		   SaveByte (&HEE)
	  Case 7
		   SaveByte (&HFE)
	  Case 8
		   SaveByte (&HFF)
	 End Select
End Sub

Private Sub g0 ()
	 
Dim dx As Integer
Dim dy As Integer
Dim dz As Integer


If Not UseZcopy Then DesZ = z_up                   'bodge z no cut

	 
	 dx = LocalDesX - LastDesX: dy = LocalDesY - LastDesY: dz = DesZ - LastDesZ
	 If (dx = 0) And (dy = 0) And (dz = 0) Then Exit Sub
	 
	 SetDirection dx, dy, dz
	 dx = Abs(dx): dy = Abs(dy): dz = Abs(dz)
	 SaveByte (16)
	 saveword (dx)
	 saveword (dy)
	 saveword (dz)
	 'LastDesX = LocalDesX: LastDesY = LocalDesY:
	 'cz = CNC_gcode.z
End Sub

Private Sub g1 ()
	 
'Dim b
Dim KX  As Integer
Dim KY  As Integer

Dim dx As Integer
Dim dy As Integer

Dim deltax As Integer
Dim deltay As Integer

Dim slopexy As Single
Dim slopeyx As Single

Dim dz As Integer

If Not UseZcopy Then DesZ = z_down            'bodge z cut

	 
	deltax = LocalDesX - LastDesX: deltay = LocalDesY - LastDesY: dz = DesZ - LastDesZ
	SetDirection deltax, deltay, dz
	send_z dz
	
	If deltax = 0 And deltay = 0 Then Exit Sub
	
	deltax = Abs(deltax): deltay = Abs(deltay): dx = 0: dy = 0


'    GoTo skip
	
	If deltay = 0 Then
	SaveByte 65
	saveword deltax
	'LastDesX = LocalDesX
	Exit Sub
	End If

	If deltax = 0 Then
	SaveByte 66
	saveword deltay
	'LastDesY = LocalDesY
	Exit Sub
	End If

skip:

	If deltax <> 0 Then slopeyx = deltay / deltax
	If deltay <> 0 Then slopexy = deltax / deltay
	
	Do
	If (deltay - dy) < (deltax - dx) Then
		SaveByte (0)                         'XY data
		If deltax - dx < 8 Then KX = deltax - dx Else KX = 8
		dx = dx + KX
		KY = Int(dx * slopeyx - dy)
		If KY > 8 Then KY = 8
		If KY < 0 Then KY = 0
		dy = dy + KY
		front (KX): front (KY)
	Else
		SaveByte (0)                         'XY data
		If deltay - dy < 8 Then KY = deltay - dy Else KY = 8
		dy = dy + KY
		KX = Int(dy * slopexy - dx)
		If KX > 8 Then KX = 8
		If KX < 0 Then KX = 0
		dx = dx + KX
		front (KX): front (KY)
	End If
	Loop Until (dx = deltax) And (dy = deltay)
	'LastDesX = LocalDesX
	'LastDesY = LocalDesY
End Sub

Private Sub g2 ()

Dim x1
Dim y1
'Dim dz
'
'        If Not UseZcopy Then DesZ = z_down            'bodge z cut
'        dz = DesZ - LastDesZ
'        If dz <> 0 Then                     'Move Z first
'        SetDirection 0, 0, dz
'        send_z dz
'        End If

	 
	 arcdir = -1
	 radsqr = CSng(LocalI) * CSng(LocalI) + CSng(LocalJ) * CSng(LocalJ)
	 radius = Sqr(radsqr)
	 
	 xs = LastDesX: ys = LastDesY              'start posns
	 If LocalDesX > xs And LocalDesY > ys Then
	  xm = xs - LocalI              'LocalDesX Middle
	  xdir = 1
	  ym = ys + LocalJ              'LocalDesY middle
	  ydir = 1
	  sector = 1
	 ElseIf LocalDesX > xs And LocalDesY <= ys Then
	  xm = xs + LocalI
	  xdir = 1
	  ym = ys + LocalJ
	  ydir = -1
	  sector = -1
	 ElseIf LocalDesX <= xs And LocalDesY > ys Then
	  xm = xs - LocalI
	  xdir = -1
	  ym = ys - LocalJ
	  ydir = 1
	  sector = -1
	 ElseIf LocalDesX <= xs And LocalDesY <= ys Then
	  xm = xs + LocalI
	  xdir = -1
	  ym = ys - LocalJ
	  ydir = -1
	  sector = 1
	 End If
	 If xdir * ydir = 1 Then
	  
	  opentmpfile

	  x1 = LocalDesX
	  y1 = LocalDesY
	  LastDesX = LocalDesX: LocalDesX = xs
	  LastDesY = LocalDesY: LocalDesY = ys
	  LocalI = Abs(xm - LastDesX)
	  LocalJ = Abs(ym - LastDesY)
	  g3
	  'LastDesX = x1
	  'LastDesY = y1
	  savebuffer
	 Else
	  do_arc
	 End If
End Sub

Private Sub g3 ()

Dim x1
Dim y1
'Dim dz As Integer

'If Not UseZcopy Then DesZ = z_down            'bodge z cut
'        dz = DesZ - LastDesZ
'        If dz <> 0 Then                     'Move Z first
'        SetDirection 0, 0, dz
'        send_z dz
'        End If


	 arcdir = 1
	 radsqr = CSng(LocalI) * CSng(LocalI) + CSng(LocalJ) * CSng(LocalJ)
	 'radsqr = LocalI * LocalI + LocalJ * LocalJ
	 radius = Sqr(radsqr)
	 
	 xs = LastDesX: ys = LastDesY
	 If LocalDesX >= xs And LocalDesY >= ys Then
	  xm = xs + LocalI
	  xdir = 1
	  ym = ys - LocalJ
	  ydir = 1
	  sector = 1
	 ElseIf LocalDesX >= xs And LocalDesY < ys Then
	  xm = xs - LocalI
	  xdir = 1
	  ym = ys - LocalJ
	  ydir = -1
	  sector = -1
	 ElseIf LocalDesX < xs And LocalDesY >= ys Then
	  xm = xs + LocalI
	  xdir = -1
	  ym = ys + LocalJ
	  ydir = 1
	  sector = -1
	 ElseIf LocalDesX < xs And LocalDesY < ys Then
	  xm = xs - LocalI
	  xdir = -1
	  ym = ys + LocalJ
	  ydir = -1
	  sector = 1
	 End If
	 If xdir * ydir = -1 Then
	  'PRINT "Before bodgery "; LocalI; LocalJ; XM; LastDesX; LocalDesX; YM; LastDesY; LocalDesY
	  opentmpfile
	  x1 = LocalDesX
	  y1 = LocalDesY
	  LastDesX = LocalDesX: LocalDesX = xs
	  LastDesY = LocalDesY: LocalDesY = ys
	  LocalI = Abs(xm - LastDesX): LocalJ = Abs(ym - LastDesY): g2
	  'LastDesX = x1: LastDesY = y1
	  savebuffer
	 Else
	  do_arc
	 End If
End Sub

Private Sub g36 ()                          'Face mill
Dim i As Integer
Dim repeat As Integer
Dim stepover As Integer
Dim ystep As Integer
Dim dz As Integer

	If Not UseZcopy Then Exit Sub


	dz = DesZ - LastDesZ
	If dz <> 0 Then                     'Move Z first
	SetDirection 0, 0, dz
	send_z dz
	End If
	
	
	If CNC_gcode.y < CNC_gcode.t Then CNC_gcode.y = CNC_gcode.t
	
	CNC_gcode.y = CNC_gcode.y - CNC_gcode.t
	repeat = Fix(CNC_gcode.y / (CNC_gcode.t * .75))    'Number of repeats required with 75% stepover
	
	If Fix(repeat / 2) = Fix((repeat + 1) / 2) Then  'Force repeat to be even
	repeat = repeat + 1
	End If

	Do
	stepover = Int(CNC_gcode.y / repeat)
	ystep = CNC_gcode.y - (stepover * (repeat - 1))
	
	If ystep > (CNC_gcode.t * .8) Then              'Don't exceed 80% stepover
		repeat = repeat + 2
	Else
		Exit Do
	End If
	Loop

	For i = 0 To repeat - 2
	CNC_gcode.X = CNC_gcode.X * -1
	'CNCDepth.Picture1.Line -Step(CNC_gcode.x, 0), QBColor(0)
	'CNCDepth.Picture1.Line -Step(0, stepover), QBColor(0)
	SetDirection CNC_gcode.X, stepover, 0
	SaveByte 65: saveword Abs(CNC_gcode.X)
	SaveByte 66: saveword stepover

	Next
	
	CNC_gcode.X = CNC_gcode.X * -1
	'CNCDepth.Picture1.Line -Step(CNC_gcode.x, 0), QBColor(0)
	'CNCDepth.Picture1.Line -Step(0, ystep), QBColor(0)

	SetDirection CNC_gcode.X, ystep, 0
	SaveByte 65: saveword Abs(CNC_gcode.X)
	SaveByte 66: saveword ystep
	
	CNC_gcode.X = CNC_gcode.X * -1
	'CNCDepth.Picture1.Line -Step(CNC_gcode.x, 0), QBColor(0)
	'CNCDepth.Picture1.Line -Step(0, -CNC_gcode.y), QBColor(1)

	SetDirection CNC_gcode.X, -CNC_gcode.y, 0
	SaveByte 65: saveword Abs(CNC_gcode.X)
	SaveByte 66: saveword CNC_gcode.y

	 
End Sub

Private Sub g38 ()
'Wait for input in x field low, input in y field high
Dim i As Integer

If Mcopy(low(LineNum), high(LineNum)).X <> notset Then
i = Mcopy(low(LineNum), high(LineNum)).X * Mcopy(low(LineNum), high(LineNum)).steps_to_units
    SaveByte (128 + 64 + 32)
    SaveByte (15)
    SaveByte (2 ^ (i - 1))
End If

If Mcopy(low(LineNum), high(LineNum)).y <> notset Then
    i = Mcopy(low(LineNum), high(LineNum)).y * Mcopy(low(LineNum), high(LineNum)).steps_to_units
    SaveByte (128 + 64 + 32)
    SaveByte (14)
    SaveByte (2 ^ (i - 1))
End If



End Sub

Private Sub g39 ()
'set output in x field low, input in y field high
Dim i As Integer



If Mcopy(low(LineNum), high(LineNum)).X <> notset Then
    i = Mcopy(low(LineNum), high(LineNum)).X * Mcopy(low(LineNum), high(LineNum)).steps_to_units
    SaveByte (128 + 64 + 32)
    SaveByte (13)
    SaveByte (2 ^ (i - 1))
End If

If Mcopy(low(LineNum), high(LineNum)).y <> notset Then
    i = Mcopy(low(LineNum), high(LineNum)).y * Mcopy(low(LineNum), high(LineNum)).steps_to_units
    SaveByte (128 + 64 + 32)
    SaveByte (12)
    SaveByte (2 ^ (i - 1))
End If


End Sub

Private Sub g4 ()

If CNC_gcode.d > 0 Then
    SaveByte (128 + 8)
    SaveByte (CNC_gcode.d * 2)
End If

End Sub

Private Sub g81 (peck, dwell)
	 
Dim zstep As Integer
Dim dx, dy, dz As Integer



	 
	If Not UseZcopy Then Exit Sub
	dz = 0: zstep = mmtosteps * .5

	dx = LocalDesX - LastDesX: dy = LocalDesY - LastDesY
	
	If (dx <> 0) Or (dy <> 0) Then
	    SetDirection dx, dy, 0
	    SaveByte (16)
	    saveword (Abs(dx))
	    saveword (Abs(dy))
	    saveword (0)
	    'LastDesX = LocalDesX: LastDesY = LocalDesY
	End If
	 
	If peck Then
	    Do
		SetDirection 0, 0, 1        'Down
		SaveByte (16)
		saveword (0)
		saveword (0)
		saveword (dz)
		
		dz = dz + zstep
		If dz > HoleDepth Then
		    dz = dz - zstep
		    zstep = HoleDepth - dz
		    dz = HoleDepth
		End If
	    
		SaveByte (64)
		saveword (zstep)
		
		If dwell And dz = HoleDepth Then g4
	    
		SetDirection 0, 0, -1        'Up
		SaveByte (16)   'xyzramp data
		saveword (0)    'no xy change
		saveword (0)
		saveword (dz)
	    Loop Until dz = HoleDepth     'DesZ
	Else
	    SetDirection 0, 0, 1        'Down
	    SaveByte (64)
	    saveword (HoleDepth)

	    If dwell Then g4
	    
	    SetDirection 0, 0, -1        'Up
	    SaveByte (16)   'xyzramp data
	    saveword (0)    'no xy change
	    saveword (0)
	    saveword (HoleDepth)
	End If
	'CNC_gcode.z = cz
End Sub

Private Sub g92 ()

Dim b

'Zero datum shift - same as g0 but Current positions not changed

	If UseZcopy Then
	    SetDirection CNC_gcode.X, CNC_gcode.y, CNC_gcode.z
	    SaveByte (16)
	    saveword (Abs(CNC_gcode.X))
	    saveword (Abs(CNC_gcode.y))
	    saveword (Abs(CNC_gcode.z))
	Else
	    SetDirection CNC_gcode.X, CNC_gcode.y, CNC_gcode.z
	    SaveByte (16)
	    saveword (Abs(CNC_gcode.X))
	    saveword (Abs(CNC_gcode.y))
	    saveword (0)
	End If

End Sub

Private Sub Home ()
    SaveByte (192)
End Sub

Private Sub m0 ()
	 If Not UseZcopy Then Exit Sub
	 
	 SaveByte (128 + 64 + 32)
	 SaveByte (10)
End Sub

Private Sub m2 ()
	 progend = True
End Sub

Private Sub m3 ()       'CW
	
	If Not UseZcopy Then Exit Sub
	
	SaveByte (128 + 64 + 32)
	SaveByte (1)
	If CNC_gcode.S > UBound(mill_spindle_spd) Then CNC_gcode.S = UBound(mill_spindle_spd)
	SaveByte (mill_spindle_spd(CNC_gcode.S))
End Sub

Private Sub m4 ()
	 'CCW
	 If Not UseZcopy Then Exit Sub
	 
	  SaveByte (128 + 64 + 32)
	  SaveByte (2)
	  SaveByte (mill_spindle_spd(CNC_gcode.S))
	  
End Sub

Private Sub m5 ()
	 'OFF
	 If Not UseZcopy Then Exit Sub
	 
	  SaveByte (128 + 64 + 32)
	  SaveByte (3)
	  
	 
End Sub

Private Sub m68 ()
	 SaveByte (128 + 64 + 32)
	 SaveByte (4)
End Sub

Private Sub m69 ()
	 'unclamp
	 SaveByte (128 + 64 + 32)
	 SaveByte (5)
End Sub

Private Sub m8 ()
'Air on
	If Not UseZcopy Then Exit Sub
	SaveByte (128 + 64 + 32)
	SaveByte (17)
End Sub

Private Sub m9 ()
'air off
	If Not UseZcopy Then Exit Sub
	SaveByte (128 + 64 + 32)
	SaveByte (18)
End Sub

Private Sub mcodes ()
	   
	 Select Case CNC_gcode.m
	  Case 0
		   m0
	  Case 2
		   m2
	  Case 3
		   m3
	  Case 4
		   m4
	  Case 5
		   m5
	  Case 8
			m8
	  Case 9
			m9
	  Case 68
		   m68
	  Case 69
		   m69
	  
	  Case notset

	  Case Else
		   MsgBox "M-Code" + Str$(CNC_gcode.m) + " is not supported"
	 End Select
	 CNC_gcode.m = notset

End Sub

Function mill_compile (Editfrm, UseZ As Integer) As Integer

Dim b As Integer
Dim k As Integer
Dim mult As Single


	
'Outhandle is already valid
    CurrentFeed = -1
    
    PromptEngrave = False
    
    mill_compile = False
    
    screen.MousePointer = 11    'busy
    SetUpStatus "Cyber Mill Compiler"
    Quit = False
    buffer = ""
	
    UseZcopy = UseZ
    
    CNCfrm(Editfrmdat(Editfrm).Frmno).EditFunc.Caption = "Copy"       'Get copy of program
    
    
    dirbyte = 0
    progend = False
    rev = False:  firstcut = True
    
    Home
    
    mult = 100 / CNCfrm(Editfrmdat(Editfrm).Frmno).Table1.Rows
    'For LineNum = 1 To CNCfrm(Editfrmdat(Editfrm).Frmno).Table1.Rows
    LineNum = 1
    Do
	If LineNum <= CNCfrm(Editfrmdat(Editfrm).Frmno).Table1.Rows Then
	    showprogress (LineNum * 100) / CNCfrm(Editfrmdat(Editfrm).Frmno).Table1.Rows
	    LineNum = Get_Millgcode(LineNum)
	    If LineNum = 0 Then
		Quit = True
	    Else
		compileline         'May mod linenum
	    End If
	    LineNum = LineNum + 1
	    If Quit Then
		CNCfrm(Editfrmdat(Editfrm).Frmno).Table1.RowIndex = LineNum
		Unload StatusDlg
		screen.MousePointer = 0
		Exit Function
	    End If
	Else
	    Exit Do
	End If
    Loop Until progend

    SaveByte (255)              'End of file marker
    PurgeBuffer
    
    Unload StatusDlg
    screen.MousePointer = 0
    
    mill_compile = True
End Function

Private Sub opentmpfile ()

rev = True

tmpptr = 0
ReDim tmpfile(1024)

'tmpfile = FreeFile
'Open "wal.tmp" For Binary Access Read Write As tmpfile



End Sub

Private Sub PurgeBuffer ()

If buffer <> "" Then
    Put #outhandle, LOF(outhandle) + 1, buffer
    buffer = ""
End If

End Sub

Private Sub savebuffer ()
	 
	 Dim b As Integer
	 Dim k As Long
	 'Transfer temp to main file

	 rev = False
	 
	 'Get #tmpfile, 1, b
	 'If (b And 4) = 4 Then b = b - 4 Else b = b + 4
	 'If (b And 2) = 2 Then b = b - 2 Else b = b + 2
	 'savebyte (b)
	 
	 b = tmpfile(0)
	 If (b And 4) = 4 Then b = b - 4 Else b = b + 4
	 If (b And 2) = 2 Then b = b - 2 Else b = b + 2
	 SaveByte (b)

	 'For k = LOF(tmpfile) - 5 To 1 Step -6
	 ' Get #tmpfile, k, b: savebyte b
	 ' Get #tmpfile, , b: savebyte b
	 ' Get #tmpfile, , b: savebyte b
	 'Next

	 For k = tmpptr - 3 To 1 Step -3
	    b = tmpfile(k): SaveByte b
	    b = tmpfile(k + 1): SaveByte b
	    b = tmpfile(k + 2): SaveByte b
	 Next
	 Erase tmpfile
	 
	' CNC_gcode.x = LastDesX: CNC_gcode.y = LastDesY
	 
	 'Close tmpfile
	 'Kill "wal.tmp"
	 
End Sub

Private Sub SaveByte (dat As Integer)

Dim byte As String * 1

	If rev Then            'save to buffer for reverse later
	    'Put #tmpfile, , dat
	    If tmpptr > UBound(tmpfile) Then
		ReDim Preserve tmpfile(tmpptr + 1024)
	    End If
	    tmpfile(tmpptr) = dat: tmpptr = tmpptr + 1
	Else                    'save direct in compiled data table
	    'byte = Chr$(dat)
	    'Put #outhandle, , byte
	    
	    buffer = buffer + Chr$(dat)
	    'If Len(buffer$) = 1024 Then Put #outhandle, , buffer$: buffer$ = ""
	End If
	 
End Sub

Private Sub saveword (dat)
	 
'6502 vesion save MSB first - CHECK WHY

	 SaveByte (dat Mod 256)
	 SaveByte (Fix(dat / 256))

'    If rev Then            'save to buffer for reverse later
'        Put #tmpfile, , dat
'    Else                    'save direct in compiled data table
'        Put #outhandle, , dat
'    End If

End Sub

Private Sub send_z (dz As Integer)
	
	If dz <> 0 Then
	If Not UseZcopy Then   'Move Z first
		SaveByte (16)
		saveword (0)
		saveword (0)
		saveword Abs(dz)

		If DesZ = z_down Then                    'Pause first time Z is down
		If firstcut Then
			SaveByte (128 + 64 + 32)
			SaveByte (10)
			firstcut = False
		End If
		End If
	Else
		SaveByte 64
		saveword Abs(dz)
	End If
	'cz = CNC_gcode.z
	End If

	
	


End Sub

Private Sub SetDirection (X, y, z)

Dim b As Integer

	b = 128
	If X = 0 Then
	    If (dirbyte And 132) = 132 Then b = b Or 4      'Keep same as last time
	ElseIf X > 0 Then
	    b = b Or 4      'x +ve
	End If
	
	If y = 0 Then
	    If (dirbyte And 130) = 130 Then b = b Or 2      'Keep same as last time
	ElseIf y > 0 Then
	    b = b Or 2      'y +ve
	End If
	
	If z = 0 Then
	    If (dirbyte And 129) = 129 Then b = b Or 1      'Keep same as last time
	ElseIf z > 0 Then
	    b = b Or 1     'CNC_gcode.z +ve
	End If
	
	
	'If dirbyte <> b Then
	    SaveByte (b)
	    dirbyte = b
	'End If

	'If B = 128 Then MsgBox "Direction byte!"

End Sub

Sub showprogress (i As Integer)
    
    Static txt$
    Static progress
    Dim position As Integer

    position = (i \ 5) * 5
    
    If (position > progress) Or (i = 0) Then
	progress = position
	StatusDlg.Picture2.Cls
	StatusDlg.Picture2.Line (0, 0)-((position * (StatusDlg.Picture2.ScaleWidth / 100)), StatusDlg.Picture2.ScaleHeight), QBColor(4), BF
	txt$ = Format$(CLng(position)) + "%"
	StatusDlg.Picture2.CurrentX = (StatusDlg.Picture2.ScaleWidth - StatusDlg.Picture2.TextWidth(txt$)) \ 2
	StatusDlg.Picture2.CurrentY = (StatusDlg.Picture2.ScaleHeight - StatusDlg.Picture2.TextHeight(txt$)) \ 2
	StatusDlg.Picture2.Print txt$
	BitBlt StatusDlg.Picture1.hDC, 0, 0, StatusDlg.Picture2.ScaleWidth, StatusDlg.Picture2.ScaleHeight, StatusDlg.Picture2.hDC, 0, 0, SRCCOPY
    End If




End Sub

