Option Explicit
DefInt A-Z

Dim buffer As String
Dim dirbyte As Integer

Dim CurX As Integer
Dim curz As Integer

Dim lastx As Integer
Dim LastZ As Integer

Const RoughFeed = 3
Const FinishFeed = 3

Const RoughSpin = 3
Const FinishSpin = 9

'Const Xzero% = 51.5 * mmtosteps
'Const Zzero% = 70.3 * mmtosteps

Global Xzero%   '= 43.3 * mmtosteps
Global Zzero%       '= 79 * mmtosteps

'Global Xstock As Integer
'Global Zstock As Integer

'Type tooloffset
'     x As Integer
'     z As Integer
'End Type
'
'
'Global tooloff() As tooloffset

Private Sub AbsFastMove (ByVal Desx As Integer, ByVal DesZ As Integer)
Dim dx As Integer
Dim dz As Integer

'lastx = Desx            'Take note
'LastZ = DesZ

'Desx = Xzero - Desx     'Add on tool offsets
'DesZ = Zzero - DesZ

dx = Desx - CurX
dz = DesZ - curz

If (dx = 0) And (dz = 0) Then Exit Sub

SetDirection dx, dz

SaveByte (16)
saveword Abs(dx)
saveword Abs(dz)

CurX = Desx
curz = DesZ

End Sub

Private Sub End_Unload ()

m5                  'Stop Spindle
AbsFastMove 0, 0
m69                 'Open vice


End Sub

Private Sub FastMove (ByVal Desx As Integer, ByVal DesZ As Integer)
         
Dim dx As Integer
Dim dz As Integer

lastx = Desx            'Take note
LastZ = DesZ

Desx = Xzero - Desx     'Add on tool offsets
DesZ = Zzero - DesZ

dx = Desx - CurX
dz = DesZ - curz

If (dx = 0) And (dz = 0) Then Exit Sub

SetDirection dx, dz

SaveByte (16)
saveword Abs(dx)
saveword Abs(dz)

CurX = Desx
curz = DesZ

End Sub

Private Sub feed (ByVal Desx As Integer, ByVal DesZ As Integer)

'FastMove Desx, DesZ

Dim dx As Integer
Dim dz As Integer


lastx = Desx            'Take note
LastZ = DesZ

Desx = Xzero - Desx     'Add on tool offsets
DesZ = Zzero - DesZ

dx = Desx - CurX
dz = DesZ - curz

'MsgBox Format$(dx) + " " + Format$(dz)

If Desx < 0 Then
'
End If

If DesZ < 0 Then
'
End If

If (dx = 0) And (dz = 0) Then Exit Sub

SetDirection dx, dz

If dx >= 0 Then
    If dx <> 0 Then SaveByte 65: saveword Abs(dx)      'Feed X in
    If dz <> 0 Then SaveByte 64: saveword Abs(dz)      'Traverse
Else
    If dz <> 0 Then SaveByte 64: saveword Abs(dz)        'Traverse
    If dx <> 0 Then SaveByte 65: saveword Abs(dx)        'Feed X in
End If

CurX = Desx
curz = DesZ

End Sub

Private Sub feedrate (Spd)
    SaveByte (128 + 64 + 32)        'Set Feedrate
    SaveByte (7)
    
    SaveByte (Lathe_feedrates(Spd) Mod 256)
    SaveByte (Fix(Lathe_feedrates(Spd)) / 256)
    
    SaveByte (Lathe_feedrates(Spd) Mod 256)
    SaveByte (Fix(Lathe_feedrates(Spd)) / 256)
        
    'i = 65551 - (600000 * Sqr(2) / (100 * (Lathe_feedrates(0))))
    'savebyte (i Mod 256)
    'savebyte (Fix(i / 256))

End Sub

Sub front (k)
         'save number with k 1's in front justified
         Select Case k
          Case 0
                   SaveByte (0)
          Case 1
                   SaveByte (&H80)
                   'SaveByte (1)
          Case 2
                   SaveByte (&H88)
          Case 3
                   SaveByte (&HA4)
          Case 4
                   SaveByte (&HAA)
          Case 5
                   SaveByte (&HEA)
          Case 6
                   SaveByte (&HEE)
          Case 7
                   SaveByte (&HFE)
          Case 8
                   SaveByte (&HFF)
          Case Else
                    MsgBox "Bugger"
         End Select
End Sub

Private Sub home_Load ()
Dim i As Long
    
    SaveByte (192)
    CurX = 0
    curz = 0

    m68                             'Close Vice

    feedrate RoughFeed
    SpinRate RoughSpin


End Sub

Private Sub Interp (ByVal Desx As Integer, ByVal DesZ As Integer)

Dim dx As Integer
Dim dz As Integer

lastx = Desx            'Take note
LastZ = DesZ

Desx = Xzero - Desx     'Add on tool offsets
DesZ = Zzero - DesZ
         
dx = Desx - CurX
dz = DesZ - curz

If (dx = 0) And (dz = 0) Then Exit Sub

SetDirection dx, dz
SaveByte 0
front Abs(dx)
front Abs(dz)


CurX = Desx
curz = DesZ


End Sub

Private Sub m0 ()
    SaveByte (128 + 64 + 32)
    SaveByte (10)
End Sub

Private Sub m5 ()       'Spindle OFF
    SaveByte (128 + 64 + 32)
    SaveByte (3)
End Sub

Private Sub m68 ()
         SaveByte (128 + 64 + 32)
         SaveByte (4)
End Sub

Private Sub m69 ()               'unclamp
    SaveByte (128 + 64 + 32)
    SaveByte (5)
End Sub

Function OldLathe_compile (Editfrm As Integer) As Integer

Dim i As Integer

'Dim Xstock As Integer
'Dim zstock As Integer

'CNCfrm(CNCfrmNo).EditFunc.Caption = "Copy"       'Get copy of program

Lathe_Graphic_exe

'OPTIONS.XStock = 15 * mmtosteps
'OPTIONS.ZStock = 60 * mmtosteps

'For i = UBound(radii) To 0 Step -1
'    If radii(i).radius = 9000 Then radii(i).radius = 0 Else Exit For
'Next
'
'For i = UBound(radii) To 0 Step -1
'    If radii(i).radius = 9000 Then radii(i).radius = OPTIONS.XStock
'Next


'Xzero = 51.5 * mmtosteps
'ZZero = 70.3 * mmtosteps


    screen.MousePointer = 11    'busy
    SetUpStatus "Cyber Lathe Compiler"
    buffer = ""
        
    dirbyte = 0
    
    home_Load
    FastMove OPTIONS.xstock, OPTIONS.zstock         'Move cutter to end of stock
    m0
    
Dim x As Integer
Dim z As Integer
Dim ZStart As Integer
    
    For x = OPTIONS.xstock To 66 Step -66
        z = 0
        For i = OPTIONS.zstock To 0 Step -1
            If x > radii(i).radius + 66 Then      'Rough cut to within ?
                If z = 0 Then ZStart = i
                z = z + 1
            Else
                If z <> 0 Then GoSub RoughCut
            End If
        Next
        i = 0
        GoSub RoughCut
    Next

    feedrate FinishFeed
    SpinRate FinishSpin
    
    
    FastMove OPTIONS.xstock, OPTIONS.zstock         'Move cutter to end of stock
    feed radii(OPTIONS.zstock).radius, OPTIONS.zstock
    
    PurgeBuffer
    
    z = OPTIONS.zstock
    While z <> 0
        i = z - 8: If i < 0 Then i = 0              'Try to move upto 8 Steps in Z
        Select Case Abs(radii(i).radius - radii(z).radius)
        Case Is <= 8                                'If X change would be less than 8, do it
            z = i
            Interp radii(z).radius, z
        Case Else                                   'Else move Z by 1
            i = z - 1: If i < 0 Then i = 0
            z = i
            feed radii(z).radius, z
        End Select
    Wend
    
    End_Unload
    
    SaveByte (255)              'End of file marker
    PurgeBuffer
    
    Unload StatusDlg
    screen.MousePointer = 0
    
    OldLathe_compile = True


Erase radii

                
Exit Function


Dim Safex As Integer

RoughCut:
    'Z=0 at chuck face
    'X=0 object centre line
    
    If z <> 0 Then
'        MsgBox Format$(x) + " " + Format$(i)
        
        
        Safex = lastx + 66              'Withdraw by at least .5mm
        For z = LastZ To OPTIONS.zstock
            If Safex < radii(z).radius + 66 Then Safex = radii(z).radius + 66
        Next
        
        
        'FastMove Safex, LastZ
        FastMove Safex, ZStart      '8032 will always come out first, in last
        feed x, ZStart
        
        'FastMove Xstock, zstock
        'FastMove Xstock, ZStart
        
        'If (x + 66) < Xstock Then feed x + 66, ZStart
        
        feed x, i
        z = 0
    End If
    Return




End Function

Private Sub PurgeBuffer ()

If buffer <> "" Then
    Put #outhandle, LOF(outhandle) + 1, buffer
    buffer = ""
End If

End Sub

Private Sub SaveByte (dat As Integer)
    buffer = buffer + Chr$(dat)
End Sub

Private Sub saveword (dat)
         
SaveByte (dat Mod 256)
SaveByte (Fix(dat / 256))

End Sub

Private Sub SetDirection (dx, dz)

Dim b As Integer

b = 128
If dx = 0 Then
    If (dirbyte And 130) = 130 Then b = b Or 2      'Keep same as last time
ElseIf dx > 0 Then
    b = b Or 2      'x +ve
End If

If dz = 0 Then
    If (dirbyte And 129) = 129 Then b = b Or 1      'Keep same as last time
ElseIf dz > 0 Then
    b = b Or 1
End If
        
'If dirbyte <> b Then
    SaveByte (b)
    dirbyte = b
'End If
        

End Sub

Private Sub SpinRate (Spd)

    SaveByte (128 + 64 + 32)
    SaveByte (1)
    SaveByte Lathe_spindle_spd(Spd)


End Sub

