Attribute VB_Name = "MENUS"
Option Explicit
Option Compare Text
DefInt A-Z

Sub CellMenuClick(Index As Integer)
Dim i As Integer
Dim j As Integer
Dim k As Integer

    Select Case Index
    Case 0 To 10
        newdevtype = Index + 2
        devaddr = -1
        Select Case newdevtype
            Case neptune1, neptune2
                TurboSel.Show 1
            Case Mentor, serpent1, serpent2, xboard                     'Mentor and serpent  can be on either RJ45 or Turbo Board
                devselad.Show 1                                 'devaddr will be returned
            Case CNCMill, cnclathe, Gryphon, Kestrel    'Only on RJ45 board
                rj45sel.Show 1                                  'devaddr will be returned
        End Select
        If devaddr <> -1 Then
            Select Case newdevtype
                Case serpent1
                    If devaddr >= 16 Then newdevtype = SerpentEC1
                Case serpent2
                    If devaddr >= 16 Then newdevtype = SerpentEC2
            End Select
            
            makeeditpane newdevtype, -1
            redraw_devicegrid
        End If
    
    Case 11     'Seperator
    
    Case 12 To 18
        Index = Index - 11          'WC_CONV = 1
        If Index = wc_part Then
            If findsubdev(1, WC_CONV) > UBound(subdev) Then
                MsgBox "No Conveyors Available To Mount Dispenser On"
                Exit Sub
            End If
        End If
        
        edit_subdev = -1
        Do
            edit_subdev = edit_subdev + 1
            If edit_subdev > UBound(subdev) Then ReDim Preserve subdev(edit_subdev)
        Loop Until subdev(edit_subdev).devtype = 0
        
        subdev(edit_subdev).devtype = Index
        editsubdev

    Case 20
        i = Definitions.Table1.RowIndex
        If MsgBox("Are you sure that you want to delete " + Definitions.Table1.ColumnText(1), vbQuestion + vbYesNo) = vbYes Then
            If devref(i) < 128 Then
                For j = 0 To UBound(subdev) 'Go through sub devices and delete refs to device
                    For k = 0 To 5
                        If subdev(j).Control_device(k) = devref(i) + 1 Then clearsubdev (j)
                    Next
                Next
                delete_device devref(i)
            Else
                clearsubdev (devref(i) - 128)
            End If
            redraw_devicegrid
        End If

    Case 21
        i = Definitions.Table1.RowIndex
        edit_subdev = devref(i) - 128
        editsubdev


    Case 23
        If MsgBox("Are you sure you want to delete all sub-devices", vbYesNo Or vbQuestion) = vbYes Then
            ReDim subdev(0)
            subdev(0).devtype = WC_UNDEF
            redraw_devicegrid
        End If

    End Select







End Sub

Sub FileMenuClick(Index As Integer)

Dim sample As String * 1024
Dim i As Integer
Dim j As Integer
Dim inifile$
Dim a$

Select Case Index
Case 0
    If Not CancelChanges() Then
        clear_all
        wallidat(0).Name = "Main"    'load in main walli edit pane
        walli_ed(0).Caption = "Main"
        redraw_devicegrid
    End If

Case 1  'open
    openwalli True

Case 2  'Save Project
    i = saveall(False)

Case 3 'Saveas
    i = saveall(True)

Case 5      'Load
    loadgrid

Case 6      'Save
    i = Savegrid(False)

Case 7       'Save as
    i = Savegrid(True)

Case 8  'Import
    Select Case CNCfrmDat(CNCfrmNo).devtype
    Case CNCMill
        TimerForm.CMDialog1.DefaultExt = ""
        TimerForm.CMDialog1.Filename = import_filename$
'        TimerForm.CMDialog1.flags = &H400& Or &H1000& Or &H4& Or &H800&
        TimerForm.CMDialog1.flags = cdlOFNExtensionDifferent Or _
                                                            cdlOFNFileMustExist Or _
                                                            cdlOFNHideReadOnly Or _
                                                            cdlOFNPathMustExist
                                                            
        
        TimerForm.CMDialog1.Filter = "HPGL|*.prt;*.prn;*.plt|NC Drill|*.0??;*.drl;*.ht?|DXF|*.dxf|ASCII|*.txt;*.lst"
        
        a$ = import_filename$
        Do
            i = InStr(a$, ".")
            If i <> 0 Then a$ = right$(a$, Len(a$) - i)
        Loop Until i = 0
        Select Case a$
            Case "PRT", "PRN", "PLT"
                TimerForm.CMDialog1.FilterIndex = 1
            Case "DXF"
                TimerForm.CMDialog1.FilterIndex = 3
            Case "TXT", "LST"
                TimerForm.CMDialog1.FilterIndex = 4
            Case Else
                TimerForm.CMDialog1.FilterIndex = 2
        End Select
        
        
        TimerForm.CMDialog1.DialogTitle = "File Import For " + CNCfrmDat(CNCfrmNo).Name
        On Local Error GoTo file_err
        TimerForm.CMDialog1.ShowOpen        'Action = 1
        On Local Error GoTo 0
        import_filename$ = UCase$(TimerForm.CMDialog1.Filename)      'Import_filename$ is global

        outhandle = FreeFile
        Open TimerForm.CMDialog1.Filename For Binary Access Read As outhandle
        Get #outhandle, , sample            'Read part of file
        Close #outhandle
        If InStr(sample, "SECTION") <> 0 Then
            DXF_MillImport
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "IN") <> 0 Then
            hpgl_millimport
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "M48") <> 0 Then
            ncdrill_import
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "G0") <> 0 Then
            ascii_import
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "D0") <> 0 Then
            Gerber_Import
            DoEvents
            i = Savegrid(True)
        Else
            MsgBox "Unknown format"
        End If
    
    
    Case cnclathe
        TimerForm.CMDialog1.DefaultExt = ""
        TimerForm.CMDialog1.Filename = import_filename$
'        TimerForm.CMDialog1.flags = &H400& Or &H1000& Or &H4& Or &H800&
        TimerForm.CMDialog1.flags = cdlOFNExtensionDifferent Or _
                                                            cdlOFNFileMustExist Or _
                                                            cdlOFNHideReadOnly Or _
                                                            cdlOFNPathMustExist

        TimerForm.CMDialog1.Filter = "DXF|*.dxf|HPGL|*.prt;*.prn;*.plt|ASCII|*.txt;*.lst"

        a$ = import_filename$
        Do
            i = InStr(a$, ".")
            If i <> 0 Then a$ = right$(a$, Len(a$) - i)
        Loop Until i = 0
        Select Case a$
            Case "PRT", "PRN", "PLT"
                TimerForm.CMDialog1.FilterIndex = 2
            Case "TXT", "LST"
                TimerForm.CMDialog1.FilterIndex = 3
            Case Else
                TimerForm.CMDialog1.FilterIndex = 1
        End Select


        TimerForm.CMDialog1.DialogTitle = "File Import For " + CNCfrmDat(CNCfrmNo).Name
        On Local Error GoTo file_err
        TimerForm.CMDialog1.ShowOpen        'Action = 1
        On Local Error GoTo 0
        import_filename$ = UCase$(TimerForm.CMDialog1.Filename)      'Import_filename$ is global

        outhandle = FreeFile
        Open TimerForm.CMDialog1.Filename For Binary Access Read As outhandle
        Get #outhandle, , sample            'Read part of file
        Close #outhandle
        
        If InStr(sample, "SECTION") <> 0 Then
            DXF_LatheImport
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "IN") <> 0 Then
            HPGL_LATHEimport
            DoEvents
            i = Savegrid(True)
        ElseIf InStr(sample, "G0") <> 0 Then
            ascii_import
            DoEvents
            i = Savegrid(True)
        Else
            MsgBox "Unknown format"
        End If

    End Select

Case 9  'Export
    ascii_export

Case 11  'PRINT
    printall


Case 12  'PRINTER setup
'    TimerForm.CMDialog1.flags = &H8& Or &H40&
    TimerForm.CMDialog1.flags = cdlPDNoPageNums Or _
                                                        cdlPDPrintSetup
    TimerForm.CMDialog1.PrinterDefault = True
    On Local Error Resume Next
    TimerForm.CMDialog1.ShowPrinter          'Action = 5
    On Local Error GoTo 0

Case 14  'RS232
    i = Shell("control ports", 1)

Case 16 'Colour
    ColourFrm.Show 1


Case 17 'FONT
'    TimerForm.CMDialog1.flags = &H42001          ' &H400& Or &H200& Or
    TimerForm.CMDialog1.flags = cdlCFTTOnly Or _
                                                        cdlCFLimitSize Or _
                                                        cdlCFScreenFonts
    
    TimerForm.CMDialog1.Min = 1
    TimerForm.CMDialog1.Max = 24

    TimerForm.CMDialog1.FontName = walfont.FontName
    TimerForm.CMDialog1.FONTBOLD = walfont.FONTBOLD
    TimerForm.CMDialog1.fONTITALIC = walfont.fONTITALIC
    TimerForm.CMDialog1.FontSize = walfont.FontSize
    
    On Local Error GoTo file_err
    TimerForm.CMDialog1.ShowFont        'Action = 4
    On Local Error GoTo 0
    walfont.FontName = TimerForm.CMDialog1.FontName
    walfont.FONTBOLD = TimerForm.CMDialog1.FONTBOLD
    walfont.fONTITALIC = TimerForm.CMDialog1.fONTITALIC
    walfont.FontSize = TimerForm.CMDialog1.FontSize
    setfonts

Case 18 'END
    Unload WALLI3

Case Else

End Select

file_err:
    Exit Sub


End Sub

Sub HelpMenuClick(Index As Integer)
Dim PID As PromIdType
Dim ver, a$, LF$, i
Dim returnedstring$, DEFAULT$


'0 = contents
'1
'2 = About
'3 = bugs

LF = Chr$(10)

Select Case Index
Case 0
    winhelp ByVal WALLI3.hWnd, ByVal App.HelpFile, ByVal HELP_CONTENTS, CLng(0)

Case 1
    winhelp ByVal WALLI3.hWnd, ByVal App.HelpFile, ByVal HELP_PARTIALKEY, ByVal ""

Case 2
    winhelp ByVal WALLI3.hWnd, ByVal App.HelpFile, ByVal HELP_HELPONHELP, CLng(0)
    
Case 4                                              'Command Summary
    TimerForm.CMDialog1.HelpFile = App.HelpFile
    TimerForm.CMDialog1.HelpCommand = HELP_CONTEXT
    TimerForm.CMDialog1.HelpContext = 600
    TimerForm.CMDialog1.Action = 6

Case 5                                              'Learning Walli
    TimerForm.CMDialog1.HelpFile = App.HelpFile
    TimerForm.CMDialog1.HelpCommand = HELP_CONTEXT
    TimerForm.CMDialog1.HelpContext = 500
    TimerForm.CMDialog1.Action = 6

Case 7
    About.Show 1
    'a$ = "Walli3 Version 1.000 18/12/94" + CRLF
    'a$ = "Walli3 Version 1.001 4/1/95" + LF
    'a$ = "Walli3 V1.003 20/2/95" + LF
    'a$ = "Walli3 Version 1.004 (23/2/94) " + Chr$(169) + " Cybernetic Applications 1994-5" + LF + LF

Case 8
    'MsgBox "RJ45 timeout " + Str$(readminrj()), 64
    For i = 0 To UBound(EditFrmDat)
        Select Case EditFrmDat(i).devtype
        Case Gryphon, CNCMill, cnclathe, Kestrel, SerpentEC1, SerpentEC2
            readId i, PID
            If PID.PromVer = "????" Then
                MsgBox "EPROM Version " + PID.PromVer, vbInformation, "About " + EditFrmDat(i).Name
            Else
                MsgBox "EPROM Version " + PID.PromVer + " " + PID.PromDate + Chr$(13) + "Checksum " + Hex$(PID.PromCsum) + Chr$(13) + PID.PromCopyright, vbInformation, "About " + EditFrmDat(i).Name
            End If
        End Select
    Next
    

End Select


End Sub

Sub Next_DeviceClick()
Dim i As Integer

'Set focus to next Edit form

If TypeOf WALLI3.ActiveForm Is WALLI_EDfrmtype Then
    i = 0
ElseIf TypeOf WALLI3.ActiveForm Is RobotFrmType Then
    i = RobotFrmDat(RobotFrmNo).devno + 1
ElseIf TypeOf WALLI3.ActiveForm Is MillFormType Then
    i = CNCfrmDat(CNCfrmNo).devno + 1
ElseIf TypeOf WALLI3.ActiveForm Is XboardformType Then
    i = XFrmdat(XFrmNo).devno + 1
End If

Do
    If i > UBound(EditFrmDat) Then i = 0
    Select Case EditFrmDat(i).devtype
        Case 0
            i = i + 1
        Case xboard
            XFrm(EditFrmDat(i).Frmno).WindowState = 0
            XFrm(EditFrmDat(i).Frmno).SetFocus
            Exit Do
        Case CNCMill, cnclathe
            CNCfrm(EditFrmDat(i).Frmno).WindowState = 0
            CNCfrm(EditFrmDat(i).Frmno).SetFocus
            Exit Do
        Case Else
            RobotFrm(EditFrmDat(i).Frmno).WindowState = 0
            RobotFrm(EditFrmDat(i).Frmno).SetFocus
            Exit Do
    End Select
Loop

End Sub

Sub Next_WalliClick()

Dim i As Integer
i = WalliFrmNo

Do
    i = i + 1
    If i > UBound(walli_ed) Then i = 0
Loop Until wallidat(i).Used = True

walli_ed(i).WindowState = 0
walli_ed(i).SetFocus

End Sub

Sub optMenuClick(Index As Integer)

Dim Robotcntrl  As robotCNTRLtype

    OptMenuChecked(Index) = Not OptMenuChecked(Index)
    
    
    Select Case Index
    Case 0                                  '0 = Graphics On/Off
        If OptMenuChecked(0) Then
            setupgraphics
        Else
            Unload drawing(0)
            Unload drawing(1)
            graphicsdevno = -1
        End If
    
    Case 1
        If OptMenuChecked(1) Then setupworkcellstatus Else Unload STATUSFRM      '1 = Workcell status
    Case 2
        If OptMenuChecked(2) Then Load WalliCue Else Unload WalliCue
    Case 3
        If OptMenuChecked(3) Then Load MillCue Else Unload MillCue
    Case 4
        If OptMenuChecked(4) Then Load LatheCue Else Unload LatheCue

    Case 6
        READDATA CNCfrmDat(CNCfrmNo).devno, Robotcntrl
        If Robotcntrl.online = 0 Then
            MsgBox CNCfrmDat(CNCfrmNo).Name + " is not connected", vbInformation, CNCfrmDat(CNCfrmNo).Name + " Control Panel"
        Else
            Select Case CNCfrmDat(CNCfrmNo).devtype
            Case CNCMill
                MillManual.Show 1
            Case cnclathe
                LatheManual.Show 1
            End Select

        End If

    Case 7
        READDATA CurrentDevno, Robotcntrl
        If Robotcntrl.online = 0 Then
            MsgBox EditFrmDat(CurrentDevno).Name + " is not connected", vbInformation, "Test Workcell"
        Else
            Select Case Robotcntrl.devtype
                Case Mentor, Mentor + &H100, Mentor + &H200, Mentor + &H300, serpent1, serpent2, neptune1, neptune2
                    MentorWC.Show 1
                Case xboard, xboard + &H100
                    XWC.Show 1
                Case Else
                    MillWC.Show 1
            End Select
        End If
    
    Case 9
        setfonts

    End Select

End Sub

Sub printall()

Dim i As Integer
Dim j As Integer
Dim h As Integer
Dim sh As Integer

    Screen.MousePointer = 11    'busy
    
    If walli_level = 1 Then
        Select Case EditFrmDat(0).devtype
            Case 0, xboard
                
            Case CNCMill, cnclathe
                CNCfrm(0).EDITFUNC.Caption = "Print"
                Printer.EndDoc

            Case Else
                RobotFrm(0).EDITFUNC.Caption = "Print"
                Printer.EndDoc
        End Select

    Else
        Load PrintWal
        
        sh = PrintWal.Height - PrintWal.ScaleHeight
        PrintWal.celldef(0).Caption = "Cell Definition"
        j = 1
        For i = 0 To UBound(EditFrmDat)
            Select Case EditFrmDat(i).devtype
                Case 0, CNCMill, cnclathe, xboard
                Case Else
                    Load PrintWal.celldef(j)
                    PrintWal.celldef(j).Caption = EditFrmDat(i).Name
                    j = j + 1
            End Select
        Next
        
        For i = 0 To UBound(EditFrmDat)
            Select Case EditFrmDat(i).devtype
                Case CNCMill, cnclathe
                    Load PrintWal.celldef(j)
                    PrintWal.celldef(j).Caption = EditFrmDat(i).Name
                    j = j + 1
            End Select
        Next
        
        For i = 0 To UBound(wallidat)
            Load PrintWal.celldef(j)
            PrintWal.celldef(j).Caption = "Walli - " + wallidat(i).Name
            j = j + 1
        Next
    
        h = PrintWal.celldef(0).Top
                                
        For i = 0 To j - 1
            PrintWal.celldef(i).Top = h
            PrintWal.celldef(i).Visible = True
            h = h + PrintWal.celldef(i).Height
        Next
            
        h = h + PrintWal.celldef(0).Height
        PrintWal.command1(0).Top = h: PrintWal.command1(1).Top = h: PrintWal.command1(2).Top = h
        PrintWal.Height = sh + PrintWal.command1(0).Top + PrintWal.command1(0).Height * 1.5
        
        PrintWal.Show 1
    End If
    Screen.MousePointer = 0

End Sub

Sub rOBMENUClick(Index As Integer)
    Select Case EditFrmDat(Index).devtype
    Case 0
    Case CNCMill, cnclathe
        CNCfrm(EditFrmDat(Index).Frmno).WindowState = 0
        CNCfrm(EditFrmDat(Index).Frmno).SetFocus
    Case xboard
        XFrm(EditFrmDat(Index).Frmno).WindowState = 0
        XFrm(EditFrmDat(Index).Frmno).SetFocus
    Case Else
        RobotFrm(EditFrmDat(Index).Frmno).WindowState = 0
        RobotFrm(EditFrmDat(Index).Frmno).SetFocus
    End Select

End Sub

Sub SetUpStatus(title$)

Load StatusDlg
StatusDlg.Caption = title$
centreform StatusDlg
showprogress 0
SetWindowPos StatusDlg.hWnd, HWND_TOP, 0, 0, 0, 0, &H53&  'Bring window to top    13
DoEvents

End Sub

Sub Tidy_WinClick(Index As Integer)
Dim i As Integer


Select Case Index
Case 0
    WALLI3.Arrange 3
    For i = 0 To Forms.count - 1
        Setwindowsize Forms(i)
    Next

Case 3      'Mentor
    set_editfocus       'sets focus to first/only edit form

Case 6      'Main
    walli_ed(0).WindowState = 0
    walli_ed(0).SetFocus

Case 8
    Definitions.WindowState = 0
    Definitions.SetFocus
End Select


End Sub

