Option Explicit
Option Compare Binary
DefInt A-Z
Dim help()  As String

Sub setup ()

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim l As Integer
Dim A$
Dim t$

ReDim help(Tok_End)
ReDim walliline(Tok_End)

help$(TOK_WA) = "WAit <n02> seconds"
help$(TOK_WD) = "Wait until Digital sensor <n02> is <o>"
help$(TOK_ID) = "If Digital sensor <n02> is <o> then goto <a08>"
help$(TOK_IS) = "If analog Sensor <n02> is between <n04> and <n04> then goto <a08>"

help$(TOK_PR) = "PRint <a30>"
help$(TOK_RE) = "REmark <a30>"
help$(TOK_MO) = "MOve <l> through position <a08> to position <a08>"

help$(TOK_SP) = "Start <l> Program <a30>"
help$(TOK_CP) = "Continue <l> Program"

help$(TOK_JX) = "Jog <l> X axis <n06> mm"
help$(TOK_JY) = "Jog <l> Y axis <n06> mm"
help$(TOK_JZ) = "Jog <l> Z axis <n06> mm"

help$(TOK_IP) = "If <l> program has Paused then goto <a08>"
help$(TOK_IE) = "If <l> program has Ended then goto <a08>"
help$(TOK_WP) = "Wait until <l> program has Paused"
help$(TOK_WE) = "Wait until <l> program has Ended"

help$(TOK_WR) = "Write to Rs232 port <n02> <a30>"
help$(TOK_OR) = "Output to Rs232 port <n02> <a30>"
help$(TOK_FR) = "Flush Rs232 port <n02>"

help$(TOK_SC) = "Start Conveyor <n02>"
help$(TOK_HC) = "Halt Conveyor <n02>"
help$(TOK_MC) = "Move Conveyor <n02> <n04> mm"

help$(TOK_ST) = "Start index Table <n02>"
help$(TOK_HT) = "Halt index Table <n02>"
help$(TOK_MT) = "Move index Table <n02> to <n03> deg"
help$(TOK_IT) = "Increment index Table <n02> through <n04> deg"

help$(TOK_GW) = "Gauge Width <n02>"
help$(TOK_GH) = "Gauge Height <n02>"

help$(TOK_CW) = "Calibrate digital Width gauge <n02>"
help$(TOK_CH) = "Calibrate digital Height gauge <n02>"

help$(TOK_FO) = "FOr <a02> = <n05> to <n05>"
help$(TOK_NE) = "NExt <a02>"
help$(TOK_GS) = "Goto Subroutine <a08>"
help$(TOK_RS) = "Return from Subroutine"
help$(TOK_SS) = "Start parallel Subroutine <a30>"
help$(TOK_ES) = "End parallel Subroutine <a30>"

help$(TOK_SF) = "Set Flag <n02>"
help$(TOK_RF) = "Reset Flag <n02>"
help$(TOK_WF) = "Wait until Flag <n02> is <o>"

help$(TOK_RC) = "Reset Counter <n02>"
help$(TOK_CO) = "COunter <n02> <+> <n02>"

help$(TOK_IC) = "If Counter <n02> <=> <n03> then goto <a08>"
help$(TOK_cC) = "Copy Counter <n02> into counter <n02>"
help$(TOK_aC) = "Add Counter <n02> into counter <n02>"


help$(TOK_cF) = "Copy Flag <n02> into flag <n02>"


help$(TOK_IW) = "If Width gauge <n02> is between <n04> and <n04> then goto <a08>"
help$(TOK_IH) = "If Height gauge <n02> is between <n04> and <n04> then goto <a08>"

help$(TOK_DP) = "Dispense Part <n02>"

help$(TOK_IA) = "If <l> Axis <n02> is between <n04> and <n04> then goto <a08>"

help$(TOK_GO) = "GOto <a08>"

help$(TOK_SO) = "Set <l> Output <n02>"
help$(TOK_RO) = "Reset <l> Output <n02>"

help$(TOK_IF) = "If Flag <n02> is <o> then goto <a08>"
help$(TOK_IR) = "If Rs232 port <n02> = <a08> then goto <a08>"

help$(TOK_dm) = "Display Message <a30>"

help$(TOK_tr) = "TRace <o>"

help$(Tok_Cr) = "Configure Rs232 port <n02> <a08>"

help$(Tok_EL) = "ELse"
help$(Tok_EI) = "End If"

help$(Tok_SL) = "Start Log file to <a12>  row <n02>"
help$(Tok_LO) = "LOg <=> <n02> to column <n02>"
help$(Tok_LF) = "Log <l> Feedback starting at column <n02>"



For i = 0 To Tok_End
    'get capitals from help$(i) - put them  in .token
     A$ = ""
     t$ = ""
     k = 0
     l = 0
     For j = 1 To Len(help$(i))
        Select Case Mid$(help$(i), j, 1)
            Case "A" To "Z"
                t$ = t$ + Mid$(help$(i), j, 1)
                A$ = A$ + Mid$(help$(i), j, 1)
                If Len(A$) = 2 Then
                    walliline(i).token = A$
                End If
            Case "<"
                walliline(i).Text(k) = UCase$(t$)
                k = k + 1
                t$ = ""
            Case ">"
                Select Case Left$(t$, 1)
                Case "n"                                'numeric field
                    walliline(i).entrytype(l) = 1 + Val(Right$(t$, 2))
                Case "a"
                    walliline(i).entrytype(l) = 100 + Val(Right$(t$, 2))       'Alpha field
                Case "l"
                        walliline(i).entrytype(l) = 666     'device list
                Case "o"
                        walliline(i).entrytype(l) = 667     'on/off list
                Case "+"
                        walliline(i).entrytype(l) = 668     '+,- list
                Case "="
                        walliline(i).entrytype(l) = 669     '=/</> list
                Case "f"
                        walliline(i).entrytype(l) = 670     'flag list

                Case Else
                    walliline(i).entrytype(l) = 999      'other
                End Select
                
                l = l + 1
                t$ = ""
            Case Else
                t$ = t$ + Mid$(help$(i), j, 1)
        End Select
     Next
     walliline(i).Text(k) = UCase$(t$)
Next
Erase help

End Sub

