Option Explicit
Option Compare Text
DefInt A-Z


Const X4 = 152#     'Column to axis 1 centre
Const Y4 = 0#

Const l5 = 250#      'Really 248.9          '400 for serp 2

Const L6 = 30#
Const L7 = 21.1
Const L8 = 31.8

Const l11 = 150#     'Really 147.3           '250 for serp2

Const L12 = 20#
Const L13 = 22.7
Const L14 = 25.4

Const R0 = 12000#
Const R1 = 12000#
Const R2 = 1000#                '2000 at motor - pulley ratio 2:1


'Const R0 = 7678     '4095 * 360 / 192         'Steps / rev
'Const R1 = 6410     '4095 * 360 / 230
'Const R2 = 3276     '4095 * 360 / 450


'Const F0 = 3300
'Const F1 = 4200
'Const F2 = 625                  'allow 450deg = 1250 steps


'Dim initialised
Dim A1  As Single
Dim A2 As Single
Dim A3 As Single
Dim A5 As Single
Dim A6 As Single
Dim A7 As Single
Dim A17 As Single
Dim A18 As Single

Dim L9 As Single
Dim L10 As Single
Dim L15 As Single
Dim L16 As Single
Dim L17 As Single
Dim L18 As Single

Private Sub DrawAxes ()
    
Dim xaxis As Integer
Dim yaxis As Integer


    drawing(1).Picture1.DrawStyle = 2
    
    For yaxis = -100 To 600 Step 100
        moveto drawing(1).Picture1.hDC, 0, (yaxis - GraphicsFrmDat.y1(1)) * yscale(1)
        LineTo drawing(1).Picture1.hDC, (GraphicsFrmDat.x2(1) - GraphicsFrmDat.x1(1)) * xscale(1), (yaxis - GraphicsFrmDat.y1(1)) * yscale(1)
    Next

    For xaxis = -500 To 500 Step 100
        moveto drawing(1).Picture1.hDC, (xaxis - GraphicsFrmDat.x1(1)) * xscale(1), 0
        LineTo drawing(1).Picture1.hDC, (xaxis - GraphicsFrmDat.x1(1)) * xscale(1), (GraphicsFrmDat.Y2(1) - GraphicsFrmDat.y1(1)) * yscale(1)
    Next
    drawing(1).Picture1.DrawStyle = 0

    
    
    
    
    moveto drawing(1).Picture1.hDC, 0, (-GraphicsFrmDat.y1(1)) * yscale(1)
    LineTo drawing(1).Picture1.hDC, (GraphicsFrmDat.x2(1) - GraphicsFrmDat.x1(1)) * xscale(1), (-GraphicsFrmDat.y1(1)) * yscale(1)
    
    moveto drawing(1).Picture1.hDC, (-GraphicsFrmDat.x1(1)) * xscale(1), 0
    LineTo drawing(1).Picture1.hDC, (-GraphicsFrmDat.x1(1)) * xscale(1), (GraphicsFrmDat.Y2(1) - GraphicsFrmDat.y1(1)) * yscale(1)
    

End Sub

Private Sub InitVars (Robno As Integer)

'If Not initialised Then
'    initialised = True

    'Axis 1 is 2*L10 x L11+L12+L13
    
    A1 = Atn(L8 / L6)
    A2 = Atn(L8 / L7)
    A3 = pi / 2 - Position(Robno).F(0) * 2 * pi / R0

    A5 = Atn(L14 / L12)
    A6 = Atn(L14 / L13)

    A7 = (Position(Robno).F(1) * pi * 2) / R1

    L9 = Sqr(L8 * L8 + L6 * L6)
    L10 = Sqr(L7 * L7 + L8 * L8)

    L15 = Sqr(L12 * L12 + L14 * L14)
    L16 = Sqr(L13 * L13 + L14 * L14)

    L17 = Sqr(12 * 12 + 16 * 16)
    L18 = Sqr(43 * 43 + 16 * 16)
    A17 = Atn(16 / 12)
    A18 = Atn(16 / 43)
    
    'A19 = F2 * 2 * pi / R2 + pi
    
'End If


End Sub

Sub SerpentEC1_drawing (redrawpic)
Dim lppoints()  As pointapi_Single

ReDim lppoints(3)

Dim RobotCntrl  As robotCNTRLtype

Dim changed As Integer


Dim i As Integer

Dim a As Single
Dim A4 As Single
Dim A8 As Single


Dim X5 As Single, Y5 As Single
Dim x6 As Single, y6 As Single
Dim x7 As Single, y7 As Single
Dim x8 As Single, y8 As Single
Dim x9 As Single, y9 As Single
Dim x10 As Single, y10 As Single
Dim x11 As Single, y11 As Single
Dim x12 As Single, y12 As Single
Dim x13 As Single, y13 As Single
Dim x14 As Single, y14 As Single
Dim x15 As Single, y15 As Single
Dim x16 As Single, y16 As Single
Dim x17 As Single, y17 As Single
Dim x18 As Single, y18 As Single

Dim Robno As Integer
Robno = EditFrmDat(GraphicsDevNo).Frmno
InitVars Robno

If redrawpic Then changed = True

READDATA GraphicsDevNo, RobotCntrl
For i = 0 To 5
    RobotFrmDat(Robno).F(i) = RobotCntrl.Feedback(i)
    If RobotFrmDat(Robno).lastgfb(i) <> RobotFrmDat(Robno).F(i) Then
        RobotFrmDat(Robno).lastgfb(i) = RobotFrmDat(Robno).F(i)
        changed = True
    End If
Next

If changed = True Then
    A4 = A3 + (RobotFrmDat(Robno).F(0) * 2 * pi) / R0
    A8 = (RobotFrmDat(Robno).F(1) * 2 * pi) / R1 - A7
    
    X5 = X4 + l5 * Sin(A4): Y5 = Y4 + l5 * Cos(A4)                'Axis 2 Centre
    x6 = X4 - L9 * Sin(A4 + A1): y6 = Y4 - L9 * Cos(A4 + A1)
    x7 = X5 + L10 * Sin(A4 - A2): y7 = Y5 + L10 * Cos(A4 - A2)
    x8 = X5 + L10 * Sin(A4 + A2): y8 = Y5 + L10 * Cos(A4 + A2)
    x9 = X4 - L9 * Sin(A4 - A1): y9 = Y4 - L9 * Cos(A4 - A1)
    
    
    a = A4 + A8
    x10 = X5 + l11 * Sin(a): y10 = Y5 + l11 * Cos(a)                'Axis 3 centre
    x11 = X5 - L15 * Sin(a + A5): y11 = Y5 - L15 * Cos(a + A5)
    x12 = x10 + L16 * Sin(a - A6): y12 = y10 + L16 * Cos(a - A6)
    x13 = x10 + L16 * Sin(a + A6): y13 = y10 + L16 * Cos(a + A6)
    x14 = X5 - L15 * Sin(a - A5): y14 = Y5 - L15 * Cos(a - A5)
    
    'a = A19 + (RobotFrmDat(RobNo).F(2) * 2 * Pi) / R2
    a = (RobotCntrl.Feedback(2) - Position(Robno).F(2)) * 2 * pi / R2 - (pi / 2)
    
    x15 = x10 - L17 * Sin(a + A17): y15 = y10 - L17 * Cos(a + A17)
    x16 = x10 + L18 * Sin(a - A18): y16 = y10 + L18 * Cos(a - A18)
    x17 = x10 + L18 * Sin(a + A18): y17 = y10 + L18 * Cos(a + A18)
    x18 = x10 - L17 * Sin(a - A17): y18 = y10 - L17 * Cos(a - A17)
    

    
    cleardrawing (0)                                            'Clear port, draw axes elevation
    
    lppoints(0).x = -29: lppoints(0).y = 0
    lppoints(1).x = 29: lppoints(1).y = 610
    drawrectangle 0, 0, lppoints()                'drawing 0, axis 0  Column
    
    lppoints(0).x = -48: lppoints(0).y = 300
    lppoints(1).x = 182: lppoints(1).y = 440
    drawrectangle 0, 0, lppoints()                'drawing 0, axis 0  Clamp
    
    lppoints(0).x = SMALLEST(x6, x7, x8, x9): lppoints(0).y = 317
    lppoints(1).x = biggEST(x6, x7, x8, x9): lppoints(1).y = 423
    drawrectangle 0, 1, lppoints()                'drawing 0, axis 1
    
    lppoints(0).x = SMALLEST(x11, x12, x13, x14): lppoints(0).y = 334
    lppoints(1).x = biggEST(x11, x12, x13, x14): lppoints(1).y = 406
    drawrectangle 0, 2, lppoints()                'drawing 0, axis 2
    
    If RobotFrmDat(Robno).F(3) = 0 Then
        lppoints(0).x = x10 - 8: lppoints(0).y = 90
        lppoints(1).x = x10 + 8: lppoints(1).y = 90 + 490
        drawrectangle 0, 3, lppoints()                'drawing 0, axis 3
        
        lppoints(0).x = x10 - 19: lppoints(0).y = 35
        lppoints(1).x = x10 + 19: lppoints(1).y = 35 + 55
        drawrectangle 0, 4, lppoints()                'drawing 0, axis 4
        
        If RobotFrmDat(Robno).F(4) = 1 Then
            lppoints(0).x = x10 - 10: lppoints(0).y = 35
            lppoints(1).x = x10 - 16: lppoints(1).y = 35
            lppoints(2).x = x10 - 16: lppoints(2).y = 0
            lppoints(3).x = x10 - 10: lppoints(3).y = 0
            drawpolygon 0, 4, lppoints()
        
            lppoints(0).x = x10 + 10: lppoints(0).y = 35
            lppoints(1).x = x10 + 16: lppoints(1).y = 35
            lppoints(2).x = x10 + 16: lppoints(2).y = 0
            lppoints(3).x = x10 + 10: lppoints(3).y = 0
            drawpolygon 0, 4, lppoints()
        Else
            lppoints(0).x = x10 - 10: lppoints(0).y = 35
            lppoints(1).x = x10 - 16: lppoints(1).y = 35
            lppoints(2).x = x10 - 26: lppoints(2).y = 0
            lppoints(3).x = x10 - 20: lppoints(3).y = 0
            drawpolygon 0, 4, lppoints()
        
            lppoints(0).x = x10 + 10: lppoints(0).y = 35
            lppoints(1).x = x10 + 16: lppoints(1).y = 35
            lppoints(2).x = x10 + 26: lppoints(2).y = 0
            lppoints(3).x = x10 + 20: lppoints(3).y = 0
            drawpolygon 0, 4, lppoints()
        End If
    Else
        lppoints(0).x = x10 - 8: lppoints(0).y = 190
        lppoints(1).x = x10 + 8: lppoints(1).y = 190 + 490
        drawrectangle 0, 3, lppoints()                'drawing 0, axis 3
        
        lppoints(0).x = x10 - 19: lppoints(0).y = 135
        lppoints(1).x = x10 + 19: lppoints(1).y = 135 + 55
        drawrectangle 0, 4, lppoints()                'drawing 0, axis 4
        
        If RobotFrmDat(Robno).F(4) = 1 Then
            lppoints(0).x = x10 - 10: lppoints(0).y = 135
            lppoints(1).x = x10 - 16: lppoints(1).y = 135
            lppoints(2).x = x10 - 16: lppoints(2).y = 100
            lppoints(3).x = x10 - 10: lppoints(3).y = 100
            drawpolygon 0, 4, lppoints()
        
            lppoints(0).x = x10 + 10: lppoints(0).y = 135
            lppoints(1).x = x10 + 16: lppoints(1).y = 135
            lppoints(2).x = x10 + 16: lppoints(2).y = 100
            lppoints(3).x = x10 + 10: lppoints(3).y = 100
            drawpolygon 0, 4, lppoints()
        Else
            lppoints(0).x = x10 - 10: lppoints(0).y = 135
            lppoints(1).x = x10 - 16: lppoints(1).y = 135
            lppoints(2).x = x10 - 26: lppoints(2).y = 100
            lppoints(3).x = x10 - 20: lppoints(3).y = 100
            drawpolygon 0, 4, lppoints()
        
            lppoints(0).x = x10 + 10: lppoints(0).y = 135
            lppoints(1).x = x10 + 16: lppoints(1).y = 135
            lppoints(2).x = x10 + 26: lppoints(2).y = 100
            lppoints(3).x = x10 + 20: lppoints(3).y = 100
            drawpolygon 0, 4, lppoints()
        End If
    End If
    displaydrawing 0
    
    cleardrawing (1)                                            'Clear port, draw axes plan

    DrawAxes

    
    
    lppoints(0).x = -51: lppoints(0).y = -48
    lppoints(1).x = 51: lppoints(1).y = 182
    drawrectangle 1, 0, lppoints()                'drawing 1, axis 0
    
    lppoints(0).y = x6: lppoints(0).x = y6
    lppoints(1).y = x7: lppoints(1).x = y7
    lppoints(2).y = x8: lppoints(2).x = y8
    lppoints(3).y = x9: lppoints(3).x = y9
    drawpolygon 1, 1, lppoints()               'drawing 1, axis 1

    lppoints(0).y = x11: lppoints(0).x = y11
    lppoints(1).y = x12: lppoints(1).x = y12
    lppoints(2).y = x13: lppoints(2).x = y13
    lppoints(3).y = x14: lppoints(3).x = y14
    drawpolygon 1, 2, lppoints()               'drawing 1, axis 2
    
    lppoints(0).y = x15: lppoints(0).x = y15
    lppoints(1).y = x16: lppoints(1).x = y16
    lppoints(2).y = x17: lppoints(2).x = y17
    lppoints(3).y = x18: lppoints(3).x = y18
    drawpolygon 1, 3, lppoints()               'drawing 1, axis 3
    
    displaydrawing 1
    
End If
End Sub

Function SerpentEC1_InverseK (Robno As Integer, d() As Integer, xyz As XYZtype, soln As Integer) As Integer

Dim r          As Single
Dim phi0       As Single
Dim phi1       As Single
Dim y          As Single

Dim alpha As Single
Dim beta As Single
Dim gamma As Single

    
    SerpentEC1_InverseK = False
    
    'InitVars Robno
    
    'XYZ.r = CSng(Feedback(2) - position(Robno).F(2)) * 360 / R2
        
'cos A = (bb + cc - aa) / 2bc
    y = xyz.y - X4
    r = (xyz.x ^ 2 + y ^ 2) ^ .5
    
    Select Case r
        Case Is < l5 - l11, Is > l5 + l11
            r = Val(Format$(r, "#.00"))
    End Select
    
    
    Select Case r
        Case Is < l5 - l11, Is > l5 + l11
              Exit Function
        Case Else
            If y = 0 Then
                alpha = pi / 2
            Else
                alpha = Atn(xyz.x / y)
            End If
            beta = ACOS((r ^ 2 + l5 ^ 2 - l11 ^ 2) / (2 * r * l5))
            gamma = ACOS((l5 ^ 2 + l11 ^ 2 - r ^ 2) / (2 * l5 * l11))
            
            If xyz.x > 0 Then
                If y < 0 Then
                    Select Case soln
                    Case 0
                        phi0 = pi + alpha - beta
                        phi1 = (pi - gamma)
                    Case Else
                        phi0 = pi + alpha + beta
                        phi1 = gamma - pi
                    End Select
                Else
                    Select Case soln
                    Case 0
                        phi0 = alpha - beta
                        phi1 = pi - gamma
                    Case Else
                        phi0 = alpha + beta
                        phi1 = gamma - pi
                    End Select
                End If
            Else
                If y < 0 Then
                    Select Case soln
                    Case 0
                        phi0 = -(pi - alpha - beta)
                        phi1 = -(pi - gamma)
                    Case Else
                        phi0 = -(pi - alpha + beta)
                        phi1 = -(gamma)
                    End Select
                Else
                    Select Case soln
                    Case 0
                        phi0 = alpha - beta
                        phi1 = pi - gamma
                    Case Else
                        phi0 = alpha + beta
                        phi1 = gamma - pi
                    End Select
                End If
            End If
            
            d(0) = (Position(Robno).F(0) + ((phi0 * R0) / (2 * pi)))
            d(1) = (Position(Robno).F(1) + ((phi1 * R1) / (2 * pi)))
            
            Select Case d(0)
            
            Case 0 To 6600
            
            Case Else
                Exit Function
            End Select
            
            
            Select Case d(1)
            
            Case 0 To 7900
            
            Case Else
                Exit Function
            End Select

    
            d(2) = Position(Robno).F(2) + xyz.r * R2 / 360
            If d(2) < 0 Then d(2) = 0
            If d(2) > 1250 Then d(2) = 1250
            
            'D(2) = CSng(XYZ.r + position(Robno).F(2) * 360) / R2
            If xyz.Z = 0 Then d(3) = 0 Else d(3) = 1
            If xyz.G = 0 Then d(4) = 0 Else d(4) = 1

            SerpentEC1_InverseK = True
            
    End Select


End Function

Sub SerpentEC1_Xyz (Robno As Integer, redrawpic As Integer)

Dim RobotCntrl  As robotCNTRLtype
Dim LastPosition As xyz
Dim xyz As XYZtype

    
If Not redrawpic Then LastPosition = Position(Robno)
    
    READDATA RobotFrmDat(Robno).devNo, RobotCntrl
    
    SerpentEC1_Xyzsums Robno, RobotCntrl.Feedback(), xyz
    
    Position(Robno).x = Format$(xyz.x, "##0")
    Position(Robno).y = Format$(xyz.y, "##0")
    Position(Robno).Z = Format$(xyz.Z, "##0")
    Position(Robno).Rot = Format$(xyz.r, "##0")
    If xyz.G = 0 Then Position(Robno).Grip = "Open" Else Position(Robno).Grip = "Shut"
    
    If LastPosition.x <> Position(Robno).x Then XYZdata(Robno).Table1.RefreshColumn = 1
    If LastPosition.y <> Position(Robno).y Then XYZdata(Robno).Table1.RefreshColumn = 2
    If LastPosition.Z <> Position(Robno).Z Then XYZdata(Robno).Table1.RefreshColumn = 3
    If LastPosition.Rot <> Position(Robno).Rot Then XYZdata(Robno).Table1.RefreshColumn = 5
    If LastPosition.Grip <> Position(Robno).Grip Then XYZdata(Robno).Table1.RefreshColumn = 6

End Sub

Sub SerpentEC1_Xyzsums (Robno As Integer, Feedback() As Integer, xyz As XYZtype)

Dim a  As Single
Dim A4 As Single
Dim A8 As Single

Dim X5 As Single
Dim Y5 As Single
    
    
    A4 = ((Feedback(0) - Position(Robno).F(0)) * 2 * pi) / R0
    A8 = ((Feedback(1) - Position(Robno).F(1)) * 2 * pi) / R1
    
    X5 = Y4 + l5 * Sin(A4): Y5 = X4 + l5 * Cos(A4)                'Axis 2 Centre
    a = A4 + A8
    
    xyz.x = X5 + l11 * Sin(a)                'Axis 3 centre
    xyz.y = Y5 + l11 * Cos(a)
    
    xyz.r = CSng(Feedback(2) - Position(Robno).F(2)) * 360 / R2
    
    xyz.Z = 100 * Feedback(3)
    
    If Feedback(4) = 0 Then xyz.G = 0 Else xyz.G = 1


End Sub

