Option Explicit
Option Compare Text
DefInt A-Z


Dim DDElog

Function debug_walli () As Integer

'scan through all walli forms and check syntax

Dim Walfrm       As Integer
Dim error_walfrm As Integer
Dim walline      As Integer
Dim i            As Long
Dim dummy        As Integer
Dim start        As Integer
Dim finish       As Integer
Dim d            As Integer
Dim r_no         As Integer
Dim Fail$
Dim A$
Dim blk As Integer

debug_walli = False

For d = 0 To UBound(Walli_ed)
    Wallidat(d).gs_sp = 0
Next

For d = 0 To 26
    ForVar(d).jump = -1
    ForVar(d).Value = 0
Next

For d = 1 To 4
    SerialPort(d).Value = ""
Next


setupworkcellstatus     'Side effect reads walli form data into array wcopy


For Walfrm = 0 To UBound(Walli_ed)                             'get access to walli line number
    If Wallidat(Walfrm).used Then
        Wallidat(Walfrm).active_wallisub = False
        Walli_ed(Walfrm).Table1.MarqueeStyle = 5         'No Highlight
        Wallidat(Walfrm).STAGE = 0
        For walline = 1 To Walli_ed(Walfrm).Table1.Rows
            'Select Case wcopy(Walfrm, walline).tok
            '    Case tok_ne
                    wcopy(Walfrm, walline).GotoField = 9999  'rub out "next" jump
            '    End Select
        Next
    End If
Next


For Walfrm = 0 To UBound(Walli_ed)
    If Wallidat(Walfrm).used Then
        For walline = 1 To Walli_ed(Walfrm).Table1.Rows
            Tok = wcopy(Walfrm, walline).Tok
            Select Case Tok

            Case Tok_Ch     'Check gauge is digital
                i = findsubdev(Val(wcopy(Walfrm, walline).field1), WC_DigVgag)     'search through subdevices
                If i > UBound(SubDev) Then
                    Fail$ = "Height gauge " + wcopy(Walfrm, walline).field1 + " not defined"
                    GoTo exit_failed
                ElseIf SubDev(i).DevType <> WC_DigVgag Then
                    Fail$ = "May only calibrate digital height gauges"
                    GoTo exit_failed
                End If

            Case Tok_Cw     'Check gauge is digital
                i = findsubdev(Val(wcopy(Walfrm, walline).field1), WC_DigWgag)     'search through subdevices
                If i > UBound(SubDev) Then
                    Fail$ = "Width gauge " + wcopy(Walfrm, walline).field1 + " not defined"
                    GoTo exit_failed
                ElseIf SubDev(i).DevType <> WC_DigWgag Then
                    Fail$ = "May only calibrate digital width gauges"
                    GoTo exit_failed
                End If

            Case Tok_gw, TOK_iw
                i = findsubdev(Val(wcopy(Walfrm, walline).field1), WC_Wgag)     'search through subdevices
                If i > UBound(SubDev) Then
                    Fail$ = "Width gauge " + wcopy(Walfrm, walline).field1 + " not defined"
                    GoTo exit_failed
                End If
                If Tok = TOK_iw Then A$ = wcopy(Walfrm, walline).field4: GoSub setgoto
            
            Case Tok_gh, TOK_IH
                i = findsubdev(Val(wcopy(Walfrm, walline).field1), WC_vgag)     'search through subdevices
                If i > UBound(SubDev) Then
                    Fail$ = "Height gauge " + wcopy(Walfrm, walline).field1 + " not defined"
                    GoTo exit_failed
                End If
                If Tok = TOK_IH Then A$ = wcopy(Walfrm, walline).field4: GoSub setgoto

            Case Tok_SL
                TimerForm.DDEText.LinkTopic = wcopy(Walfrm, walline).field1          'DDE file
                DDElog = Val(wcopy(Walfrm, walline).field2)
        
            TimerForm.DDEText.LinkMode = 0         'none
            TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C1"
            On Local Error GoTo Debug_DDE_Error
            TimerForm.DDEText.LinkMode = 2         'none
            TimerForm.DDEText.LinkRequest
            TimerForm.DDEText.LinkMode = 0         'none
            
            
            A$ = RTrim$(LTrim$(TimerForm.DDEText.Text))
            If Left$(A$, 1) <> Chr$(13) Then
                Fail$ = "Cell " & TimerForm.DDEText.LinkItem & " Not Clear"
                GoTo exit_failed
            End If
            
            
            Case Tok_Lo, Tok_LF
            
            Case Tok_El, Tok_EI
            
            Case tok_so, tok_ro

            Case tok_dm, TOK_tr

            
            Case tok_wr, tok_cr, tok_fr   'Write rs232
            
            Case Tok_IR
                A$ = wcopy(Walfrm, walline).field3: GoSub setgoto
            
            
            Case 0, TOK_PR, Tok_Re, TOK_WA, tok_rs, Tok_SF, TOK_RF, TOK_WF       'blank line print comment
            Case tok_co, tok_rc, tok_cc, tok_cf, TOK_ac

            Case tok_IC 'if counter
                A$ = wcopy(Walfrm, walline).field4: GoSub setgoto

            Case Tok_IF 'if Flag
                A$ = wcopy(Walfrm, walline).field3: GoSub setgoto


                
            Case TOK_GO, tok_gs                'search cuurent grid for label
                A$ = wcopy(Walfrm, walline).field1: GoSub setgoto
                
            Case tok_Fo                     'FOR
                                                'go down from here to find next
            A$ = wcopy(Walfrm, walline).field1
            For i = walline + 1 To Walli_ed(Walfrm).Table1.Rows
                If wcopy(Walfrm, i).Tok = tok_ne Then
                    If A$ = wcopy(Walfrm, i).field1 Then Exit For
                End If
            Next
            If i = Walli_ed(Walfrm).Table1.Rows + 1 Then
                Fail$ = "For without Next"
                GoTo exit_failed
'            Else
                '0 Token
                '1 Variable
                '2 Start
                '3 Finish'4 Finished jump vector
'
'                If wcopy(Walfrm, i).Gotofield = 9999 Then
'                    wcopy(Walfrm, i).Gotofield = walline    'store jump back in next
'                Else
'                    fail$ = "Nested For"
'                    GoTo exit_failed
'                End If
'                wcopy(Walfrm, walline).Gotofield = i + 1    'Finish of FOR line after Next
            End If
'
            Case tok_ne                     'NEXT
'                If wcopy(Walfrm, walline).Gotofield = 9999 Then
'                    fail$ = "Next without For"
'                    GoTo exit_failed
'               End If
            
            
            Case tok_Wd               'wait until sensor
                                      'check sensor is valid

               i = findsubdev(Val(wcopy(Walfrm, walline).field1), WC_DigSENS)     'search through subdevices for sensor
                If i > UBound(SubDev) Then
                    Fail$ = "Digital Sensor " + wcopy(Walfrm, walline).field1 + " not defined"
                    GoTo exit_failed
                End If
 
            
            Case tok_ID               'iF sensor
                                      'check sensor is valid
                i = findsubdev(Val(wcopy(Walfrm, walline).field1), WC_DigSENS)     'search through subdevices for sensor
                If i > UBound(SubDev) Then
                    Fail$ = "Digital Sensor " + wcopy(Walfrm, walline).field1 + " not defined"
                    GoTo exit_failed
                End If
                A$ = wcopy(Walfrm, walline).field3: GoSub setgoto
            
            
            Case Tok_IS
                i = findsubdev(Val(wcopy(Walfrm, walline).field1), WC_AnaSENS)     'search through subdevices for sensor
                If i > UBound(SubDev) Then
                    Fail$ = "Analog Sensor " + wcopy(Walfrm, walline).field1 + " not defined"
                    GoTo exit_failed
                End If
                A$ = wcopy(Walfrm, walline).field4: GoSub setgoto

                
    
            
            Case TOK_SS     'START PAR sub
                For i = 0 To UBound(Walli_ed)
                    If Wallidat(i).used Then
                        If Wallidat(i).name = wcopy(Walfrm, walline).field1 Then
                            wcopy(Walfrm, walline).field2 = Str$(i)    'save for execution phase
                            If i = Walfrm Then
                               Fail$ = "Recursion not supported"
                               GoTo exit_failed
                           End If
                           Exit For
                       End If
                   End If
               Next
               If i > UBound(Walli_ed) Then
                   Fail$ = "Parallel subroutine not defined"
                   GoTo exit_failed
               End If

        Case Tok_Es
                For i = 0 To UBound(Walli_ed)
                    If Wallidat(i).used Then
                        If Wallidat(i).name = wcopy(Walfrm, walline).field1 Then
                            wcopy(Walfrm, walline).field2 = Format$(i)    'save for execution phase
                            'If i = walfrm Then
                            '   fail$ = "Recursion not supported"
                            '   GoTo exit_failed
                           'End If
                           Exit For
                       End If
                   End If
               Next
               If i > UBound(Walli_ed) Then
                   Fail$ = "Parallel subroutine not defined"
                   GoTo exit_failed
               End If





            Case tok_IA     'If axis
                d = EditFrmdat(Val(wcopy(Walfrm, walline).field1)).Frmno
                Select Case RobotFrmDat(d).DevType
                Case 0, CNCMill, CNCLathe, Xboard
                   Fail$ = "Device not defined"
                   GoTo exit_failed
                Case Else
               End Select

               i = Val(wcopy(Walfrm, walline).field2)   'Axis no
               If i < 0 Or i > 8 Then Fail$ = "Axis not valid": GoTo exit_failed

              i = Val(wcopy(Walfrm, walline).field3)    'Lower limit
              i = Val(wcopy(Walfrm, walline).field4)    ' Upper limit
              A$ = wcopy(Walfrm, walline).field5: GoSub setgoto
              

            Case TOK_Mo     'MOVE ROBOT
                d = EditFrmdat(Val(wcopy(Walfrm, walline).field1)).Frmno
                
                Select Case RobotFrmDat(d).DevType
                Case 0, CNCMill, CNCLathe, Xboard
                    Fail$ = "Device not defined"
                    GoTo exit_failed
                Case Else
                End Select
                
                RobotFrm(d).EDITFUNC = "Copy"
                start = 0
                finish = 0
                If IsNumeric(wcopy(Walfrm, walline).field2) Then
                    blk = 0
                    For i = 1 To RobotFrm(d).Table1.Rows
                        If rcopy(low(i), high(i)).LineName <> "" Then
                            blk = blk + 1
                            If blk = Val(wcopy(Walfrm, walline).field2) Then
                                start = i
                                Exit For
                            End If
                        End If
                    Next
                    If start = 0 Then
                        Fail$ = "Failed to find line " + wcopy(Walfrm, walline).field2
                        GoTo exit_failed
                    End If
                    wcopy(Walfrm, walline).field4 = Str$(start)
                ElseIf Len(wcopy(Walfrm, walline).field2) = 1 Then
                    wcopy(Walfrm, walline).field4 = wcopy(Walfrm, walline).field2
                Else
                    For i = 1 To RobotFrm(d).Table1.Rows
                        If rcopy(low(i), high(i)).LineName = wcopy(Walfrm, walline).field2 Then
                            start = i
                            Exit For
                        End If
                    Next
                    If start = 0 Then
                        Fail$ = "Failed to find line " + wcopy(Walfrm, walline).field2
                        GoTo exit_failed
                    End If
                    wcopy(Walfrm, walline).field4 = Str$(start)
                End If
                
                If IsNumeric(wcopy(Walfrm, walline).field3) Then
                    blk = 0
                    For i = 1 To RobotFrm(d).Table1.Rows
                        If rcopy(low(i), high(i)).LineName <> "" Then
                            blk = blk + 1
                            If blk = Val(wcopy(Walfrm, walline).field3) Then
                                finish = i
                                Exit For
                            End If
                        End If
                    Next
                    If finish = 0 Then
                        Fail$ = "Failed to find line " + wcopy(Walfrm, walline).field3
                        GoTo exit_failed
                    End If
                    If start > finish Then
                            Fail$ = "Start > Fin"
                            GoTo exit_failed
                    Else
                            For i = finish + 1 To RobotFrm(d).Table1.Rows       'bump on through to end of block
                               If rcopy(low(i), high(i)).LineName <> "" Then Exit For
                            Next
                            finish = i
                    End If
                    wcopy(Walfrm, walline).field5 = Str$(finish - 1)'non inclusive
                
                ElseIf Len(wcopy(Walfrm, walline).field3) = 1 Then
                    wcopy(Walfrm, walline).field5 = wcopy(Walfrm, walline).field3
                ElseIf wcopy(Walfrm, walline).field3 = "" Then
                    For i = start + 1 To RobotFrm(d).Table1.Rows
                        If rcopy(low(i), high(i)).LineName <> "" Then Exit For
                    Next
                    finish = i
                    wcopy(Walfrm, walline).field5 = Str$(finish - 1)'non inclusive
                Else
                    finish = 0
                    For i = 1 To RobotFrm(d).Table1.Rows
                        If rcopy(low(i), high(i)).LineName = wcopy(Walfrm, walline).field3 Then
                            finish = i
                            Exit For
                        End If
                    Next
                    If finish = 0 Then
                        Fail$ = "Failed to find line " + wcopy(Walfrm, walline).field3
                        GoTo exit_failed
                    End If
                    If start > finish Then
                            Fail$ = "Start > Finish"
                            GoTo exit_failed
                    Else
                            For i = finish + 1 To RobotFrm(d).Table1.Rows       'bump on through to end of block
                               If rcopy(low(i), high(i)).LineName <> "" Then Exit For
                            Next
                            finish = i
                    End If
                    wcopy(Walfrm, walline).field5 = Str$(finish - 1)'non inclusive
                End If
                Erase rcopy

            
            
            Case TOK_SC, TOK_HC, TOK_mC         'Conveyors
            Case TOK_St, TOK_Ht, tok_mt, Tok_It        'Index Tables
            Case tok_dp     'Dispense Part



            Case tok_sp     'Start Mill program
                d = EditFrmdat(Val(wcopy(Walfrm, walline).field1)).Frmno
                Select Case CNCFrmDat(d).DevType
                Case CNCMill, CNCLathe
                Case Else
                    Fail$ = "Device not defined": GoTo exit_failed
                End Select

                A$ = wcopy(Walfrm, walline).field2
                If InStr(A$, ".") = 0 Then A$ = A$ + ".ncm"       'force an extension

                On Local Error GoTo file_error
                If Dir$(A$) = "" Then
                    Fail$ = "File not found": GoTo exit_failed
                End If
                On Local Error GoTo 0

            Case tok_cp, tok_we, tok_wp
                d = EditFrmdat(Val(wcopy(Walfrm, walline).field1)).Frmno
                Select Case CNCFrmDat(d).DevType
                Case CNCMill, CNCLathe
                Case Else
                    Fail$ = "Device not defined": GoTo exit_failed
                End Select

            Case tok_jx, tok_jy, tok_jz
                d = EditFrmdat(Val(wcopy(Walfrm, walline).field1)).Frmno
                Select Case CNCFrmDat(d).DevType
                Case CNCMill, CNCLathe
                Case Else
                    Fail$ = "Device not defined": GoTo exit_failed
                End Select
            
            Case Tok_IE, tok_IP
                d = EditFrmdat(Val(wcopy(Walfrm, walline).field1)).Frmno
                Select Case CNCFrmDat(d).DevType
                Case CNCMill, CNCLathe
                Case Else
                    Fail$ = "Device not defined": GoTo exit_failed
                End Select
                A$ = wcopy(Walfrm, walline).field2: GoSub setgoto

            Case Else
                Fail$ = "Unknown Command": GoTo exit_failed

            End Select

        
        Next
    End If
Next

    debug_walli = True
    Exit Function

    
exit_failed:
        screen.MousePointer = 0
        error_walfrm = Walfrm
        Walli_ed(error_walfrm).SetFocus
        Walli_ed(error_walfrm).Table1.RowIndex = walline
        Walli_ed(error_walfrm).Table1.MarqueeStyle = 2                'Highlight cell
        WalliErr Fail$
        debug_walli = False
        Exit Function


setgoto:
    If A$ = "" Then             'Block if  added 8/7/96
    '
    'search for else
    ' Else becomes GOTO line after EndIf


    Else
        i = 0
        Do
            i = i + 1
            If A$ = wcopy(Walfrm, i).LineName Then wcopy(Walfrm, walline).GotoField = i: Exit Do
        Loop Until i = Walli_ed(Walfrm).Table1.Rows
    
        If wcopy(Walfrm, walline).GotoField <> i Then
            Fail$ = "Failed to find line " + A$
            GoTo exit_failed
        End If
    End If
    
    Return


error_hand:
    If walline <> 0 Then
        walline = walline - 1
        Resume
    Else
        Resume Next
    End If


file_error:
    Fail$ = "Bad file name"
    GoTo exit_failed



Debug_DDE_Error:
    Fail$ = Error$ + Chr$(13) & "Topic : " & TimerForm.DDEText.LinkTopic & Chr$(13) & "Item : " & TimerForm.DDEText.LinkItem
    GoTo exit_failed

End Function

Function execute_walli (Walfrm As Integer) As Integer

Dim ErrorFile As Integer

Dim XYZ As XYZtype

Dim Nest As Integer
Dim Fail$
Dim start As Integer
Dim finish As Integer
Dim blk As Integer

Dim RobotCntrl  As robotCNTRLtype
Dim i As Integer
Dim J As Integer
'Dim q As Integer
Dim Var      As Integer
Dim Highlim    As Single
Dim LowLim     As Single
Dim EditFrm As Integer
Dim tmp As Long
Dim A$
'Dim n$
Dim ext$
        
execute_walli = True


Do
    Select Case wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).Tok
        Case 0, Tok_Re
            GoSub ForceNEXTLINE
        Case Else
            Exit Do
    End Select
    If Wallidat(Walfrm).active_wallisub = False Then Exit Function
Loop


If Traceon Then
    On Local Error GoTo MemErr
    If Wallidat(Walfrm).STAGE = 0 Then
        A$ = Format$(Now, "d/m,hh:mm:ss")        '& "," & Format$(Time$, "hh:mm:ss")
        A$ = A$ + "," + Left$(Wallidat(Walfrm).name + Space$(16), 16) + " "
        A$ = A$ + "," + wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).linetext
        
        Select Case wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).Tok
        Case TOK_IH
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            A$ = A$ + Chr$(9) + "- Value " + Format$(HeightGauge(i).Value)
        
        Case TOK_iw
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            A$ = A$ + Chr$(9) + "- Value " + Format$(WidthGauge(i).Value)

        End Select

        A$ = Trim$(A$)

        Trace.Trace.AddItem A$

        
        If Trace.Trace.ListCount = 1000 Then    'limit number or entries
            Trace.Trace.RemoveItem 0
        End If

        Trace.Trace.ListIndex = Trace.Trace.ListCount - 1


        ErrorFile = FreeFile
        Open app.Path + "\Walli3.trc" For Append As ErrorFile
        Print #ErrorFile, A$
        Close ErrorFile


    End If
    On Local Error GoTo 0
End If


Select Case wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).Tok

    Case Tok_SL
        TimerForm.DDEText.LinkTopic = wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1          'DDE file
        DDElog = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
        GoSub NextLine
    
    Case Tok_LF
        TimerForm.DDEText.LinkMode = 0         'none
        
        TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C1"
        TimerForm.DDEText.Text = Date$
        
        On Local Error GoTo DDE_Error
        
        TimerForm.DDEText.LinkMode = 2      'Manual
        TimerForm.DDEText.LinkPoke
        TimerForm.DDEText.LinkMode = 0       'none
        
        TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C2"
        TimerForm.DDEText.Text = Time$
        TimerForm.DDEText.LinkMode = 2      'Manual
        TimerForm.DDEText.LinkPoke
        TimerForm.DDEText.LinkMode = 0      'none
        
        

        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        READDATA EditFrm, RobotCntrl          'get latest copy'

        Select Case EditFrmdat(EditFrm).DevType
        Case MENTOR
            LowLim = 0: Highlim = 5
            Mentor_XYZsums EditFrm, RobotCntrl.Feedback(), XYZ
        Case GRYPHON, GryphonSlide
            LowLim = 0: Highlim = 5
            Gryphon_XYZsums EditFrm, RobotCntrl.Feedback(), XYZ
        Case Serpent1
            LowLim = 0: Highlim = 5
            Serpent1_Xyzsums EditFrm, RobotCntrl.Feedback(), XYZ
        Case SERPENT2
            LowLim = 0: Highlim = 5
            Serpent2_Xyzsums EditFrm, RobotCntrl.Feedback(), XYZ
        Case sERPENTEC1
            LowLim = 0: Highlim = 5
            SerpentEC1_Xyzsums EditFrm, RobotCntrl.Feedback(), XYZ
        Case sERPENTEC2
            LowLim = 0: Highlim = 5
            SerpentEC2_Xyzsums EditFrm, RobotCntrl.Feedback(), XYZ
        
        Case nEPTUNE1
            LowLim = 0: Highlim = 5
            XYZ.X = -9999
        Case Neptune2
            LowLim = 0: Highlim = 6
            XYZ.X = -9999

        Case kestrel
            LowLim = 0: Highlim = 5
            XYZ.X = -9999
        
        End Select




            For i = LowLim To Highlim
                TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C" & Format$(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) + i)
                TimerForm.DDEText.Text = Format$(RobotCntrl.Feedback(i))
                TimerForm.DDEText.LinkMode = 2      'Manual
                TimerForm.DDEText.LinkPoke
                TimerForm.DDEText.LinkMode = 0         'none
            Next

        If XYZ.X <> -9999 Then

            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) + Highlim + 1
            TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C" & Format$(i)
            TimerForm.DDEText.Text = Format$(XYZ.X)
            TimerForm.DDEText.LinkMode = 2      'Manual
            TimerForm.DDEText.LinkPoke
            TimerForm.DDEText.LinkMode = 0         'none

            i = i + 1
            TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C" & Format$(i)
            TimerForm.DDEText.Text = Format$(XYZ.y)
            TimerForm.DDEText.LinkMode = 2      'Manual
            TimerForm.DDEText.LinkPoke
            TimerForm.DDEText.LinkMode = 0         'none


            i = i + 1
            TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C" & Format$(i)
            TimerForm.DDEText.Text = Format$(XYZ.z)
            TimerForm.DDEText.LinkMode = 2      'Manual
            TimerForm.DDEText.LinkPoke
            TimerForm.DDEText.LinkMode = 0         'none


            i = i + 1
            TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C" & Format$(i)
            TimerForm.DDEText.Text = Format$(XYZ.E)
            TimerForm.DDEText.LinkMode = 2      'Manual
            TimerForm.DDEText.LinkPoke
            TimerForm.DDEText.LinkMode = 0         'none


            i = i + 1
            TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C" & Format$(i)
            TimerForm.DDEText.Text = Format$(XYZ.R)
            TimerForm.DDEText.LinkMode = 2      'Manual
            TimerForm.DDEText.LinkPoke
            TimerForm.DDEText.LinkMode = 0         'none

            i = i + 1
            TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C" & Format$(i)
            TimerForm.DDEText.Text = Format$(XYZ.G)
            TimerForm.DDEText.LinkMode = 2      'Manual
            TimerForm.DDEText.LinkPoke
            TimerForm.DDEText.LinkMode = 0         'none
    End If



        'TimerForm.DDEText.LinkMode = 2      'Manual
        'TimerForm.DDEText.LinkPoke
        'TimerForm.DDEText.LinkMode = 0         'none
        DDElog = DDElog + 1

        On Local Error GoTo 0

        GoSub NextLine


    
    
    Case Tok_Lo
        TimerForm.DDEText.LinkMode = 0         'none
        
        TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C1"
        TimerForm.DDEText.Text = Date$
        
        On Local Error GoTo DDE_Error
        
        TimerForm.DDEText.LinkMode = 2      'Manual
        TimerForm.DDEText.LinkPoke
        TimerForm.DDEText.LinkMode = 0       'none
        
        TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C2"
        TimerForm.DDEText.Text = Time$
        TimerForm.DDEText.LinkMode = 2      'Manual
        TimerForm.DDEText.LinkPoke
        TimerForm.DDEText.LinkMode = 0      'none
        
        TimerForm.DDEText.LinkItem = "R" & Format$(DDElog) & "C" & wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3
        
        Select Case Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Case 0  'Flag
                If Flag(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)).Value Then
                    TimerForm.DDEText.Text = "-1"
                Else
                    TimerForm.DDEText.Text = "1"
                End If
            
            Case 1  'Counter
                TimerForm.DDEText.Text = Format$(Counter(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)).Value)
            
            Case 2      'Width Gauge
                TimerForm.DDEText.Text = Format$(WidthGauge(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)).Value)
            
            Case 3      'Height Gauge
                TimerForm.DDEText.Text = Format$(HeightGauge(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)).Value)
            
            Case 4      'Digital Sensor
                TimerForm.DDEText.Text = Format$(ReadDigSensor(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)))
            
            Case 5      'Analog Sensor
                TimerForm.DDEText.Text = Format$(ReadAnaSensor(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)))
                
            Case Else
            '

        End Select
        
        

        TimerForm.DDEText.LinkMode = 2      'Manual
        TimerForm.DDEText.LinkPoke
        TimerForm.DDEText.LinkMode = 0         'none
        DDElog = DDElog + 1

        On Local Error GoTo 0

        GoSub NextLine




    
    Case tok_cr
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        On Local Error Resume Next
        If i <> 1 Then Load TimerForm.Serial(i)
        On Local Error GoTo RS232Error
        If TimerForm.Serial(i).PortOpen = True Then TimerForm.Serial(i).PortOpen = False
        TimerForm.Serial(i).CommPort = i
        TimerForm.Serial(i).Settings = wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2
        TimerForm.Serial(i).PortOpen = True
        TimerForm.Serial(i).Tag = ""
        On Local Error GoTo 0
        GoSub NextLine
    
    Case tok_wr
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        On Local Error GoTo RS232Error
        TimerForm.Serial(i).Output = RSchars(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
        On Local Error GoTo 0
        GoSub NextLine

    Case tok_fr
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        SerialPort(i).Value = ""
        GoSub NextLine

    Case Tok_IR
        Wallidat(Walfrm).STAGE = 1
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        On Local Error GoTo RS232Error
        
        If TimerForm.Serial(i).InBufferCount <> 0 Then
            A$ = TimerForm.Serial(i).Input
            If Right$(A$, 1) = Chr$(4) Then A$ = Left$(A$, Len(A$) - 1)
            SerialPort(i).Value = A$
        Else
            A$ = SerialPort(i).Value
        End If

        If A$ <> "" Then
            
        If A$ = RSchars(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) Then
            GoSub readnewline
            SerialPort(i).Value = ""
        Else
            GoSub ReadElseLine
        End If

        End If
        showSerial i
        
        On Local Error GoTo 0

    Case TOK_tr
        If Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1) = 0 Then
            Traceon = False
        Else
            Traceon = True
        End If
        GoSub NextLine
    
    Case tok_dm
        MsgBox wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1
        GoSub NextLine

    Case tok_so
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        setop EditFrm, Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) - 1, 1
        GoSub NextLine

    Case tok_ro
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        setop EditFrm, Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) - 1, 0
        GoSub NextLine

    Case Tok_gh
        'Digital or Analo
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        i = findsubdev(i, WC_vgag)     'search through subdevices
        If SubDev(i).DevType = WC_vgag Then
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            If CellOnline Then
                Select Case Wallidat(Walfrm).STAGE
                Case 0          'First call
                    If close_vgauge(i) Then
                        SetWait Walfrm, 8
                        Wallidat(Walfrm).STAGE = 1
                    Else
                        execute_walli = False
                    End If
                Case 1
                    If Timer > Wallidat(Walfrm).wait Then
                        HeightGauge(i).Value = vgauge(i)
                        If open_vgauge(i, True) Then
                            SetWait Walfrm, 4
                            Wallidat(Walfrm).STAGE = 2
                        Else
                            execute_walli = False
                        End If
                    End If
                Case 2
                    If Timer > Wallidat(Walfrm).wait Then GoSub NextLine
                End Select
            Else
                HeightGauge(i).Value = vgauge(i)
                GoSub NextLine
            End If
        Else
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            If CellOnline Then
                Select Case Wallidat(Walfrm).STAGE
                    Case 0
                        If StartDigHeightGauge(i) Then
                            Wallidat(Walfrm).STAGE = 1
                        Else
                            execute_walli = False
                        End If
                    Case 1
                        J = DigGauge(findsubdev(i, WC_DigVgag))
                        Select Case J
                        Case 998
                            Wallidat(Walfrm).STAGE = 0      'Retry - read error
                        Case 999                            'Not finished
                        
                        Case Else
                            HeightGauge(i).Value = HeightGauge(i).Stroke - (J * DGaugeMult)
                            If HeightGauge(i).Value < 0 Then HeightGauge(i).Value = 0
                            GoSub NextLine
                        End Select
                End Select
            Else
                HeightGauge(i).Value = vgauge(i)
                GoSub NextLine
            End If

        End If


    Case Tok_Cw
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        If CellOnline Then
            Select Case Wallidat(Walfrm).STAGE
                Case 0
                    SetWait Walfrm, 10
                    If StartDigWidthGauge(i) Then
                        Wallidat(Walfrm).STAGE = 1
                    Else
                        execute_walli = False
                    End If
                Case 1
                    J = DigGauge(findsubdev(i, WC_DigWgag))
                    Select Case J
                    Case 998
                        Wallidat(Walfrm).STAGE = 0  'Retry - read error
                    Case 999
                        If Timer > Wallidat(Walfrm).wait Then
                            Wallidat(Walfrm).STAGE = 0
                        End If
                    Case Else
                        WidthGauge(i).Stroke = J * DGaugeMult
                        GoSub NextLine
                    End Select
            End Select
        Else
            GoSub NextLine
        End If

    Case Tok_Ch
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        If CellOnline Then
            Select Case Wallidat(Walfrm).STAGE
                Case 0
                    If StartDigHeightGauge(i) Then
                        Wallidat(Walfrm).STAGE = 1
                    Else
                        execute_walli = False
                    End If
                Case 1
                    J = DigGauge(findsubdev(i, WC_DigVgag))
                    Select Case J
                    Case 998
                        Wallidat(Walfrm).STAGE = 0
                    Case 999
                    Case Else
                        HeightGauge(i).Stroke = J * DGaugeMult
                        GoSub NextLine
                    End Select
            End Select
        Else
            GoSub NextLine
        End If



    
    Case Tok_gw
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        If CellOnline Then
            If SubDev(findsubdev(i, WC_Wgag)).DevType = WC_Wgag Then
                Select Case Wallidat(Walfrm).STAGE
                    Case 0
                        If close_wgauge(i) Then
                            SetWait Walfrm, 8       'Online
                            Wallidat(Walfrm).STAGE = 1
                        Else
                            execute_walli = False
                        End If
                    Case 1
                        If Timer > Wallidat(Walfrm).wait Then
                            WidthGauge(i).Value = wgauge(i)
                            If open_wgauge(i, True) Then
                                SetWait Walfrm, 4       'Online
                                Wallidat(Walfrm).STAGE = 2
                            Else
                                execute_walli = False
                            End If
                        End If
                    Case 2
                        If Timer > Wallidat(Walfrm).wait Then GoSub NextLine
                End Select
            Else
                Select Case Wallidat(Walfrm).STAGE
                    Case 0
                        SetWait Walfrm, 10
                        If StartDigWidthGauge(i) Then
                            Wallidat(Walfrm).STAGE = 1
                        Else
                            execute_walli = False
                        End If
                    Case 1
                        J = DigGauge(findsubdev(i, WC_DigWgag))
                        Select Case J
                        Case 998
                            Wallidat(Walfrm).STAGE = 0      'Retry
                        Case 999
                            If Timer > Wallidat(Walfrm).wait Then
                                Wallidat(Walfrm).STAGE = 0
                                 '
                            End If
                        Case Else
                            WidthGauge(i).Value = WidthGauge(i).Stroke - (J * DGaugeMult) + .1
                            'If WidthGauge(i).Value < 0 Then WidthGauge(i).Value = 0
                            GoSub NextLine
                        End Select
                End Select
            End If
        Else
            WidthGauge(i).Value = wgauge(i)
            GoSub NextLine
        End If

    
    Case tok_Wd         'Wait until sensor
        If CellOnline Then
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Select Case ReadDigSensor(i)
                Case Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
                    GoSub NextLine
                Case Else
                     Wallidat(Walfrm).STAGE = 1
            End Select
        Else
            GoSub NextLine
        End If
    
    Case tok_ID         'If sensor
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        Select Case ReadDigSensor(i)
            Case Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
                GoSub readnewline
            Case Else
                GoSub ReadElseLine
        End Select

    Case Tok_IS
        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        LowLim = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
        Highlim = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3)
            Select Case ReadAnaSensor(i)
            Case Is <= LowLim, Is >= Highlim
                GoSub ReadElseLine
            Case Else
                GoSub readnewline
            End Select

        Case TOK_IH
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            LowLim = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            Highlim = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3)
            If (HeightGauge(i).Value) >= LowLim And (HeightGauge(i).Value <= Highlim) Then
                GoSub readnewline
            Else
                GoSub ReadElseLine
            End If
        
        Case TOK_iw
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            LowLim = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            Highlim = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3)
            If (WidthGauge(i).Value) >= LowLim And (WidthGauge(i).Value <= Highlim) Then
                GoSub readnewline
            Else
                GoSub ReadElseLine
            End If
        
        Case tok_co
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            tmp = Counter(i).Value
            Select Case Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            Case 0
                tmp = tmp + Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3)
            Case 1
                tmp = tmp - Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3)
            Case 2
                tmp = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3)
            End Select
            If tmp > 32767 Then tmp = 32767
            If tmp < -32768 Then tmp = -32768
            Counter(i).Value = tmp
            showcounter (i)
            GoSub NextLine

        Case tok_cc
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            tmp = Counter(i).Value
            
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            Counter(i).Value = tmp
            
            showcounter (i)
            GoSub NextLine
        
        Case TOK_ac
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            tmp = Counter(i).Value
            
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            tmp = Counter(i).Value + tmp
            
            If tmp > 32767 Then tmp = 32767
            If tmp < -32768 Then tmp = -32768
            Counter(i).Value = tmp
            showcounter (i)
            GoSub NextLine


        Case tok_IC
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Select Case Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            Case 0
                If Counter(i).Value = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3) Then
                    GoSub readnewline
                Else
                    GoSub ReadElseLine
                End If
            Case 1
                If Counter(i).Value < Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3) Then
                    GoSub readnewline
                Else
                    GoSub ReadElseLine  'NextLine
                End If
            Case 2
                If Counter(i).Value > Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3) Then
                    GoSub readnewline
                Else
                    GoSub ReadElseLine  'NextLine
                End If
            End Select

        
        Case tok_rc
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Counter(i).Value = 0
            showcounter (i)
            GoSub NextLine

        Case Tok_SF
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Flag(i).Value = True
            showflag (i)
            GoSub NextLine
        
        Case tok_cf
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            tmp = Flag(i).Value
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            Flag(i).Value = tmp
            showflag (i)
            GoSub NextLine

        Case TOK_RF
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Flag(i).Value = False
            showflag (i)
            GoSub NextLine

        Case TOK_WF
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Select Case Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            Case 1
                If Flag(i).Value = True Then
                    GoSub NextLine
                Else
                    Wallidat(Walfrm).STAGE = 1
                End If
            Case 0
                If Flag(i).Value = False Then
                    GoSub NextLine
                Else
                    Wallidat(Walfrm).STAGE = 1
                End If
            End Select

        Case Tok_IF
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Select Case Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
            Case 1
                If Flag(i).Value Then GoSub readnewline Else GoSub ReadElseLine
            Case 0
                If Not Flag(i).Value Then GoSub readnewline Else GoSub ReadElseLine
            End Select
        
        Case tok_Fo
            Var = Asc(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1) - Asc("A")
            If ForVar(Var).jump <> -1 Then
                MsgBox ("Nested For")
                execute_walli = False
            Else
                ForVar(Var).Value = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
                ForVar(Var).finish = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3)
                ForVar(Var).jump = Walli_ed(Walfrm).Table1.RowIndex + 1
                showVar Var
                GoSub NextLine
            End If
        
        Case tok_ne
            Var = Asc(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1) - Asc("A")
            If ForVar(Var).jump = -1 Then
                MsgBox ("Next without for")
                execute_walli = False
            Else
                ForVar(Var).Value = ForVar(Var).Value + 1
                showVar Var
                If ForVar(Var).Value > ForVar(Var).finish Then
                    ForVar(Var).jump = -1
                    GoSub NextLine
                Else
                    Walli_ed(Walfrm).Table1.RowIndex = ForVar(Var).jump
                End If
            End If
        
        
        Case TOK_SS     'START PAR Sub
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)    'get jump calculated in debug
            If Wallidat(i).active_wallisub Then
                MsgBox "Parallel subroutine [" + Wallidat(i).name + "] is already running", 48, "Walli Error"
                execute_walli = False
            Else
                Wallidat(i).active_wallisub = True
                Walli_ed(i).Table1.RowIndex = 1
                If CellOnline Then
                    Walli_ed(i).Caption = Wallidat(i).name + " - Executing Online"
                Else
                    Walli_ed(i).Caption = Wallidat(i).name + " - Executing Offline"
                End If
                Walli_ed(i).Table1.MarqueeStyle = 3         'Highlight row
                GoSub NextLine
            End If
            

        Case Tok_Es
            i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)    'get jump calculated in debug
            If Wallidat(i).active_wallisub Then
                Wallidat(i).active_wallisub = False
                Walli_ed(i).Caption = Wallidat(i).name        'Finished exe
                Walli_ed(i).Table1.MarqueeStyle = 5           'No Highlight
            End If
            GoSub NextLine

        
        Case TOK_PR
            On Local Error Resume Next
            Printer.Print wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1
            PrinterUsed = True
            On Local Error GoTo 0
            GoSub NextLine



    Case TOK_WA   ' wait
        Select Case Wallidat(Walfrm).STAGE
        Case 0
            SetWait Walfrm, Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            Wallidat(Walfrm).STAGE = 1
        Case Else
            If Timer > Wallidat(Walfrm).wait Then
                GoSub NextLine
            End If
        End Select

        
    Case tok_IA     'If axis
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        READDATA EditFrm, RobotCntrl          'get latest copy

        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2)
        LowLim = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3)
        Highlim = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field4)

        If (RobotCntrl.Feedback(i) >= LowLim) And (RobotCntrl.Feedback(i) <= Highlim) Then
            GoSub readnewline
        Else
            GoSub ReadElseLine
        End If
        
        
        Case TOK_Mo     'MOVE ROBOT
            'robot in position then
            'nextline<finishline send nextline
            'else goto next walliline

            EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            
            Select Case Wallidat(Walfrm).STAGE
                Case 0
                    start = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field4)
                    finish = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field5)
                    
                    Robotfrmno = EditFrmdat(EditFrm).Frmno
                    RobotFrm(Robotfrmno).EDITFUNC = "Copy"
                    
                    If Not IsNumeric(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field4) Then
                        Var = Asc(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field4) - Asc("A")
                        Var = ForVar(Var).Value
                        start = 0
                        blk = 0
                        For i = 1 To RobotFrm(Robotfrmno).Table1.Rows
                            If rcopy(low(i), high(i)).LineName <> "" Then
                                blk = blk + 1
                                If blk = Var Then
                                    start = i
                                    Exit For
                                End If
                            End If
                        Next
                        If start = 0 Then
                            MsgBox "Failed to find line " + Format$(Var)
                            execute_walli = False: Exit Function
                        End If
                        
                        If wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field3 = "" Then
                            For i = start + 1 To RobotFrm(Robotfrmno).Table1.Rows
                                If rcopy(low(i), high(i)).LineName <> "" Then Exit For
                            Next
                            finish = i - 1
                        End If
                    End If
                    
                    If Not IsNumeric(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field5) Then
                        Var = Asc(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field5) - Asc("A")
                        Var = ForVar(Var).Value
                        blk = 0
                        For i = 1 To RobotFrm(Robotfrmno).Table1.Rows
                            If rcopy(low(i), high(i)).LineName <> "" Then
                                blk = blk + 1
                                If blk = Var Then
                                    finish = i
                                    Exit For
                                End If
                            End If
                        Next
                    
                        If finish = 0 Then
                            MsgBox "Failed to find line " + Format$(Var)
                            execute_walli = False: Exit Function
                        End If
                    
                        For i = finish + 1 To RobotFrm(Robotfrmno).Table1.Rows       'bump on through to end of block
                            If rcopy(low(i), high(i)).LineName <> "" Then Exit For
                        Next
                        finish = i - 1
                    End If
                    
                    Erase rcopy
                    If start > finish Then
                        MsgBox "Start > Finish"
                        execute_walli = False: Exit Function
                    End If

                    
                    RobotFrm(Robotfrmno).Table1.RowIndex = start
                    'If RobotFrm(Robotfrmno).WindowState <> 0 Then
                    RobotFrm(Robotfrmno).EDITFUNC = "Send"        'Row changes don't happen if minimised/ or hidden?
                    EditFrmdat(EditFrm).ExeFinish = finish
                    
                    EditFrmdat(EditFrm).ExeMode = cont
                    Wallidat(Walfrm).STAGE = 1

                Case Else
                    If EditFrmdat(EditFrm).ExeMode = 0 Then GoSub NextLine
                    
            End Select


        Case TOK_GO     'GoTo
            GoSub readnewline                    'get jump calculated in debug

        Case tok_gs     'Goto Sub
            'save current line on stack for return
            If Wallidat(Walfrm).gs_sp < 16 Then
                Wallidat(Walfrm).gs_stack(Wallidat(Walfrm).gs_sp) = Walli_ed(Walfrm).Table1.RowIndex
                Wallidat(Walfrm).gs_sp = Wallidat(Walfrm).gs_sp + 1
                GoSub readnewline                   'get jump calculated in debug
            Else
                MsgBox ("Too many nested subroutines")
                execute_walli = False
            End If
        
        Case tok_rs
            If Wallidat(Walfrm).gs_sp <> 0 Then
                Wallidat(Walfrm).gs_sp = Wallidat(Walfrm).gs_sp - 1
                wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).GotoField = Wallidat(Walfrm).gs_stack(Wallidat(Walfrm).gs_sp) + 1
                GoSub readnewline
            Else
                MsgBox ("Return without Gosub")
                execute_walli = False
            End If
        
        Case TOK_SC
            If startconveyor(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)) Then
                GoSub NextLine
            Else
                execute_walli = False
            End If
        
        Case TOK_St
            If startitab(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)) Then
                GoSub NextLine
            Else
                execute_walli = False
            End If
        
        Case TOK_HC
            If stopconveyor(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1), True) Then
                GoSub NextLine
            Else
                execute_walli = False
            End If

        
        Case TOK_Ht
            If stopitab(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)) Then
                GoSub NextLine
            Else
                execute_walli = False
            End If

        
        Case TOK_mC
            If CellOnline Then
                Select Case Wallidat(Walfrm).STAGE
                    Case 0
                        i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
                        Select Case incconveyor(i, Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2))
                        Case False
                            execute_walli = False
                        Case True
                            GoSub NextLine
                        Case Else
                            SetWait Walfrm, Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) / 18
                            Wallidat(Walfrm).STAGE = 1
                        End Select
                    Case Else
                        If Timer > Wallidat(Walfrm).wait Then GoSub NextLine
                        
                End Select
            Else
                GoSub NextLine
            End If

        Case tok_mt
            If CellOnline Then
            Select Case Wallidat(Walfrm).STAGE
                Case 0
                    i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
                    If indextablezero(i).position = -1 Then
                        If Not Zeroitab(i) Then execute_walli = False: Exit Function
                        SetWait Walfrm, 20
                        Wallidat(Walfrm).STAGE = 1
                    Else
                        Wallidat(Walfrm).STAGE = 2      'Already zeroed - skip to move
                    End If

                Case 1
                    i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
                    If (Timer > Wallidat(Walfrm).wait) Or ItabAtZero(i) Then
                        Wallidat(Walfrm).STAGE = 2
                    End If
                
                Case 2
                    i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
                    i = incitab(i, Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2), True)
                    If i < 0 Then
                        execute_walli = False
                    Else
                        SetWait Walfrm, i
                        Wallidat(Walfrm).STAGE = 3
                    End If
                
                Case Else
                    If Timer > Wallidat(Walfrm).wait Then GoSub NextLine
                    
            End Select
            Else
                GoSub NextLine
            End If

        
        Case Tok_It     'Inc Index Tab
            If CellOnline Then
            Select Case Wallidat(Walfrm).STAGE
                Case 0
                    i = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
                    i = incitab(i, Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2), False)
                    If i < 0 Then
                        execute_walli = False
                    Else
                        SetWait Walfrm, i
                        Wallidat(Walfrm).STAGE = 1
                    End If
                
                Case Else
                    If Timer > Wallidat(Walfrm).wait Then GoSub NextLine
                    
            End Select
            Else
                GoSub NextLine
            End If



        Case tok_dp
            If CellOnline Then
            Select Case Wallidat(Walfrm).STAGE
            Case 0
                If dispensepart(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)) Then
                    Wallidat(Walfrm).STAGE = 1
                Else
                    execute_walli = False
                End If
            Case Else
                If dispensedpart(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)) Then GoSub NextLine
            End Select
            Else
                GoSub NextLine
            End If



    Case tok_sp     'Start Mill program
        If CellOnline Then
        
        screen.MousePointer = 11    'Busy

        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)

        Select Case EditFrmdat(EditFrm).DevType
        Case CNCMill
            ext$ = "NCM"
        Case CNCLathe
            ext$ = "NCL"
        Case Else
            MsgBox ("Cods up sending Mill program")
            execute_walli = False
        End Select


        A$ = wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2
        If InStr(A$, ".") = 0 Then A$ = A$ + "." + "ext$        'force an extension"
        
        READDATA EditFrm, RobotCntrl
        If (RobotCntrl.Inpos And 1) = 1 Then    'Executing
            send_rj45_mesg EditFrm, mCNTRL, tok_abort       'must also kill file handle
            If EditFrmdat(EditFrm).Exe_Handle <> 0 Then
                Close EditFrmdat(EditFrm).Exe_Handle
                EditFrmdat(EditFrm).Exe_Handle = 0
            End If
        End If
        
            CncFrmNo = EditFrmdat(EditFrm).Frmno
            If RobotCntrl.online = 1 Then
                CNCFrmDat(EditFrmdat(EditFrm).Frmno).Filename = A$
                If LoadMill(ext$) Then
                    Select Case EditFrmdat(EditFrm).DevType
                        Case CNCMill
                            If SendMillCmp(EditFrm, True) Then                   'Start execution
                                Do
                                    READDATA EditFrm, RobotCntrl          'get latest copy
                                Loop Until ((RobotCntrl.Inpos And 1) = 1) Or (RobotCntrl.online <> 1)
                            Else
                                MsgBox ("Cods up sending Mill program")
                                execute_walli = False
                            End If
                            
                        Case CNCLathe
                            If SendLatheCmp(EditFrm) Then                   'Start execution
                                Do
                                    READDATA EditFrm, RobotCntrl          'get latest copy
                                Loop Until ((RobotCntrl.Inpos And 1) = 1) Or (RobotCntrl.online <> 1)
                            Else
                                MsgBox ("Cods up sending Lathe program")
                                execute_walli = False
                            End If
                    End Select
                End If
            End If

            screen.MousePointer = 0    'Busy
            GoSub NextLine

            Else
                GoSub NextLine
            End If

        

    Case tok_we     'Wait til ended
        If CellOnline Then
            Wallidat(Walfrm).STAGE = 1
            EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            READDATA EditFrm, RobotCntrl          'get latest copy
            If RobotCntrl.online = 1 Then
                If (RobotCntrl.Inpos And 1) = 0 Then GoSub NextLine
            Else
                GoSub NextLine
            End If
        Else
            GoSub NextLine
        End If

        
    Case tok_wp     'Wait til paused
        If CellOnline Then
            Wallidat(Walfrm).STAGE = 1
            EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
            READDATA EditFrm, RobotCntrl          'get latest copy
            If RobotCntrl.online = 1 Then
                If (RobotCntrl.Inpos And 2) = 2 Then GoSub NextLine
            Else
                GoSub NextLine
            End If
        Else
            GoSub NextLine
        End If

    Case Tok_IE
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        READDATA EditFrm, RobotCntrl          'get latest copy
        If RobotCntrl.online = 1 Then
            If (RobotCntrl.Inpos And 1) = 0 Then
                GoSub readnewline
            Else
                GoSub ReadElseLine
            End If
        Else
            GoSub ReadElseLine
        End If
    
    Case tok_IP
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        READDATA EditFrm, RobotCntrl          'get latest copy
        If RobotCntrl.online = 1 Then
            If (RobotCntrl.Inpos And 2) = 2 Then
                GoSub readnewline
            Else
                GoSub ReadElseLine
            End If
        Else
            GoSub ReadElseLine  'NextLine
        End If
    
    Case tok_cp
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        READDATA EditFrm, RobotCntrl          'get latest copy
        If RobotCntrl.online = 1 Then
            If (RobotCntrl.Inpos And 2) = 2 Then
                If Wallidat(Walfrm).STAGE = 0 Then
                    send_rj45_mesg EditFrm, mCNTRL, TOK_continue
                    Wallidat(Walfrm).STAGE = 1
                    SetWait Walfrm, 1
                Else
                    If Timer > Wallidat(Walfrm).wait Then
                        Wallidat(Walfrm).STAGE = 0
                        'If Traceon Then
                        '    On Local Error GoTo MemErr
                        '    a$ = Format$(Time$, "hh:mm:ss")
                        '    a$ = a$ + Chr$(9) + "!!! Resent Continue Mill Command !!!"
                        '    Trace.Trace.AddItem a$
                        '    Trace.Trace.ListIndex = Trace.Trace.ListCount - 1
                        '    On Local Error GoTo 0
                        'End If
                    End If
                End If
            Else
                GoSub NextLine
            End If
        Else
            GoSub NextLine
        End If



    Case tok_jx
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        i = Abs(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) * mmtosteps)
        send_rj45_mesg EditFrm, jogcnt, (i Mod 256)
        send_rj45_mesg EditFrm, jogcnt + 1, Fix(i / 256)
        If InStr(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2, "-") <> 0 Then
            send_rj45_mesg EditFrm, mCNTRL, TOK_jogx_m
        Else
            send_rj45_mesg EditFrm, mCNTRL, TOK_jogx_p
        End If
        GoSub NextLine
    
    Case tok_jy
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        i = Abs(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) * mmtosteps)
        send_rj45_mesg EditFrm, jogcnt, (i Mod 256)
        send_rj45_mesg EditFrm, jogcnt + 1, Fix(i / 256)
        If InStr(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2, "-") <> 0 Then
            send_rj45_mesg EditFrm, mCNTRL, TOK_jogy_m
        Else
            send_rj45_mesg EditFrm, mCNTRL, TOK_jogy_p
        End If
        GoSub NextLine
    
    Case tok_jz
        EditFrm = Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field1)
        i = Abs(Val(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2) * mmtosteps)
        send_rj45_mesg EditFrm, jogcnt, (i Mod 256)
        send_rj45_mesg EditFrm, jogcnt + 1, Fix(i / 256)
        If InStr(wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).field2, "-") <> 0 Then
            send_rj45_mesg EditFrm, mCNTRL, TOK_jogz_m
        Else
            send_rj45_mesg EditFrm, mCNTRL, TOK_jogz_p
        End If
        GoSub NextLine

    Case Tok_El     'Jump to line after endif
    '
    GoSub ReadElseLine

    Case Tok_EI     'End If - nothing to do
    '
        GoSub NextLine
        
    Case Else
        GoSub NextLine
End Select

Exit Function


NextLine:
    Wallidat(Walfrm).STAGE = 0
    GoSub singlestep
ForceNEXTLINE:
    On Local Error GoTo endofprog
    Walli_ed(Walfrm).Table1.RowIndex = Walli_ed(Walfrm).Table1.RowIndex + 1          'Goto next line
    On Local Error GoTo 0
    Return

endofprog:
    Wallidat(Walfrm).active_wallisub = False
    Walli_ed(Walfrm).Table1.MarqueeStyle = 5    'No Highlight
    Walli_ed(Walfrm).Caption = Wallidat(Walfrm).name
    Resume Next
    


ReadElseLine:
    If wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).GotoField = 9999 Then
    'Search Down for Else or EndIf and Jump to line after It
        Nest = 0
        For i = Walli_ed(Walfrm).Table1.RowIndex + 1 To Walli_ed(Walfrm).Table1.Rows
        
        Select Case wcopy(Walfrm, i).Tok
        Case Tok_El, Tok_EI
            If Nest = 0 Then
                On Local Error GoTo endofprog
                Walli_ed(Walfrm).Table1.RowIndex = i + 1
                On Local Error GoTo 0
                Return
            End If
            If wcopy(Walfrm, i).Tok = Tok_EI Then Nest = Nest - 1
        
        Case Tok_IR, tok_ID, Tok_IS, TOK_IH, TOK_iw, tok_IC, Tok_IF, tok_IA, Tok_IE, tok_IP
                If wcopy(Walfrm, i).GotoField = 9999 Then Nest = Nest + 1
                
        End Select
        Next
                
        MsgBox ("No End for Block IF")
        execute_walli = False


    Else
        GoSub NextLine
    End If
    
    Return

readnewline:
    If wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).GotoField = 9999 Then
        GoSub NextLine
    Else
    Wallidat(Walfrm).STAGE = 0
    GoSub singlestep
    On Local Error GoTo endofprog
    Walli_ed(Walfrm).Table1.RowIndex = wcopy(Walfrm, Walli_ed(Walfrm).Table1.RowIndex).GotoField
    On Local Error GoTo 0
    End If
    Return

singlestep:
    Select Case exe_seq
        Case init_sing, sing
            If MsgBox("Execute next line", mb_yesno, "Single Step Execution") = idno Then
                Wallidat(Walfrm).active_wallisub = False
            End If
    End Select
    Return

'errhand:
'    i = i - 1
'    Resume


MemErr:
    Dim ErrI As Integer
    
    Select Case Err
    Case 6, 7     'Overflow (NT when > 32K items in list ), Out of memory
        'ErrorFile = FreeFile
        'Open app.Path + "\Walli3.trc" For Append As ErrorFile
        For ErrI = 0 To 99
        '    Print #ErrorFile, Trace.Trace.List(0)
            Trace.Trace.RemoveItem 0
        Next
        'Close ErrorFile
        Resume
    Case 70
        MsgBox Error$
        Resume

    Case 61     'Disk full
        If Traceon Then
            MsgBox "Disk Full - Trace ended"
            Traceon = False
            Resume
        Else
            MsgBox Error$
            execute_walli = False
            Exit Function
        End If

        
    Case Else
        MsgBox Error$
        execute_walli = False
        Exit Function
    End Select



RS232Error:
    Select Case Err
    Case 340
        MsgBox "RS232 Port " + Format$(i) + " is not configured"
    Case Else
        MsgBox Error$, , "RS232 Port " + Format$(i)
    End Select
    execute_walli = False
    Exit Function


DDE_Error:
    MsgBox Error$ + Chr$(13) & "Topic : " & TimerForm.DDEText.LinkTopic & Chr$(13) & "Item : " & TimerForm.DDEText.LinkItem

    execute_walli = False
    Exit Function

    
    
    


End Function

Sub get_wcopy ()
Dim maxline
Dim Walfrm As Integer


If exe_seq <> 0 Then
    Exit Sub
End If

For Walfrm = 1 To UBound(Flag)            'Clear all flags
    Flag(Walfrm).Value = False
    Counter(Walfrm).Value = 0
Next

maxline = 0
For Walfrm = 0 To UBound(Walli_ed)                             'get access to walli line number
    If Wallidat(Walfrm).used Then
        Wallidat(Walfrm).active_wallisub = False
        Walli_ed(Walfrm).Table1.MarqueeStyle = 5         'No Highlight
        If Walli_ed(Walfrm).Table1.Rows > maxline Then
            maxline = Walli_ed(Walfrm).Table1.Rows
        End If
    End If
Next

ReDim wcopy(UBound(Walli_ed), 1 To maxline)

For Walfrm = 0 To UBound(Walli_ed)
    If Wallidat(Walfrm).used Then Walli_ed(Walfrm).EDITFUNC = "Copy"
Next


End Sub

Private Function RSchars (f$) As String
        
Dim tmp As Long
Dim i As Integer
Dim q As Integer
Dim A$
Dim n$


        q = False
        A$ = ""
        n$ = ""
        For i = 1 To Len(f$)
        
            Select Case Mid$(f$, i, 1)
                Case Chr$(34)
                    GoSub AddN
                    q = Not q
                
                Case Else
                    If q Then
                        A$ = A$ + Mid$(f$, i, 1)
                    Else
                        Select Case Mid$(f$, i, 1)
                        Case "0" To "9"
                            n$ = n$ + Mid$(f$, i, 1)
                        Case Else
                            GoSub AddN
                        End Select
                    End If
            End Select
        
        Next
        GoSub AddN
        RSchars = A$

    Exit Function

AddN:
    If n$ <> "" Then
        tmp = Val(n$)
        Select Case tmp
        Case 0 To 255
            A$ = A$ + Chr$(Val(n$))
        Case Else
        End Select
        n$ = ""
    End If
    Return


End Function

Sub SetPinLimits (r_no As Integer, pins As PinType)

Dim RobotCntrl  As robotCNTRLtype

    READDATA r_no, RobotCntrl                      'get latest copy
    Select Case RobotCntrl.DevType
        Case MENTOR + &H100
            pins.Lops = 0: pins.ops = 5: pins.aips = 4: pins.dips = 2       '5 out 4 analog in
        Case MENTOR, MENTOR + &H200, MENTOR + &H300
            pins.Lops = 8: pins.ops = 8: pins.aips = 4: pins.dips = 8       '8 out 4 analog in
        Case Serpent1, SERPENT2, nEPTUNE1, Neptune2
            pins.Lops = 0: pins.ops = 6: pins.aips = 1: pins.dips = 3
        Case Xboard, Xboard + &H100
            pins.Lops = 16: pins.ops = 16: pins.aips = 8: pins.dips = 16
        Case CNCMill, CNCLathe, kestrel
            pins.Lops = 8: pins.ops = 8: pins.aips = 0: pins.dips = 8
        Case Else
            pins.Lops = 8: pins.ops = 8: pins.aips = 2: pins.dips = 8
    End Select

End Sub

Sub setupworkcellstatus ()

Dim Var As Integer
Dim Walfrm  As Integer
Dim walline As Integer
Dim J       As Integer
Dim K As Integer


If walli_level = 1 Then Exit Sub

If OptMenuChecked(1) = True Then
    'statusfrm.Timer1.Enabled = False
End If

Erase status
Erase dsensor
Erase asensor
'Erase indextablezero
Erase partsdispenserfree


For Walfrm = 1 To UBound(Flag)            'assume all flags are unused
    Flag(Walfrm).gridrow = -1
    Counter(Walfrm).gridrow = -1
Next

For Walfrm = 0 To 26
    ForVar(Walfrm).gridrow = -1
Next

For K = 1 To 4
    SerialPort(K).gridrow = -1
Next



get_wcopy               'Read walli form data into array wcopy


For Walfrm = 0 To UBound(Walli_ed)
    If Wallidat(Walfrm).used Then
        walline = 1
        While walline < Walli_ed(Walfrm).Table1.Rows
            Select Case wcopy(Walfrm, walline).Tok
            Case Tok_SF, TOK_RF, TOK_WF, Tok_IF        'using flags
                Flag(Val(wcopy(Walfrm, walline).field1)).gridrow = 0
            Case tok_cf
                Flag(Val(wcopy(Walfrm, walline).field1)).gridrow = 0
                Flag(Val(wcopy(Walfrm, walline).field2)).gridrow = 0
            Case tok_rc, tok_co, tok_IC               'using counters
                Counter(Val(wcopy(Walfrm, walline).field1)).gridrow = 0
            Case tok_cc, TOK_ac
                Counter(Val(wcopy(Walfrm, walline).field1)).gridrow = 0
                Counter(Val(wcopy(Walfrm, walline).field2)).gridrow = 0
            Case tok_Fo, tok_ne
                Var = Asc(wcopy(Walfrm, walline).field1) - Asc("A")
                ForVar(Var).gridrow = 0
            Case tok_cr, Tok_IR, tok_wr, tok_fr                          'Serial ports
                SerialPort(Val(wcopy(Walfrm, walline).field1)).gridrow = 0      '1 to 4

            End Select
            walline = walline + 1
        Wend
    End If
Next

J = 1
For Walfrm = LBound(Counter) To UBound(Counter)
    If Counter(Walfrm).gridrow = 0 Then
        ReDim Preserve status(1 To J)
        status(J).col1 = "Counter" + Str$(Walfrm)
        status(J).col2 = Str$(Counter(Walfrm).Value)
        Counter(Walfrm).gridrow = J: J = J + 1          'tell counter which row to update
    End If
Next

For Walfrm = LBound(Flag) To UBound(Flag)
    If Flag(Walfrm).gridrow = 0 Then
        ReDim Preserve status(1 To J)
        status(J).col1 = "Flag" + Str$(Walfrm)
        status(J).col2 = "Reset"
        Flag(Walfrm).gridrow = J: J = J + 1          'tell flag which row to update
    End If
Next

For Walfrm = 0 To 26
    If ForVar(Walfrm).gridrow = 0 Then
        ReDim Preserve status(1 To J)
        status(J).col1 = "Variable " + Chr$(Walfrm + Asc("A"))
        status(J).col2 = Str$(ForVar(Walfrm).Value)
        ForVar(Walfrm).gridrow = J: J = J + 1          'tell ForVar which row to update
    End If
Next


K = 1
For Walfrm = 0 To UBound(SubDev)
    If SubDev(Walfrm).DevType = WC_DigSENS Then
        ReDim Preserve status(1 To J)
        status(J).col1 = "Digital Sensor" + Str$(K)
        status(J).col2 = ""
        ReDim Preserve dsensor(1 To K)
        dsensor(K).gridrow = J: J = J + 1: K = K + 1
    End If
Next

K = 1
For Walfrm = 0 To UBound(SubDev)
    If SubDev(Walfrm).DevType = WC_AnaSENS Then
        ReDim Preserve status(1 To J)
        status(J).col1 = "Analog Sensor" + Str$(K)
        status(J).col2 = ""
        ReDim Preserve asensor(1 To K)
        asensor(K).gridrow = J: J = J + 1: K = K + 1
    End If
Next


K = 1   'Search for gauges
For Walfrm = 0 To UBound(SubDev)
    Select Case SubDev(Walfrm).DevType
    Case WC_Wgag, WC_DigWgag
        ReDim Preserve status(1 To J + 1)          'Two lines per Gauge
        status(J).col1 = "Width Gauge" + Str$(K)
        status(J).col2 = ""
        
        If SubDev(Walfrm).DevType = WC_DigWgag Then
            status(J + 1).col1 = "   Stroke"
        Else
            status(J + 1).col1 = ""
        End If
        status(J + 1).col2 = ""

        On Error GoTo DimWidthGauge
        If K > UBound(WidthGauge) Then
            ReDim Preserve WidthGauge(1 To K)
            WidthGauge(K).Stroke = 95
        End If
        On Error GoTo 0
        
        WidthGauge(K).gridrow = J: J = J + 2: K = K + 1
    End Select
Next
If K = 1 Then
    Erase WidthGauge
Else
    ReDim Preserve WidthGauge(1 To K - 1)
End If


K = 1  'Search for gauges
For Walfrm = 0 To UBound(SubDev)
    Select Case SubDev(Walfrm).DevType
    Case WC_vgag, WC_DigVgag
        ReDim Preserve status(1 To J + 1)           'Two lines per Gauge
        status(J).col1 = "Height Gauge" + Str$(K)
        status(J).col2 = ""
        
        If SubDev(Walfrm).DevType = WC_DigVgag Then
            status(J + 1).col1 = "   Stroke"
        Else
            status(J + 1).col1 = ""
        End If
        status(J + 1).col2 = ""

        On Error GoTo DimHeightGauge
        If K > UBound(HeightGauge) Then
            ReDim Preserve HeightGauge(1 To K)
            HeightGauge(K).Stroke = 95
        End If
        On Error GoTo 0
        
        HeightGauge(K).gridrow = J: J = J + 2: K = K + 1
    End Select
Next
If K = 1 Then
    Erase HeightGauge
Else
    ReDim Preserve HeightGauge(1 To K - 1)
End If





K = 1
For Walfrm = 0 To UBound(SubDev)
    If SubDev(Walfrm).DevType = WC_itab Then
        ReDim Preserve status(1 To J + 1)           'Two lines per index table
        status(J).col1 = "Index Table" + Str$(K)
        status(J).col2 = ""

        status(J + 1).col1 = ""
        status(J + 1).col2 = ""

        If K > UBound(indextablezero) Then ReDim Preserve indextablezero(1 To K)
        indextablezero(K).position = -1                     'Mark in need of zeroing
        indextablezero(K).gridrow = J: J = J + 2: K = K + 1
    End If
Next

K = 1
For Walfrm = 0 To UBound(SubDev)
    If SubDev(Walfrm).DevType = WC_part Then
        ReDim Preserve status(1 To J)
        status(J).col1 = "Dispenser" + Str$(K)
        status(J).col2 = ""
        ReDim Preserve partsdispenserfree(1 To K)
        partsdispenserfree(K).gridrow = J: J = J + 1: K = K + 1
    End If
Next


For K = 1 To 4
    If SerialPort(K).gridrow = 0 Then
        ReDim Preserve status(1 To J)
        status(J).col1 = "RS232 Port" + Str$(K)
        status(J).col2 = ""
        SerialPort(K).gridrow = J: J = J + 1
    End If
Next



If OptMenuChecked(1) = True Then
    statusfrm.Table1.Rows = J - 1
    'statusfrm.Timer1.Enabled = True
    statusfrm.Table1.Refresh
End If



Exit Sub

DimWidthGauge:
    ReDim WidthGauge(1 To 1)
    WidthGauge(1).Stroke = 95
    Resume

DimHeightGauge:
    ReDim HeightGauge(1 To 1)
    HeightGauge(1).Stroke = 95
    Resume


End Sub

Sub SetWait (Walfrm, Seconds)
               
Wallidat(Walfrm).wait = (Timer + Seconds) Mod 86400         'wrap round at mid-night

'This is still wrong
'How cope with if timer>.wait?

'If wallidat(Walfrm).wait < Seconds Then wallidat(Walfrm).wait = Seconds

End Sub

Sub showcounter (i As Integer)

If OptMenuChecked(1) = False Then Exit Sub

If status(Counter(i).gridrow).col2 <> Str$(Counter(i).Value) Then
    status(Counter(i).gridrow).col2 = Str$(Counter(i).Value)
    statusfrm.Table1.RefreshRow = Counter(i).gridrow
End If

End Sub

Sub ShowDigVGauge (SubDevNo As Integer)

Dim i As Integer
Dim r_no As Integer
Dim A$
Dim B$
Dim RobotCntrl  As robotCNTRLtype
Dim robotWC As robotWCtype


If OptMenuChecked(1) = False Then Exit Sub

i = findsubdev(SubDevNo, WC_DigVgag)     'search through subdevices for gauge

A$ = "Not Connected"
r_no = SubDev(i).Control_device(2) - 1
If r_no >= 0 Then
    A$ = Format$(HeightGauge(SubDevNo).Value, "0.0")
End If

If status(HeightGauge(SubDevNo).gridrow).col2 <> A$ Then
    status(HeightGauge(SubDevNo).gridrow).col2 = A$
    statusfrm.Table1.RefreshRow = HeightGauge(SubDevNo).gridrow
End If


B$ = Format$(HeightGauge(SubDevNo).Stroke, "0.0")
If status(HeightGauge(SubDevNo).gridrow + 1).col2 <> B$ Then
    status(HeightGauge(SubDevNo).gridrow + 1).col2 = B$
    statusfrm.Table1.RefreshRow = HeightGauge(SubDevNo).gridrow + 1
End If

End Sub

Sub ShowDigWGauge (SubDevNo As Integer)

Dim i As Integer
Dim r_no As Integer
Dim A$
Dim B$
Dim RobotCntrl  As robotCNTRLtype
Dim robotWC As robotWCtype


If OptMenuChecked(1) = False Then Exit Sub

i = findsubdev(SubDevNo, WC_DigWgag)     'search through subdevices for gauge

A$ = "Not Connected"
r_no = SubDev(i).Control_device(2) - 1
If r_no >= 0 Then
    A$ = Format$(WidthGauge(SubDevNo).Value, "0.0")
End If

If status(WidthGauge(SubDevNo).gridrow).col2 <> A$ Then
    status(WidthGauge(SubDevNo).gridrow).col2 = A$
    statusfrm.Table1.RefreshRow = WidthGauge(SubDevNo).gridrow
End If


B$ = Format$(WidthGauge(SubDevNo).Stroke, "0.0")
If status(WidthGauge(SubDevNo).gridrow + 1).col2 <> B$ Then
    status(WidthGauge(SubDevNo).gridrow + 1).col2 = B$
    statusfrm.Table1.RefreshRow = WidthGauge(SubDevNo).gridrow + 1
End If


End Sub

Sub showflag (i As Integer)
Dim A$

If OptMenuChecked(1) = False Then Exit Sub

If Flag(i).Value Then A$ = "Set" Else A$ = "Reset"

If status(Flag(i).gridrow).col2 <> A$ Then
    status(Flag(i).gridrow).col2 = A$
    statusfrm.Table1.RefreshRow = Flag(i).gridrow
End If







End Sub

Sub showitabsensor (SubDevNo)
    Dim i     As Integer
    Dim r_no  As Integer
    Dim RobotCntrl  As robotCNTRLtype
    Dim robotWC As robotWCtype
    Dim A$
    Dim B$
    
    i = findsubdev(SubDevNo, WC_itab)

    
    r_no = SubDev(i).Control_device(4) - 1
    If r_no >= 0 Then
        READDATA r_no, RobotCntrl
        If RobotCntrl.online <> 0 Then
            READWC r_no, robotWC
            If robotWC.diginputs(SubDev(i).Control_Pin(4)) = 1 Then
                indextablezero(SubDevNo).Sensor = True
                A$ = "ON"
            Else
                indextablezero(SubDevNo).Sensor = False
                A$ = "OFF"
            End If
        Else
            indextablezero(SubDevNo).Sensor = True
            A$ = "Not Connected"
        End If
    Else
        indextablezero(SubDevNo).Sensor = True
        A$ = "Not Connected"
    End If

    If status(indextablezero(SubDevNo).gridrow).col2 <> A$ Then
        status(indextablezero(SubDevNo).gridrow).col2 = A$
        statusfrm.Table1.RefreshRow = indextablezero(SubDevNo).gridrow
    End If

    If indextablezero(SubDevNo).position = -1 Then
        B$ = "Uninitialised"
    Else
        B$ = Format$(indextablezero(SubDevNo).position)
    End If
    If status(indextablezero(SubDevNo).gridrow + 1).col2 <> B$ Then
        status(indextablezero(SubDevNo).gridrow + 1).col2 = B$
        statusfrm.Table1.RefreshRow = indextablezero(SubDevNo).gridrow + 1
    End If




End Sub

Sub showparts (SubDevNo As Integer)
    Dim i     As Integer
    Dim r_no  As Integer
    Dim RobotCntrl  As robotCNTRLtype
    Dim robotWC As robotWCtype
    Dim A$
    
    i = findsubdev(SubDevNo, WC_part)
    
    r_no = SubDev(i).Control_device(1) - 1
    If r_no >= 0 Then
        READDATA r_no, RobotCntrl
        If RobotCntrl.online <> 0 Then
            READWC r_no, robotWC
            If robotWC.diginputs(SubDev(i).Control_Pin(1)) = 1 Then
                partsdispenserfree(SubDevNo).Value = True
                A$ = "ON"
            Else
                partsdispenserfree(SubDevNo).Value = False
                A$ = "OFF"
            End If
        Else
            partsdispenserfree(SubDevNo).Value = True
            A$ = "Not Connected"
        End If
    Else
        partsdispenserfree(SubDevNo).Value = True
        A$ = "Not Connected"
    End If

    If status(partsdispenserfree(SubDevNo).gridrow).col2 <> A$ Then
        status(partsdispenserfree(SubDevNo).gridrow).col2 = A$
        statusfrm.Table1.RefreshRow = partsdispenserfree(SubDevNo).gridrow
    End If



End Sub

Sub showSerial (i As Integer)

If OptMenuChecked(1) = False Then Exit Sub

If status(SerialPort(i).gridrow).col2 <> SerialPort(i).Value Then
    status(SerialPort(i).gridrow).col2 = SerialPort(i).Value
    statusfrm.Table1.RefreshRow = SerialPort(i).gridrow
End If

End Sub

Sub showVar (i As Integer)

If OptMenuChecked(1) = False Then Exit Sub


If status(ForVar(i).gridrow).col2 <> Str$(ForVar(i).Value) Then
    status(ForVar(i).gridrow).col2 = Str$(ForVar(i).Value)
    statusfrm.Table1.RefreshRow = ForVar(i).gridrow
End If



End Sub

Sub showvgauge (SubDevNo As Integer)
Dim i As Integer
Dim r_no As Integer

Dim A$
Dim B$


Dim RobotCntrl  As robotCNTRLtype
Dim robotWC As robotWCtype

If OptMenuChecked(1) = False Then Exit Sub


i = findsubdev(SubDevNo, WC_vgag)     'search through subdevices for gauge

A$ = "Not Connected"
r_no = SubDev(i).Control_device(2) - 1
If r_no >= 0 Then
    READDATA r_no, RobotCntrl
    If RobotCntrl.online = 1 Then
        READWC r_no, robotWC
        A$ = Format$(robotWC.anainputs(SubDev(i).Control_Pin(2)))
    End If
End If


If status(HeightGauge(SubDevNo).gridrow).col2 <> A$ Then
    status(HeightGauge(SubDevNo).gridrow).col2 = A$
    statusfrm.Table1.RefreshRow = HeightGauge(SubDevNo).gridrow
End If


B$ = Format$(HeightGauge(SubDevNo).Value)
If status(HeightGauge(SubDevNo).gridrow + 1).col2 <> B$ Then
    status(HeightGauge(SubDevNo).gridrow + 1).col2 = B$
    statusfrm.Table1.RefreshRow = HeightGauge(SubDevNo).gridrow + 1
End If


End Sub

Sub showwgauge (SubDevNo As Integer)




Dim i As Integer
Dim r_no As Integer
Dim A$
Dim B$
Dim RobotCntrl  As robotCNTRLtype
Dim robotWC As robotWCtype


If OptMenuChecked(1) = False Then Exit Sub

i = findsubdev(SubDevNo, WC_Wgag)     'search through subdevices for gauge

A$ = "Not Connected"
r_no = SubDev(i).Control_device(2) - 1
If r_no >= 0 Then
    READDATA r_no, RobotCntrl
    If RobotCntrl.online = 1 Then
        READWC r_no, robotWC
        A$ = Format$(robotWC.anainputs(SubDev(i).Control_Pin(2)))
    End If
End If

If status(WidthGauge(SubDevNo).gridrow).col2 <> A$ Then
    status(WidthGauge(SubDevNo).gridrow).col2 = A$
    statusfrm.Table1.RefreshRow = WidthGauge(SubDevNo).gridrow
End If


B$ = Format$(WidthGauge(SubDevNo).Value)
If status(WidthGauge(SubDevNo).gridrow + 1).col2 <> B$ Then
    status(WidthGauge(SubDevNo).gridrow + 1).col2 = B$
    statusfrm.Table1.RefreshRow = WidthGauge(SubDevNo).gridrow + 1
End If





    
End Sub

