VERSION 2.00
Begin Form xyzdataType 
   Caption         =   "XYZ"
   ClientHeight    =   1215
   ClientLeft      =   2700
   ClientTop       =   6225
   ClientWidth     =   4935
   FontBold        =   -1  'True
   FontItalic      =   0   'False
   FontName        =   "Arial"
   FontSize        =   9
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   Height          =   1845
   HelpContextID   =   360
   Left            =   2670
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   1215
   ScaleWidth      =   4935
   Top             =   5625
   Width           =   4995
   Begin TrueGrid Table1 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BorderStyle     =   0  'None
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "Arial"
      FontSize        =   9
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      HeadingHeight   =   1
      Height          =   852
      HorzLines       =   0  'None
      Layout          =   XYZ.FRX:0000
      LayoutIndex     =   1
      Left            =   0
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   -1  'True
      SplitTabMode    =   0  'Don't tab across splits
      TabCapture      =   0   'False
      TabIndex        =   1
      Top             =   0
      UseBookmarks    =   -1  'True
      Width           =   4932
      WrapCellPointer =   0   'False
   End
   Begin Label EDITFUNC 
      Height          =   372
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   972
   End
   Begin Menu calib 
      Caption         =   "C&alibration"
   End
   Begin Menu help 
      Caption         =   "&Help"
   End
End
Option Explicit
Option Compare Text
DefInt A-Z

Dim Rindex As Integer
Dim Columns As Integer

Sub calib_Click ()

Calib_Robot Rindex

End Sub

Sub EditFunc_Change ()

Select Case EDITFUNC.Caption
Case "Resize"
    Form_Resize
Case Else

End Select
EDITFUNC.Caption = ""

End Sub

Sub Form_Activate ()

Dim Robotcntrl  As robotCNTRLtype


Calib.Enabled = False

Select Case RobotFrmDat(Rindex).DevType
Case SerpentEC1, SerpentEC2, Gryphon, GryphonSlide, Neptune1, Neptune2
     READDATA RobotFrmDat(Rindex).DevNo, Robotcntrl
     If Robotcntrl.online = 1 Then Calib.Enabled = True
End Select


End Sub

Sub Form_Load ()


Rindex = 0
Do
    If Me Is XyzData(Rindex) Then Exit Do
    Rindex = Rindex + 1
Loop
Caption = RobotFrmDat(Rindex).name
position(Rindex).Cartesian = True
                 
Select Case RobotFrmDat(Rindex).DevType
    Case Neptune2
        Caption = RobotFrmDat(Rindex).name + " (Yaw=2048)"
        Columns = 6

    Case Serpent1, Serpent2, SerpentEC1, SerpentEC2, Kestrel
        Table1.ColumnVisible(4) = False
        Columns = 5
    Case Else
        Columns = 6
        'table1.LayoutIndex = 1
End Select
Table1.Rows = 1

Setwindowsize Me
End Sub

Sub Form_Resize ()

Dim Metrics As TEXTMETRIC
Dim i As Integer
Dim j As Integer
Dim w As Integer
Dim cursize As Variant

    If WindowState = 1 Then Exit Sub
    
    Table1.Width = scalewidth
    Table1.Height = scaleheight
    
    If OptMenuChecked(9) Then
        SetAvailFontSize
        For i = 0 To TimerForm.fontsizes.ListCount - 1
            cursize = TimerForm.fontsizes.List(i) + .1
            FontName = Walfont.FontName
            FontSize = cursize
            FontName = Walfont.FontName
            FontBold = Walfont.FontBold
            FontItalic = Walfont.FontItalic
    
           If GetTextMetrics(hdc, Metrics) = 0 Then
                MsgBox "Serious Error #1!"
                Exit For
           End If

            w = 0
            For j = 1 To Table1.Columns
                If Table1.ColumnVisible(j) Then
                    w = w + Table1.ColumnWidth(j) * Metrics.tmAveCharWidth * screen.TwipsPerPixelX
                End If
            Next

           'w = Columns * 6 * Metrics.tmAveCharWidth * screen.TwipsPerPixelX       '6 columns of 6 chars
            If w < scalewidth Then
                Exit For
            End If
        Next
        'Second to fit both rows
        'If GetTextMetrics(hdc, Metrics) = 0 Then
        '    MsgBox "Serious Error #2!"
        '    Exit Sub
        'End If
        'range(0).Height = (Metrics.tmHeight + Metrics.tmExternalLeading + 1) * screen.TwipsPerPixelY
        'range(0).Width = rangechars * Metrics.tmAveCharWidth * screen.TwipsPerPixelX + (Metrics.tmAveCharWidth - 1) * screen.TwipsPerPixelX

    Else
         cursize = Walfont.FontSize
    End If


    FontName = Walfont.FontName
    FontSize = cursize
    FontName = Walfont.FontName
    FontBold = Walfont.FontBold
    FontItalic = Walfont.FontItalic
    On Local Error Resume Next
    For i = 0 To controls.Count - 1
        controls(i).FontName = Walfont.FontName
        controls(i).FontSize = cursize
        controls(i).FontName = Walfont.FontName
        controls(i).FontBold = Walfont.FontBold
        controls(i).FontItalic = Walfont.FontItalic
        controls(i).BackColor = newcolour(Table_BackColor)
        controls(i).ForeColor = newcolour(Table_ForeColor)
    Next
    On Local Error GoTo 0


        
    Table1.FontName = Walfont.FontName
    Table1.FontSize = cursize
    Table1.FontName = Walfont.FontName
    Table1.FontBold = Walfont.FontBold
    Table1.FontItalic = Walfont.FontItalic

    Table1.BackColor = newcolour(Table_BackColor)
    Table1.ForeColor = newcolour(Table_ForeColor)

    Table1.HeadBackColor = newcolour(Head_BackColor)
    Table1.InactiveBackColor = newcolour(Head_BackColor)

    Table1.HeadForeColor = newcolour(Head_ForeColor)
    Table1.InactiveForeColor = newcolour(Head_ForeColor)

'    For i = 0 To Columns
'        heading(i).Visible = True
'        Position(i).Visible = True
 '   Next

    
    



End Sub

Sub Form_Unload (Cancel As Integer)
position(Rindex).Cartesian = False
End Sub

Sub Help_Click ()
    screen.MousePointer = 11        'wait
    TimerForm.CMDialog1.HelpFile = app.Path & "\" & app.HelpFile
    TimerForm.CMDialog1.HelpCommand = HELP_context
    TimerForm.CMDialog1.HelpContext = helpcontextid
    TimerForm.CMDialog1.Action = 6
    screen.MousePointer = 0
End Sub

Sub Table1_Fetch (Row As Long, col As Integer, Value As String)
Select Case col
Case 1
    Value = position(Rindex).X
Case 2
    Value = position(Rindex).y
Case 3
    Value = position(Rindex).z
Case 4
    Value = position(Rindex).Ele
Case 5
    Value = position(Rindex).Rot
Case 6
    Value = position(Rindex).Grip
Case Else
    Value = ""
End Select

End Sub

