VERSION 2.00
Begin Form CartesianFrm 
   Caption         =   "Cartesian"
   ClientHeight    =   2925
   ClientLeft      =   2385
   ClientTop       =   4335
   ClientWidth     =   6945
   FontBold        =   -1  'True
   FontItalic      =   0   'False
   FontName        =   "Arial"
   FontSize        =   9.75
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   Height          =   3555
   HelpContextID   =   190
   Left            =   2355
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   2925
   ScaleWidth      =   6945
   Top             =   3735
   Width           =   7005
   Begin SSPanel Panel 
      Align           =   2  'Align Bottom
      AutoSize        =   3  'AutoSize Child To Panel
      BorderWidth     =   1
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "Arial"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   495
      Left            =   0
      RoundedCorners  =   0   'False
      TabIndex        =   1
      Top             =   2430
      Width           =   6945
   End
   Begin TrueGrid Table1 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BorderStyle     =   0  'None
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "Arial"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      HeadingHeight   =   1
      Height          =   1335
      HorzLines       =   0  'None
      Layout          =   CARTESIA.FRX:0000
      LayoutIndex     =   1
      Left            =   0
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   -1  'True
      SplitTabMode    =   0  'Don't tab across splits
      TabCapture      =   0   'False
      TabIndex        =   0
      Top             =   0
      UseBookmarks    =   -1  'True
      Width           =   5415
      WrapCellPointer =   0   'False
   End
   Begin Menu MainMenu 
      Caption         =   "&Solution"
      Begin Menu Soln 
         Caption         =   "Solution &1"
         Index           =   0
         Shortcut        =   +{F1}
      End
      Begin Menu Soln 
         Caption         =   "Solution &2"
         Index           =   1
         Shortcut        =   +{F2}
      End
      Begin Menu Soln 
         Caption         =   "Solution &3"
         Index           =   2
         Shortcut        =   +{F3}
      End
      Begin Menu Soln 
         Caption         =   "Solution &4"
         Index           =   3
         Shortcut        =   +{F4}
      End
   End
End
Option Explicit
Dim xyz  As XYZtype

Sub Form_Activate ()
Table1.RowIndex = RobotFrm(Robotfrmno).Table1.RowIndex

    Select Case RobotFrmDat(Robotfrmno).DevType
    Case Serpent1, Serpent2, SerpentEC1, SerpentEC2
        Table1.ColumnVisible(5) = False
    End Select

setsnap RobotFrmDat(Robotfrmno).DevNo, True


End Sub

Sub Form_Deactivate ()
Unload Me
End Sub

Sub Form_Load ()
Setwindowsize Me
End Sub

Sub Form_Resize ()


Table1.Width = scalewidth
Table1.Height = panel.Top



Dim Metrics As TEXTMETRIC
Dim i As Integer
Dim j As Integer
Dim w As Integer
Dim cursize As Variant

If windowstate <> 0 Then Exit Sub


        
        If OptMenuChecked(9) Then
                SetAvailFontSize
                For i = 0 To timerform.fontsizes.ListCount - 1
                cursize = timerform.fontsizes.List(i) + .1
                FontName = WalFont.FontName
                FontSize = cursize
                FontName = WalFont.FontName
                FontBold = WalFont.FontBold
                FontItalic = WalFont.FontItalic

                If GetTextMetrics(hdc, Metrics) = 0 Then
                        MsgBox "Serious Error #1!"
                        Exit For
                End If
                w = (Table1.Columns - 1 + getsystemmetrics(SM_CXVSCROLL)) * screen.TwipsPerPixelX
                
                For j = 1 To Table1.Columns
                        w = w + Table1.ColumnWidth(j) * Metrics.tmAveCharWidth * screen.TwipsPerPixelX + (Metrics.tmAveCharWidth - 1) * screen.TwipsPerPixelX
                Next
                If w < scalewidth Then
                        Exit For
                End If
                Next
        Else
                cursize = WalFont.FontSize
                FontName = WalFont.FontName
                FontSize = cursize
                FontName = WalFont.FontName
                FontBold = WalFont.FontBold
                FontItalic = WalFont.FontItalic
        End If
        
        
        For i = 0 To controls.Count - 1
                Table1.FontName = WalFont.FontName
                Table1.FontSize = cursize
                Table1.FontName = WalFont.FontName
                Table1.FontBold = WalFont.FontBold
                Table1.FontItalic = WalFont.FontItalic
        Next


        Table1.HeadBackColor = newcolour(Head_BackColor)
        Table1.InactiveBackColor = newcolour(Head_BackColor)

        Table1.HeadForeColor = newcolour(Head_ForeColor)
        Table1.InactiveForeColor = newcolour(Head_ForeColor)

        Table1.BackColor = newcolour(Table_BackColor)
        Table1.ForeColor = newcolour(Table_ForeColor)

        
        Table1.EditBackColor = newcolour(Edit_BackColor)
        Table1.EditForeColor = newcolour(Edit_Forecolor)

        Table1.SelectedForeColor = newcolour(Table2_BackColor)
        Table1.SelectedBackColor = newcolour(Table2_ForeColor)

        panel.BackColor = newcolour(Table_BackColor)
        panel.ForeColor = newcolour(Table_ForeColor)




End Sub

Sub Form_Unload (Cancel As Integer)
setsnap RobotFrmDat(Robotfrmno).DevNo, False
End Sub

Sub SetValidSolns (send As Integer)
    
Static tmp(7)  As Integer
Dim index As Integer
Dim Row As Long
Dim i As Integer
Dim j As Integer
Static change(3) As Integer


    For i = 0 To 3  'up to 4 solutions
        change(i) = 0
    Next

    Row = Table1.RowIndex
    
    i = 0
    Select Case RobotFrmDat(Robotfrmno).DevType
    Case MENTOR
        For index = 0 To 3
            If Gryphon_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, index) Then
                Soln(i).Tag = index
                For j = 0 To 2  'Sum changes of axes 0,1,2,3,4
                    change(i) = change(i) + Abs(tmp(j) - rcopy(low(Row), high(Row)).c(j))
                Next
                i = i + 1
            End If
        Next

    Case GRYPHON, GRYPHONSlide
        For index = 0 To 3
            If Gryphon_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, index) Then
                Soln(i).Tag = index
                For j = 0 To 2  'Sum changes of axes 0,1,2,3,4
                    change(i) = change(i) + Abs(tmp(j) - rcopy(low(Row), high(Row)).c(j))
                Next
                i = i + 1
            End If
        Next
    Case Serpent1
        For index = 0 To 1
            If Serpent1_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, index) Then
                Soln(i).Tag = index
                For j = 0 To 1  'Sum changes of axes 0,1
                    change(i) = change(i) + Abs(tmp(j) - rcopy(low(Row), high(Row)).c(j))
                Next
                i = i + 1
            End If
        Next
    
    Case Serpent2
        For index = 0 To 1
            If Serpent2_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, index) Then
                Soln(i).Tag = index
                For j = 0 To 1  'Sum changes of axes 0,1
                    change(i) = change(i) + Abs(tmp(j) - rcopy(low(Row), high(Row)).c(j))
                Next
                i = i + 1
            End If
        Next
    Case SerpentEC1
        For index = 0 To 1
            If SerpentEC1_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, index) Then
                Soln(i).Tag = index
                For j = 0 To 1  'Sum changes of axes 0,1
                    change(i) = change(i) + Abs(tmp(j) - rcopy(low(Row), high(Row)).c(j))
                Next
                i = i + 1
            End If
        Next
    
    Case SerpentEC2
        For index = 0 To 1
            If SerpentEC2_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, index) Then
                Soln(i).Tag = index
                For j = 0 To 1  'Sum changes of axes 0,1
                    change(i) = change(i) + Abs(tmp(j) - rcopy(low(Row), high(Row)).c(j))
                Next
                i = i + 1
            End If
        Next
        
    End Select


    index = 0: j = change(index)    'Assume solution 0 will be used
    
    Select Case i   'Number of valid solutions
        Case 0
            MainMenu.Enabled = False
            panel.Caption = "No Solutions Available"
        Case 1
            panel.Caption = "One Solution Available"
            MainMenu.Enabled = False
            If send Then Soln_click 0
        Case 2
            panel.Caption = "Two Solutions Available"
            MainMenu.Enabled = True
            If send Then
                If change(1) < j Then index = 1
                Soln_click index
            End If
            Soln(2).Enabled = False
            Soln(3).Enabled = False
        Case 3
            panel.Caption = "Three Solutions Available"
            MainMenu.Enabled = True
            For i = 1 To 2
                If change(i) < j Then index = i: j = change(i)
            Next
            If send Then Soln_click index
            Soln(2).Enabled = True
            Soln(3).Enabled = False
        Case 4
            panel.Caption = "Four Solutions Available"
            MainMenu.Enabled = True
            If send Then
                For i = 1 To 3
                    If change(i) < j Then index = i: j = change(i)
                Next
                Soln_click index
            End If
            Soln(2).Enabled = True
            Soln(3).Enabled = True
    End Select

End Sub

Sub Soln_click (index As Integer)

Static tmp(7) As Integer
Dim Row As Long
Dim i As Integer


Row = Table1.RowIndex
    
    For i = 0 To 7
        tmp(i) = rcopy(low(Row), high(Row)).c(i)
    Next
    i = Soln(index).Tag

    Select Case RobotFrmDat(Robotfrmno).DevType
    Case MENTOR
        If Not Mentor_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, i) Then Exit Sub
    Case GRYPHON, GRYPHONSlide
        If Not Gryphon_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, i) Then Exit Sub
    
    Case Serpent1
        If Not Serpent1_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, i) Then Exit Sub
        
    Case Serpent2
        If Not Serpent2_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, i) Then Exit Sub
    
    Case SerpentEC1
        If Not SerpentEC1_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, i) Then Exit Sub
    
    Case SerpentEC2
        If Not SerpentEC2_InverseK(RobotFrmDat(Robotfrmno).DevNo, tmp(), xyz, i) Then Exit Sub
    End Select
        
    For i = 0 To 7
        rcopy(low(Row), high(Row)).c(i) = tmp(i)
    Next
    RobotFrm(Robotfrmno).EDITFUNC.Caption = "inverse"
    Table1.RefreshRow = 0

End Sub

Sub Table1_Fetch (Row As Long, col As Integer, value As String)

Select Case col
Case 1
    value = rcopy(low(Row), high(Row)).LineName
    Select Case RobotFrmDat(Robotfrmno).DevType
    Case MENTOR
        Mentor_XYZsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case GRYPHON, GRYPHONSlide
        Gryphon_XYZsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case Serpent1
        Serpent1_Xyzsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case Serpent2
        Serpent2_Xyzsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case SerpentEC1
        SerpentEC1_Xyzsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case SerpentEC2
        SerpentEC2_Xyzsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    End Select
Case 2
    value = Format$(xyz.X, "##0.0")
Case 3
    value = Format$(xyz.y, "##0.0")
Case 4
    value = Format$(xyz.z, "##0.0")
Case 5
    value = Format$(xyz.E, "##0.0")
Case 6
    value = Format$(xyz.R, "##0.0")
Case 7
    value = Format$(xyz.G, "##0")

End Select

End Sub

Sub Table1_RowChange ()
Dim Row As Long
    
    Row = Table1.RowIndex
    RobotFrm(Robotfrmno).Table1.RowIndex = Row
    
    Select Case RobotFrmDat(Robotfrmno).DevType
    Case MENTOR
        Mentor_XYZsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case GRYPHON, GRYPHONSlide
        Gryphon_XYZsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case Serpent1
        Serpent1_Xyzsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case Serpent2
        Serpent2_Xyzsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case SerpentEC1
        SerpentEC1_Xyzsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    Case SerpentEC2
        SerpentEC2_Xyzsums RobotFrmDat(Robotfrmno).DevNo, rcopy(low(Row), high(Row)).c(), xyz
    End Select

SetValidSolns (False)



End Sub

Sub Table1_Update (Row As Long, col As Integer, value As String)

    Select Case col
    Case 1
        rcopy(low(Row), high(Row)).LineName = value
        RobotFrm(Robotfrmno).EDITFUNC.Caption = "inverse"
    
    Case 2
        xyz.X = Val(value)
        SetValidSolns True
    
    Case 3
        xyz.y = Val(value)
        SetValidSolns True
    
    Case 4
        xyz.z = Val(value)
        SetValidSolns True
    
    Case 5
        xyz.E = Val(value)
        SetValidSolns True
    
    Case 6
        xyz.R = Val(value)
        SetValidSolns True
    
    Case 7
        Select Case RobotFrmDat(Robotfrmno).DevType
        Case GRYPHON, MENTOR, GRYPHONSlide
            rcopy(low(Row), high(Row)).c(5) = Val(value)
        Case Else
            rcopy(low(Row), high(Row)).c(4) = Val(value)
        End Select
        RobotFrm(Robotfrmno).EDITFUNC.Caption = "inverse"
    End Select


End Sub

