Comment *
	Walli3 For Windows
	(C) Cybernetic Aplications 1994/5

	Version History 
	Started                           10/1/94
	Sent to Feedback                  20/5/94

	Mill and xboard added            30/10/94

	Released to Thailand             23/12/94 Walli ver 1.000 Cyber Ver 1.008

	Gryphon (offline) added            3/1/95
	Serpent (offline) added           10/1/95

	Pre-release to Nigel @ Feedback   12/1/95 Walli ver 1.000+ Cyber ver 1.009

	Serpent (online) added            13/1/95
	Kestrel (offline) added           17/1/95

	Lathe (offline) added             19/1/95  

	Gryphon released (1 Feedback)     17/2/95 Walli ver 1.02 Cyber ver 1.02

	Vietnam table                             Walli ver 1.009 Cyber ver 2.007
											  Serpent us
	
	Feedback Serp+Gry                 4/8/95  Walli ver 1.010 Cyber ver 2.007
	
	India Nep1,Kes etc                8/8/95  Walli ver 1.011
											  Changes listed in updates


*





include cyber.inc



.LALL


inthand proto far pascal, :word, :word, :dword, :dword, :dword
dummyinthand proto far pascal, :word, :word, :dword, :dword, :dword


.data
taskhead byte 16 dup(0)         ;Page 265 of MASM Programmer's guide
timeid dw 0
intcnt dw 0

BaseSelector dw 0

rj45base dw 0                   ;IO address of interface
rj45id  dw 0

installdriver dw false

retval dw 0


ifdef ps2build
ps2 dw false
endif

ifdef oldturbo
turbocnt dw 100
endif

ifdef winnt
hVDD dw 0               ;Handle to 32bit DLL
tmpreg dw 0


DllName  db "iovdd.dll",0
InitFunc db "InitFunc",0
DispFunc db "DispFunc",0




endif




commondata


.code
dllinit proc far pascal public
	mov ax,TRUE
	ret
dllinit endp






service_pulsedevice proc near private
	
	mov ax,robot[bx].rj45
	mov rj45id,ax

	mov ax,robot.devtype[bx]
	.if ax==MENTOR+0100h
		call service_turbo_mentor_pulses
	
	.elseif ax==MENTOR+0200h
		call service_rj45_turbo_mentor_pulses
	
	.elseif ax==MENTOR+0300h
		call service_rj45_mentor_pulses
	
	.elseif ax==XBOARD
		call service_turbo_xboard_pulses
	
	.elseif ax==XBOARD+0100h
		call service_rj45_xboard_pulses

	.elseif (ax==SERPENT1) || (ax==SERPENT2)
		call service_turbo_serpent_pulses
	
	.else           ;8032 device, do nothing
		
	.endif
	ret
service_pulsedevice endp




option prologue:none
option epilogue:none



loadbop proc far pascal export 

	Prolog
		
	ifdef winnt
		push ds
		pop  es
		mov si,offset DllName   ;DS:SI
		mov di,offset InitFunc  ;DS:DI
		mov bx,offset DispFunc  ;DS:BX

		RegisterModule
				
		mov hVDD,ax
				
		.if carry?
		      mov ax,666
		.endif
	endif 


	Epilog
	ret
loadbop endp


unloadbop proc far pascal export 
	Prolog
	ifdef winnt
		mov ax,hVDD
		UnRegisterModule
	endif
	Epilog
	ret
unloadbop endp



chain proc far pascal export baseseg:word, rj45seg:word
	Prolog
	push es
	pushad
	
	.if timeid == 0
		
		.if (rj45base != 0) || (baseseg != 0)
			mov installdriver,true        
		.else
			mov installdriver,false
		.endif
		
		
		
		mov ax,rj45seg
		mov rj45base,ax

		
		
		.if baseseg != 0
			invoke AllocSelector, es
			movzx edx,baseseg       ;convert 16 bit selector
			shl edx,4               ;to 32 bit physical address
			invoke SetSelectorBase, ax, edx
			mov BaseSelector,ax
			invoke SetSelectorLimit, ax, 04000h
			
			;Check that DL card actually exists
			
			mov installdriver,false
			
			mov ax,BaseSelector
			mov es,ax
			
			ifdef OldTurbo 
				mov installdriver,true            
			Else
				mov al,es:[0e0h]        ;start dummy turbo cycle
				mov al,es:[02000h]      ;read End Of Cycle flag
				and al,1                ;which should not        
				.if al==0               ;be set - yet
					mov cx,1000
					.repeat
						mov al,es:[02000h]      ;read End Of Cycle flag
						and al,1
					.untilcxz al==1
					.if cx != 0
						mov installdriver,true
						ifdef ps2build
						mov ps2,false
						endif
					.endif
				.endif
			endif

			ifdef ps2build
				.if installdriver==false        ;Check for MCA card
					mov ax,BaseSelector
					mov es,ax
					mov al,es:[0e0h]        ;start dummy turbo cycle
					mov al,es:[0200h]       ;read End Of Cycle flag
					and al,1                ;which should not        
					.if al==1               ;be set - yet
						mov cx,1000
						.repeat
							mov al,es:[0200h]      ;read End Of Cycle flag
							and al,1
						.untilcxz al!=1
						.if cx != 0
							mov installdriver,true
							mov ps2,true
						.endif
					.endif
				.endif
			endif

		.else
			mov BaseSelector,0              
		.endif
		
		
		.if installdriver==true
			;Original version was set for 25msec repeat
			;   caused mouse grief on IBM? Irish table bodged to 75usec
			;   IBM interrupts > 55 appeared to be set in multiples of 55
			;   hence 50 cf 55 to force(?) exact period
			
			ifdef winnt
				invoke timeSetEvent, 150, 150, cs, lroffset cs:inthand, 2, TIME_PERIODIC
			else
				invoke timeSetEvent, 50, 50, cs, lroffset cs:inthand, 2, TIME_PERIODIC
			endif


		.else
			invoke timeSetEvent, 50, 50, cs, lroffset cs:dummyinthand, 2, TIME_PERIODIC
		.endif
		mov timeid,ax
	
	.endif
	
	popad
	pop es

	
	Epilog
	ret 4
chain endp


unchain proc far pascal export
	Prolog
	pushad
	.if timeid != 0
		invoke timeKillEvent, timeid
		mov timeid,0
		.if BaseSelector!=0
			invoke FreeSelector, BaseSelector
		.endif
		mov bx,0
		.repeat
			mov robot[bx].online,DEV_UNCONNECT
			add bx,sizeof robot_data_Struc
		.until bx==16*sizeof robot_data_Struc


	.endif
	popad
	Epilog
	ret
unchain endp


dummyinthand proc far pascal export wTimerID:word, wMsg:word, dwUser:dword, dw1:dword, dw2:dword
	Prolog
	pusha

	inc intcnt
	mov bx,0
	.repeat
		mov ax,robot.devtype[bx]
		.if ax==MENTOR
			call service_mentor_offline
		
		.elseif (ax==SERPENT1) || (ax==SERPENT2)
			call service_turbo_serpent_offline
		
		.elseif (ax==SerpentEc1) || (ax==SerpentEc2)
			call service_rj45_serpent_offline
		
		.elseif ax==GRYPHON
			call service_gryphon_offline
		.elseif ax==GRYPHONSLIDE
			call service_gryphonslide_offline

		.elseif ax==KESTREL
			call service_kestrel_offline

		.elseif ax==Neptune1
			call service_Neptune1_offline

		.elseif ax==Neptune2
			call service_Neptune2_offline

		.elseif (ax==XBoard) || (ax==XBOARD+0100h)
			call service_xboard_offline

		.endif

		add bx,sizeof robot_data_Struc
	.until bx==16*sizeof robot_data_Struc
	
	popa
	Epilog
	ret
dummyinthand endp



inthand proc far pascal export wTimerID:word, wMsg:word, dwUser:dword, dw1:dword, dw2:dword
	Prolog
	push es
	pushad 
	pushfd 
	
	inc intcnt
	
	mov bx,0
	mov dx,0        ;dx will still be 0 if nobody wants pulses
	.repeat
		.IF robot.pulsecount[bx] > 1
			mov dx,1
		.endif
		add bx,sizeof robot_data_Struc
	.until bx==16*sizeof robot_data_Struc
	
	.if dx==0
		
		settimer2 66000
		
		mov ax,BaseSelector
		mov es,ax
		
		;mov al,255
		;mov es:[0e7h],al
	
		mov bx,0
		.repeat
			mov ax,robot[bx].rj45
			mov rj45id,ax
			mov ax,robot.devtype[bx]
			.if ax==MENTOR
				call getmentorissue           ;rj45 or turbo bus
			.elseif ax==MENTOR+0100h
				call Service_turbo_mentor
			.elseif ax==MENTOR+0200h
				call service_rj45_turbo_mentor
			.elseif ax==MENTOR+0300h
				call service_rj45_mentor
			
			.elseif ax==XBOARD
				call service_turbo_xboard
			
			.elseif ax==XBOARD+0100h
				call service_rj45_xboard
			
			.elseif ax==GRYPHON
				call service_rj45_gryphon
			.elseif ax==GRYPHONSLIDE
				call service_rj45_gryphonSLIDE
				
			
			.elseif (ax==SERPENT1) || (ax==SERPENT2)
				call service_turbo_serpent
			
			.elseif (ax==SerpentEc1) || (ax==SerpentEc2)
				call service_rj45_serpent
			
			.elseif ax==KESTREL
				call service_rj45_kestrel
			
			.elseif ax==NEPTUNE1
				call service_Neptune1
			
			.elseif ax==NEPTUNE2
				call service_Neptune2
			
			.elseif ax==CNCMILL
				call service_rj45_mill
			
			.elseif ax==CNCLATHE
				call service_rj45_lathe
			.endif
			add bx,sizeof robot_data_Struc
		.until bx==16*sizeof robot_data_Struc


		;mov al,0
		;mov es:[0e7h],al


	.endif

	popfd 
	popad
	pop es
	Epilog
	ret
inthand endp


readWC proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov si,ax
	add si,lroffset robot.WC.DIG_inputs[0] 

	les di,address
	mov cx,(sizeof WC_Struc)/2
	rep movsw
	
	pop di
	pop si
	pop es
	Epilog
	ret 6
readWC endp


readId proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov si,ax
	add si,lroffset robot.Prom.PromId[0]

	les di,address
	mov cx,sizeof Prom_Struc
	rep movsb
	
	pop di
	pop si
	pop es
	Epilog
	ret 6
readId endp


setbacklash proc far pascal export dev:word, x:word, y:word, z:word
	Prolog
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	
	mov ax,x
	mov robot[bx].MillCalib.X_back,ax
	mov ax,y
	mov robot[bx].MillCalib.Y_back,ax
	mov ax,z
	mov robot[bx].MillCalib.Z_back,ax
	
	Epilog
	ret 8
setbacklash endp

setcalib proc far pascal export dev:word, x:word, y:word, z:word, valid:word
	Prolog
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	
	mov ax,x
	mov robot[bx].MillCalib.X_calib,ax
	mov ax,y
	mov robot[bx].MillCalib.Y_calib,ax
	mov ax,z
	mov robot[bx].MillCalib.Z_calib,ax

	mov ax,valid
	mov robot[bx].MillCalib.calibrated,ax
	
	Epilog
	ret 10
setcalib endp


setserpentcalib proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov si,ax

	add si,lroffset robot.SerpCalib.cal.cal_m[0]

	les di,address
	mov cx,sizeof Serpent_Cal_Struc/2
	
	.repeat                                 
		mov ax,es:[di]
		mov [si],ax                                 ;save to robot.cal0
		
		mov [si+sizeof Serpent_Cal_Struc],ax        ;save to robot.cal1
		mov [si+2*sizeof Serpent_Cal_Struc],ax      ;save to robot.cal2
		mov [si+3*sizeof Serpent_Cal_Struc],ax      ;save to robot.cal3

		add di,2
		add si,2
   .untilcxz


	pop di
	pop si
	pop es
	Epilog
	ret 6
setserpentcalib endp

readserpentcalib proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	
	mov si,ax
	add si,lroffset robot.SerpCalib.cal.cal_m[0]
	
	les di,address
	mov cx,sizeof Serpent_Cal_Struc/2
	rep movsw
	

	pop di
	pop si
	pop es
	Epilog
	ret 6
readserpentcalib endp


SetNeptunecalib proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov si,ax

	add si,lroffset robot.NepCalib.cal_m[0]

	les di,address
	mov cx,sizeof Neptune_Calibration_Struc/2
	
	.repeat                                 
		mov ax,es:[di]
		mov [si],ax                                 ;save to robot.cal0
		
		add di,2
		add si,2
   .untilcxz

	pop di
	pop si
	pop es
	Epilog
	ret 6
setNeptunecalib endp

readNeptunecalib proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	
	mov si,ax
	add si,lroffset robot.NepCalib.cal_m[0]
	
	les di,address
	mov cx,sizeof Neptune_Calibration_Struc/2
	rep movsw
	

	pop di
	pop si
	pop es
	Epilog
	ret 6
readNeptunecalib endp



SetLatheCalib proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov si,ax

	add si,lroffset robot.LatheCalib.X_Tool[0]

	les di,address
	mov cx,sizeof Lathe_Calibration_Struc/2
	
	.repeat                                 
		mov ax,es:[di]
		mov [si],ax    
		
		add di,2
		add si,2
   .untilcxz

	pop di
	pop si
	pop es
	Epilog
	ret 6
setLathecalib endp

readLathecalib proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	
	mov si,ax
	add si,lroffset robot.LatheCalib.X_Tool[0]
	
	les di,address
	mov cx,sizeof Lathe_Calibration_Struc/2
	rep movsw
	

	pop di
	pop si
	pop es
	Epilog
	ret 6
readLathecalib endp



setemerstop proc far pascal
	Prolog
	cli
	mov bx,0
	.repeat
		mov ax,robot[bx].teachmode
		mov robot[bx].Lastteachmode,ax
		mov robot[bx].teachmode,EmerStop
		add bx,sizeof robot_data_Struc
	.until bx==16*sizeof robot_data_Struc
	sti
	Epilog
	ret
setemerstop endp

Clearemerstop proc far pascal
	Prolog
	cli 
	mov bx,0
	.repeat
		mov ax,robot[bx].Lastteachmode
		mov robot[bx].teachmode,ax
		mov robot[bx].resend,true
		add bx,sizeof robot_data_Struc
	.until bx==16*sizeof robot_data_Struc
	sti

	Epilog
	ret
Clearemerstop endp


setSnap proc far pascal export dev:word, state:word
	Prolog
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	
	mov ax,state
	mov robot[bx].snap,ax

	Epilog
	ret 4
SetSnap Endp 

SetFilter proc far pascal export dev:word, state:word
	Prolog
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	
	.if state==false
		mov robot[bx].filterenable,false
	.else
		mov robot[bx].filterenable,true
	.endif


	Epilog
	ret 4
SetFilter Endp 




setonline proc far pascal export dev:word
	Prolog
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	mov ax,robot[bx].online
	.if ax==DEV_OFFLINE
		mov robot[bx].online,DEV_ONLINE
		mov robot[bx].teachmode,init        ; Sets Despos = FB

		mov intcnt,0            ;wait until timer interrupt
		.repeat                 ;send data to arms
		.until intcnt!=0

	.endif
	Epilog
	ret 2
setonline endp

setoffline proc far pascal export dev:word
	Prolog
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	mov ax,robot[bx].online
	.if ax==DEV_ONLINE
		mov robot[bx].online,DEV_OFFLINE
	.endif
	Epilog
	ret 2
setoffline endp


setbuffer proc far pascal export dev:WORD, address:dword, first:word 
;comment writes to 256 byte string at address to buffer        
	
	Prolog
	push es
	pusha 

	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	.if first != FALSE
		mov robot[bx].startmill,true            ;Tells mill to reset counters
	.endif
	
	mov si,bx
	add si,lroffset robot[0].buffer
	
	
	les di,address
	mov cx,128                      ;Move 256 bytes              
	.repeat                                
		mov ax,es:[di]
		mov [si],ax
		add di,2
		add si,2
	.untilcxz

	mov robot[bx].buffer_empty,false                ;Mark buffer valid

	popa
	pop es
	Epilog
	ret 8
setbuffer endp



setdespos proc far pascal export dev:WORD, address:dword 
	Prolog
	push es
	push si
	push di

	mov ax,sizeof robot_data_Struc
	mul dev
	mov si,ax
	add si,lroffset robot.despos[0] 

	
	les di,address
	mov cx,(sizeof despos_data)/2
	.repeat                                 ;rep movsw
		mov ax,es:[di]
		mov [si],ax
		add di,2
		add si,2
	.untilcxz

	mov intcnt,0            ;wait until timer interrupt
	.repeat                 ;send data to arms
	.until intcnt>2

	pop di
	pop si
	pop es
	Epilog
	ret 6
setdespos endp


readdata proc far pascal export dev:word, address:dword
	Prolog
	push es
	push si
	push di
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov si,ax
	add si,lroffset robot.despos[0] 

	les di,address
	mov cx,(sizeof common_data)/2         ;Write despos thru inpos
	rep movsw
	
	pop di
	pop si
	pop es
	Epilog
	ret 6
readdata endp


waitint proc far pascal export
	Prolog
	mov intcnt,0            ;wait until timer interrupt
	.repeat                 ;send data to arms
	.until intcnt!=0
	Epilog
	ret
waitint endp


stopaxis proc far pascal export dev:word, axis:word
	Prolog
	push si

	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	
	mov intcnt,0            ;wait for next interrupt

	mov si,axis
	add si,si

	mov robot[bx].stop[si],18       ; Was TRUE
									; altered to 18 for Neptunes
	.repeat
	.until (robot[bx].stop[si]==false) || (intcnt > 64)
	mov robot[bx].stop[si],false

	mov ax,robot[bx].despos[si]

	pop si
	Epilog
	ret 4
stopaxis endp



setpulseop proc far pascal export dev:word, op:word, count:word, speed:word
	Prolog
	
	
	push es
	pushall

	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax

	.if robot.online[bx]==DEV_ONLINE
	
	mov ax,robot.devtype[bx]
	.if ax==CNCMILL || ax==CNCLATHE || ax==GRYPHON|| ax==GRYPHONSLIDE || ax==KESTREL || ax==SerpentEc1 || ax==SerpentEc2
		
		mov ax,rate_wcpulses
		mov robot.mesgaddr[bx],ax
		mov robot.mesg[bx],080h
		mov robot.mesgflag[bx],true
		.repeat                             ;send data to device
		.until robot.mesgflag[bx]==false 

			
		mov ax,rate_wcpulses+1
		mov robot.mesgaddr[bx],ax
		mov robot.mesg[bx],0f8h
		mov robot.mesgflag[bx],true
		.repeat                             ;send data to device
		.until robot.mesgflag[bx]==false
		
		
		mov ax,wc_pulses
		mov robot.mesgaddr[bx],ax
		mov ax,count
		mov ah,0
		mov robot.mesg[bx],ax
		mov robot.mesgflag[bx],true
		.repeat                 ;send data to device
		.until robot.mesgflag[bx]==false
		
		
		mov ax,wc_pulses+1
		mov robot.mesgaddr[bx],ax
		mov ax,count
		mov al,ah
		mov ah,0
		mov robot.mesg[bx],ax
		mov robot.mesgflag[bx],true
		.repeat                 ;send data to device
		.until robot.mesgflag[bx]==false
		
		mov ax,WCNTRL
		mov robot.mesgaddr[bx],ax
		mov ax,pulse_wc     ;Mill function call
		add ax,op
		add ax,op
		mov robot.mesg[bx],ax
		mov robot.mesgflag[bx],true
		.repeat                 ;send data to device
		.until robot.mesgflag[bx]==false
	
	.else
		.while robot.pulsecount[bx] != 0
		.endw
		mov ax,op
		mov robot.pulseop[bx],ax
		mov ax,count
		mov robot.pulsecount[bx],ax
		.IF AX > 1
			mov ax,BaseSelector
			mov es,ax
			settimer2 20000
			
			mov cx,robot.pulsecount[bx]
			.repeat
				push cx
				mov cx,speed            ;50 about right for conveyor
				.repeat
					timer2wait
				.untilcxz
				call service_pulsedevice
				pop cx
			.untilcxz
			mov robot.pulsecount[bx],0
		.ENDIF
	.endif

	.endif
	popall
	pop es
	Epilog
	ret 8
setpulseop endp



setop proc far pascal export dev:word, op:word, state:word
	Prolog

	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax

	
	.if robot.online[bx]==DEV_ONLINE
	
	mov ax,robot.devtype[bx]
	.if ax==CNCMILL || ax==CNCLATHE || ax==GRYPHON|| ax==GRYPHONSLIDE || ax==KESTREL || ax==SerpentEc1 || ax==SerpentEc2

		mov robot.mesgaddr[bx],wcntrl
		
		mov ax,state
		.if ax==0
			mov ax,Reset_WC
		.else
			mov ax,Set_WC
		.endif
		add ax,op
		add ax,op
		mov robot.mesg[bx],ax
		mov robot.mesgflag[bx],true
		
		.repeat                             ;send data to device
		.until robot.mesgflag[bx]==false


	.else
		mov cx,op
		.if cx<8
			mov ax,robot[bx].WC.DIG_output[0]
			mov dx,1
			sal dx,cl
			or ax,dx
			mov cx,ax
			sub ax,dx
			.if state==0
				mov robot[bx].WC.DIG_output[0],ax
			.else
				mov robot[bx].WC.DIG_output[0],cx
			.endif
		.else
			sub cx,8
			mov ax,robot[bx].WC.DIG_output[2]
			mov dx,1
			sal dx,cl
			or ax,dx
			mov cx,ax
			sub ax,dx
			.if state==0
				mov robot[bx].WC.DIG_output[2],ax
			.else
				mov robot[bx].WC.DIG_output[2],cx
			.endif
		.endif
		
		
		mov intcnt,0            ;wait until timer interrupt
		.repeat                 ;send data to arms
		.until intcnt!=0
	.endif

	.endif

	Epilog
	ret 6

setop endp

setrs232op proc far pascal export dev:word, op:word, dialog:word
	Prolog
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	
	mov ax,op
	mov robot.pulseop[bx],ax

	mov ax,dialog
	mov robot.rs232data[bx],ax

	mov robot.rs232flag[bx],true

	
	.repeat                 ;send data to arms
	.until robot.rs232flag[bx]==false

	Epilog
	ret 6

setrs232op endp


Comment *
	Sync Serial added 15/12/96
*

ReadSerial proc far pascal export dev:word, op:word, ip:word
	Prolog
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	
	mov ax,op
	mov robot.pulseop[bx],ax

	mov ax,ip
	mov robot.SerialIP[bx],ax

	mov robot.SerialFlag[bx],true

	
	.repeat             
	.until robot.SerialFlag[bx]==false      

	mov ax,robot[BX].SerialOP       ;Return result

	Epilog
	ret 6

ReadSerial endp








send_rj45_mesg proc far pascal export dev:word, mesgaddr:word, mesg:word
	Prolog

	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	
	
	.if robot.online[bx]==DEV_ONLINE
		mov ax,mesgaddr
		mov robot.mesgaddr[bx],ax
	
		mov ax,mesg
		mov robot.mesg[bx],ax

		mov robot.mesgflag[bx],true

		.repeat                 ;send data to device
		.until robot.mesgflag[bx]==false
	.endif

	Epilog
	ret 6
send_rj45_mesg endp





setteachmode proc far pascal export dev:word, dtype:word
	Prolog
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	mov ax,dtype
	mov robot.teachmode[bx],ax
	
	Epilog
	ret 4
setteachmode endp


SetInsert proc far pascal export dev:word, dtype:word
Comment *        
	Flag is set by Neptune Nose-Lead
	Clear when line inserted by Timer
*

	Prolog
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	mov ax,dtype
	mov robot[bx].Insert,ax
	
	Epilog
	ret 4
SetInsert endp




setdevtype proc far pascal export dev:word, dtype:word, devaddress:word
comment *        
	devaddress
	0  - A4l
	1  - A5l
	2  - A6l
	3  - A7l
	4  - AWl
	5  - AXl
	6  - AYl
	7  - AZl
	8  - A4h 
	9  - A5h
	10 - A6h 
	11 - A7h 
	12 - AWh 
	13 - AXh 
	14 - AYh 
	15 - AZh 

	16 - RJ45 0
	17 - RJ45 1 etc

*
	
	Prolog
	push si
	
	mov ax,sizeof robot_data_Struc
	mul dev
	mov bx,ax
	mov ax,devaddress
	.if ax==0
		mov robot[BX].write,0e0h
		mov robot[BX].read,010h
	.elseif ax==1
		mov robot[BX].write,0d0h
		mov robot[BX].read,020h
	.elseif ax==2
		mov robot[BX].write,0b0h
		mov robot[BX].read,040h
	.elseif ax==3
		mov robot[BX].write,070h
		mov robot[BX].read,080h
	.elseif ax==4
		mov robot[BX].write,0
		mov robot[BX].read,030h
	.elseif ax==5
		mov robot[BX].write,050h
		mov robot[BX].read,060h
	.elseif ax==6
		mov robot[BX].write,090h
		mov robot[BX].read,0a0h
	.elseif ax==7
		mov robot[BX].write,0c0h
		mov robot[BX].read,0f0h
	.elseif ax==8
		mov robot[BX].write,0e8h
		mov robot[BX].read,018h
	.elseif ax==9
		mov robot[BX].write,0d8h
		mov robot[BX].read,028h
	.elseif ax==10
		mov robot[BX].write,0b8h
		mov robot[BX].read,048h
	.elseif ax==11
		mov robot[BX].write,078h
		mov robot[BX].read,088h
	.elseif ax==12
		mov robot[BX].write,08h
		mov robot[BX].read,038h
	.elseif ax==13
		mov robot[BX].write,058h
		mov robot[BX].read,068h
	.elseif ax==14
		mov robot[BX].write,098h
		mov robot[BX].read,0a8h
	.elseif ax==15
		mov robot[BX].write,0c8h
		mov robot[BX].read,0f8h
	
	.elseif ax==16
		mov robot[BX].rj45,011100000b     ;RJ45 device 1
		mov robot[BX].write,-1
	
	.elseif ax==17
		mov robot[BX].rj45,011010000b     ;RJ45 device 2
		mov robot[BX].write,-1
	
	.elseif ax==18
		mov robot[BX].rj45,010110000b     ;RJ45 device 3
		mov robot[BX].write,-1
	
	.elseif ax==19
		mov robot[BX].rj45,001110000b     ;RJ45 device 4
		mov robot[BX].write,-1
	
	
	.elseif ax==20
		mov robot[BX].rj45,011000000b     ;RJ45 device 5
		mov robot[BX].write,-1

	.elseif ax==21
		mov robot[BX].rj45,010100000b     ;RJ45 device 6
		mov robot[BX].write,-1

	.elseif ax==22
		mov robot[BX].rj45,001100000b     ;RJ45 device 7
		mov robot[BX].write,-1

	.elseif ax==23                                                
		mov robot[BX].rj45,010010000b     ;RJ45 device 8
		mov robot[BX].write,-1






	.endif               
	
	mov ax,dtype
	;.if ax==SERPENT1 || ax==SERPENT2
	;    .if devaddress >= 16                ;If serpent is on RJ45 bus
	;        add ax,0100h                    ; add 0100h
	;    .endif
	;.endif
	
	.if ax==Xboard
		.if devaddress >= 16                ;If Xboard is on RJ45 bus
			add ax,0100h                    ; add 0100h
		.endif
	.endif
	mov robot.devtype[bx],ax


	mov robot.online[bx],DEV_UNCONNECT
	mov robot.teachmode[bx],INIT
	mov robot.SimPres[bx],1             ;Assume Simulator will be present 
	
	mov robot[bx].table_page,2          ;First page to be written will be 2
	mov robot[bx].buffer_empty,true
	mov robot[bx].startmill,false

	mov robot[bx].filterenable,true
	
	invoke InitFilters
	


	;mov robot.pad[bx],0

	pop si
	Epilog
	ret 6
setdevtype endp



LowI Proc far pascal export INDEX:dword
	Prolog
	mov eax,index
	dec eax
	and eax,1023
	inc eax
	
	Epilog
	ret 4
LowI Endp

HighI Proc far pascal export INDEX:dword
	Prolog

	mov eax,index
	dec eax
	shr eax,10      ;\1024

	Epilog
	ret 4
HighI Endp




clear_rj45 macro id
	
	waitrjfree
	
	RJout 4,id
	RJout 8,0       ;start transmit cycle - clears DATA_EN on 8032 cards

	endm



isrj45 proc far pascal export baseseg:word, tries:word
	Prolog

	
	mov retval,0
	
	mov dx,baseseg
	mov rj45base,dx
	
	
	settimer2 66000
	
	mov rj45id,011100000b     ;RJ45 device 1
	invoke set8032page,INTERNAL
	invoke peek_8032,scratch
	
	mov rj45id,011010000b     ;RJ45 device 2
	invoke set8032page,INTERNAL
	invoke peek_8032,scratch
	
	mov rj45id,010110000b     ;RJ45 device 3
	invoke set8032page,INTERNAL
	invoke peek_8032,scratch

	mov rj45id,001110000b     ;RJ45 device 4
	invoke set8032page,INTERNAL
	invoke peek_8032,scratch

	mov rj45id,011000000b     ;RJ45 device 5
	invoke set8032page,INTERNAL
	invoke peek_8032,scratch

	mov rj45id,010100000b     ;RJ45 device 6
	invoke set8032page,INTERNAL
	invoke peek_8032,scratch

	mov rj45id,001100000b     ;RJ45 device 7
	invoke set8032page,INTERNAL
	invoke peek_8032,scratch

	mov rj45id,010010000b     ;RJ45 device 8
	invoke set8032page,INTERNAL
	invoke peek_8032,scratch
	
	mov cx,tries

	.repeat
		waitrjfree

		RJout 0,0aah
		
		RJout 4,255     ; read status dummy device
		
		RJout 6,0aah
		RJout 8,0aah

		waitrjfree

		add dx,2

		Portin al,dx
		
		.if al == 85
			inc retval
		.endif
		
	.untilcxz


	mov ax,retval

	Epilog
	ret 4
isrj45 endp


clearrj45 proc near private
	clear_rj45 011100011b     ;RJ45 device 1
	clear_rj45 011010011b     ;RJ45 device 2
	clear_rj45 010110011b     ;RJ45 device 3
	clear_rj45 001110011b     ;RJ45 device 4
	clear_rj45 011000011b     ;RJ45 device 5
	clear_rj45 010100011b     ;RJ45 device 6
	clear_rj45 001100011b     ;RJ45 device 7
	clear_rj45 010010011b     ;RJ45 device 8
	ret
clearrj45 endp





SetTurboCnt proc far pascal export Counter:word
	Prolog
	ifdef oldturbo
		mov ax,Counter
		Mov TurboCnt,ax
	endif
	Epilog
	ret 2
SetTurboCnt Endp

SubVersion proc far pascal export
	Prolog
	
	ifdef winnt
		Echo <WinNT>
		mov ax,3
	
	else
	
	
	
	ifdef oldturbo
		echo <Old Turbo>
		mov ax,2        ; Build for old turbo boards
	else
		Echo <Normal>
		mov ax,1        ; Standard build
	endif

	endif
	Epilog
	ret
SubVersion endp

testformem proc far pascal export baseseg:word
	Prolog
	invoke AllocSelector, es
	movzx edx,baseseg               ;convert 16 bit selector
	shl edx,4                       ;to 32 bit physical address
	invoke SetSelectorBase, ax, edx
	push ax
	invoke SetSelectorLimit, ax, 04000h
	pop es

	mov dx,es:[017h]                ;take copy - may need to replace
	
	mov es:[017h],word ptr 100      ;turbo board will fail - memory ok
	mov ax,es:[017h]
	mov es:[017h],dx                ;replace - in case its memory
	
	
	.if ax==100
		mov ax,1               ; its RAM
	.else
		;could be ROM, Free, or Turbo
		call isturbo
		.if ax==TRUE
			mov ax,2      ;its Turbo  
		.else
			call ismca
			.if ax==TRUE
				mov ax,5        ;its MCA turbo card
			.else
				call isROM
				.if ax==TRUE
					mov ax,3
				.else
					;mov ax,4

					mov dl,es:[016h]
					mov es:[016h],byte ptr 69
					
					mov cx,100      ;Wait
					.repeat
					.untilcxz
					
					mov al,es:[016h]
					mov es:[016h],dl

					.if al==69
						mov ax,4        ;Old turbo
					.else
						mov ax,6        ;UFO        
					.endif

				.endif
			.endif
		.endif
	.endif


	PUSH AX
	invoke FreeSelector, es
	POP AX
	
	Epilog
	ret 2
testformem endp


ismca proc near private                
	mov al,es:[0e0h]        ;start dummy turbo cycle
	mov al,es:[0200h]       ;read End Of Cycle flag
	and al,1                ;which should not        
	.if al==1               ;be cleared - yet
		mov cx,1000
		.repeat
			mov al,es:[0200h]      ;read End Of Cycle flag
			and al,1
		.untilcxz al!=1
		.if cx != 0
			mov ax,TRUE
		.else
			mov ax,FALSE
		.endif
	.else
		mov ax,FALSE
	.endif
	ret
ismca endp

		
isturbo proc near private                
	mov al,es:[0e0h]        ;start dummy turbo cycle
	mov al,es:[02000h]      ;read End Of Cycle flag
	and al,1                ;which should not        
	.if al==0               ;be set - yet
		mov cx,1000
		.repeat
			mov al,es:[02000h]      ;read End Of Cycle flag
			and al,1
		.untilcxz al==1
		.if cx != 0
			mov ax,TRUE
		.else
			mov ax,FALSE
		.endif
	.else
		mov ax,FALSE
	.endif
	ret
isturbo endp 


isROM proc near private                
	mov dx,es:[0]
	mov ax,es:[8]
	.if (ax==0ffffh) && (dx==0ffffh)
		mov ax,FALSE    ;its not ROM
	.else
		mov ax,TRUE     
	.endif
	
	ret
isROM endp



DLchecksum proc far pascal export baseseg:word
	Prolog
	
	invoke AllocSelector, es
	movzx edx,baseseg               ;convert 16 bit selector
	shl edx,4                       ;to 32 bit physical address
	invoke SetSelectorBase, ax, edx
	push ax
	invoke SetSelectorLimit, ax, 04000h
	pop es

	mov dx,0                ;dx will be checksum
	
	mov di,0
	.repeat
		peek di
		add dx,ax
		inc di
	.until di==010h
	
	mov di,050h
	.repeat
		peek di
		add dx,ax
		inc di
	.until di==060h
	
	mov di,090h
	.repeat
		peek di
		add dx,ax
		inc di
	.until di==0a0h
	
	mov di,0C0h
	.repeat
		peek di
		add dx,ax
		inc di
	.until di==0cfh
	
	
	PUSH dX
	invoke FreeSelector, es
	POP AX
	Epilog
	ret 2
DLchecksum endp



code2 segment 'code'
	assume cs:code2

wep proc far export
	Prolog
	mov ax,1
	Epilog
	ret
wep endp

code2 ends


end dllinit





