Option Explicit
Option Compare Text
DefInt A-Z


'Const Horizontal = &H10
'Const Vertical = &H20
'Const Diagonal1 = &H40
'Const Diagonal2 = &H80
'Const Hole = &H100
'Const SizeMask = &HF
'Const DirMask = &HFF0


Const bufferlen = 4096

Dim quit      As Integer
Dim in_handle As Integer
Dim Absolute  As Integer
Dim pen       As Integer
Dim Curline As Long
Dim X As tranSform
Dim y As tranSform
Dim z As tranSform

Dim buffer As String
Dim PTR As Integer

Dim Tmp_GCode() As tmp_gcode_type
Dim G As gscales

Type dxf_type
    G  As Integer
    x1 As Integer
    y1 As Integer

    x2 As Integer
    Y2 As Integer

    Xc As Integer
    Yc As Integer

    Comment As String
End Type

Type Poly_type
    X As Single
    y As Single
    Bulge As Single
End Type

Dim dxf() As dxf_type
Dim Poly() As Poly_type
Dim Lptr() As Integer

Dim Blockname() As String


Dim Matrix()  As Integer

Dim PcbTable As table
Dim db As DataBase

Function ACOS (theta As Single) As Single

Select Case theta
Case 1
    ACOS = 0
Case -1
    ACOS = PI
Case 0
    ACOS = PI / 2
Case Else
    ACOS = Atn(-theta / Sqr(-theta * theta + 1)) + PI / 2
End Select

End Function

Private Sub clearline (linenum As Long)
    
    'Mcopy(LOW(linenum), HIGH(linenum)).n = linenum
    Mcopy(low(linenum), high(linenum)).G = Notset
    Mcopy(low(linenum), high(linenum)).X = Notset
    Mcopy(low(linenum), high(linenum)).y = Notset
    Mcopy(low(linenum), high(linenum)).z = Notset
    Mcopy(low(linenum), high(linenum)).i = Notset
    Mcopy(low(linenum), high(linenum)).j = Notset
    Mcopy(low(linenum), high(linenum)).k = Notset
    Mcopy(low(linenum), high(linenum)).F = Notset
    Mcopy(low(linenum), high(linenum)).S = Notset
    Mcopy(low(linenum), high(linenum)).t = Notset
    Mcopy(low(linenum), high(linenum)).d = Notset
    Mcopy(low(linenum), high(linenum)).m = Notset
    Mcopy(low(linenum), high(linenum)).pen = Notset
    Mcopy(low(linenum), high(linenum)).steps_to_units = Tmp_GCode(1, 0).steps_to_units

    Mcopy(low(linenum), high(linenum)).remarkPtr = 0

End Sub

Private Sub CNC_Addlastline (includeload, Keepscale, keepall)
Dim i As Integer

Cnc_Addline

'ReDim Preserve tmp_gcode(0 to chunk+1, 1 To high(curline - 1))


insert_rows = Curline - 1
Millcompress includeload, Keepscale, keepall

CNCfrm(CNCFrmNo).EditFunc.Caption = "Get"   'Give copy of prog to Mill Form



Erase Tmp_Remarks
Erase Tmp_GCode
Erase Mcopy



End Sub

Private Sub Cnc_Addline ()

Dim emptyline


    If Curline = 1 Then
        If Tmp_GCode(low(Curline), high(Curline)).G = Notset Then Exit Sub
        emptyline = False
    Else
        emptyline = True
        If Tmp_GCode(low(Curline), high(Curline)).G <> Tmp_GCode(low(Curline - 1), high(Curline - 1)).G Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).X <> Tmp_GCode(low(Curline - 1), high(Curline - 1)).X Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).y <> Tmp_GCode(low(Curline - 1), high(Curline - 1)).y Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).z <> Tmp_GCode(low(Curline - 1), high(Curline - 1)).z Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).i <> Tmp_GCode(low(Curline - 1), high(Curline - 1)).i Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).j <> Tmp_GCode(low(Curline - 1), high(Curline - 1)).j Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).k <> Tmp_GCode(low(Curline - 1), high(Curline - 1)).k Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).pen <> Notset Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).t <> Notset Then emptyline = False
        If Tmp_GCode(low(Curline), high(Curline)).m <> Notset Then emptyline = False
    End If
    
    If Not emptyline Then
        If high(Curline + 1) > UBound(Tmp_GCode, 2) Then
            ReDim Preserve Tmp_GCode(1 To CHUNK, 0 To UBound(Tmp_GCode, 2) + 1)         'Faster to add as many as possible
        End If
        
        Curline = Curline + 1                               'Point to next line
        Tmp_GCode(low(Curline), high(Curline)) = Tmp_GCode(low(Curline - 1), high(Curline - 1))     'Seed next line
        
        Tmp_GCode(low(Curline), high(Curline)).F = Notset
        Tmp_GCode(low(Curline), high(Curline)).S = Notset
        Tmp_GCode(low(Curline), high(Curline)).t = Notset
        Tmp_GCode(low(Curline), high(Curline)).pen = Notset
        Tmp_GCode(low(Curline), high(Curline)).d = Notset
        Tmp_GCode(low(Curline), high(Curline)).m = Notset

        Tmp_GCode(low(Curline), high(Curline)).remarkPtr = 0
    End If
End Sub

Private Sub CNC_Addline_ascii ()

'Used by ASCII insert

    If high(Curline + 1) > UBound(Tmp_GCode, 2) Then
        ReDim Preserve Tmp_GCode(1 To CHUNK, 0 To UBound(Tmp_GCode, 2) + 1)         'Faster to add as many as possible
    End If
        
    Curline = Curline + 1                               'Point to next line
        
    
    Tmp_GCode(low(Curline), high(Curline)).X = Notset
    Tmp_GCode(low(Curline), high(Curline)).y = Notset
    Tmp_GCode(low(Curline), high(Curline)).z = Notset
    Tmp_GCode(low(Curline), high(Curline)).i = Notset
    Tmp_GCode(low(Curline), high(Curline)).j = Notset
    Tmp_GCode(low(Curline), high(Curline)).k = Notset
    Tmp_GCode(low(Curline), high(Curline)).F = Notset
    Tmp_GCode(low(Curline), high(Curline)).S = Notset
    Tmp_GCode(low(Curline), high(Curline)).t = Notset
    Tmp_GCode(low(Curline), high(Curline)).pen = Notset
    Tmp_GCode(low(Curline), high(Curline)).d = Notset
    Tmp_GCode(low(Curline), high(Curline)).m = Notset
    Tmp_GCode(low(Curline), high(Curline)).remarkPtr = 0
    
    Tmp_GCode(low(Curline), high(Curline)).G = Tmp_GCode(low(Curline - 1), high(Curline - 1)).G
    Tmp_GCode(low(Curline), high(Curline)).steps_to_units = Tmp_GCode(low(Curline - 1), high(Curline - 1)).steps_to_units
End Sub

Private Sub CNC_Addline1 (Profile As Integer)

Dim i As Integer

Curline = 1


CNCFrmDat(CNCFrmNo).Filename = import_filename$                             'strip of extension 'if any

For i = Len(CNCFrmDat(CNCFrmNo).Filename) To 1 Step -1
    If Mid$(CNCFrmDat(CNCFrmNo).Filename, i, 1) = "\" Then Exit For
    If Mid$(CNCFrmDat(CNCFrmNo).Filename, i, 1) = "." Then
        CNCFrmDat(CNCFrmNo).Filename = Left$(CNCFrmDat(CNCFrmNo).Filename, i - 1)
        Exit For
    End If
Next

If Profile Then
    CNCFrmDat(CNCFrmNo).Filename = CNCFrmDat(CNCFrmNo).Filename + ".NCL"
Else
    CNCFrmDat(CNCFrmNo).Filename = CNCFrmDat(CNCFrmNo).Filename + ".NCM"
End If
    

ReDim Tmp_GCode(1 To CHUNK, 0 To 0)
ReDim Tmp_Remarks(1 To 1)

Tmp_GCode(low(Curline), high(Curline)).G = Notset

Tmp_GCode(low(Curline), high(Curline)).X = Notset
Tmp_GCode(low(Curline), high(Curline)).y = Notset
Tmp_GCode(low(Curline), high(Curline)).z = Notset
Tmp_GCode(low(Curline), high(Curline)).i = Notset
Tmp_GCode(low(Curline), high(Curline)).j = Notset
Tmp_GCode(low(Curline), high(Curline)).k = Notset

Tmp_GCode(low(Curline), high(Curline)).F = Notset
Tmp_GCode(low(Curline), high(Curline)).S = Notset
Tmp_GCode(low(Curline), high(Curline)).d = Notset
Tmp_GCode(low(Curline), high(Curline)).t = Notset
Tmp_GCode(low(Curline), high(Curline)).pen = Notset
Tmp_GCode(low(Curline), high(Curline)).m = Notset



If Profile Then
    Tmp_GCode(low(Curline), high(Curline)).G = 25
    Addremark Curline, "Profile imported from " + import_filename$
    Cnc_Addline
End If


If Options.metric Then
    Tmp_GCode(low(Curline), high(Curline)).steps_to_units = stepstomm      'Default to mm input
    Tmp_GCode(low(Curline), high(Curline)).G = 71
    Addremark Curline, "Metric"
Else
    Tmp_GCode(low(Curline), high(Curline)).steps_to_units = stepstoin      'Imperial
    Tmp_GCode(low(Curline), high(Curline)).G = 70
    Addremark Curline, "Imperial"
End If

End Sub

Sub DefPadx (CenterX, CenterY, R, Xinc, Yinc)


Dim dx, dy
Dim h As Long
Dim S, F
Dim y, y1, Y2

h = R ^ 2              'Hypot for outline
S = -1

Do
    S = S + 1
    y = Sqr(Abs((h - (S ^ 2))))

    Do Until Matrix(CenterX + (S * Xinc), CenterY + (y * Yinc)) <> 1      '1=copper
        If S = R Then Exit Sub
        S = S + 1
        y = Sqr(Abs((h - (S ^ 2))))
    Loop


    F = S
    Do
        Do Until Matrix(CenterX + (F * Xinc), CenterY + (y * Yinc)) <> 0
            If F = R Then Exit Do
            F = F + 1
            y = Sqr(Abs((h - (F ^ 2))))
        Loop
    
        If F = R Then
            Exit Do
        Else
            y = Sqr(Abs((h - ((F + 1) ^ 2))))
            If Matrix(CenterX + ((F + 1) * Xinc), CenterY + (y * Yinc)) <> 0 Then
                Exit Do
            Else
                F = F + 1
            End If
        End If
    Loop
    
    If F <> S Then
        If Matrix(CenterX + (F * Xinc), CenterY + (y * Yinc)) = 1 Then F = F - 1

        y1 = Sqr(Abs((h - (S ^ 2))))
        '
        'Dx = Tmp_GCode(low(Curline), high(Curline)).X - ((CenterX + (S * Xinc)) * intosteps / 200)
        'Dy = Tmp_GCode(low(Curline), high(Curline)).Y - (Options.blocky - ((CenterY + (Y1 * Yinc)) * intosteps / 200))
        'If (Dx <> 0) Or (Dy <> 0) Then
        '    Tmp_GCode(low(Curline), high(Curline)).G = 0
        '    Tmp_GCode(low(Curline), high(Curline)).X = (CenterX + (S * Xinc)) * intosteps / 200
        '    Tmp_GCode(low(Curline), high(Curline)).Y = Options.blocky - ((CenterY + (Y1 * Yinc)) * intosteps / 200)
        '    Tmp_GCode(low(Curline), high(Curline)).z = 0
        '    Cnc_Addline
        'End If
        '
        Y2 = Sqr(Abs((h - (F ^ 2))))
        'Tmp_GCode(low(Curline), high(Curline)).G = 3
        'Tmp_GCode(low(Curline), high(Curline)).X = (CenterX + (F * Xinc)) * intosteps / 200
        'Tmp_GCode(low(Curline), high(Curline)).Y = Options.blocky - ((CenterY + (Y2 * Yinc)) * intosteps / 200)
        '
        'Tmp_GCode(low(Curline), high(Curline)).i = (Abs(S)) * intosteps / 200
        'Tmp_GCode(low(Curline), high(Curline)).j = (Abs(Y1) * intosteps / 200)
        '
        'Tmp_GCode(low(Curline), high(Curline)).z = .1 * intosteps
        'Cnc_Addline
        'If S <> 0 Then
            '
            'Y2 = Sqr((S ^ 2) + (y1 ^ 2))
            
            'Y2 = Sqr(Abs((h - (S ^ 2))))
            'Y2 = Sqr(Abs((h - (y1 ^ 2))))
        'End If

        'If F <> R Then
             '
        'End If


    PcbTable.AddNew
    PcbTable("X1") = CenterX + (S * Xinc)
    PcbTable("Y1") = CenterY + (y1 * Yinc)
    
    PcbTable("X2") = CenterX + (F * Xinc)
    PcbTable("Y2") = CenterY + (Y2 * Yinc)

    PcbTable("XC") = CenterX
    PcbTable("YC") = CenterY

    PcbTable.Update



    End If
    
    S = F

Loop Until S = R































End Sub

Sub DefPady (CenterX, CenterY, R, Xinc, Yinc)

Dim dx, dy
Dim h As Long
Dim S, F
Dim X

h = R ^ 2              'Hypot for outline
S = -1

Do
    S = S + 1
    X = Sqr(Abs((h - (S ^ 2))))

    Do Until Matrix(CenterX + (X * Xinc), CenterY + (S * Yinc)) <> 1      '1=copper
        If S = R Then Exit Sub
        S = S + 1
        X = Sqr(Abs((h - (S ^ 2))))
    Loop


    F = S
    Do
        Do Until Matrix(CenterX + (X * Xinc), CenterY + (F * Yinc)) <> 0
            If F = R Then Exit Do
            F = F + 1
            X = Sqr(Abs((h - (F ^ 2))))
        Loop
        If F = R Then
            Exit Do
        Else
            X = Sqr(Abs((h - ((F + 1) ^ 2))))
            If Matrix(CenterX + (X * Xinc), CenterY + ((F + 1) * Yinc)) <> 0 Then
                Exit Do
            Else
                F = F + 1
            End If
        End If
    Loop




    
    If F <> S Then
        If Matrix(CenterX + (X * Xinc), CenterY + (F * Yinc)) = 1 Then F = F - 1

        'x = Sqr(Abs((h - (s ^ 2))))
        'Dx = Tmp_GCode(low(Curline), high(Curline)).x - ((CenterX + (x * Xinc)) * intosteps / 200)
        'Dy = Tmp_GCode(low(Curline), high(Curline)).Y - (Options.blocky - ((CenterY + (s * Yinc)) * intosteps / 200))
        'If (Dx <> 0) Or (Dy <> 0) Then
        '    Tmp_GCode(low(Curline), high(Curline)).G = 0
         '   Tmp_GCode(low(Curline), high(Curline)).x = (CenterX + (x * Xinc)) * intosteps / 200
         '   Tmp_GCode(low(Curline), high(Curline)).Y = Options.blocky - ((CenterY + (s * Yinc)) * intosteps / 200)
         '   Tmp_GCode(low(Curline), high(Curline)).z = 0
         '   Cnc_Addline
        'End If
        '
        'Tmp_GCode(low(Curline), high(Curline)).G = 3
        '
        'Tmp_GCode(low(Curline), high(Curline)).i = x * intosteps / 200
        'Tmp_GCode(low(Curline), high(Curline)).j = s * intosteps / 200
        '
        'x = Sqr(Abs((h - (f ^ 2))))
        'T'mp_GCode(low(Curline), high(Curline)).x = (CenterX + (x * Xinc)) * intosteps / 200
        'T'mp_GCode(low(Curline), high(Curline)).Y = Options.blocky - ((CenterY + (f * Yinc)) * intosteps / 200)
         '
        'Tmp_GCode(low(Curline), high(Curline)).z = .1 * intosteps
        'Cnc_Addline

    PcbTable.AddNew
    X = Sqr(Abs((h - (S ^ 2))))
    PcbTable("X1") = CenterX + (X * Xinc)
    PcbTable("Y1") = CenterY + (S * Yinc)
    
    X = Sqr(Abs((h - (F ^ 2))))
    PcbTable("X2") = CenterX + (X * Xinc)
    PcbTable("Y2") = CenterY + (F * Yinc)

    PcbTable("XC") = CenterX
    PcbTable("YC") = CenterY

    PcbTable.Update



    End If
    
    S = F

Loop Until S = R
































End Sub

Sub DefXLine (StartX, FinalX, y, m)
    
Dim S, F

    
    
    S = StartX - m * Sgn(FinalX - StartX)      'Before Start
    F = FinalX + m * Sgn(FinalX - StartX)          'After End
    MakeXLine S, F, y - m
    MakeYLine y - m, y + m, F
    MakeXLine F, S, y + m
    MakeYLine y + m, y - m, S

End Sub

Sub DefYLine (StartY, FinalY, X, m)
                    
Dim S, F

S = StartY - m * Sgn(FinalY - StartY)          'Before Start
F = FinalY + m * Sgn(FinalY - StartY)              'After End
MakeXLine X - m, X + m, S
MakeYLine S, F, X + m
MakeXLine X + m, X - m, F
MakeYLine F, S, X - m

End Sub

Private Sub der (i As Long)

Dim mm As Single
Dim j As Long
    
    mm = Val(Format$(i * stepstomm, "#.##"))
    j = mm * mmtosteps

    If j <> i Then
        i = j
    End If



End Sub

Sub DXF_LatheImport ()

Dim Msg As String
Dim Fail As Integer
Dim G As Integer
Dim g1 As Integer
Dim S As String

Dim v As Single
Dim A As Single
Dim P As Single
Dim F As Single

Dim X  As Single
Dim y  As Single
Dim x1 As Single
Dim x2 As Single
Dim y1 As Single
Dim Y2 As Single


Dim Xc As Single
Dim Yc As Single
Dim Radius As Single
Dim theta1 As Single
Dim theta2 As Single
Dim i As Integer


ReDim Tool(1 To 1)

If ReadDxf(False, 0) Then          'Read DXF file no layers
    Fail = False
    For i = 1 To UBound(dxf)            'Check bounds
        Select Case dxf(0, i).x1
            Case 0 To 66 * mmtosteps
            Case Else
                dxf(0, i).G = 0
                dxf(0, i).x1 = 0
                Fail = True
        End Select
        Select Case dxf(0, i).x2
            Case 0 To 66 * mmtosteps
            Case Else
                dxf(0, i).G = 0
                dxf(0, i).x2 = 0
                Fail = True
        End Select
        Select Case dxf(0, i).y1
            Case 0 To 16 * mmtosteps
            Case Else
                dxf(0, i).G = 0
                dxf(0, i).y1 = 0
                Fail = True
        End Select
        Select Case dxf(0, i).Y2
            Case 0 To 16 * mmtosteps
            Case Else
                dxf(0, i).G = 0
                dxf(0, i).Y2 = 0
                Fail = True
        End Select
    Next
    ShellSort

    CNC_Addline1 True       'Profile
    Cnc_Addline

x1 = -1
y1 = -1

For i = 1 To UBound(dxf, 2)
    If (x1 <> dxf(0, i).x1) Or (y1 <> dxf(0, i).y1) Then
        If (x1 = dxf(0, i).x2) And (y1 = dxf(0, i).Y2) Then     'swap x1 and x2
             dxf(0, i).x2 = dxf(0, i).x1: dxf(0, i).x1 = x1
             dxf(0, i).Y2 = dxf(0, i).y1: dxf(0, i).y1 = y1
             Select Case dxf(0, i).G
             Case 2
                dxf(0, i).G = 3
             Case 3
                dxf(0, i).G = 2
             End Select
        Else
            Tmp_GCode(low(Curline), high(Curline)).G = 0
            Tmp_GCode(low(Curline), high(Curline)).X = dxf(0, i).x1
            Tmp_GCode(low(Curline), high(Curline)).y = dxf(0, i).y1
            Cnc_Addline
        End If
    End If
    
    Tmp_GCode(low(Curline), high(Curline)).G = dxf(0, i).G
    Tmp_GCode(low(Curline), high(Curline)).X = dxf(0, i).x2
    Tmp_GCode(low(Curline), high(Curline)).y = dxf(0, i).Y2
        
    Tmp_GCode(low(Curline), high(Curline)).i = Abs(dxf(0, i).x1 - dxf(0, i).Xc)
    Tmp_GCode(low(Curline), high(Curline)).j = Abs(dxf(0, i).y1 - dxf(0, i).Yc)
    Cnc_Addline

    x1 = dxf(0, i).x2
    y1 = dxf(0, i).Y2
Next

Options.zstock = x1 + mmtosteps    'Default stock 1mm longer than object
Options.xstock = 15 * mmtosteps
Options.MaxCutDepth = .5 * mmtosteps
Options.blockx = Options.zstock * 1.1
Options.blocky = Options.xstock * 2.1

    mirrorx = 0
    mirrory = 1

Lathe_Addlastline True         'Don't scale

If Fail Then
    screen.MousePointer = 0
    DoEvents
    MsgBox "Entities beyond object bounds have been ignored", , "DXF Error"
End If

End If


DXF_End:

Unload StatusDlg
DoEvents
Erase dxf
Erase Tmp_GCode
Erase Mcopy
Erase Tool
screen.MousePointer = 0
Exit Sub



End Sub

Function DXF_MillImport ()

Dim SectionNo As Integer
Dim NewPen
Dim Fail As Integer
Dim i As Integer
Dim x1
Dim y1
Dim Dummy As Integer
Dim Layer As Integer

Load import
import.Caption = "DXF Postprocessor"
import.Tag = 3
import.Show 1
Dummy = import.Tag
Unload import
If Not Dummy Then Exit Function

ReDim Blockname(10)

For SectionNo = 0 To 10
    Blockname(SectionNo) = ""
Next
SectionNo = 0

Do
    If ReadDxf(True, SectionNo) Then          'Read DXF file using layers
        If SectionNo = 0 Then
            Fail = WriteDXF_Main()
        Else
             WriteDXF_Sub SectionNo, Fail
        End If
    End If
    SectionNo = SectionNo + 1
    If SectionNo > UBound(Blockname) Then
        ReDim Preserve Blockname(SectionNo + 10)
    End If
Loop Until Blockname(SectionNo) = ""


mirrorx = 0
mirrory = 1
CNC_Addlastline True, True, False           'Add nothing, keepscale

DXF_MillImport = True
    
    
Unload StatusDlg
DoEvents
Erase dxf
Erase Lptr
Erase Tmp_GCode
Erase Mcopy
Erase Tool
Erase Blockname
screen.MousePointer = 0

End Function

Sub fILL45lINE (StartX, FinalX, StartY, FinalY)

Dim Sx, SY

Sx = StartX
SY = StartY

Do
    If Sx < 0 Then Sx = 0
    If SY < 0 Then SY = 0
    
    Matrix(Sx, SY) = 1
    Sx = Sx + Sgn(FinalX - StartX)
    SY = SY + Sgn(FinalY - StartY)

Loop Until Sx = FinalX + Sgn(FinalX - StartX)





End Sub

Sub Gerber_Holes (pen)

Dim Dummy, X, y

Dim FirstHole


FirstHole = True


in_handle = FreeFile
Open import_filename$ For Binary Access Read Lock Write As in_handle
PTR = 1: buffer = "": refreshbuffer
Do
    refreshbuffer
    While Mid$(buffer, PTR, 1) < "*"                'Throw away white space and  was A
        If PTR > Len(buffer) Then Exit Do           'unwanted parameters
        PTR = PTR + 1
    Wend
        
        updatestatus
        PTR = PTR + 1
        Select Case Mid$(buffer, PTR - 1, 1)
        
        Case "D"
            Dummy = readnum(0, 0)
            Select Case Dummy
            
            Case 3  'Pad?
                If FirstHole Then
                    FirstHole = False
                    If pen <> 1 Then Tmp_GCode(low(Curline), high(Curline)).pen = pen
                    Tmp_GCode(low(Curline), high(Curline)).G = 0
                    Tmp_GCode(low(Curline), high(Curline)).X = X * intosteps / 400
                    Tmp_GCode(low(Curline), high(Curline)).y = Options.blocky - (y * intosteps / 400)
                    Tmp_GCode(low(Curline), high(Curline)).z = 0
                    Cnc_Addline
                End If

                Tmp_GCode(low(Curline), high(Curline)).G = 81
                Tmp_GCode(low(Curline), high(Curline)).X = X * intosteps / 400
                Tmp_GCode(low(Curline), high(Curline)).y = Options.blocky - (y * intosteps / 400)
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth
                Cnc_Addline

            
            Case Else
                
            End Select

        Case "X"
            'X = (readnum(0, 0) / 5) + 50            '50 gives room to go round track
            X = (2 * readnum(0, 0) / 5) + 100
            
        Case "Y"
            'y = (readnum(0, 0) / 5) + 50
            y = (2 * readnum(0, 0) / 5) + 100
    End Select

Loop
Close in_handle

End Sub

Sub Gerber_Import ()

Dim A$
Dim i As Integer
Dim FirstHole As Integer
Dim Dummy


Dim Xc, Yc, Radius

Load import
import.Caption = "Gerber Postprocessor"
import.Tag = 2
import.Show 1
Dummy = import.Tag
Unload import
If Not Dummy Then Exit Sub

SetUpStatus "Gerber Postprocessor"

CNC_Addline1 False

in_handle = FreeFile
Open import_filename$ For Binary Access Read Lock Write As in_handle
PTR = 1: buffer = "": refreshbuffer
Do
    refreshbuffer
    While Mid$(buffer, PTR, 1) < "*"                'Throw away white space and  was A
        If PTR > Len(buffer) Then Exit Do           'unwanted parameters
        PTR = PTR + 1
    Wend
        
        updatestatus
        PTR = PTR + 1
        Select Case Mid$(buffer, PTR - 1, 1)
        Case "*"
            '
            Cnc_Addline
        
        Case "D"
            Dummy = readnum(0, 0)
            Select Case Dummy
            Case 1
                'If pen <> 1 Then pen = 1: tmp_gcode(LOW(curline), HIGH(curline)).pen = pen
                Tmp_GCode(low(Curline), high(Curline)).G = 1
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth
                Cnc_Addline
            
            Case 2
                Tmp_GCode(low(Curline), high(Curline)).G = 0
                Tmp_GCode(low(Curline), high(Curline)).z = 0
                Cnc_Addline
            
            Case 3  'Pad?
                'If pen <> 2 Then pen = 2: tmp_gcode(LOW(curline), HIGH(curline)).pen = pen
                'tmp_gcode(LOW(curline), HIGH(curline)).g = 81
                'tmp_gcode(LOW(curline), HIGH(curline)).z = tool(pen).depth
                'CNC_Addline

                Radius = Tool(pen).size / 2
                         
                Xc = Tmp_GCode(low(Curline), high(Curline)).X
                Yc = Tmp_GCode(low(Curline), high(Curline)).y

                Tmp_GCode(low(Curline), high(Curline)).G = 0
                Tmp_GCode(low(Curline), high(Curline)).X = Xc - Radius
                Tmp_GCode(low(Curline), high(Curline)).y = Yc
                Tmp_GCode(low(Curline), high(Curline)).z = 0
                Cnc_Addline
                
                Tmp_GCode(low(Curline), high(Curline)).G = 3           'Remember Y is inverted?
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth
                Tmp_GCode(low(Curline), high(Curline)).X = Xc
                Tmp_GCode(low(Curline), high(Curline)).y = Yc - Radius: Tmp_GCode(low(Curline), high(Curline)).i = Radius: Tmp_GCode(low(Curline), high(Curline)).j = 0:            Cnc_Addline
                
                Tmp_GCode(low(Curline), high(Curline)).X = Xc + Radius: Tmp_GCode(low(Curline), high(Curline)).y = Yc: Tmp_GCode(low(Curline), high(Curline)).i = 0: Tmp_GCode(low(Curline), high(Curline)).j = Radius:             Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).X = Xc: Tmp_GCode(low(Curline), high(Curline)).y = Yc + Radius: Tmp_GCode(low(Curline), high(Curline)).i = Radius: Tmp_GCode(low(Curline), high(Curline)).j = 0:            Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).X = Xc - Radius: Tmp_GCode(low(Curline), high(Curline)).y = Yc: Tmp_GCode(low(Curline), high(Curline)).i = 0: Tmp_GCode(low(Curline), high(Curline)).j = Radius:             Cnc_Addline

                Tmp_GCode(low(Curline), high(Curline)).G = 0
                Tmp_GCode(low(Curline), high(Curline)).X = Xc
                Tmp_GCode(low(Curline), high(Curline)).y = Yc
                Tmp_GCode(low(Curline), high(Curline)).z = 0
                Cnc_Addline


            
            Case Else
                For pen = 1 To UBound(Apertures)
                    If Dummy = Apertures(pen) Then Exit For
                Next
                Tmp_GCode(low(Curline), high(Curline)).pen = pen
                    

            End Select

        Case "X"
            Tmp_GCode(low(Curline), high(Curline)).X = readnum(0, 0) * intosteps / 1000      ' g.scalex       'Convert to steps
            
        Case "Y"
            Tmp_GCode(low(Curline), high(Curline)).y = Options.blocky - readnum(0, 0) * intosteps / 1000    'g.scaley      'Convert to steps
            
    End Select

Loop

CNC_Addlastline True, True, False
'CNC_Addlastline True, False, False
Close in_handle

Unload StatusDlg
Erase Tool



End Sub

Sub Gerber_OutLine ()





Dim Dummy
Dim Lastx, X
Dim Lasty, y
Dim m, m45
Dim S, F
Dim G



Load import
import.Caption = "Gerber Postprocessor"
import.Tag = 2
import.Show 1
Dummy = import.Tag
Unload import
If Not Dummy Then Exit Sub



screen.MousePointer = 11    'busy


SetUpStatus "Gerber Postprocessor"
StatusDlg.Message.Caption = "Collecting Vectors": DoEvents

CNC_Addline1 False



Make_GerberMatrix       'Do First Pass
MDB         'create database for vectors
StatusDlg.Message.Caption = "Sorting Vectors": DoEvents


Tmp_GCode(low(Curline), high(Curline)).pen = 1

in_handle = FreeFile
Open import_filename$ For Binary Access Read Lock Write As in_handle
PTR = 1: buffer = "": refreshbuffer
Do
    refreshbuffer
    While Mid$(buffer, PTR, 1) < "*"                'Throw away white space and  was A
        If PTR > Len(buffer) Then Exit Do           'unwanted parameters
        PTR = PTR + 1
    Wend
        
        updatestatus
        PTR = PTR + 1
        Select Case Mid$(buffer, PTR - 1, 1)
        Case "*"
            If G = 1 Then
                If Lastx <> X Then
                    If Lasty <> y Then
                        Select Case Abs(Lastx - X) - Abs(Lasty - y)
                        Case 0
                        Case 1
                            Lastx = Lastx - Sgn(Lastx - X)
                        Case -1     ' Change Y by Less
                            Lasty = Lasty - Sgn(Lasty - y)
                        Case Else
                            'MsgBox "TOO DIFFICULT"
                            If Abs(Lasty - y) > Abs(Lastx - X) Then
                                DefYLine Lasty, Lasty + Sgn((Lasty - y)) * (Abs(Lastx - X) - Abs(Lasty - y)), X, m
                                Lasty = Lasty + Sgn((Lasty - y)) * (Abs(Lastx - X) - Abs(Lasty - y))
                            Else
                                DefXLine Lastx, Lastx + Sgn((Lastx - X)) * (Abs(Lasty - y) - Abs(Lastx - X)), y, m
                                Lastx = Lastx + Sgn((Lastx - X)) * (Abs(Lasty - y) - Abs(Lastx - X))
                            End If

                        End Select

                        If Abs(Lasty - y) = Abs(Lastx - X) Then
                            S = Sgn(Lastx - X) * m45
                            F = Sgn(Lasty - y) * m45
                            Make45Line X, Lastx + S, y - F, Lasty
                            Make45Line Lastx + S, Lastx, Lasty, Lasty + F
                            Make45Line Lastx, X - S, Lasty + F, y
                            Make45Line X - S, X, y, y - F
                        Else
                            MsgBox "Lines should be at multiples of 45 degrees"
                        End If

                    Else
                        DefXLine Lastx, X, y, m
                    End If
                ElseIf Lasty <> y Then
                    DefYLine Lasty, y, X, m
                End If
            End If
            Lastx = X
            Lasty = y
        
        Case "D"
            Dummy = readnum(0, 0)
            Select Case Dummy
            Case 1
                G = 1
            Case 2
                G = 0
            Case 3  'Pad?
                DefPadx X, y, m, 1, 1
                DefPady X, y, m, 1, -1
                DefPadx X, y, m, -1, -1
                DefPady X, y, m, -1, 1

                'MakeXLine X - m, X + m, y - m
                'MakeYLine y - m, y + m, X + m
                'MakeXLine X + m, X - m, y + m
                'MakeYLine y + m, y - m, X - m
            
            Case Else
                For pen = 1 To UBound(Apertures)
                    If Dummy = Apertures(pen) Then Exit For
                Next
                pen = pen + 2

                m = Tool(pen).size * stepstoin * 1000       'diameter in thou
                m = 2 * m / 5                               'Convert to 2.5 thou
                m = m - 1                                   'center
                m = m / 2                                   'rest either side
                If m = 0 Then m = 1
                m = m + 1

                m45 = Tool(pen).size * stepstoin * 1000      'diameter in thou
                m45 = m45 * Sqr(2)
                m45 = 2 * m45 / 5
                m45 = m45 - 1
                m45 = m45 / 2
                If m45 = 0 Then m45 = 1
                m45 = m45 + 1

            End Select

        Case "X"
            X = (2 * readnum(0, 0) / 5) + 100
            
        Case "Y"
            y = (2 * readnum(0, 0) / 5) + 100
            
    End Select

Loop
Close in_handle



Erase Matrix

'Gerber_Pads

StatusDlg.Message.Caption = "Processing Vectors": DoEvents
ProcessDb

StatusDlg.Message.Caption = "Centre Holes": DoEvents
Gerber_Holes 1       'Centre pop

StatusDlg.Message.Caption = "Drill Holes": DoEvents
Gerber_Holes 2       'Drill Holes

CNC_Addlastline True, True, False

Unload StatusDlg
Erase Tool


screen.MousePointer = 0


End Sub

Sub HPGL_LATHEimport ()

Dim Dummy As Long
Dim bytesleft As Long
Dim p1 As LongPoint
Dim p2 As LongPoint
Dim p1default As LongPoint
Dim p2default As LongPoint
Dim S1 As LongPoint
Dim s2 As LongPoint

Dim scalemode As Integer

Dim Xc As Single
Dim Yc As Single
Dim Radius As Single
Dim sweep As Single
Dim A As Single



Load LatheHpgl

If Options.xstock = 0 Then Options.xstock = 15 * mmtosteps
If Options.zstock = 0 Then Options.zstock = 66 * mmtosteps

Options.blocky = Options.xstock - mmtosteps
Options.blockx = Options.zstock - mmtosteps

LatheHpgl.size(0).Text = Format$(Options.xstock * stepstomm, "0.0")            'Block size
LatheHpgl.size(1).Text = Format$(Options.zstock * stepstomm, "0.0")

LatheHpgl.size(2).Text = Format$(Options.blocky * stepstomm, "0.0")      'Object Size
LatheHpgl.size(3).Text = Format$(Options.blockx * stepstomm, "0.0")

LatheHpgl.Show 1

Options.xstock = Val(LatheHpgl.size(0).Text) * mmtosteps
Options.zstock = Val(LatheHpgl.size(1).Text) * mmtosteps
Options.blocky = Val(LatheHpgl.size(2).Text) * mmtosteps
Options.blockx = Val(LatheHpgl.size(3).Text) * mmtosteps


Unload LatheHpgl
ReDim Tool(1 To 1)




screen.MousePointer = 11    'busy

in_handle = FreeFile
Open import_filename$ For Binary Access Read Lock Write As in_handle

SetUpStatus "HPGL Postprocessor"


PTR = 1: buffer = "": refreshbuffer

PTR = InStr(buffer, "IN")       'Find INitialise
If PTR = 0 Then

Else
    pen = 1
    CNC_Addline1 True       'Profile
    Cnc_Addline



    Do
        refreshbuffer
        While Mid$(buffer, PTR, 1) < "A"                'Throw away white space and
            If PTR > Len(buffer) Then Exit Do          'unwanted parameters
            PTR = PTR + 1
        Wend

        updatestatus
        PTR = PTR + 2
        Select Case Mid$(buffer, PTR - 2, 2)
'            Case "AC"       'Anchor corner
'            Case "AD"       'Alternate font Def
'
'            Case "BP"       'Begin Plot
'            Case "BR"       'Bezier
            Case "PG"       'Advance page
            Case "OE"       'Output error
            Case "EC"       'Enable cutter
            Case "LT"       'Line Type
            
            Case "EP"       'Edge Polygon
            Case "PM"       'Polygon mode
            Case "NR"       'Not Ready

            Case "CA"       'Character Set (?) not HPGL-2
            Case "GM"

            Case "IW"       'Input window
            Case "DI"       'Absolute Direction (Text)
            Case "SD"       'Standard font def
            Case "VS"       'Set velocity
            Case "PT"       'Pen size
            Case "FS"
            Case "AS"
            
            Case "FT"       'Fill type
            Case "FP"       'Fill polygon
            
            Case "AA"                       'Arc xc,yc,sweep angle


                Xc = readnum(0, 0) * X.m + X.c
                Yc = readnum(0, 0) * y.m + y.c
                sweep = readnum(0, 0)
                'Tmp_GCode(low(Curline), high(Curline)).z = tool(pen).depth

                'If Int(xc) = 15358 Then MsgBox "Centre " + Format$(sweep) + " " + Format$(xc)

                '+ve sweep CCW normally
                'BUT for Y reversal +VE = CW

                Radius = Sqr((G.X - Xc) * (G.X - Xc) + (G.y - Yc) * (G.y - Yc))
                'If Int(radius) = 854 Then
                    '
                'End If
                
                
                'Tmp_GCode(low(Curline), high(Curline)).z = tool(pen).depth
                
                While sweep <> 0
                    Tmp_GCode(low(Curline), high(Curline)).G = 3           'Remember Y is inverted?
                    
                    Tmp_GCode(low(Curline), high(Curline)).i = Abs(G.X - Xc)
                    Tmp_GCode(low(Curline), high(Curline)).j = Abs(G.y - Yc)
                    If Tmp_GCode(low(Curline), high(Curline)).i > Int(Radius) Then
                        Tmp_GCode(low(Curline), high(Curline)).i = Int(Radius)
                    End If
                    
                    If Tmp_GCode(low(Curline), high(Curline)).j > Int(Radius) Then
                        Tmp_GCode(low(Curline), high(Curline)).j = Int(Radius)
                    End If


                    If Abs(Sqr((Tmp_GCode(low(Curline), high(Curline)).i * Tmp_GCode(low(Curline), high(Curline)).i) + (Tmp_GCode(low(Curline), high(Curline)).j * Tmp_GCode(low(Curline), high(Curline)).j)) - Radius) > 2 Then
                    '
                    End If

                    If (Tmp_GCode(low(Curline), high(Curline)).i < 10) And (Tmp_GCode(low(Curline), high(Curline)).j < 10) Then
                        sweep = 0
                    ElseIf sweep > -.1 Then
                        sweep = 0
                    Else
                    If G.y - Yc = 0 Then
                        Select Case sweep
                            Case Is <= -90      '-ve = CCW
                                sweep = sweep + 90
                                If G.X > Xc Then
                                    G.y = Yc + Radius
                                Else
                                    G.y = Yc - Radius
                                End If
                                G.X = Xc
                                
                        
                            Case Is <= 0        'Sweep round clockwise
                                If G.X > Xc Then
                                    G.y = Yc - Sin(sweep * PI / 180) * Radius
                                    G.X = Xc + Cos(sweep * PI / 180) * Radius
                                    
                                Else
                                    G.X = G.X + (Radius - Cos(sweep * PI / 180) * Radius)    'WRONG
                                    
                                    G.y = G.y + Sin(sweep * PI / 180) * Radius
                                End If
                                sweep = 0

                            Case Else
                                MsgBox "Cockup on the arc front part 1"
                                sweep = 0
                        End Select
                    ElseIf G.X - Xc = 0 Then
                        Select Case sweep
                            Case Is <= -90
                                sweep = sweep + 90
                                If G.y > Yc Then
                                    G.X = Xc - Radius
                                    
                                Else
                                    G.X = Xc + Radius
                                    
                                End If
                                G.y = Yc
                    
                            Case Is <= 0
                                If G.y > Yc Then
                                    G.X = G.X + Sin(sweep * PI / 180) * Radius
                                    G.y = G.y - (Radius - Cos(sweep * PI / 180) * Radius)
                                    'If (Int(g.x) = -10475) Then MsgBox "From 6"
                                Else
                                    G.y = Yc - Cos(sweep * PI / 180) * Radius   '   'SHOULD BE +ve?
                                    G.X = Xc - Sin(sweep * PI / 180) * Radius
                                    'MsgBox "CORRECT?"
                                End If
                                sweep = 0
                        Case Else
                            MsgBox "Cockup on the arc front part 2"
                            sweep = 0
                        End Select
                    Else
                        A = Atn(Tmp_GCode(low(Curline), high(Curline)).j / Tmp_GCode(low(Curline), high(Curline)).i) * 180 / PI
                        If (G.X > Xc) Then
                            If (G.y > Yc) Then       'Top rhs
                                If sweep + (90 - A) <= 0 Then
                                    G.y = Yc + Radius
                                    G.X = Xc
                                    sweep = sweep + (90 - A)            'Correct
                                Else
                                    G.y = Yc - Sin((sweep - A) * PI / 180) * Radius     'correct
                                    G.X = Xc + Cos((sweep - A) * PI / 180) * Radius
                                    sweep = 0
                                End If
                            Else                    'Bottom rhs
                                If sweep + A <= 0 Then
                                    G.X = Xc + Radius
                                    G.y = Yc
                                    sweep = sweep + A                   'Correct ?
                                Else
                                    '????
                                    G.X = Xc + Cos((sweep + A) * PI / 180) * Radius
                                    G.y = Yc - Sin((sweep + A) * PI / 180) * Radius
                                    sweep = 0
                                End If
                            End If
                        Else
                            If (G.y > Yc) Then       'Top lhs
                                If sweep + A <= 0 Then
                                    G.y = Yc
                                    G.X = Xc - Radius
                                    sweep = sweep + A                    'Correct
                                Else
                                    G.X = Xc - Cos((sweep + A) * PI / 180) * Radius
                                    G.y = Yc + Sin((sweep + A) * PI / 180) * Radius
                                    sweep = 0
                                End If
                            Else                    'Bottom lhs
                                If sweep + 90 - A <= 0 Then
                                    G.y = Yc - Radius           'HERE FIRST
                                    G.X = Xc
                                    sweep = sweep + 90 - A
                                Else
                                    G.y = Yc + Sin((sweep - A) * PI / 180) * Radius     'correct
                                    G.X = Xc - Cos((sweep - A) * PI / 180) * Radius
                                    sweep = 0
                                End If
                            End If
                        End If
                    End If
                    Tmp_GCode(low(Curline), high(Curline)).X = G.X
                    Tmp_GCode(low(Curline), high(Curline)).y = G.y
                    
                    

                    Cnc_Addline
                    End If
                     
                Wend
                
                
            
            
            Case "CI"                       'Circle radius,[chord angle]
                Xc = (G.X * X.m + X.c)
                Yc = (G.y * y.m + y.c)
                Dummy = readnum(0, 0)
                Radius = Dummy * X.m
                Radius = Dummy * y.m
 
                Tmp_GCode(low(Curline), high(Curline)).G = 0: Tmp_GCode(low(Curline), high(Curline)).X = Xc - Radius: Tmp_GCode(low(Curline), high(Curline)).y = Yc: Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).G = 3           'Remember Y is inverted?
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth
                Tmp_GCode(low(Curline), high(Curline)).X = Xc: Tmp_GCode(low(Curline), high(Curline)).y = Yc - Radius: Tmp_GCode(low(Curline), high(Curline)).i = Radius: Tmp_GCode(low(Curline), high(Curline)).j = 0:            Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).X = Xc + Radius: Tmp_GCode(low(Curline), high(Curline)).y = Yc: Tmp_GCode(low(Curline), high(Curline)).i = 0: Tmp_GCode(low(Curline), high(Curline)).j = Radius:             Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).X = Xc: Tmp_GCode(low(Curline), high(Curline)).y = Yc + Radius: Tmp_GCode(low(Curline), high(Curline)).i = Radius: Tmp_GCode(low(Curline), high(Curline)).j = 0:            Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).X = Xc - Radius: Tmp_GCode(low(Curline), high(Curline)).y = Yc: Tmp_GCode(low(Curline), high(Curline)).i = 0: Tmp_GCode(low(Curline), high(Curline)).j = Radius:             Cnc_Addline
            
            Case "IN"                   'Initialize
                Absolute = True
                'tmp_gcode(low(curline),high(curline)).g = 0     'Fast traverse
                'tmp_gcode(low(curline),high(curline)).x = 0
                'tmp_gcode(low(curline),high(curline)).y = 0
                'tmp_gcode(low(curline),high(curline)).z = 0
                G.X = 0
                G.y = 0         '7600
                G.z = 0

                p1default.X = 0&
                p1default.y = 0&
                p2default.X = 7100&
                p2default.y = 9600&

                p1 = p1default
                p2 = p2default
                
                scalemode = False

        

            Case "IP"
                p1.X = readnum(0, p1default.X)
                p1.y = readnum(0, p1default.y)
                p2.X = readnum(0, p2default.X)
                p2.y = readnum(0, p2default.y)

                If scalemode Then
                    X.m = (p2.X - p1.X) / (s2.X - S1.X)
                    X.c = p1.X
                    y.m = (p2.y - p1.y) / (s2.y - S1.y)
                    y.c = p1.y
                Else
                    X.m = 1: y.m = 1
                    X.c = 0: y.c = 0
                End If

        
            Case "SC"                       'Scale
                Dummy = readnum(0, Notset)
                If Dummy = Notset Then
                    X.m = 1: y.m = 1                'No param turns scaling off
                    X.c = 0: y.c = 0
                    scalemode = False
                Else
                    scalemode = True
                    S1.X = Dummy                    'Xmin
                    s2.X = readnum(0, p2.X)         'Xmax
                
                    S1.y = readnum(0, p1.y)         'Ymin
                    s2.y = readnum(0, p2.y)         'Ymax
                
                    X.c = p1.X
                    X.m = (p2.X - p1.X) / (s2.X - S1.X)
                    
                    y.c = p1.y
                    y.m = (p2.y - p1.y) / (s2.y - S1.y)
                End If
        

            Case "PD"                   'Pen Down
                'CNC_Addline
                Tmp_GCode(low(Curline), high(Curline)).G = 1
                'Tmp_GCode(low(Curline), high(Curline)).z = tool(pen).depth
                readxy
    
            Case "PU"                   'Pen up
                'CNC_Addline
                Tmp_GCode(low(Curline), high(Curline)).G = 0
                Tmp_GCode(low(Curline), high(Curline)).z = 0
                readxy

            Case "SP"                   'Select pen
                Dummy = readnum(0, Notset)
                'If dummy = 0 Then dummy = NotSet
                'If dummy <> NotSet Then
                '    If Tmp_GCode(low(Curline), high(Curline)).pen <> dummy Then
                '        Tmp_GCode(low(Curline), high(Curline)).pen = dummy
                '        pen = dummy
                '    End If
                'End If

            Case "PA"                   'Plot Absolute
                Absolute = True
                readxy

            Case "PR"                   'Plot Relative
                Absolute = False
                readxy

            Case Else
                MsgBox "Don't understand " + Mid$(buffer, PTR - 2, 2) + Chr$(13) + "Please send copy of HPGL file"
                GoTo ExitSub1_1
        End Select
    Loop

        
        
    mirrorx = 0
    mirrory = 0
        
        
        Lathe_Addlastline False     'scale
ExitSub1_1:
        Close in_handle
        'exe_grid
End If


Unload StatusDlg

DoEvents


Erase Tmp_GCode
Erase Mcopy
Erase Tool

screen.MousePointer = 0
    


End Sub

Sub hpgl_millimport ()
Dim Dummy As Long
Dim bytesleft As Long
Dim p1 As LongPoint
Dim p2 As LongPoint
Dim p1default As LongPoint
Dim p2default As LongPoint
Dim S1 As LongPoint
Dim s2 As LongPoint

Dim scalemode As Integer

Dim Xc As Single
Dim Yc As Single
Dim Radius As Single
Dim sweep As Single
Dim A As Single
            


Load import
import.Caption = "HPGL Postprocessor"
import.Tag = 0
import.Show 1
Dummy = import.Tag
Unload import
If Not Dummy Then Exit Sub

screen.MousePointer = 11    'busy

in_handle = FreeFile
Open import_filename$ For Binary Access Read Lock Write As in_handle

SetUpStatus "HPGL Postprocessor"


PTR = 1: buffer = "": refreshbuffer

PTR = InStr(buffer, "IN")       'Find INitialise
If PTR = 0 Then

Else
    pen = 1
    CNC_Addline1 False
    Do
        refreshbuffer
        While Mid$(buffer, PTR, 1) < "A"                'Throw away white space and
            If PTR > Len(buffer) Then Exit Do          'unwanted parameters
            PTR = PTR + 1
        Wend

        updatestatus
        PTR = PTR + 2
        Select Case Mid$(buffer, PTR - 2, 2)
'            Case "AC"       'Anchor corner
'            Case "AD"       'Alternate font Def
'
'            Case "BP"       'Begin Plot
'            Case "BR"       'Bezier
            Case "PG"       'Advance page
            Case "OE"       'Output error
            Case "EC"       'Enable cutter
            Case "LT"       'Line Type
            
            Case "EP"       'Edge Polygon
            Case "PM"       'Polygon mode
            Case "NR"       'Not Ready

            Case "CA"       'Character Set (?) not HPGL-2
            Case "GM"

            Case "IW"       'Input window
            Case "DI"       'Absolute Direction (Text)
            Case "SD"       'Standard font def
            Case "VS"       'Set velocity
            Case "PT"       'Pen size
            Case "FS"
            Case "AS"
            
            Case "FT"       'Fill type
            Case "FP"       'Fill polygon
            
            Case "AA"                       'Arc xc,yc,sweep angle


                Xc = readnum(0, 0) * X.m + X.c
                Yc = readnum(0, 0) * y.m + y.c
                sweep = readnum(0, 0)
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth

                'If Int(xc) = 15358 Then MsgBox "Centre " + Format$(sweep) + " " + Format$(xc)

                '+ve sweep CCW normally
                'BUT for Y reversal +VE = CW

                Radius = Sqr((G.X - Xc) * (G.X - Xc) + (G.y - Yc) * (G.y - Yc))
                'If Int(radius) = 854 Then
                    '
                'End If
                
                
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth
                
                While sweep <> 0
                    Tmp_GCode(low(Curline), high(Curline)).G = 3           'Remember Y is inverted?
                    
                    Tmp_GCode(low(Curline), high(Curline)).i = Abs(G.X - Xc)
                    Tmp_GCode(low(Curline), high(Curline)).j = Abs(G.y - Yc)
                    If Tmp_GCode(low(Curline), high(Curline)).i > Int(Radius) Then
                        Tmp_GCode(low(Curline), high(Curline)).i = Int(Radius)
                    End If
                    
                    If Tmp_GCode(low(Curline), high(Curline)).j > Int(Radius) Then
                        Tmp_GCode(low(Curline), high(Curline)).j = Int(Radius)
                    End If


                    If Abs(Sqr((Tmp_GCode(low(Curline), high(Curline)).i * Tmp_GCode(low(Curline), high(Curline)).i) + (Tmp_GCode(low(Curline), high(Curline)).j * Tmp_GCode(low(Curline), high(Curline)).j)) - Radius) > 2 Then
                    '
                    End If

                    If (Tmp_GCode(low(Curline), high(Curline)).i < 10) And (Tmp_GCode(low(Curline), high(Curline)).j < 10) Then
                        sweep = 0
                    ElseIf sweep > -.1 Then
                        sweep = 0
                    Else
                    If G.y - Yc = 0 Then
                        Select Case sweep
                            Case Is <= -90      '-ve = CCW
                                sweep = sweep + 90
                                If G.X > Xc Then
                                    G.y = Yc + Radius
                                Else
                                    G.y = Yc - Radius
                                End If
                                G.X = Xc
                                
                        
                            Case Is <= 0        'Sweep round clockwise
                                If G.X > Xc Then
                                    G.y = Yc - Sin(sweep * PI / 180) * Radius
                                    G.X = Xc + Cos(sweep * PI / 180) * Radius
                                    
                                Else
                                    G.X = G.X + (Radius - Cos(sweep * PI / 180) * Radius)    'WRONG
                                    
                                    G.y = G.y + Sin(sweep * PI / 180) * Radius
                                End If
                                sweep = 0

                            Case Else
                                MsgBox "Cockup on the arc front part 1"
                                sweep = 0
                        End Select
                    ElseIf G.X - Xc = 0 Then
                        Select Case sweep
                            Case Is <= -90
                                sweep = sweep + 90
                                If G.y > Yc Then
                                    G.X = Xc - Radius
                                    
                                Else
                                    G.X = Xc + Radius
                                    
                                End If
                                G.y = Yc
                    
                            Case Is <= 0
                                If G.y > Yc Then
                                    G.X = G.X + Sin(sweep * PI / 180) * Radius
                                    G.y = G.y - (Radius - Cos(sweep * PI / 180) * Radius)
                                    'If (Int(g.x) = -10475) Then MsgBox "From 6"
                                Else
                                    G.y = Yc - Cos(sweep * PI / 180) * Radius   '   'SHOULD BE +ve?
                                    G.X = Xc - Sin(sweep * PI / 180) * Radius
                                    'MsgBox "CORRECT?"
                                End If
                                sweep = 0
                        Case Else
                            MsgBox "Cockup on the arc front part 2"
                            sweep = 0
                        End Select
                    Else
                        A = Atn(Tmp_GCode(low(Curline), high(Curline)).j / Tmp_GCode(low(Curline), high(Curline)).i) * 180 / PI
                        If (G.X > Xc) Then
                            If (G.y > Yc) Then       'Top rhs
                                If sweep + (90 - A) <= 0 Then
                                    G.y = Yc + Radius
                                    G.X = Xc
                                    sweep = sweep + (90 - A)            'Correct
                                Else
                                    G.y = Yc - Sin((sweep - A) * PI / 180) * Radius     'correct
                                    G.X = Xc + Cos((sweep - A) * PI / 180) * Radius
                                    sweep = 0
                                End If
                            Else                    'Bottom rhs
                                If sweep + A <= 0 Then
                                    G.X = Xc + Radius
                                    G.y = Yc
                                    sweep = sweep + A                   'Correct ?
                                Else
                                    '????
                                    G.X = Xc + Cos((sweep + A) * PI / 180) * Radius
                                    G.y = Yc - Sin((sweep + A) * PI / 180) * Radius
                                    sweep = 0
                                End If
                            End If
                        Else
                            If (G.y > Yc) Then       'Top lhs
                                If sweep + A <= 0 Then
                                    G.y = Yc
                                    G.X = Xc - Radius
                                    sweep = sweep + A                    'Correct
                                Else
                                    G.X = Xc - Cos((sweep + A) * PI / 180) * Radius
                                    G.y = Yc + Sin((sweep + A) * PI / 180) * Radius
                                    sweep = 0
                                End If
                            Else                    'Bottom lhs
                                If sweep + 90 - A <= 0 Then
                                    G.y = Yc - Radius           'HERE FIRST
                                    G.X = Xc
                                    sweep = sweep + 90 - A
                                Else
                                    G.y = Yc + Sin((sweep - A) * PI / 180) * Radius     'correct
                                    G.X = Xc - Cos((sweep - A) * PI / 180) * Radius
                                    sweep = 0
                                End If
                            End If
                        End If
                    End If
                    Tmp_GCode(low(Curline), high(Curline)).X = G.X
                    Tmp_GCode(low(Curline), high(Curline)).y = G.y
                    
                    

                    Cnc_Addline
                    End If
                     
                Wend
                
                
            
            
            Case "CI"                       'Circle radius,[chord angle]
                Xc = (G.X * X.m + X.c)
                Yc = (G.y * y.m + y.c)
                Dummy = readnum(0, 0)
                Radius = Dummy * X.m
                Radius = Dummy * y.m
 
                Tmp_GCode(low(Curline), high(Curline)).G = 0: Tmp_GCode(low(Curline), high(Curline)).X = Xc - Radius: Tmp_GCode(low(Curline), high(Curline)).y = Yc: Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).G = 3           'Remember Y is inverted?
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth
                Tmp_GCode(low(Curline), high(Curline)).X = Xc: Tmp_GCode(low(Curline), high(Curline)).y = Yc - Radius: Tmp_GCode(low(Curline), high(Curline)).i = Radius: Tmp_GCode(low(Curline), high(Curline)).j = 0:            Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).X = Xc + Radius: Tmp_GCode(low(Curline), high(Curline)).y = Yc: Tmp_GCode(low(Curline), high(Curline)).i = 0: Tmp_GCode(low(Curline), high(Curline)).j = Radius:             Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).X = Xc: Tmp_GCode(low(Curline), high(Curline)).y = Yc + Radius: Tmp_GCode(low(Curline), high(Curline)).i = Radius: Tmp_GCode(low(Curline), high(Curline)).j = 0:            Cnc_Addline
                Tmp_GCode(low(Curline), high(Curline)).X = Xc - Radius: Tmp_GCode(low(Curline), high(Curline)).y = Yc: Tmp_GCode(low(Curline), high(Curline)).i = 0: Tmp_GCode(low(Curline), high(Curline)).j = Radius:             Cnc_Addline
            
            Case "IN"                   'Initialize
                Absolute = True
                'tmp_gcode(low(curline),high(curline)).g = 0     'Fast traverse
                'tmp_gcode(low(curline),high(curline)).x = 0
                'tmp_gcode(low(curline),high(curline)).y = 0
                'tmp_gcode(low(curline),high(curline)).z = 0
                G.X = 0
                G.y = 0         '7600
                G.z = 0

                p1default.X = 0&
                p1default.y = 0&
                p2default.X = 7100&
                p2default.y = 9600&

                p1 = p1default
                p2 = p2default
                
                scalemode = False

        

            Case "IP"
                p1.X = readnum(0, p1default.X)
                p1.y = readnum(0, p1default.y)
                p2.X = readnum(0, p2default.X)
                p2.y = readnum(0, p2default.y)

                If scalemode Then
                    X.m = (p2.X - p1.X) / (s2.X - S1.X)
                    X.c = p1.X
                    y.m = (p2.y - p1.y) / (s2.y - S1.y)
                    y.c = p1.y
                Else
                    X.m = 1: y.m = 1
                    X.c = 0: y.c = 0
                End If

        
            Case "SC"                       'Scale
                Dummy = readnum(0, Notset)
                If Dummy = Notset Then
                    X.m = 1: y.m = 1                'No param turns scaling off
                    X.c = 0: y.c = 0
                    scalemode = False
                Else
                    scalemode = True
                    S1.X = Dummy                    'Xmin
                    s2.X = readnum(0, p2.X)         'Xmax
                
                    S1.y = readnum(0, p1.y)         'Ymin
                    s2.y = readnum(0, p2.y)         'Ymax
                
                    X.c = p1.X
                    X.m = (p2.X - p1.X) / (s2.X - S1.X)
                    
                    y.c = p1.y
                    y.m = (p2.y - p1.y) / (s2.y - S1.y)
                End If
        

            Case "PD"                   'Pen Down
                'CNC_Addline
                Tmp_GCode(low(Curline), high(Curline)).G = 1
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth
                readxy
    
            Case "PU"                   'Pen up
                'CNC_Addline
                Tmp_GCode(low(Curline), high(Curline)).G = 0
                Tmp_GCode(low(Curline), high(Curline)).z = 0
                readxy

            Case "SP"                   'Select pen
                Dummy = readnum(0, Notset)
                If Dummy = 0 Then Dummy = Notset
                If Dummy <> Notset Then
                    If Tmp_GCode(low(Curline), high(Curline)).pen <> Dummy Then
                        Tmp_GCode(low(Curline), high(Curline)).pen = Dummy
                        pen = Dummy
                    End If
                End If

            Case "PA"                   'Plot Absolute
                Absolute = True
                readxy

            Case "PR"                   'Plot Relative
                Absolute = False
                readxy

            Case Else
                MsgBox "Don't understand " + Mid$(buffer, PTR - 2, 2) + Chr$(13) + "Please send copy of HPGL file"
                GoTo exitsub1
        End Select
    Loop

        CNC_Addlastline True, False, False
exitsub1:
        Close in_handle
        'exe_grid
End If


Unload StatusDlg

DoEvents


Erase Tmp_GCode
Erase Mcopy
Erase Tool

screen.MousePointer = 0
    

End Sub

Private Sub Lathe_Addlastline (Keepscale As Integer)
Dim i As Integer

Cnc_Addline

insert_rows = Curline - 1
Lathecompress Keepscale

CNCfrm(CNCFrmNo).EditFunc.Caption = "Get"   'Give copy of prog to Mill Form

Erase Tmp_Remarks
Erase Tmp_GCode
Erase Mcopy

End Sub

Private Sub Lathecompress (Keepscale)

Dim Xshift As Integer
Dim yshift As Integer

Dim i As Long
Dim maxx As Long
Dim maxy As Long
Dim minx As Long
Dim miny As Long

Dim xmult As Double
Dim ymult As Double

'Dim rotate As Integer
Dim newline As Integer

Dim highi As Integer
Dim lowi As Integer

    'options.blocky = 15 * mmtosteps
    'options.blockx = 60 * mmtosteps
    
    

    maxx = -99999999
    maxy = -99999999
    minx = 99999999
    miny = 99999999
    'Find largest X and y

    Curline = insert_rows
    If Tmp_GCode(low(Curline), high(Curline)).G = 0 Then     'Plotter will sometimes go to "zero" at end - remove
        Tmp_GCode(low(Curline), high(Curline)).X = Tmp_GCode(low(Curline - 1), high(Curline - 1)).X
        Tmp_GCode(low(Curline), high(Curline)).y = Tmp_GCode(low(Curline - 1), high(Curline - 1)).y
    End If

    For i = 1 To insert_rows
        highi = high(i): lowi = low(i)

        Select Case Tmp_GCode(lowi, highi).G
        Case 0, 1, 2, 3, 81, 82, 83
            If Tmp_GCode(lowi, highi).X > maxx Then maxx = Tmp_GCode(lowi, highi).X
            If Tmp_GCode(lowi, highi).X < minx Then minx = Tmp_GCode(lowi, highi).X
            If Tmp_GCode(lowi, highi).y > maxy Then maxy = Tmp_GCode(lowi, highi).y
            If Tmp_GCode(lowi, highi).y < miny Then miny = Tmp_GCode(lowi, highi).y
        Case Else

        End Select
    Next

    Xshift = 0
    yshift = 0


    If Keepscale Then
        If (minx < 0) Or (miny < 0) Or (maxx > Options.blockx) Or (maxy > Options.blocky) Then
            If (maxx - minx) > Options.blockx Then
                'MsgBox "Travel out of bounds, scaling"
                StatusDlg.Message.Caption = "Travel out of bounds, scaling": Keepscale = False
                DoEvents
            ElseIf (maxy - miny) > Options.blocky Then
                'MsgBox "Travel out of bounds, scaling": keepscale = False
                StatusDlg.Message.Caption = "Travel out of bounds, scaling": Keepscale = False
                DoEvents
            Else
                If (minx < 0) Or (maxx > Options.blockx) Then Xshift = -minx
                If (miny < 0) Or (maxy > Options.blocky) Then yshift = -miny
            End If
        End If
    End If
    
    If Keepscale Then
        xmult = 1
        ymult = 1
        minx = -Xshift: Xshift = 0
        miny = -yshift: yshift = 0
    Else
        xmult = Options.blockx / (maxx - minx)
        ymult = Options.blocky / (maxy - miny)

        If Int(xmult * 1000) <> Int(ymult * 1000) Then
            xmult = Options.blockx / (maxx - minx)
            ymult = Options.blocky / (maxy - miny)
    
            If xmult > ymult Then
                Options.blockx = Options.blocky * (maxx - minx) / (maxy - miny)
            Else
                Options.blocky = Options.blockx * (maxy - miny) / (maxx - minx)
            End If
            xmult = Options.blockx / (maxx - minx)
            ymult = Options.blocky / (maxy - miny)
        End If
    End If
    

    For i = 1 To insert_rows
            highi = high(i): lowi = low(i)
    
            Select Case Tmp_GCode(lowi, highi).G
            Case 0, 1, 81, 82, 83
                If mirrorx Then
                    Tmp_GCode(lowi, highi).X = Options.blockx - (Tmp_GCode(lowi, highi).X - minx) * xmult
                Else
                    Tmp_GCode(lowi, highi).X = (Tmp_GCode(lowi, highi).X - minx) * xmult
                End If
                
                If mirrory Then
                    Tmp_GCode(lowi, highi).y = (Tmp_GCode(lowi, highi).y - miny) * ymult
                Else
                    Tmp_GCode(lowi, highi).y = Options.blocky - (Tmp_GCode(lowi, highi).y - miny) * ymult
                End If
            Case 2, 3
                If mirrorx Then
                    Tmp_GCode(lowi, highi).X = Options.blockx - (Tmp_GCode(lowi, highi).X - minx) * xmult
                    If Tmp_GCode(lowi, highi).G = 2 Then Tmp_GCode(lowi, highi).G = 3 Else Tmp_GCode(lowi, highi).G = 2
                Else
                    Tmp_GCode(lowi, highi).X = (Tmp_GCode(lowi, highi).X - minx) * xmult
                End If
                
                
                If mirrory Then
                    Tmp_GCode(lowi, highi).y = (Tmp_GCode(lowi, highi).y - miny) * ymult
                    If Tmp_GCode(lowi, highi).G = 2 Then Tmp_GCode(lowi, highi).G = 3 Else Tmp_GCode(lowi, highi).G = 2
                Else

                    Tmp_GCode(lowi, highi).y = Options.blocky - (Tmp_GCode(lowi, highi).y - miny) * ymult
                End If
    
                Tmp_GCode(lowi, highi).i = Abs(Tmp_GCode(lowi, highi).i * xmult)
                Tmp_GCode(lowi, highi).j = Abs(Tmp_GCode(lowi, highi).j * ymult)
                
    
                If (Tmp_GCode(lowi, highi).i < 66) And (Tmp_GCode(lowi, highi).j < 66) Then
                    Tmp_GCode(lowi, highi).G = 1 'Ignore arcs of < .5 rad
                ElseIf (Tmp_GCode(lowi, highi).i > 32000) Or (Tmp_GCode(lowi, highi).j > 32000) Then
                    Tmp_GCode(lowi, highi).G = 1 'Ignore arcs greater than 240 rad
                ElseIf i <> 1 Then
                    If Tmp_GCode(lowi, highi).X = Tmp_GCode(low(i - 1), high(i - 1)).X Then
                        Tmp_GCode(lowi, highi).G = 1
                    ElseIf Tmp_GCode(lowi, highi).y = Tmp_GCode(low(i - 1), high(i - 1)).y Then
                        Tmp_GCode(lowi, highi).G = 1
                    End If
                End If
            
            Case Else
            
            End Select
        Next
    
    


Dim DEFAULTG As Long
Dim DEFAULTx As Long
Dim DEFAULTy As Long
Dim DEFAULTi As Long
Dim DEFAULTj As Long
Dim DEFAULTt

DEFAULTG = 1'refers to line with default value
DEFAULTx = 1
DEFAULTy = 1


For i = 2 To insert_rows
    highi = high(i): lowi = low(i)

        'der Tmp_GCode(lowi, highi).x
        'der Tmp_GCode(lowi, highi).y
    
    Select Case Tmp_GCode(low(i), highi).G
    Case 2, 3
    
    Case Else
        Tmp_GCode(lowi, highi).i = Notset
        Tmp_GCode(lowi, highi).j = Notset
    End Select
    
    Select Case Tmp_GCode(low(i), highi).G
    
    Case 0, 1, 2, 3
        If Tmp_GCode(lowi, highi).G = Tmp_GCode(low(DEFAULTG), high(DEFAULTG)).G Then Tmp_GCode(lowi, highi).G = Notset Else DEFAULTG = i
        If Tmp_GCode(lowi, highi).X = Tmp_GCode(low(DEFAULTx), high(DEFAULTx)).X Then Tmp_GCode(lowi, highi).X = Notset Else DEFAULTx = i
        If Tmp_GCode(lowi, highi).y = Tmp_GCode(low(DEFAULTy), high(DEFAULTy)).y Then Tmp_GCode(lowi, highi).y = Notset Else DEFAULTy = i
        
    Case 70, 71, 25
        Tmp_GCode(lowi, highi).X = Notset
        Tmp_GCode(lowi, highi).y = Notset
        DEFAULTG = 1
        DEFAULTx = 1
        DEFAULTy = 1

    Case Else
    '
    End Select

Next

Dim src As Long
Dim Dest As Long
Dim lowSrc As Integer
Dim lowDest As Integer
Dim highSrc As Integer
Dim highDest As Integer


    ReDim Mcopy(1 To UBound(Tmp_GCode, 1), 0 To UBound(Tmp_GCode, 2))    'No extra lines
    
    For src = 1 To insert_rows
        Dest = src
        
        highSrc = high(src): lowSrc = low(src)
        highDest = high(Dest): lowDest = low(Dest)
        
        Mcopy(lowDest, highDest).G = Tmp_GCode(lowSrc, highSrc).G
        
        Mcopy(lowDest, highDest).X = Tmp_GCode(lowSrc, highSrc).y     'Rotate
        Mcopy(lowDest, highDest).z = Tmp_GCode(lowSrc, highSrc).X
        
        Mcopy(lowDest, highDest).i = Tmp_GCode(lowSrc, highSrc).j
        Mcopy(lowDest, highDest).k = Tmp_GCode(lowSrc, highSrc).i

        Mcopy(lowDest, highDest).steps_to_units = Tmp_GCode(lowSrc, highSrc).steps_to_units
        Mcopy(lowDest, highDest).remarkPtr = Tmp_GCode(lowSrc, highSrc).remarkPtr

        
        Mcopy(lowDest, highDest).y = Notset
        Mcopy(lowDest, highDest).j = Notset
        Mcopy(lowDest, highDest).F = Notset
        Mcopy(lowDest, highDest).S = Notset
        Mcopy(lowDest, highDest).t = Notset
        Mcopy(lowDest, highDest).pen = Notset
        Mcopy(lowDest, highDest).d = Notset
        Mcopy(lowDest, highDest).m = Notset
    Next



End Sub

Sub Make_GerberMatrix ()


Dim Dummy
Dim G As Integer
Dim X As Integer
Dim y As Integer

Dim Lastx As Integer
Dim Lasty As Integer

Dim i As Integer
Dim S, F
Dim m45, m, j

'ReDim Matrix(1600, 800)     'In 5 thou

ReDim Matrix(3200, 1600)     'In 2.5 thou



in_handle = FreeFile
Open import_filename$ For Binary Access Read Lock Write As in_handle
PTR = 1: buffer = "": refreshbuffer
Do
    refreshbuffer
    While Mid$(buffer, PTR, 1) < "*"                'Throw away white space and  was A
        If PTR > Len(buffer) Then Exit Do           'unwanted parameters
        PTR = PTR + 1
    Wend
        
        updatestatus
        PTR = PTR + 1
        Select Case Mid$(buffer, PTR - 1, 1)
        Case "*"
            If G = 1 Then
                If Lastx <> X Then
                    If Lasty <> y Then
                        Select Case Abs(Lastx - X) - Abs(Lasty - y)
                        Case 0
                        Case 1
                            Lastx = Lastx - Sgn(Lastx - X)
                        Case -1     ' Change Y by Less
                            Lasty = Lasty - Sgn(Lasty - y)
                        Case Else
                            If Abs(Lasty - y) > Abs(Lastx - X) Then
                                  YLine Lasty, Lasty + Sgn((Lasty - y)) * (Abs(Lastx - X) - Abs(Lasty - y)), X, m
                                  Lasty = Lasty + Sgn((Lasty - y)) * (Abs(Lastx - X) - Abs(Lasty - y))
                            Else
                                  Xline Lastx, Lastx + Sgn((Lastx - X)) * (Abs(Lasty - y) - Abs(Lastx - X)), y, m
                                  Lastx = Lastx + Sgn((Lastx - X)) * (Abs(Lasty - y) - Abs(Lastx - X))
                            End If

                        End Select

                        Select Case Abs(Lastx - X) - Abs(Lasty - y)
                        Case 0
                        'm = 3
                        For i = 0 To m45
                            S = Sgn(Lastx - X) * i
                            F = Sgn(Lasty - y) * i
                               
                            fILL45lINE X, Lastx + S, y - F, Lasty
                            fILL45lINE Lastx + S, Lastx, Lasty, Lasty + F
                            fILL45lINE Lastx, X - S, Lasty + F, y
                            fILL45lINE X - S, X, y, y - F
                        Next

                        Case Else
                            MsgBox "TOO DIFFICULT"
                        
                        End Select
                        
                    Else
                        Xline Lastx, X, y, m

                    End If
                ElseIf Lasty <> y Then
                    YLine Lasty, y, X, m
                End If
            End If
            Lastx = X
            Lasty = y
        
        Case "D"
            Dummy = readnum(0, 0)
            Select Case Dummy
            Case 1
                G = 1   'Cut
            Case 2
                G = 0   'Move
            
            Case 3  'Pad?
                'For i = X - m To X + m
                '    For j = Y - m To Y + m
                '        Matrix(i, j) = 1
                '    Next
                'Next
                Pad X, y, m

                Lastx = X
                Lasty = y
            
            Case Else
                For pen = 1 To UBound(Apertures)
                    If Dummy = Apertures(pen) Then Exit For
                Next
                pen = pen + 2

                m = Tool(pen).size * stepstoin * 1000       'diameter in thou
                m = 2 * m / 5                               'Convert to 2.5 thou
                m = m - 1                                   'center
                m = m / 2                                   'rest either side
                If m = 0 Then m = 1


                m45 = Tool(pen).size * stepstoin * 1000      'diameter in thou
                m45 = m45 * Sqr(2)
                m45 = 2 * m45 / 5
                m45 = m45 - 1
                m45 = m45 / 2
                If m45 = 0 Then m45 = 1

                
            End Select

        Case "X"
            X = (2 * readnum(0, 0) / 5) + 100          '50 gives room to go round track
            

            
        Case "Y"
            y = (2 * readnum(0, 0) / 5) + 100
            
            
    End Select

Loop
Close in_handle

End Sub

Sub Make45Line (StartX, FinalX, StartY, FinalY)

Dim dx, dy
Dim Sx, Fx
Dim Incx

Dim SY, FY
Dim Incy


If StartX < 0 Then
    '
    StartX = 0
End If
If FinalX < 0 Then
    '
    FinalX = 0
End If

If StartY < 0 Then
    StartY = 0
End If

If FinalY < 0 Then
    FinalY = 0
End If

If Abs(FinalX - StartX) <> Abs(FinalY - StartY) Then
     '
End If

Incx = Sgn(FinalX - StartX)
Incy = Sgn(FinalY - StartY)

Sx = StartX - Incx
SY = StartY - Incy

Do
    Sx = Sx + Incx
    SY = SY + Incy

    Do Until Matrix(Sx, SY) <> 1              '1=copper
        If Sx = FinalX Then Exit Sub
        Sx = Sx + Incx
        SY = SY + Incy
    Loop

Fx = Sx
FY = SY
Do Until Matrix(Fx, FY) <> 0
    If Fx = FinalX Then Exit Do
    Fx = Fx + Incx
    FY = FY + Incy
Loop


If Matrix(Fx, FY) = 1 Then
    Fx = Fx - Incx
    FY = FY - Incy
End If


If Fx <> Sx Then
    'Dx = Tmp_GCode(low(Curline), high(Curline)).X - (Sx * intosteps / 200)
    'Dy = Tmp_GCode(low(Curline), high(Curline)).Y - (Options.blocky - (sY * intosteps / 200))
    '
    'If (Dx <> 0) Or (Dy <> 0) Then
    '    Tmp_GCode(low(Curline), high(Curline)).G = 0
    '    Tmp_GCode(low(Curline), high(Curline)).X = Sx * intosteps / 200
    '    Tmp_GCode(low(Curline), high(Curline)).Y = Options.blocky - (sY * intosteps / 200)
    '    Tmp_GCode(low(Curline), high(Curline)).z = 0
    '    Cnc_Addline
    'End If
    '
    'Tmp_GCode(low(Curline), high(Curline)).G = 1
    'Tmp_GCode(low(Curline), high(Curline)).X = Fx * intosteps / 200
    'Tmp_GCode(low(Curline), high(Curline)).Y = Options.blocky - (fY * intosteps / 200)
    'Tmp_GCode(low(Curline), high(Curline)).z = .1 * intosteps
    'Cnc_Addline

    PcbTable.AddNew
    If Sx < Fx Then
        PcbTable("X1") = Sx
        PcbTable("Y1") = SY
        
        PcbTable("X2") = Fx
        PcbTable("Y2") = FY
    Else
        PcbTable("X1") = Fx
        PcbTable("Y1") = FY
        
        PcbTable("X2") = Sx
        PcbTable("Y2") = SY
    End If


    PcbTable("XC") = -1
    PcbTable("YC") = -1

    PcbTable.Update

End If

Sx = Fx
SY = FY


Loop Until Sx = FinalX

'
End Sub

Sub MakeXLine (Start, Finish, y)


Dim dx, dy
Dim Add

Dim S1, F1
Dim S, F
Dim Inc


If Start < 0 Then Start = 0
If Finish < 0 Then Finish = 0
If y < 0 Then y = 0

Inc = Sgn(Finish - Start)
S = Start - Inc

Do

S = S + Inc


Do Until Matrix(S, y) <> 1              '1=copper
    If S = Finish Then Exit Sub
    S = S + Inc
Loop

F = S
Do Until Matrix(F, y) <> 0
    If F = Finish Then Exit Do
    F = F + Inc
Loop
'If F <> fINISH Then F = F - iNC


If Matrix(S, y) = 1 Then
'
End If


If Matrix(F, y) = 1 Then
    F = F - Inc'
End If


If F <> S Then
    F1 = F: S1 = S
    If S > F Then
        S = F1
        F = S1
    End If
    
    Add = True
    PcbTable.Index = "Y1"
    PcbTable.Seek "=", y
    If Not PcbTable.NoMatch Then
        Do
            If PcbTable("Y2") = y Then
                If (PcbTable("X1") <= S) And (PcbTable("X2") >= F) Then
                        Add = False 'Line Already defined
                        Exit Do
                End If
            End If
            PcbTable.MoveNext
            If PcbTable.EOF Then Exit Do
        Loop Until PcbTable("Y1") <> y
    End If
    
    If Add Then
        'First see if we can remove anything
        
        PcbTable.Index = "Y1"
        PcbTable.Seek "=", y
        If Not PcbTable.NoMatch Then
            Do
                If PcbTable("Y2") = y Then
                    Select Case PcbTable("X1")
                        Case S To F
                            If PcbTable("X2") > F Then
                                F = PcbTable("X2")
                            End If
                            PcbTable.Delete
                        Case Else
                            Select Case PcbTable("X2")
                                Case S To F
                                    If PcbTable("X1") < S Then
                                        S = PcbTable("X1")
                                    End If
                                    PcbTable.Delete
                            End Select
                    End Select
                End If
                PcbTable.MoveNext
                If PcbTable.EOF Then Exit Do
            Loop Until PcbTable("Y1") <> y
        End If

        PcbTable.AddNew
        PcbTable("X1") = S      'x1 will always be the smaller
        PcbTable("Y1") = y
    
        PcbTable("X2") = F
        PcbTable("Y2") = y
        
        PcbTable("XC") = -1
        PcbTable("YC") = -1
        PcbTable.Update
    

        F = F1      'recover start and Fin
        S = S1
    End If

End If

S = F


Loop Until S = Finish



End Sub

Sub MakeYLine (Start, Finish, X)


Dim S, F
Dim Inc

Dim dx
Dim dy
Dim Add
Dim F1, S1
If Start < 0 Then Start = 0
If Finish < 0 Then Finish = 0

If X < 0 Then X = 0


Inc = Sgn(Finish - Start)
S = Start - Inc




Do

S = S + Inc

Do Until Matrix(X, S) <> 1              '1=copper
    If S = Finish Then Exit Sub
    S = S + Inc
Loop

F = S
Do Until Matrix(X, F) <> 0
    If F = Finish Then Exit Do
    F = F + Inc
Loop


If Matrix(X, S) = 1 Then
'
End If

If Matrix(X, F) = 1 Then
    F = F - Inc
End If



If F <> S Then
    
    F1 = F: S1 = S
    If S > F Then
        S = F1
        F = S1
    End If

    Add = True
    PcbTable.Index = "X1"
    PcbTable.Seek "=", X
    If Not PcbTable.NoMatch Then
        Do
            If PcbTable("X2") = X Then
                If (PcbTable("Y1") <= S) And (PcbTable("Y2") >= F) Then
                    Add = False 'Line Already defined
                    Exit Do
                End If
            End If
            PcbTable.MoveNext
            If PcbTable.EOF Then Exit Do
        Loop Until PcbTable("X1") <> X
    End If

    If Add Then
        PcbTable.Index = "X1"
        PcbTable.Seek "=", X
        If Not PcbTable.NoMatch Then
            Do
                If PcbTable("X2") = X Then
                    Select Case PcbTable("Y1")
                        Case S To F
                            If PcbTable("Y2") > F Then
                                F = PcbTable("Y2")
                            End If
                            PcbTable.Delete
                        Case Else
                            Select Case PcbTable("Y2")
                                Case S To F
                                    If PcbTable("Y1") < S Then
                                        S = PcbTable("Y1")
                                    End If
                                    PcbTable.Delete
                            End Select
                    End Select
                End If
                PcbTable.MoveNext
                If PcbTable.EOF Then Exit Do
            Loop Until PcbTable("X1") <> X
        End If
    
    PcbTable.AddNew
    PcbTable("X1") = X
    PcbTable("Y1") = S
    PcbTable("X2") = X
    PcbTable("Y2") = F

    PcbTable("XC") = -1
    PcbTable("YC") = -1
    PcbTable.Update
    F = F1: S = S1
    End If

Else
'

End If


S = F


Loop Until S = Finish




End Sub

Sub MDB ()


Dim tb As New TableDef

Dim F As New Field
Dim i As New Index

If Dir$("pcb.mdb") <> "" Then Kill "pcb.mdb"
Set db = CreateDatabase("pcb.mdb", db_lang_general, db_version10)
'If db Is Nothing Then MsgBox "Could not create database": End

StatusDlg.Message.Caption = "Initialising database": DoEvents


Set tb = New TableDef

tb.Name = "PCB"
F.Name = "X1": F.Type = db_integer: tb.Fields.Append F: Set F = New Field
F.Name = "Y1": F.Type = db_integer: tb.Fields.Append F: Set F = New Field
F.Name = "X2": F.Type = db_integer: tb.Fields.Append F: Set F = New Field
F.Name = "Y2": F.Type = db_integer: tb.Fields.Append F: Set F = New Field
F.Name = "XC": F.Type = db_integer: tb.Fields.Append F: Set F = New Field
F.Name = "YC": F.Type = db_integer: tb.Fields.Append F: Set F = New Field


i.Name = "All"
i.Fields = "X1;Y1;X2;Y2"
i.Primary = False
i.Unique = False
tb.Indexes.Append i: Set i = New Index



i.Name = "Start"
i.Fields = "X1;Y1"
i.Primary = False
i.Unique = False
tb.Indexes.Append i: Set i = New Index


i.Name = "X1"
i.Fields = "X1"
i.Primary = False
i.Unique = False
tb.Indexes.Append i: Set i = New Index

i.Name = "Y1"
i.Fields = "Y1"
i.Primary = False
i.Unique = False
tb.Indexes.Append i: Set i = New Index




i.Name = "End"
i.Fields = "X2;Y2"
i.Primary = False
i.Unique = False
tb.Indexes.Append i: Set i = New Index


i.Name = "X2"
i.Fields = "X2"
i.Primary = False
i.Unique = False
tb.Indexes.Append i: Set i = New Index

i.Name = "Y2"
i.Fields = "Y2"
i.Primary = False
i.Unique = False
tb.Indexes.Append i: Set i = New Index






db.TableDefs.Append tb: Set tb = New TableDef

Set PcbTable = db.OpenTable("PCB")

'db.Close

StatusDlg.Message.Caption = "Database made": DoEvents


End Sub

Private Sub Millcompress (includeload As Integer, Keepscale As Integer, keepall As Integer)
'copy tmp_gcode to mcopy


Dim Spinon
Dim EndLine As Integer
Dim Xshift As Integer
Dim yshift As Integer

Dim i As Long
Dim maxx As Long
Dim maxy As Long
Dim minx As Long
Dim miny As Long

Dim xmult As Double
Dim ymult As Double

Dim newline As Integer

Dim highi As Integer
Dim lowi As Integer

    EndLine = False

    maxx = -99999999
    maxy = -99999999
    minx = 99999999
    miny = 99999999
    'Find largest X and y

    Absolute = True
    
    Curline = insert_rows
    If Tmp_GCode(low(Curline), high(Curline)).G = 0 Then     'Plotter will sometimes go to "zero" at end - remove
        Tmp_GCode(low(Curline), high(Curline)).X = Tmp_GCode(low(Curline - 1), high(Curline - 1)).X
        Tmp_GCode(low(Curline), high(Curline)).y = Tmp_GCode(low(Curline - 1), high(Curline - 1)).y
    End If

    For i = 1 To insert_rows
        highi = high(i): lowi = low(i)

        Select Case Tmp_GCode(lowi, highi).G
        Case 0, 1, 2, 3, 81, 82, 83
            If Absolute Then
            If Tmp_GCode(lowi, highi).X <> Notset Then
                If Tmp_GCode(lowi, highi).X > maxx Then maxx = Tmp_GCode(lowi, highi).X
                If Tmp_GCode(lowi, highi).X < minx Then minx = Tmp_GCode(lowi, highi).X
            End If
            If Tmp_GCode(lowi, highi).y <> Notset Then
                If Tmp_GCode(lowi, highi).y > maxy Then maxy = Tmp_GCode(lowi, highi).y
                If Tmp_GCode(lowi, highi).y < miny Then miny = Tmp_GCode(lowi, highi).y
            End If
            End If
        
        Case 90
            Absolute = True
        Case 91
            Absolute = False
        
        Case Else

        End Select
    Next

    Xshift = 0
    yshift = 0

    If Keepscale Then
        If (minx < 0) Or (miny < 0) Or (maxx > Options.blockx) Or (maxy > Options.blocky) Then
            If (maxx - minx) > Options.blockx Then
                Keepscale = False
            ElseIf (maxy - miny) > Options.blocky Then
                Keepscale = False
            Else
                If (minx < 0) Or (maxx > Options.blockx) Then Xshift = -minx
                If (miny < 0) Or (maxy > Options.blocky) Then yshift = -miny
            End If

            If Not Keepscale Then
                If MsgBox("Design excedes mill bounds." & Chr$(13) & "Please refer to manual" & Chr$(13) & Chr$(13) & "Scale to fit?", 32 + 4 + 256) <> 6 Then
                    Keepscale = True
                Else
                    StatusDlg.Message.Caption = "Travel out of bounds, scaling"
                    DoEvents
                End If
            End If
        End If
    End If
    
    If Keepscale Then
        xmult = 1
        ymult = 1
        minx = -Xshift: Xshift = 0
        miny = -yshift: yshift = 0
    Else
        xmult = Options.blockx / (maxx - minx)
        ymult = Options.blocky / (maxy - miny)

        If Int(xmult * 1000) <> Int(ymult * 1000) Then
            'Options.blockx = 200 * mmtosteps
            'Options.blocky = 100 * mmtosteps
            
            xmult = Options.blockx / (maxx - minx)
            ymult = Options.blocky / (maxy - miny)
    
            If xmult > ymult Then
                Options.blockx = Options.blocky * (maxx - minx) / (maxy - miny)
            Else
                Options.blocky = Options.blockx * (maxy - miny) / (maxx - minx)
            End If
            xmult = Options.blockx / (maxx - minx)
            ymult = Options.blocky / (maxy - miny)
        End If
    End If

    If Not keepall Then
        For i = 1 To insert_rows
            highi = high(i): lowi = low(i)
    
            Select Case Tmp_GCode(lowi, highi).G
            Case 65
            '
            Case 98
            '
            Case 0, 1, 81, 82, 83, 99
                If mirrorx Then
                    Tmp_GCode(lowi, highi).X = Options.blockx - (Tmp_GCode(lowi, highi).X - minx) * xmult
                Else
                    Tmp_GCode(lowi, highi).X = (Tmp_GCode(lowi, highi).X - minx) * xmult
                End If
                
                If mirrory Then
                    Tmp_GCode(lowi, highi).y = (Tmp_GCode(lowi, highi).y - miny) * ymult
                Else
                    Tmp_GCode(lowi, highi).y = Options.blocky - (Tmp_GCode(lowi, highi).y - miny) * ymult
                End If
            Case 2, 3
                If mirrorx Then
                    Tmp_GCode(lowi, highi).X = Options.blockx - (Tmp_GCode(lowi, highi).X - minx) * xmult
                    If Tmp_GCode(lowi, highi).G = 2 Then Tmp_GCode(lowi, highi).G = 3 Else Tmp_GCode(lowi, highi).G = 2
                Else
                    Tmp_GCode(lowi, highi).X = (Tmp_GCode(lowi, highi).X - minx) * xmult
                End If
                
                
                If mirrory Then
                    Tmp_GCode(lowi, highi).y = (Tmp_GCode(lowi, highi).y - miny) * ymult
                    If Tmp_GCode(lowi, highi).G = 2 Then Tmp_GCode(lowi, highi).G = 3 Else Tmp_GCode(lowi, highi).G = 2
                Else

                    Tmp_GCode(lowi, highi).y = Options.blocky - (Tmp_GCode(lowi, highi).y - miny) * ymult
                End If
    
                Tmp_GCode(lowi, highi).i = Abs(Tmp_GCode(lowi, highi).i * xmult)
                Tmp_GCode(lowi, highi).j = Abs(Tmp_GCode(lowi, highi).j * ymult)
                
                Tmp_GCode(lowi, highi).k = Abs(Tmp_GCode(lowi, highi).k * ymult)
    
                If (Tmp_GCode(lowi, highi).i < 66) And (Tmp_GCode(lowi, highi).j < 66) Then
                    Tmp_GCode(lowi, highi).G = 1 'Ignore arcs of < .5 rad
                ElseIf (Tmp_GCode(lowi, highi).i > 32000) Or (Tmp_GCode(lowi, highi).j > 32000) Then
                    Tmp_GCode(lowi, highi).G = 1 'Ignore arcs greater than 240 rad
                ElseIf Absolute Then
                    If i <> 1 Then
                        If Tmp_GCode(lowi, highi).X = Tmp_GCode(low(i - 1), high(i - 1)).X Then
                            Tmp_GCode(lowi, highi).G = 1
                        ElseIf Tmp_GCode(lowi, highi).y = Tmp_GCode(low(i - 1), high(i - 1)).y Then
                            Tmp_GCode(lowi, highi).G = 1
                        End If
                    End If
                End If
            
            Case Else
            
            End Select
        Next
        End If
    

Dim DEFAULTG As Long
Dim DEFAULTx As Long
Dim DEFAULTy As Long
Dim DEFAULTz As Long
Dim DEFAULTi As Long
Dim DEFAULTj As Long

Dim DEFAULTt

DEFAULTG = Notset'refers to line with default value
DEFAULTx = Notset
DEFAULTy = Notset
DEFAULTz = Notset

Absolute = True

For i = 2 To insert_rows
    highi = high(i): lowi = low(i)
    
    Select Case Tmp_GCode(low(i), highi).G
    Case 2, 3
    Case 65'
    
    Case Else
        Tmp_GCode(lowi, highi).i = Notset
        Tmp_GCode(lowi, highi).j = Notset
        Tmp_GCode(lowi, highi).k = Notset
    End Select
    
    Select Case Tmp_GCode(low(i), highi).G
    
    Case 0, 1, 2, 3, 81, 82, 83
        If DEFAULTG = Notset Then
           DEFAULTG = i
        Else
            If Tmp_GCode(lowi, highi).G = Tmp_GCode(low(DEFAULTG), high(DEFAULTG)).G Then
                Tmp_GCode(lowi, highi).G = Notset
            Else
                DEFAULTG = i
            End If
        End If
        
        If Absolute Then
            If DEFAULTx = Notset Then
                DEFAULTx = i
            Else
                If Tmp_GCode(lowi, highi).X = Tmp_GCode(low(DEFAULTx), high(DEFAULTx)).X Then Tmp_GCode(lowi, highi).X = Notset Else DEFAULTx = i
            End If
            If DEFAULTy = Notset Then
                DEFAULTy = i
            Else
                If Tmp_GCode(lowi, highi).y = Tmp_GCode(low(DEFAULTy), high(DEFAULTy)).y Then Tmp_GCode(lowi, highi).y = Notset Else DEFAULTy = i
            End If
            If DEFAULTz = Notset Then
                DEFAULTz = i
            Else
                If Tmp_GCode(lowi, highi).z = Tmp_GCode(low(DEFAULTz), high(DEFAULTz)).z Then Tmp_GCode(lowi, highi).z = Notset Else DEFAULTz = i
            End If
        Else
            If Tmp_GCode(lowi, highi).X = 0 Then Tmp_GCode(lowi, highi).X = Notset
            If Tmp_GCode(lowi, highi).y = 0 Then Tmp_GCode(lowi, highi).y = Notset
            If Tmp_GCode(lowi, highi).z = 0 Then Tmp_GCode(lowi, highi).z = Notset
            DEFAULTx = Notset
            DEFAULTy = Notset
            DEFAULTz = Notset
        End If
    
    Case 33, 5
        DEFAULTG = Notset
        DEFAULTx = Notset
        DEFAULTy = Notset
        DEFAULTz = Notset
        
   Case 98, 99
        DEFAULTG = Notset
    
    Case 38, 39
        Tmp_GCode(lowi, highi).z = Notset
        DEFAULTG = Notset
        DEFAULTx = Notset
        DEFAULTy = Notset
        DEFAULTz = Notset
    
    Case 65, 28, 73
        Tmp_GCode(lowi, highi).y = Notset
        Tmp_GCode(lowi, highi).z = Notset
        DEFAULTG = Notset
        
    Case 90
        'If Absolute Then Tmp_gcode(lowi, highi).g = notset
        Absolute = True
        Tmp_GCode(lowi, highi).X = Notset
        Tmp_GCode(lowi, highi).y = Notset
        Tmp_GCode(lowi, highi).z = Notset
        DEFAULTG = Notset
        DEFAULTx = Notset
        DEFAULTy = Notset
        DEFAULTz = Notset

    Case 91
        'If Not Absolute Then Tmp_gcode(lowi, highi).g = notset
        Absolute = False
        Tmp_GCode(lowi, highi).X = Notset
        Tmp_GCode(lowi, highi).y = Notset
        Tmp_GCode(lowi, highi).z = Notset
        DEFAULTG = Notset
        DEFAULTx = Notset
        DEFAULTy = Notset
        DEFAULTz = Notset


    Case 4, 6, 70, 71
        Tmp_GCode(lowi, highi).X = Notset
        Tmp_GCode(lowi, highi).y = Notset
        Tmp_GCode(lowi, highi).z = Notset
        DEFAULTG = Notset
        DEFAULTx = Notset
        DEFAULTy = Notset
        DEFAULTz = Notset

    Case Else
    '
    
    End Select

Next


skipit:

If keepall Then
    ReDim Mcopy(1 To UBound(Tmp_GCode, 1), 0 To UBound(Tmp_GCode, 2))    'No extra lines
    For i = 1 To insert_rows
        highi = high(i): lowi = low(i)
        'Mcopy(lowi, highi).n = i
        Mcopy(lowi, highi).G = Tmp_GCode(lowi, highi).G
        Mcopy(lowi, highi).X = Tmp_GCode(lowi, highi).X
        Mcopy(lowi, highi).y = Tmp_GCode(lowi, highi).y
        Mcopy(lowi, highi).z = Tmp_GCode(lowi, highi).z
        Mcopy(lowi, highi).i = Tmp_GCode(lowi, highi).i
        Mcopy(lowi, highi).j = Tmp_GCode(lowi, highi).j
        Mcopy(lowi, highi).k = Tmp_GCode(lowi, highi).k
        Mcopy(lowi, highi).F = Tmp_GCode(lowi, highi).F
        Mcopy(lowi, highi).S = Tmp_GCode(lowi, highi).S
        Mcopy(lowi, highi).t = Tmp_GCode(lowi, highi).t
        'If tmp_gcode(low(i),high(i)).pen <> notset Then pen = tmp_gcode(low(i),high(i)).pen
        Mcopy(lowi, highi).pen = Notset
        Mcopy(lowi, highi).d = Tmp_GCode(lowi, highi).d
        Mcopy(lowi, highi).m = Tmp_GCode(lowi, highi).m
        Mcopy(lowi, highi).steps_to_units = Tmp_GCode(lowi, highi).steps_to_units

        Mcopy(lowi, highi).remarkPtr = Tmp_GCode(lowi, highi).remarkPtr
    Next

Else



Dim datum As Integer
Dim clamped As Integer
Dim newdatum As Integer
Dim remove As Integer

datum = 0
clamped = False
newdatum = False
remove = False
        
ReDim Mcopy(1 To CHUNK, 0 To UBound(Tmp_GCode, 2) + 10 + (1024 / CHUNK))'Allow for extra lines

Curline = 1
clearline Curline
If Options.metric Then
    Mcopy(low(1), high(1)).G = 71            'Metric
    AddRemark_Mcopy 1, "Metric"
Else
    Mcopy(low(1), high(1)).G = 70            'Imperial
    AddRemark_Mcopy 1, "Imperial"
End If


If includeload And (Options.autoload = 1) Then
    Curline = Curline + 1
    clearline Curline
    Mcopy(low(Curline), high(Curline)).G = 0
    Mcopy(low(Curline), high(Curline)).X = Options.loadx
    Mcopy(low(Curline), high(Curline)).y = Options.loady
    AddRemark_Mcopy Curline, "Move to Robot Load Point"

    Curline = Curline + 1
    clearline Curline
    Mcopy(low(Curline), high(Curline)).m = 0    'Pause
    AddRemark_Mcopy Curline, "Pause For Robot Load"

End If


pen = 1
For i = 1 To insert_rows
    highi = high(i): lowi = low(i)
    If Tmp_GCode(lowi, highi).pen <> Notset Then               'Purge boundary box
        If Tool(Tmp_GCode(lowi, highi).pen).depth = 0 Then
            remove = True
        Else
            remove = False
        End If
    End If

    If Not remove Then
        Curline = Curline + 1
        clearline Curline
        If Tmp_GCode(lowi, highi).G = 28 Then GoSub addEnd  ' Start of subroutines
        
        Mcopy(low(Curline), high(Curline)).remarkPtr = Tmp_GCode(lowi, highi).remarkPtr
        Mcopy(low(Curline), high(Curline)).G = Tmp_GCode(lowi, highi).G
        If Tmp_GCode(lowi, highi).X > 8 * intosteps Then Tmp_GCode(lowi, highi).X = 8 * intosteps
        Mcopy(low(Curline), high(Curline)).X = Tmp_GCode(lowi, highi).X
        If Tmp_GCode(lowi, highi).y > 4 * intosteps Then Tmp_GCode(lowi, highi).y = 4 * intosteps
        Mcopy(low(Curline), high(Curline)).y = Tmp_GCode(lowi, highi).y

        Mcopy(low(Curline), high(Curline)).z = Tmp_GCode(lowi, highi).z
        Mcopy(low(Curline), high(Curline)).i = Tmp_GCode(lowi, highi).i
        Mcopy(low(Curline), high(Curline)).j = Tmp_GCode(lowi, highi).j
        Mcopy(low(Curline), high(Curline)).k = Tmp_GCode(lowi, highi).k
        Mcopy(low(Curline), high(Curline)).d = Notset
        
        If Tmp_GCode(lowi, highi).pen <> Notset Then pen = Tmp_GCode(lowi, highi).pen
        Mcopy(low(Curline), high(Curline)).pen = pen
        
        If Not clamped Then
            Mcopy(low(Curline), high(Curline)).m = 68
            AddRemark_Mcopy Curline, "Clamp Work"
            clamped = True
        ElseIf newdatum Then
            Select Case Mcopy(low(Curline), high(Curline)).G
            Case 1, 2, 3, 81, 82, 83
                Mcopy(low(Curline), high(Curline)).m = 0
                AddRemark_Mcopy Curline, "Pause For Tool Datum"
                newdatum = False
            End Select
        Else
            Mcopy(low(Curline), high(Curline)).m = Notset
        End If
        Mcopy(low(Curline), high(Curline)).steps_to_units = Tmp_GCode(lowi, highi).steps_to_units
        
        If Tmp_GCode(lowi, highi).pen <> Notset Then
            newdatum = True             'insert pause on next line
            Mcopy(low(Curline), high(Curline)).F = Tool(Tmp_GCode(lowi, highi).pen).feed
            Mcopy(low(Curline), high(Curline)).S = Tool(Tmp_GCode(lowi, highi).pen).Speed
            Mcopy(low(Curline), high(Curline)).t = Tool(Tmp_GCode(lowi, highi).pen).size
            'Change of tool
            Curline = Curline + 1
            clearline Curline
            If Options.pause = 1 Then
                If Spinon Then
                    Mcopy(low(Curline), high(Curline)).m = 5           'Stop spindle
                    AddRemark_Mcopy Curline, "Stop Spindle"
                    Curline = Curline + 1           'Air off
                    clearline Curline
                    Mcopy(low(Curline), high(Curline)).m = 9
                    AddRemark_Mcopy Curline, "Air Off"
                    Curline = Curline + 1           'Pause to allow for toolchange
                    Spinon = False
                End If
                
                clearline Curline
                Mcopy(low(Curline), high(Curline)).m = 0
                AddRemark_Mcopy Curline, "Pause for toolchange"

                Curline = Curline + 1           'Air on
                clearline Curline
                Mcopy(low(Curline), high(Curline)).m = 8
                AddRemark_Mcopy Curline, "Air On"
        
                Curline = Curline + 1            'Start spindle and go back down
                clearline Curline
                Mcopy(low(Curline), high(Curline)).m = 3
                AddRemark_Mcopy Curline, "Start Spindle and go back down"
                Spinon = True
        
                datum = Tool(Tmp_GCode(lowi, highi).pen).datum
                GoSub SetG92
            Else
                Mcopy(low(Curline), high(Curline)).m = 8       'Air on
                AddRemark_Mcopy Curline, "Air On"
                
                Curline = Curline + 1
                clearline Curline
                Mcopy(low(Curline), high(Curline)).m = 3       'Spindle on
                AddRemark_Mcopy Curline, "Spindle On"
                Spinon = True
                'datum = -datum + Tool(Tmp_GCode(lowi, highi).pen).datum    '92 altered 16/9/96
                
                datum = Tool(Tmp_GCode(lowi, highi).pen).datum
                GoSub SetG92
                
                
            End If
        Else
            Mcopy(low(Curline), high(Curline)).F = Notset
            Mcopy(low(Curline), high(Curline)).S = Notset
            Mcopy(low(Curline), high(Curline)).t = Notset
        End If
    End If
Next

    GoSub addEnd

    
    insert_rows = Curline
    ReDim Preserve Mcopy(1 To CHUNK, 0 To high(Curline))
End If


Exit Sub

                    
SetG92:
    Curline = Curline + 1
    clearline Curline
    
    Mcopy(low(Curline), high(Curline)).G = 92
        
    Mcopy(low(Curline), high(Curline)).z = datum: datum = Notset        'Use data and clear
    Mcopy(low(Curline), high(Curline)).X = Xshift: Xshift = Notset
    Mcopy(low(Curline), high(Curline)).y = yshift: yshift = Notset


    Curline = Curline + 1   'Added
    clearline Curline
    
    Mcopy(low(Curline), high(Curline)).G = 0
        
    Mcopy(low(Curline), high(Curline)).z = datum: datum = Notset        'Use data and clear
    Mcopy(low(Curline), high(Curline)).X = Xshift: Xshift = Notset
    Mcopy(low(Curline), high(Curline)).y = yshift: yshift = Notset

    
    Return



unsetg92:
    Curline = Curline + 1
    clearline Curline

'    If datum <> 0 Then             'Undo previous G92
        Mcopy(low(Curline), high(Curline)).G = 92
        Mcopy(low(Curline), high(Curline)).z = 0        '-datum
        Mcopy(low(Curline), high(Curline)).X = 0
        Mcopy(low(Curline), high(Curline)).y = 0
        datum = 0
'    End If
    Return


addEnd:
    If EndLine Then Return
    EndLine = True
    Curline = Curline + 1
    clearline Curline
    Mcopy(low(Curline), high(Curline)).G = 0
    Mcopy(low(Curline), high(Curline)).z = 0
    
    Curline = Curline + 1
    clearline Curline
    Mcopy(low(Curline), high(Curline)).m = 5           'Spindle off
    AddRemark_Mcopy Curline, "Spindle Off"
    'GoSub unsetg92
    Curline = Curline + 1           'Air off
    clearline Curline
    Mcopy(low(Curline), high(Curline)).m = 9
    AddRemark_Mcopy Curline, "Air Off"

    GoSub unsetg92

    
    Curline = Curline + 1
    clearline Curline
    If includeload And (Options.autoload = 1) Then
        Mcopy(low(Curline), high(Curline)).G = 0
        Mcopy(low(Curline), high(Curline)).X = Options.loadx
        Mcopy(low(Curline), high(Curline)).y = Options.loady
    Else
        Mcopy(low(Curline), high(Curline)).G = 0
        Mcopy(low(Curline), high(Curline)).X = 0
        Mcopy(low(Curline), high(Curline)).y = 0
    End If
    Mcopy(low(Curline), high(Curline)).m = 69          'Open vice
    AddRemark_Mcopy Curline, "UnClamp Work"

    Curline = Curline + 1           'End of program
    clearline Curline
    Mcopy(low(Curline), high(Curline)).m = 2
    AddRemark_Mcopy Curline, "That's all Folks"
    Curline = Curline + 1
    clearline Curline
    Return


End Sub

Sub ncdrill_import ()

Dim A$
Dim i As Integer
Dim FirstHole As Integer
Dim Dummy

Load import
import.Caption = "NC Drill Postprocessor"
import.Tag = 1
import.Show 1
Dummy = import.Tag
Unload import
If Not Dummy Then Exit Sub

SetUpStatus "NC Drill Postprocessor"

CNC_Addline1 False

in_handle = FreeFile
Open import_filename$ For Binary Access Read Lock Write As in_handle
PTR = 1: buffer = "": refreshbuffer
Do
    refreshbuffer
    While Mid$(buffer, PTR, 1) < "A"                'Throw away white space and
        If PTR > Len(buffer) Then Exit Do           'unwanted parameters
        PTR = PTR + 1
    Wend
        
        updatestatus
        PTR = PTR + 1
        Select Case Mid$(buffer, PTR - 1, 1)
        Case "M"
        
        Case "%"
        
        Case "T"
            Dummy = readnum(0, 0)
            If Dummy <> 0 Then
                If Tmp_GCode(low(Curline), high(Curline)).pen <> Dummy Then
                    Tmp_GCode(low(Curline), high(Curline)).pen = Dummy
                    pen = Dummy
                End If
            End If
            FirstHole = True

        Case "X"
            Tmp_GCode(low(Curline), high(Curline)).X = readnum(0, 0) * intosteps / 1000      ' g.scalex       'Convert to steps
            
        Case "Y"
            Tmp_GCode(low(Curline), high(Curline)).y = Options.blocky - readnum(0, 0) * intosteps / 1000    'g.scaley      'Convert to steps
            
            If FirstHole Then
                FirstHole = False
                Tmp_GCode(low(Curline), high(Curline)).G = 0
                Tmp_GCode(low(Curline), high(Curline)).z = 0
                Cnc_Addline
            End If
            
            Tmp_GCode(low(Curline), high(Curline)).G = 83           'Drill cycle - no dwell
            Tmp_GCode(low(Curline), high(Curline)).z = Tool(pen).depth
            Cnc_Addline

    End Select

Loop

CNC_Addlastline True, True, False
Close in_handle

Unload StatusDlg
Erase Tool


End Sub

Function nextdxf (Layer, X, y)

Dim i    As Integer
Dim j    As Integer
Dim dist As Long
Dim n    As Long
    
    n = 64000
    j = -1
    For i = 1 To UBound(dxf, 2)
        Select Case dxf(Layer, i).G
        Case -1
        Case 1, 2, 3
            dist = CLng(Abs(CLng(X) - CLng(dxf(Layer, i).x1))) + CLng(Abs(CLng(y) - CLng(dxf(Layer, i).y1)))
            If dist = 0 Then j = i: Exit For
            If dist < n Then n = dist: j = i

            dist = CLng(Abs(CLng(X) - CLng(dxf(Layer, i).x2))) + CLng(Abs(CLng(y) - CLng(dxf(Layer, i).Y2)))
            If dist = 0 Then j = i: Exit For
            If dist < n Then n = dist: j = i

        Case Else

        End Select
    Next
    
    If j <> -1 Then
        If CLng(Abs(CLng(X) - CLng(dxf(Layer, j).x1))) + CLng(Abs(CLng(y) - CLng(dxf(Layer, j).y1))) > CLng(Abs(CLng(X) - CLng(dxf(Layer, j).x2))) + CLng(Abs(CLng(y) - CLng(dxf(Layer, j).Y2))) Then
            swapi dxf(Layer, j).x1, dxf(Layer, j).x2
            swapi dxf(Layer, j).y1, dxf(Layer, j).Y2
            Select Case dxf(Layer, j).G
                Case 2
                    dxf(Layer, j).G = 3
                Case 3
                    dxf(Layer, j).G = 2
            End Select
        End If
    End If

    nextdxf = j
    

End Function

Sub Pad (CenterX, CenterY, R)

Dim X, i, j, y
Dim h As Long

                'For i = X - m To X + m
                '    For j = Y - m To Y + m
                '        Matrix(i, j) = 1
                '    Next
                'Next


h = (R + 1) ^ 2             'Hypot for outline

For X = 0 To R
    y = Fix(Sqr(Abs((h - (X ^ 2))))) - 3  'Subtract to avoid outline
    If y > 0 Then
        For j = CenterY - y To CenterY + y
            Matrix(CenterX + X, j) = 1
            Matrix(CenterX - X, j) = 1
        Next
    End If
Next


'For Y = R / 2 To R
'    X = Sqr(Abs((h - (Y ^ 2)))) - 1 'Subtract to avoid outline
'    If X < 0 Then X = 0
'
'    For i = CenterX - X To CenterX + X
'        Matrix(i, CenterY + Y) = 1
'        Matrix(i, CenterY + Y) = 1
'    Next
'
'Next









End Sub

Sub ProcessDb ()

Dim x1, x2, Xc, Lastx
Dim y1, Y2, Yc, Lasty
Dim arc, Dif1, Dif2

Const NoCut = 0 * mmtosteps


PcbTable.Index = "Start"
PcbTable.MoveFirst
x1 = PcbTable("X1")
y1 = PcbTable("Y1")
x2 = PcbTable("X2")
Y2 = PcbTable("Y2")
Xc = PcbTable("XC")
Yc = PcbTable("YC")
arc = 3


Lastx = 9999
Lasty = 9999



Do
    
    Select Case Sqr((Lastx - x1) ^ 2 + (Lasty - y1) ^ 2)
    Case 0
    Case Is < 5
        Tmp_GCode(low(Curline), high(Curline)).G = 1
        Tmp_GCode(low(Curline), high(Curline)).X = x1 * intosteps / 400
        Tmp_GCode(low(Curline), high(Curline)).y = Options.blocky - (y1 * intosteps / 400)
        Tmp_GCode(low(Curline), high(Curline)).z = Tool(1).depth
        Cnc_Addline
    Case Else
        Tmp_GCode(low(Curline), high(Curline)).G = 0
        Tmp_GCode(low(Curline), high(Curline)).X = x1 * intosteps / 400
        Tmp_GCode(low(Curline), high(Curline)).y = Options.blocky - (y1 * intosteps / 400)
        Tmp_GCode(low(Curline), high(Curline)).z = NoCut
        Cnc_Addline
    End Select

    If Xc = -1 Then         'line
        Tmp_GCode(low(Curline), high(Curline)).G = 1
    Else                'arc
        Tmp_GCode(low(Curline), high(Curline)).G = arc
        Tmp_GCode(low(Curline), high(Curline)).i = Abs(x1 - Xc) * intosteps / 400
        Tmp_GCode(low(Curline), high(Curline)).j = Abs(y1 - Yc) * intosteps / 400
    End If
    
    Tmp_GCode(low(Curline), high(Curline)).X = x2 * intosteps / 400
    Tmp_GCode(low(Curline), high(Curline)).y = Options.blocky - (Y2 * intosteps / 400)
    Tmp_GCode(low(Curline), high(Curline)).z = Tool(1).depth
    Cnc_Addline

    
    
    PcbTable.Index = "All": PcbTable.Seek "=", x1, y1, x2, Y2
    If PcbTable.NoMatch Then PcbTable.Seek "=", x2, Y2, x1, y1

    PcbTable.Delete 'Used entry - remove it
    Lastx = x2: Lasty = Y2

    
    PcbTable.Index = "Start": PcbTable.Seek "=", Lastx, Lasty
    
    If Not PcbTable.NoMatch Then        'Found match
        GoSub Set3
    Else
        PcbTable.Index = "End": PcbTable.Seek "=", Lastx, Lasty
        If Not PcbTable.NoMatch Then        'Found match
            GoSub Set2
        Else
            PcbTable.Index = "Start": PcbTable.MoveFirst
            If PcbTable.NoMatch Then Exit Do
            
            GoSub Set3  'Set default next node
            Dif1 = Sqr((Lastx - x1) ^ 2 + (Lasty - y1) ^ 2)   'Distance to node
            
            PcbTable.Index = "X1": GoSub Searchx1    'No exact match - find nearest node
            PcbTable.Index = "X2": GoSub Searchx2
            'PcbTable.Index = "Y1": GoSub SearchY1
            'PcbTable.Index = "Y2": GoSub SearchY2
        End If
    End If
Loop


PcbTable.Close
db.Close

Exit Sub



Searchx1:
    If Dif1 > 50 Then
        PcbTable.Seek ">=", Lastx - 50
    Else
        PcbTable.Seek ">=", Lastx - Dif1
    End If
    If Not PcbTable.NoMatch Then
        Do Until PcbTable("X1") > (Lastx + Dif1)
            Dif2 = Sqr(((Lastx - PcbTable("X1")) ^ 2) + ((Lasty - PcbTable("Y1")) ^ 2))
            If Dif2 < Dif1 Then
                Dif1 = Dif2: GoSub Set3
            End If
            PcbTable.MoveNext
            If PcbTable.EOF Then Exit Do
        Loop
    End If
    If Dif1 > 100 Then
         '
    End If
    Return

Searchx2:
    If Dif1 > 50 Then
        PcbTable.Seek ">=", Lastx - 50
    Else
        PcbTable.Seek ">=", Lastx - Dif1
    End If
    If Not PcbTable.NoMatch Then
        Do Until PcbTable("X2") > (Lastx + Dif1)
            Dif2 = Sqr(((Lastx - PcbTable("X2")) ^ 2) + ((Lasty - PcbTable("Y2")) ^ 2))
            If Dif2 < Dif1 Then
                Dif1 = Dif2: GoSub Set2
            End If
            PcbTable.MoveNext
            If PcbTable.EOF Then Exit Do
        Loop
    End If
    If Dif1 > 100 Then
         '
    End If

    Return

SearchY1:
    PcbTable.Seek "=", Lasty - Dif1
    If Not PcbTable.NoMatch Then
        Do Until PcbTable("Y1") > (Lasty + Dif1)
            Dif2 = Sqr((Lastx - PcbTable("X1")) ^ 2 + (Lasty - PcbTable("Y1")) ^ 2)
            If Dif2 < Dif1 Then
                Dif1 = Dif2: GoSub Set2
            End If
            PcbTable.MoveNext
            If PcbTable.EOF Then Exit Do
        Loop
    End If
    Return

SearchY2:
    PcbTable.Seek "=", Lasty - Dif1
    If Not PcbTable.NoMatch Then
        Do Until PcbTable("Y2") > (Lasty + Dif1)
            Dif2 = Sqr((Lastx - PcbTable("X2")) ^ 2 + (Lasty - PcbTable("Y2")) ^ 2)
            If Dif2 < Dif1 Then
                Dif1 = Dif2: GoSub Set3
            End If
            PcbTable.MoveNext
            If PcbTable.EOF Then Exit Do
        Loop
    End If
    Return




Set3:
    x1 = PcbTable("X1")
    y1 = PcbTable("Y1")
    x2 = PcbTable("X2")
    Y2 = PcbTable("Y2")
    Xc = PcbTable("XC")
    Yc = PcbTable("YC")
    arc = 3                     'Arcs will be as defined
    Return


Set2:
    x1 = PcbTable("X2")
    y1 = PcbTable("Y2")
    x2 = PcbTable("X1")
    Y2 = PcbTable("Y1")
    Xc = PcbTable("XC")
    Yc = PcbTable("YC")
    arc = 2                     'Arc backward
    Return



End Sub

Private Function ReadDxf (LayerMode As Integer, SectionNo As Integer)

Dim Font As Integer
Dim Dirn As Integer
Dim h As Integer
Dim W As Integer
Dim xscale As Single
Dim yscale As Single
Dim h1 As Integer
Dim w1 As Integer

Dim Bulge As Single
Dim Closed As Integer
Dim PolyPtr As Integer
Dim Msg As String
Dim Fail As Integer

Dim G As Integer
Dim g1 As Integer
Dim S As String

Dim v As Single
Dim A As Single
Dim P As Integer
Dim F As Integer

Dim X  As Single
Dim y  As Single
Dim x1 As Single
Dim x2 As Single
Dim y1 As Single
Dim Y2 As Single

Dim Xc As Single
Dim Yc As Single
Dim Radius As Single
Dim theta1 As Single
Dim theta2 As Single
Dim alpha  As Single
Dim beta   As Single
Dim Layer As Integer

Dim BlkNo As Integer

If LayerMode Then
    ReDim dxf(LBound(LayerName) To UBound(LayerName), 1 To 1024)        'Array for each layer
    ReDim Lptr(LBound(LayerName) To UBound(LayerName))
    For Layer = LBound(Lptr) To UBound(Lptr)
        Lptr(Layer) = 1
    Next
    Layer = LBound(LayerName)                                           'Make sure default layer is valid
Else
    ReDim dxf(0 To 0, 1 To 1024)                                        'Array for each layer - Lathe limited to single layer
    ReDim Lptr(0)
    Layer = 0                                                           'Make sure default layer is valid
    Lptr(Layer) = 1
End If

screen.MousePointer = 11    'busy

in_handle = FreeFile
Open import_filename$ For Input Access Read Lock Write As in_handle

SetUpStatus "DXF Postprocessor": PTR = 0
    
If SectionNo = 0 Then
    Do
        Do
            ReadDxfLine G, S, v, A, P, F, X, y
        Loop Until (G = 0) And S = "SECTION"
        ReadDxfLine G, S, v, A, P, F, X, y
        'MsgBox S
    Loop Until S = "ENTITIES"
'

Else
    Do
        Do
            ReadDxfLine G, S, v, A, P, F, X, y
        Loop Until S = "Block"
    
        Do
            ReadDxfLine G, S, v, A, P, F, X, y
            If S = "Insert" Then Exit Do
        Loop Until S = Blockname(SectionNo)
    Loop Until S = Blockname(SectionNo)


End If

Fail = False
Do
If G <> 0 Then ReadDxfLine G, S, v, A, P, F, X, y
Select Case G
    Case 0
        Select Case S
            Case "ENDSEC", "Endblk"
                Exit Do
            Case "LINE"
                Do
                    ReadDxfLine G, S, v, A, P, F, X, y
                    Select Case G
                        Case 0
                            'Generate Line from x1 to X2
                            dxf(Layer, Lptr(Layer)).G = 1
                            If x1 < x2 Then
                                dxf(Layer, Lptr(Layer)).x1 = to_mm(x1)
                                dxf(Layer, Lptr(Layer)).x2 = to_mm(x2)
                                dxf(Layer, Lptr(Layer)).y1 = to_mm(y1)
                                dxf(Layer, Lptr(Layer)).Y2 = to_mm(Y2)
                            Else
                                dxf(Layer, Lptr(Layer)).x2 = to_mm(x1)
                                dxf(Layer, Lptr(Layer)).x1 = to_mm(x2)
                                dxf(Layer, Lptr(Layer)).Y2 = to_mm(y1)
                                dxf(Layer, Lptr(Layer)).y1 = to_mm(Y2)
                            End If
                            Lptr(Layer) = Lptr(Layer) + 1
                            Exit Do
                        Case 8      'Layer name
                            GoSub SetLayer
                        Case 10
                            x1 = X: y1 = -y
                        Case 11
                            x2 = X: Y2 = -y
                    End Select
                Loop
            
            
            Case "ARC", "CIRCLE"
                theta1 = 0
                theta2 = 2 * PI
                Do
                    ReadDxfLine G, S, v, A, P, F, X, y
                    Select Case G
                        Case 0
                            GoSub makearcs
                            Exit Do
                        Case 8      'Layer name
                            GoSub SetLayer
                        Case 10
                            Xc = X
                            Yc = -y   'Centre
                        Case 40                 'radius
                            Radius = v
                        Case 50                         'Start angle
                            theta1 = A * PI / 180       'Convert to radians
                        Case 51                         'End angle
                            theta2 = A * PI / 180       'Convert to radians
                        Case Else
                        '
                    End Select
                Loop

            Case "POLYLINE"
                ReDim Poly(1024)
                PolyPtr = -1
                Closed = False
                
                Do
                    ReadDxfLine G, S, v, A, P, F, X, y
                    
                    Select Case G
                        Case 0
                            Select Case S
                                Case "VERTEX"
                                    PolyPtr = PolyPtr + 1   'Point to next
                                    Poly(PolyPtr).Bulge = 0 'Default to straight line
                                
                                Case "SEQEND"
                                    If PolyPtr <> -1 Then

                                    If Closed Then   'Closed poly
                                        PolyPtr = PolyPtr + 1
                                        Poly(PolyPtr).X = Poly(0).X
                                        Poly(PolyPtr).y = Poly(0).y
                                        Poly(PolyPtr).Bulge = 0
                                    End If
                                    
                                    ReDim Preserve Poly(PolyPtr)
                                    For PolyPtr = 0 To UBound(Poly) - 1
                                        If Poly(PolyPtr).Bulge = 0 Then
                                            dxf(Layer, Lptr(Layer)).G = 1
                                            dxf(Layer, Lptr(Layer)).x1 = to_mm(Poly(PolyPtr).X)
                                            dxf(Layer, Lptr(Layer)).y1 = to_mm(Poly(PolyPtr).y)
                                        
                                            dxf(Layer, Lptr(Layer)).x2 = to_mm(Poly(PolyPtr + 1).X)
                                            dxf(Layer, Lptr(Layer)).Y2 = to_mm(Poly(PolyPtr + 1).y)
                                            Lptr(Layer) = Lptr(Layer) + 1
                                        Else    'Arc segment
                                            x1 = Poly(PolyPtr).X            'start
                                            x2 = Poly(PolyPtr + 1).X        'end
                                            y1 = Poly(PolyPtr).y
                                            Y2 = Poly(PolyPtr + 1).y
                                            X = x1 - x2
                                            y = y1 - Y2
                                            
                                            theta1 = Atn(Poly(PolyPtr).Bulge) * 2      'Bulge angle
                                            
                                            alpha = Sqr(X ^ 2 + y ^ 2) / 2
                                            
                                            Radius = Abs(alpha / Sin(theta1))
                                            
                                            beta = Sqr(Abs(Radius ^ 2 - alpha ^ 2))
                                            
                                            If Poly(PolyPtr).Bulge > 0 Then
                                                Xc = (x1 + x2) / 2 + beta * (Y2 - y1) / (2 * alpha)
                                                Yc = (y1 + Y2) / 2 - beta * (x2 - x1) / (2 * alpha)
                                                If (y1 = Yc) Then
                                                    theta1 = -PI
                                                Else
                                                    theta1 = Atn((x1 - Xc) / (y1 - Yc)) - PI / 2
                                                End If

                                                
                                                If (Abs(x1 - (Xc + Radius * Cos(theta1))) > .01) Then theta1 = theta1 + PI
                                                If (Abs(y1 - (Yc - Radius * Sin(theta1))) > .01) Then theta1 = theta1 + PI
                                                If (Abs(x1 - (Xc + Radius * Cos(theta1))) > .01) Then MsgBox "X Error 1"
                                                If (Abs(y1 - (Yc - Radius * Sin(theta1))) > .01) Then MsgBox "Y Error 1"
                                                theta2 = theta1 + Atn(Poly(PolyPtr).Bulge) * 4
                                            
                                            Else
                                                Xc = (x1 + x2) / 2 - beta * (Y2 - y1) / (2 * alpha)
                                                Yc = (y1 + Y2) / 2 + beta * (x2 - x1) / (2 * alpha)
                                                theta2 = Atn((x1 - Xc) / (y1 - Yc)) + PI / 2

                                                If (Abs(x1 - (Xc + Radius * Cos(theta2))) > .01) Then theta2 = theta2 + PI
                                                If (Abs(y1 - (Yc - Radius * Sin(theta2))) > .01) Then theta2 = theta2 + PI
                                                If (Abs(x1 - (Xc + Radius * Cos(theta2))) > .01) Then MsgBox "X Error 2"
                                                If (Abs(y1 - (Yc - Radius * Sin(theta2))) > .01) Then MsgBox "Y Error 2"
                                                theta1 = theta2 + Atn(Poly(PolyPtr).Bulge) * 4
                                            End If

                                            theta1 = Val(Format$(theta1, "##.######"))
                                            theta2 = Val(Format$(theta2, "##.######"))
                                            
                                            GoSub makearcs
                                        End If
                                    Next
                                    
                                    
                                    PolyPtr = 0
                                    Else
                                    '
                                    End If
                                    G = -1'Force read of next token
                                    Exit Do
                                
                                Case "ENDSEC"
                                    Exit Do

                                Case Else
                                '
                                    Exit Do
                            End Select

                        Case 8
                            GoSub SetLayer
                        
                        Case 10
                            Poly(PolyPtr).X = X
                            Poly(PolyPtr).y = -y

                        Case 42     'Bulge
                            Poly(PolyPtr).Bulge = v

                        Case 70                 'Flags
                            '1 = closed poly
                            '2 = curve fit
                            '4 = spline fit
                            Select Case F
                                Case 1
                                    Closed = True
                                Case 2, 4
                                      '
                                
                                Case 8
                                
                                Case 16         'Spline control point
                                    PolyPtr = PolyPtr - 1       'Throw it awawy

                                Case Else
                                '

                            End Select
                        Case 66                 'Vertices follow


                    End Select
                Loop
            Case "TEXT"
                If LayerMode Then
                Dirn = 1
                Font = 1
                W = Notset
                h = Notset
                xscale = 1
                yscale = 1
                
                Do
                    ReadDxfLine G, S, v, A, P, F, X, y
                    Select Case G
                        Case 0
                            If Len(dxf(Layer, Lptr(Layer) + 1).Comment) = 0 Then
                            
                            Else
                            dxf(Layer, Lptr(Layer)).G = 98
                            dxf(Layer, Lptr(Layer)).x1 = Dirn * mmtosteps
                            dxf(Layer, Lptr(Layer)).y1 = Font * mmtosteps
                            Lptr(Layer) = Lptr(Layer) + 1
                            
                            'Need to know length of text
                            Select Case Dirn
                            Case 2, 4
                                swapi W, h
                                swap xscale, yscale
                            End Select
                            w1 = W
                            h1 = h
                            EngraveTextInfo dxf(Layer, Lptr(Layer)).Comment, Font, Dirn, w1, h1

                            '
                            x1 = to_mm(x1)      'Gives bottom left
                            y1 = to_mm(y1)
                            
                            x1 = x1 + w1 / 2 * xscale   'Gives centre
                            y1 = y1 - h1 / 2 * yscale
                            
                            dxf(Layer, Lptr(Layer)).G = 99
                            Select Case Dirn
                            Case 2, 4
                                If yscale = 1 Then
                                    dxf(Layer, Lptr(Layer)).y1 = Notset
                                Else
                                    dxf(Layer, Lptr(Layer)).y1 = h1 * yscale
                                End If
                                dxf(Layer, Lptr(Layer)).x1 = W
                            
                            Case Else
                                If xscale = 1 Then
                                    dxf(Layer, Lptr(Layer)).x1 = Notset
                                Else
                                    dxf(Layer, Lptr(Layer)).x1 = w1 * xscale
                                End If
                                dxf(Layer, Lptr(Layer)).y1 = h
                            End Select
                            
                            dxf(Layer, Lptr(Layer)).x2 = x1      'Insertion point
                            dxf(Layer, Lptr(Layer)).Y2 = y1
                            Lptr(Layer) = Lptr(Layer) + 1
                            End If
                            Exit Do
                        Case 1
                            dxf(Layer, Lptr(Layer) + 1).Comment = S
                        Case 7                          'font
                            Font = 1
                            Select Case S
                            Case "STANDARD", "TXT"
                                Font = 1
                            Case "MONOTXT"
                                Font = 2
                            Case "ROMANC"
                                Font = 3
                            Case "ROMAND"
                                Font = 4
                            Case "ROMANT"
                                Font = 5
                            Case "ROMANS"
                                Font = 6
                            Case "SIMPLEX"
                                Font = 7
                            Case "COMPLEX"
                                Font = 8
                            Case "SCRIPTC"
                                Font = 9
                            Case "SCRIPTS"
                                Font = 10
                            Case "ITALICC"
                                Font = 11
                            Case "ITALICT"
                                Font = 12
                            Case "GOTHICE"
                                Font = 13
                            Case "GOTHICG"
                                Font = 14
                            Case "GOTHICI"
                                Font = 15
                            Case "GREEKC"
                                Font = 16
                            Case "GREEKS"
                                Font = 17
                            Case "CYRILLIC"
                                Font = 18
                            Case "CYRILTLC"
                                Font = 19
                            Case Else
                                     '
                            End Select
                        
                        Case 8      'Layer name
                            GoSub SetLayer
                        
                        Case 10                         'insertion point
                            x1 = X: y1 = -y
                        
                        Case 11                         'alignment point
                            x2 = X: Y2 = -y
                        
                        Case 40                         'Height
                            h = v * mmtosteps
                        
                        Case 41                         'x scale
                            xscale = v

                        Case 50                         'rotation angle
                            Select Case A
                                Case 0
                                    Dirn = 1
                                Case 90
                                    Dirn = 4
                                Case 180
                                    Dirn = 3
                                Case 270
                                    Dirn = 2
                            End Select

                        Case 71
                            'flag = f
                        
                        Case 72                         'justification
                            'f

                    End Select
                Loop
                
                Else
                    ReadDxfLine G, S, v, A, P, F, X, y
                    Fail = True

                End If

            Case "Insert"
                Do
                    ReadDxfLine G, S, v, A, P, F, X, y
                    Select Case G
                        Case 0
                            dxf(Layer, Lptr(Layer)).G = 65
                            dxf(Layer, Lptr(Layer)).x1 = to_mm(x1)
                            dxf(Layer, Lptr(Layer)).y1 = to_mm(y1)
                            dxf(Layer, Lptr(Layer)).x2 = BlkNo * mmtosteps

                            dxf(Layer, Lptr(Layer)).Comment = "Insert " & Blockname(BlkNo)

                            Lptr(Layer) = Lptr(Layer) + 1
                            Exit Do
                        Case 2      'Block name
                            BlkNo = 1
                            Do
                                If Blockname(BlkNo) = "" Then Exit Do
                                If Blockname(BlkNo) = S Then Exit Do
                                BlkNo = BlkNo + 1
                    
                                If BlkNo > UBound(Blockname) Then
                                    ReDim Preserve Blockname(BlkNo + 10)
                                End If
                            Loop
                            Blockname(BlkNo) = S

                        Case 8      'Layer name
                            GoSub SetLayer
                        
                        Case 10         'Insertion point
                            x1 = X: y1 = -y
                        
                        Case 41, 42, 43         'Scale - must be 1
                        '

                        Case 44, 45
                        '
                        
                        Case 50
                        '
                        
                        Case 70, 71
                        '

                    End Select
                Loop

            Case Else
                ReadDxfLine G, S, v, A, P, F, X, y
                Fail = True

        End Select
End Select

Loop Until EOF(in_handle)



If Fail Then
    For Layer = LBound(Lptr) To UBound(Lptr)
        If Lptr(Layer) <> 1 Then Fail = False
    Next
    If Fail Then
        Msg = "Un-supported entities have been ignored" + Chr$(13) + "Nothing else of interest was found"
        GoTo Abort_MillDXF
    Else
        Msg = "Un-supported entities have been ignored"
        MsgBox Msg, , "DXF Error"
    End If
End If

Fail = True
For Layer = LBound(Lptr) To UBound(Lptr)
    If Lptr(Layer) <> 1 Then Fail = False
Next

If Fail Then
    Msg = "Nothing of interest was found"
    GoTo Abort_MillDXF
End If


Close in_handle
If Not LayerMode Then ReDim Preserve dxf(0 To 0, 1 To Lptr(0) - 1)
ReadDxf = True

Exit Function


makearcs:
    
    While theta1 < 0
        theta1 = theta1 + 2 * PI
    Wend
    If theta1 > theta2 Then theta2 = theta2 + 2 * PI        '360
    'Theta1 = Theta1 * PI / 180      'Convert to radians
    'Theta2 = Theta2 * PI / 180      'Convert to radians
    x1 = Xc + Radius * Cos(theta1)  'Get start point
    y1 = Yc - Radius * Sin(theta1)
    Do              'Break arc up into quadrant
        Select Case theta1
            Case Is < PI / 2
                If theta2 > PI / 2 Then theta1 = PI / 2 Else theta1 = theta2
            Case Is < PI
                If theta2 > PI Then theta1 = PI Else theta1 = theta2
            Case Is < 3 * PI / 2
                If theta2 > 3 * PI / 2 Then theta1 = 3 * PI / 2 Else theta1 = theta2
            Case Else
                If theta2 > 2 * PI Then theta1 = 0: theta2 = theta2 - 2 * PI Else theta1 = theta2
        End Select
        x2 = Xc + Radius * Cos(theta1)  'Get end point
        Y2 = Yc - Radius * Sin(theta1)
        dxf(Layer, Lptr(Layer)).Xc = to_mm(Xc)
        dxf(Layer, Lptr(Layer)).Yc = to_mm(Yc)


        If x1 < x2 Then
            dxf(Layer, Lptr(Layer)).G = 2
            dxf(Layer, Lptr(Layer)).x1 = to_mm(x1)
            dxf(Layer, Lptr(Layer)).x2 = to_mm(x2)
            dxf(Layer, Lptr(Layer)).y1 = to_mm(y1)
            dxf(Layer, Lptr(Layer)).Y2 = to_mm(Y2)
        Else
            dxf(Layer, Lptr(Layer)).G = 3
            dxf(Layer, Lptr(Layer)).x2 = to_mm(x1)
            dxf(Layer, Lptr(Layer)).x1 = to_mm(x2)
            dxf(Layer, Lptr(Layer)).Y2 = to_mm(y1)
            dxf(Layer, Lptr(Layer)).y1 = to_mm(Y2)
        End If
        Lptr(Layer) = Lptr(Layer) + 1
        x1 = x2                     'Use end of arc as start of next
        y1 = Y2
    Loop Until theta1 = theta2
    Return


SetLayer:
    If LayerMode Then
        For Layer = 1 To UBound(LayerName)
            If S = LayerName(Layer) Then Exit For
        Next
        If Layer > UBound(dxf, 1) Then
            Msg = "Invalid layer name": GoTo Abort_MillDXF
        End If
    End If
    Return



Abort_MillDXF:
    DoEvents
    Close in_handle
    screen.MousePointer = 0
    MsgBox Msg, , "DXF Error"
    ReadDxf = False


                            



End Function

Private Sub ReadDxfLine (G As Integer, S As String, v As Single, A As Single, P As Integer, F As Integer, X As Single, y As Single)

Dim g1 As Integer
Static txt$
Dim R As Integer
Dim bytesleft As Long
Dim position As Integer


Input #in_handle, G
Select Case G
Case Is < 10
    Line Input #in_handle, S

Case 30 To 49
    Input #in_handle, v

Case 50 To 59                   'angles
    Input #in_handle, A
Case 60 To 69
    Input #in_handle, P

Case 70 To 79                   'Flags
    Input #in_handle, F

Case Is >= 20
    'Msg = "Error in DXF File"
    'GoTo Abort_MillDxf
Case Else
    Input #in_handle, X
    Input #in_handle, g1
    Input #in_handle, y
End Select

    If PTR < 32000 Then PTR = PTR + 10        'fIRST NUMBER THOUGHT OF
    bytesleft = LOF(in_handle) - PTR
    position = bytesleft * 100 / LOF(in_handle)
    If position > 100 Then position = 100
    position = 100 - position
    showprogress position

End Sub

Private Function readnum (convert, zero As Long) As Long

Dim A As Single
Dim i As Integer

    refreshbuffer
    
    Do
        Select Case Mid$(buffer, PTR, 1)
            Case "0" To "9", "+", "-", "."
                'Pointing to a number read it
                i = PTR
                Do
                    Select Case Mid$(buffer, PTR, 1)
                        Case "0" To "9", "+", "-", "."
                            PTR = PTR + 1
                        Case Else
                            Exit Do
                    End Select
                Loop
                A = Val(Mid$(buffer, i, PTR - i))
                If convert = 0 Then readnum = A Else readnum = A / Tmp_GCode(low(Curline), high(Curline)).steps_to_units
                Exit Do
            
            
            Case "A" To "Z", ";"
                readnum = zero  'M sets zero to notset
                Exit Do
            
            Case Else
                If PTR > Len(buffer) Then Exit Do
                PTR = PTR + 1

        End Select
    Loop


End Function

Private Function ReadText () As String

Dim A$

    refreshbuffer
    A$ = ""
    Do
        If PTR > Len(buffer) Then Exit Do
        Select Case Mid$(buffer, PTR, 1)
            Case Chr$(13)
                PTR = PTR + 1
                Exit Do

            Case Else
                A$ = A$ + Mid$(buffer, PTR, 1)
                PTR = PTR + 1
        End Select
    Loop
    
    ReadText = A$


End Function

Private Sub readxy ()

    'CNC_Addline
    Do
        Select Case Mid$(buffer, PTR, 1)
            Case "0" To "9", "-", "+"
                If Absolute Then
                    G.X = readnum(0, 0) ' * x.M + x.c                 ' - g.minx
                    G.y = readnum(0, 0) ' * y.M + y.c
                Else
                    G.X = G.X + readnum(0, 0)   '* x.M
                    G.y = G.y + readnum(0, 0)   '* y.M
                End If
                
                Tmp_GCode(low(Curline), high(Curline)).X = G.X * X.m + X.c        '* 10 / 3       '15
                Tmp_GCode(low(Curline), high(Curline)).y = G.y * y.m + y.c        '* 10 / 3      '15
                Cnc_Addline
        
            Case "A" To "Z"
                'CNC_Addline
                Exit Do
            Case Else
                If PTR > Len(buffer) Then Exit Do
                PTR = PTR + 1
        End Select
        Loop

End Sub

Private Sub refreshbuffer ()

Dim tmpbuffer As String
Dim bytesleft  As Long

If EOF(in_handle) Then Exit Sub

If PTR > Len(buffer) / 2 Then
    bytesleft = LOF(in_handle) - Loc(in_handle) + 2
    If bytesleft > bufferlen Then
        tmpbuffer = Space$(bufferlen)
        Get #in_handle, , tmpbuffer              'Read bufferlen bytes
    Else
        tmpbuffer = Space$(bytesleft)
        Get #in_handle, , tmpbuffer              'Read rest of file
    End If
    If Len(buffer) = 0 Then
        buffer = tmpbuffer
        PTR = 1
    Else
        buffer = Right$(buffer, Len(buffer) - PTR + 1)
        buffer = buffer + tmpbuffer
        PTR = 1
    End If
    'Printer.Print buffer
End If



End Sub

Private Sub ShellSort ()

Dim maxrow As Integer
Dim row As Integer
Dim limit As Integer
Dim offset As Integer
Dim sw As Integer
Dim tmp  As dxf_type

maxrow = UBound(dxf, 2)

offset = maxrow \ 2
Do While offset > 0
    limit = maxrow - offset
    Do
        sw = False
        For row = 1 To limit
            If dxf(0, row).x2 = dxf(0, row + offset).x2 Then
                If dxf(0, row).x1 > dxf(0, row + offset).x1 Then
                    tmp = dxf(0, row)
                    dxf(0, row) = dxf(0, row + offset)
                    dxf(0, row + offset) = tmp
                    sw = row
                End If
            ElseIf dxf(0, row).x2 > dxf(0, row + offset).x2 Then
                tmp = dxf(0, row)
                dxf(0, row) = dxf(0, row + offset)
                dxf(0, row + offset) = tmp
                sw = row
            End If
        Next
        limit = sw - offset
    Loop While sw
    offset = offset \ 2
Loop

End Sub

Private Sub swap (A As Single, b As Single)
Dim c As Single
    c = A
    A = b
    b = c

End Sub

Private Sub swapi (A As Integer, b As Integer)
Dim c As Integer
    c = A
    A = b
    b = c
End Sub

Private Function to_mm (i As Single) As Integer

Select Case i
Case Is < -240
    to_mm = -240 * mmtosteps
Case Is > 240
    to_mm = 240 * mmtosteps
Case Else
    to_mm = Val(Format$(i, "#.0")) * mmtosteps
End Select

End Function

Private Sub updatestatus ()
    
    Static txt$
    Dim R As Integer
    Dim bytesleft As Long
    Dim position As Integer

    bytesleft = LOF(in_handle) - Loc(in_handle) + Len(buffer) - PTR
    position = bytesleft * 100 / LOF(in_handle)
    If position > 100 Then position = 100
    position = 100 - position

    showprogress position
    

End Sub

Private Function WriteDXF_Main ()
    
Dim NewPen As Integer
Dim i As Integer
Dim Layer As Integer
Dim x1 As Integer
Dim y1 As Integer
Dim Ignored
    
    WriteDXF_Main = False   'Default

    For Layer = LBound(dxf, 1) To UBound(dxf, 1)          'Check bounds
        For i = 1 To UBound(dxf, 2)           'Check bounds
            Select Case dxf(Layer, i).x1
            Case 0 To 8 * intosteps, Notset
            Case Else
                WriteDXF_Main = True
            End Select
            Select Case dxf(Layer, i).x2
            Case 0 To 8 * intosteps, Notset
            Case Else
                     WriteDXF_Main = True
            End Select
            Select Case dxf(Layer, i).y1
            Case 0 To 4 * intosteps, Notset
            Case Else
                     WriteDXF_Main = True
            End Select
        
            Select Case dxf(Layer, i).Y2
            Case 0 To 4 * intosteps, Notset
            Case Else
                     WriteDXF_Main = True
            End Select
        Next
    Next

    CNC_Addline1 False
    x1 = -1
    y1 = -1

    For Layer = LBound(dxf, 1) To UBound(dxf, 1)
    For i = 1 To UBound(dxf, 2)
        If dxf(Layer, i).x1 = dxf(Layer, i).x2 Then
            If dxf(Layer, i).y1 = dxf(Layer, i).Y2 Then
                Select Case dxf(Layer, i).G
                Case 0, 1, 2, 3
                    dxf(Layer, i).G = -1
                Case Else

                End Select
            End If
        End If
    Next
    Next
    
    
    x1 = 0  'Start point
    y1 = 0
    If Options.autoload = 1 Then
        x1 = Options.loadx
        y1 = Options.loady
    End If

    For Layer = LBound(dxf, 1) To UBound(dxf, 1)
        NewPen = True

    Do
        i = nextdxf(Layer, x1, y1)      'Returns index of nearest line to x1,y1
        If i = -1 Then Exit Do
        
        If NewPen Then
            Tmp_GCode(low(Curline), high(Curline)).G = 0
            Tmp_GCode(low(Curline), high(Curline)).X = x1
            Tmp_GCode(low(Curline), high(Curline)).y = y1
            Tmp_GCode(low(Curline), high(Curline)).z = 0
            Tmp_GCode(low(Curline), high(Curline)).pen = Layer
            NewPen = False
            Cnc_Addline
        End If
        
        If (x1 <> dxf(Layer, i).x1) Or (y1 <> dxf(Layer, i).y1) Then
            If (x1 = dxf(Layer, i).x2) And (y1 = dxf(Layer, i).Y2) Then     'swap x1 and x2
                dxf(Layer, i).x2 = dxf(Layer, i).x1: dxf(Layer, i).x1 = x1
                dxf(Layer, i).Y2 = dxf(Layer, i).y1: dxf(Layer, i).y1 = y1
                Select Case dxf(Layer, i).G
                    Case 2
                        dxf(Layer, i).G = 3
                    Case 3
                        dxf(Layer, i).G = 2
                End Select
            Else
                Tmp_GCode(low(Curline), high(Curline)).G = 0
                Tmp_GCode(low(Curline), high(Curline)).z = 0
                Cnc_Addline

                Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x1
                Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).y1
                Cnc_Addline
        
                Tmp_GCode(low(Curline), high(Curline)).G = 1
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(Layer).depth
                Cnc_Addline
            End If
        End If
        
        Tmp_GCode(low(Curline), high(Curline)).G = dxf(Layer, i).G
        Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x2
        Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).Y2
        Tmp_GCode(low(Curline), high(Curline)).z = Tool(Layer).depth
        Tmp_GCode(low(Curline), high(Curline)).i = Abs(dxf(Layer, i).x1 - dxf(Layer, i).Xc)
        Tmp_GCode(low(Curline), high(Curline)).j = Abs(dxf(Layer, i).y1 - dxf(Layer, i).Yc)
        x1 = dxf(Layer, i).x2
        y1 = dxf(Layer, i).Y2
        If dxf(Layer, i).Comment <> "" Then Addremark Curline, dxf(Layer, i).Comment
        Cnc_Addline
        dxf(Layer, i).G = -1          'Mark used
    Loop

                'Search for text/subroutine calls
        For i = 1 To UBound(dxf, 2)
            Select Case dxf(Layer, i).G
                Case 65
                    Tmp_GCode(low(Curline), high(Curline)).G = 0
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x1
                    Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).y1
                    Tmp_GCode(low(Curline), high(Curline)).z = 0
                    Cnc_Addline
                    
                    Tmp_GCode(low(Curline), high(Curline)).G = 65
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x2
                    Tmp_GCode(low(Curline), high(Curline)).y = Notset
                    Tmp_GCode(low(Curline), high(Curline)).z = Notset
                    If dxf(Layer, i).Comment <> "" Then Addremark Curline, dxf(Layer, i).Comment
                    Cnc_Addline
                
                Case 98
                    If NewPen Then
                        Tmp_GCode(low(Curline), high(Curline)).G = 0
                        Tmp_GCode(low(Curline), high(Curline)).z = 0
                        Tmp_GCode(low(Curline), high(Curline)).pen = Layer
                        NewPen = False
                        Cnc_Addline
                    End If
                    Tmp_GCode(low(Curline), high(Curline)).G = dxf(Layer, i).G
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x1
                    Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).y1
                    Tmp_GCode(low(Curline), high(Curline)).z = Notset
                    If dxf(Layer, i).Comment <> "" Then Addremark Curline, dxf(Layer, i).Comment
                    Cnc_Addline

                Case 99
                    Tmp_GCode(low(Curline), high(Curline)).G = 0                'Move to insertion point
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x2
                    Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).Y2
                    Tmp_GCode(low(Curline), high(Curline)).z = 0
                    Cnc_Addline
                   
                    Tmp_GCode(low(Curline), high(Curline)).G = 99
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x1
                    Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).y1
                    Tmp_GCode(low(Curline), high(Curline)).z = Tool(Layer).depth
                    If dxf(Layer, i).Comment <> "" Then Addremark Curline, dxf(Layer, i).Comment
                    Cnc_Addline
            End Select
        Next
    Next


    Exit Function

'IgnoreOrFail:
'    If Not Ignored Then
'        If MsgBox("Outside Mill Bounds - Ignore Error", 33, "DXF Import") <> 1 Then
'            WriteDXF_Main = True: Exit Function
'        End If
'        Ignored = True
'    End If
'    Return

End Function

Sub WriteDXF_Sub (SectionNo As Integer, Default As Integer)
    
'Writes incremental sub-routine
Dim Layer As Integer
Dim i As Integer
Dim x1 As Integer
Dim y1 As Integer
Dim z1 As Integer
    
    For Layer = LBound(dxf, 1) To UBound(dxf, 1)          'Check bounds
    
    For i = 1 To UBound(dxf, 2)           'Check bounds
        Select Case dxf(Layer, i).x1
        Case 0 To 8 * intosteps, Notset
        Case Else
            Default = True
        End Select
        Select Case dxf(Layer, i).x2
        Case 0 To 8 * intosteps, Notset
        Case Else
            Default = True
        End Select
        Select Case dxf(Layer, i).y1
        Case 0 To 4 * intosteps, Notset
        Case Else
            Default = True
        End Select
        Select Case dxf(Layer, i).Y2
        Case 0 To 4 * intosteps, Notset
        Case Else
            Default = True
        End Select
    Next
    Next

    
    
    
    x1 = -1
    y1 = -1

    For Layer = LBound(dxf, 1) To UBound(dxf, 1)
    For i = 1 To UBound(dxf, 2)
        If dxf(Layer, i).x1 = dxf(Layer, i).x2 Then
            If dxf(Layer, i).y1 = dxf(Layer, i).Y2 Then
                Select Case dxf(Layer, i).G
                Case 0, 1, 2, 3
                    dxf(Layer, i).G = -1
                Case Else

                End Select
            End If
        End If
    Next
    Next
    
    
    x1 = 0  'Start point
    y1 = 0
    z1 = 0
    
    Tmp_GCode(low(Curline), high(Curline)).G = 28
    Tmp_GCode(low(Curline), high(Curline)).X = SectionNo * mmtosteps
    Tmp_GCode(low(Curline), high(Curline)).y = Notset
    Tmp_GCode(low(Curline), high(Curline)).z = Notset

    Addremark Curline, "Define " & Blockname(SectionNo)
    Cnc_Addline

    Tmp_GCode(low(Curline), high(Curline)).G = 91
    Cnc_Addline

    
    For Layer = LBound(dxf, 1) To UBound(dxf, 1)
    
    Do
        i = nextdxf(Layer, x1, y1)      'Returns index of nearest line to x1,y1
        If i = -1 Then Exit Do
        
        
        If (x1 <> dxf(Layer, i).x1) Or (y1 <> dxf(Layer, i).y1) Then
            If (x1 = dxf(Layer, i).x2) And (y1 = dxf(Layer, i).Y2) Then     'swap x1 and x2
                dxf(Layer, i).x2 = dxf(Layer, i).x1: dxf(Layer, i).x1 = x1
                dxf(Layer, i).Y2 = dxf(Layer, i).y1: dxf(Layer, i).y1 = y1
                Select Case dxf(Layer, i).G
                    Case 2
                        dxf(Layer, i).G = 3
                    Case 3
                        dxf(Layer, i).G = 2
                End Select
            Else
                Tmp_GCode(low(Curline), high(Curline)).G = 0
                Tmp_GCode(low(Curline), high(Curline)).X = Notset
                Tmp_GCode(low(Curline), high(Curline)).y = Notset
                Tmp_GCode(low(Curline), high(Curline)).z = 0 - z1
                z1 = 0
                Cnc_Addline

                Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x1 - x1
                Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).y1 - y1
                Tmp_GCode(low(Curline), high(Curline)).z = Notset
                Cnc_Addline
                x1 = dxf(Layer, i).x1
                y1 = dxf(Layer, i).y1
        
                Tmp_GCode(low(Curline), high(Curline)).G = 1
                Tmp_GCode(low(Curline), high(Curline)).X = Notset
                Tmp_GCode(low(Curline), high(Curline)).y = Notset
                Tmp_GCode(low(Curline), high(Curline)).z = Tool(Layer).depth - z1
                Cnc_Addline
                z1 = Tool(Layer).depth
            End If
        End If
        
        
        Tmp_GCode(low(Curline), high(Curline)).G = dxf(Layer, i).G
        Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x2 - x1
        Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).Y2 - y1
        Tmp_GCode(low(Curline), high(Curline)).z = Tool(Layer).depth - z1
        Tmp_GCode(low(Curline), high(Curline)).i = Abs(dxf(Layer, i).x1 - dxf(Layer, i).Xc)
        Tmp_GCode(low(Curline), high(Curline)).j = Abs(dxf(Layer, i).y1 - dxf(Layer, i).Yc)
        x1 = dxf(Layer, i).x2
        y1 = dxf(Layer, i).Y2
        z1 = Tool(Layer).depth
        If dxf(Layer, i).Comment <> "" Then Addremark Curline, dxf(Layer, i).Comment
        Cnc_Addline
        dxf(Layer, i).G = -1          'Mark used
    Loop

                'Search for text/subroutine calls
        For i = 1 To UBound(dxf, 2)
            Select Case dxf(Layer, i).G
                Case 65
                    Tmp_GCode(low(Curline), high(Curline)).G = 0
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x1 - x1
                    Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).y1 - y1
                    Tmp_GCode(low(Curline), high(Curline)).z = 0 - z1
                    Cnc_Addline
                    x1 = dxf(Layer, i).x1
                    y1 = dxf(Layer, i).y1
                    z1 = 0

                    
                    Tmp_GCode(low(Curline), high(Curline)).G = 65
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x2
                    Tmp_GCode(low(Curline), high(Curline)).y = Notset
                    Tmp_GCode(low(Curline), high(Curline)).z = Notset
                    If dxf(Layer, i).Comment <> "" Then Addremark Curline, dxf(Layer, i).Comment
                    Cnc_Addline
                
                Case 98
                    Tmp_GCode(low(Curline), high(Curline)).G = dxf(Layer, i).G
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x1
                    Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).y1
                    Tmp_GCode(low(Curline), high(Curline)).z = Notset
                    If dxf(Layer, i).Comment <> "" Then Addremark Curline, dxf(Layer, i).Comment
                    Cnc_Addline

                Case 99
                    Tmp_GCode(low(Curline), high(Curline)).G = 0                'Move to insertion point
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x2 - x1
                    Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).Y2 - y1
                    Tmp_GCode(low(Curline), high(Curline)).z = 0 - z1
                    Cnc_Addline
                    x1 = dxf(Layer, i).x2
                    y1 = dxf(Layer, i).Y2
                    z1 = 0

                   
                    Tmp_GCode(low(Curline), high(Curline)).G = 99
                    Tmp_GCode(low(Curline), high(Curline)).X = dxf(Layer, i).x1
                    Tmp_GCode(low(Curline), high(Curline)).y = dxf(Layer, i).y1
                    Tmp_GCode(low(Curline), high(Curline)).z = Tool(Layer).depth
                    If dxf(Layer, i).Comment <> "" Then Addremark Curline, dxf(Layer, i).Comment
                    Cnc_Addline
            End Select
        Next
                

    Next



    Tmp_GCode(low(Curline), high(Curline)).G = 0
    Tmp_GCode(low(Curline), high(Curline)).X = 0 - x1
    Tmp_GCode(low(Curline), high(Curline)).y = 0 - y1
    Tmp_GCode(low(Curline), high(Curline)).z = 0 - z1
    Cnc_Addline

    
    Tmp_GCode(low(Curline), high(Curline)).G = 5
    Tmp_GCode(low(Curline), high(Curline)).X = Notset
    Tmp_GCode(low(Curline), high(Curline)).y = Notset
    Tmp_GCode(low(Curline), high(Curline)).z = Notset
    Cnc_Addline


    




End Sub

Sub Xline (StartX, FinalX, y, m)

Dim S, F, i, j


'Square track
S = StartX - m * Sgn(FinalX - StartX)
F = FinalX + m * Sgn(FinalX - StartX)
    
If S < 0 Then S = 0
If F < 0 Then F = 0
                            
For i = S To F Step Sgn(FinalX - StartX)
    For j = y - m To y + m
        Matrix(i, j) = 1
    Next
Next

End Sub

Sub YLine (StartY, FinalY, X, m)
                    
Dim S, F, i, j

S = StartY - m * Sgn(FinalY - StartY)'Before Start
F = FinalY + m * Sgn(FinalY - StartY)'After End
                    
If S < 0 Then S = 0
If F < 0 Then F = 0

For i = X - m To X + m
    For j = S To F Step Sgn(FinalY - StartY)
        Matrix(i, j) = 1
    Next
Next

End Sub

Private Sub Addremark (i As Long, Text As String)

    Tmp_GCode(low(i), high(i)).remarkPtr = UBound(Tmp_Remarks)
    Tmp_Remarks(UBound(Tmp_Remarks)) = Text
    ReDim Preserve Tmp_Remarks(1 To UBound(Tmp_Remarks) + 1)


End Sub

Private Sub AddRemark_Mcopy (i As Long, Text As String)

    Mcopy(low(i), high(i)).remarkPtr = UBound(Tmp_Remarks)
    Tmp_Remarks(UBound(Tmp_Remarks)) = Text
    ReDim Preserve Tmp_Remarks(1 To UBound(Tmp_Remarks) + 1)


End Sub

Sub ascii_import ()
   

Dim Dummy As Long

    CNCfrm(CNCFrmNo).EditFunc.Caption = "Clear"
    CNCfrm(CNCFrmNo).EditFunc.Caption = "CopyD"   'Get copy of tool parameters


    SetUpStatus "ASCII File Import"
    
    mirrory = 1
    mirrorx = 0
    
    quit = False
    CNC_Addline1 False
    
    in_handle = FreeFile
    Open import_filename$ For Binary Access Read Lock Write As in_handle
    
    buffer = ""
    PTR = 1
    Do
        If quit Then GoTo exitsub2
        
        refreshbuffer
        updatestatus
        
        While (Mid$(buffer, PTR, 1) < "A") And (Mid$(buffer, PTR, 1) <> ";")                'Throw away white space and
            If PTR > Len(buffer) Then Exit Do           'unwanted parameters
            PTR = PTR + 1
        Wend


        PTR = PTR + 1
        Select Case Mid$(buffer, PTR - 1, 1)
        Case "N"
            Tmp_GCode(low(Curline), high(Curline)).pen = Notset
            CNC_Addline_ascii
        Case "G"
            Tmp_GCode(low(Curline), high(Curline)).G = readnum(0, 0)
            Select Case Tmp_GCode(low(Curline), high(Curline)).G
            Case 70
                Tmp_GCode(low(Curline), high(Curline)).steps_to_units = stepstoin
            Case 71
                Tmp_GCode(low(Curline), high(Curline)).steps_to_units = stepstomm
            End Select

        Case "X"
            'Select Case tmp_gcode(low(curline), high(curline)).g
            'Case 38, 39, 73, 65, 28
            '    tmp_gcode(low(curline), high(curline)).x = readnum(0, 0)
            'Case Else
                Tmp_GCode(low(Curline), high(Curline)).X = readnum(1, 0)
            'End Select

        Case "Y"
            'Select Case tmp_gcode(low(curline), high(curline)).g
            'Case 38, 39, 73, 65, 28
            '    tmp_gcode(low(curline), high(curline)).y = readnum(0, 0)
            'Case Else
                Tmp_GCode(low(Curline), high(Curline)).y = readnum(1, 0)
            'End Select
            
        
        Case "Z"
            Tmp_GCode(low(Curline), high(Curline)).z = readnum(1, 0)
        
        Case "I"
            Tmp_GCode(low(Curline), high(Curline)).i = readnum(1, 0)
        Case "J"
            Tmp_GCode(low(Curline), high(Curline)).j = readnum(1, 0)
        
        Case "K"
            Tmp_GCode(low(Curline), high(Curline)).k = readnum(1, 0)
        
        
        Case "F"
            Tmp_GCode(low(Curline), high(Curline)).F = readnum(0, 0)
            Select Case CNCFrmDat(CNCFrmNo).DevType
                Case CncMill
                    If Tmp_GCode(low(Curline), high(Curline)).F > UBound(mill_feedrates) Then Tmp_GCode(low(Curline), high(Curline)).F = UBound(mill_feedrates)
                Case CncLathe
                    If Tmp_GCode(low(Curline), high(Curline)).F > UBound(Lathe_feedrates) Then Tmp_GCode(low(Curline), high(Curline)).F = UBound(Lathe_feedrates)
            End Select
        
        Case "S"
            Tmp_GCode(low(Curline), high(Curline)).S = readnum(0, 0)
        Case "T"
            Select Case CNCFrmDat(CNCFrmNo).DevType
                Case CncMill
                    Tmp_GCode(low(Curline), high(Curline)).t = readnum(1, 0)
                Case CncLathe
                    Tmp_GCode(low(Curline), high(Curline)).t = readnum(0, 0)
            End Select

        Case "D"
            Tmp_GCode(low(Curline), high(Curline)).d = readnum(0, 0)
        Case "M"
            Tmp_GCode(low(Curline), high(Curline)).m = readnum(0, Notset)
        Case ";"
            Addremark Curline, ReadText()
            
            'Tmp_GCode(low(Curline), high(Curline)).remarkPtr = UBound(Tmp_Remarks)
            'Tmp_Remarks(UBound(Tmp_Remarks)) = ReadText()
            'ReDim Preserve Tmp_Remarks(1 To UBound(Tmp_Remarks) + 1)

        Case Else
    
    End Select
    Loop Until PTR > Len(buffer)
    CNC_Addline_ascii

exitsub2:

CNC_Addlastline False, True, True           'Add nothing, keepscale
Close in_handle
'exe_grid

Unload StatusDlg


End Sub

