Option Explicit
Option Compare Text

Function GetFileVersion (FileToCheck As String, topic As String) As String
Dim lpdwHandle&
Dim VersionInfoSize&
Dim lpvdata$
Dim VersionInfo%
Dim lplpBuffer&
Dim lpcb%
Dim ptrFixed%
Dim TransString$
Dim ptrString%
Dim fixedstr$
Dim stringcopy&
Dim i As Integer
Dim char$
Dim nextchar$
Dim TransValue&
Dim TransTable$
Dim tmp$

    VersionInfoSize& = GetFileVersionInfoSize(FileToCheck, lpdwHandle&)
    If VersionInfoSize& = 0 Then
        GetFileVersion = ""
        Exit Function
    End If
    lpvdata$ = String(VersionInfoSize&, Chr$(0))
    VersionInfo% = GetFileVersionInfo(FileToCheck, lpdwHandle&, VersionInfoSize&, lpvdata$)
    ptrFixed% = VerQueryValue(lpvdata$, "\FILEVERSION", lplpBuffer&, lpcb%)
    If ptrFixed% = 0 Then
        ' Take a shot with the hardcoded TransString
        TransString$ = "040904E4"
        ptrString% = VerQueryValue(lpvdata$, "\StringFileInfo\" & TransString$ & "\CompanyName", lplpBuffer&, lpcb%)
        If ptrString% <> 0 Then GoTo GetValues
        ptrFixed% = VerQueryValue(lpvdata$, "\", lplpBuffer&, lpcb%)
        If ptrFixed% = 0 Then
            GetFileVersion = ""
            Exit Function
        Else
            TransString$ = ""
            fixedstr$ = String(lpcb% + 1, Chr(0))
            stringcopy& = lstrcpyn(fixedstr$, lplpBuffer&, lpcb% + 1)
            For i = lpcb% To 1 Step -1
                char$ = Hex(Asc(Mid(fixedstr$, i, 1)))
                If Len(char$) = 1 Then
                    char$ = "0" + char$
                End If
                TransString$ = TransString$ + char$
                If Len(TransString$ & nextchar$) Mod 8 = 0 Then
                    TransString$ = "&H" & TransString$
                    TransValue& = Val(TransString$)
                    TransString$ = ""
                End If
            Next i
        End If
    End If
    TransTable$ = String(lpcb% + 1, Chr(0))
    TransString$ = String(0, Chr(0))
    stringcopy& = lstrcpyn(TransTable$, lplpBuffer&, lpcb% + 1)
    For i = 1 To lpcb%
        char$ = Hex(Asc(Mid(TransTable$, i, 1)))
        If Len(char$) = 1 Then
            char$ = "0" + char$
        End If
        If Len(TransString$ & nextchar$) Mod 4 = 0 Then
            nextchar$ = char$
        Else
            TransString$ = TransString$ + char$ + nextchar$
            nextchar$ = ""
            char$ = ""
        End If
    Next i
GetValues:
    'ptrString% = VerQueryValue(lpvdata$, "\StringFileInfo\" & TransString$ & "\FileVersion", lplpBuffer&, lpcb%)
    ptrString% = VerQueryValue(lpvdata$, "\StringFileInfo\" & TransString$ & topic, lplpBuffer&, lpcb%)
    If ptrString% = 1 Then
        TransTable$ = String(lpcb%, Chr(0))
        stringcopy& = lstrcpyn(TransTable$, lplpBuffer&, lpcb% + 1)
        If InStr(TransTable$, Chr$(0)) <> 0 Then TransTable$ = Left$(TransTable$, InStr(TransTable$, Chr$(0)) - 1)
        GetFileVersion = TransTable$
    Else
        GetFileVersion = ""
    End If
    
    'ptrString% = VerQueryValue(lpvdata$, "\StringFileInfo\" & TransString$ & "\CompanyName", lplpBuffer&, lpcb%)
    'If ptrString% = 1 Then
    '    TransTable$ = String(lpcb%, Chr(0))
    '    stringcopy& = lstrcpyn(TransTable$, lplpBuffer&, lpcb% + 1)
    '    If InStr(TransTable$, Chr$(0)) <> 0 Then TransTable$ = Left$(TransTable$, InStr(TransTable$, Chr$(0)) - 1)
    '    GetFileVersion = tmp$ + ", " + TransTable$
    'Else
    '    GetFileVersion = tmp$
    'End If



End Function

