.LALL

	.model medium, pascal, farstack
	.386
	option expr32
	option casemap:all






Prolog  MACRO
	mov     ax, ds                  ; Must be 1st, since Windows overwrites
	nop                             ; Placeholder for 3rd byte
	inc     bp                      ; Push odd BP.  Not required, but
	push    bp                      ;   allows CodeView to recognize stack
	mov     bp, sp                  ; Set up stack frame to access params
	push    ds                      ; Save DS
	mov     ds, ax                  ; Point DS to DLL's data segment
	ENDM

Epilog  MACRO
	pop     ds                      ; Recover original DS
	pop     bp                      ;   and BP+1
	dec     bp                      ; Reset to original BP
	ENDM


pushall macro
	pusha
	endm


popall macro
	popa
	endm




RegisterModule macro
	db 0c4h,0c4h,058h,0
endm

UnRegisterModule macro
	db 0c4h,0c4h,058h,1
endm

DispatchCall macro
	db 0c4h,0c4h,058h,2
endm


VDDin        equ 0
VDDout       equ 1
VDDpeek_8032 equ 2
VDDdeek_8032 equ 3
VDDpoke_8032 equ 4
VDDdoke_8032 equ 5
VDDpage_8032 equ 6


PortIn Macro a,d           ;in al,dx
ifdef winnt
	call ntin
else
	in a,d
endif
	endm



PortOut Macro d,a          ;out dx,al
ifdef winnt        
	call ntout 
else 
	out d,a
endif
	endm












FilterLen Equ 80           ;was 128


FALSE           EQU             0t
TRUE            EQU             1t
false equ FALSE
true  equ TRUE  


DEV_UNCONNECT EQU 0
DEV_ONLINE    EQU 1
DEV_OFFLINE   EQU 2

NOTPRES  equ 0          ;THESE MUST FOLLOW DEFINITIONS IN
MENTOR   equ 2          ;BASIC PROGS
GRYPHON  equ 3
KESTREL  equ 4
SERPENT1 equ 5
SERPENT2 equ 6
NEPTUNE1 equ 7
NEPTUNE2 equ 8
CNCMILL  equ 9
CNCLATHE equ 10
XBOARD   equ 11

SerpentEC1 equ 12
SerpentEC2 equ 13


GRYPHONSLIDE  equ 14



INIT       equ 0
KEYBOARD   equ 1
NOSELEAD   equ 2 
NOSELEAD2  equ 3 
PENDANT    equ 4
SIMULATOR  equ 5
SIMULATOR2 equ 6



Jammed     equ 253      ;Pseudo teach modes
EmerStop   equ 254
ZEROING    equ 255 



toohigh equ 0
toolow  equ 1
changed equ 2


AllocSelector           PROTO FAR PASCAL :WORD
FreeSelector            PROTO FAR PASCAL :WORD
SetSelectorBase         PROTO FAR PASCAL :WORD, :DWORD
SetSelectorLimit        PROTO FAR PASCAL :WORD, :DWORD 
InvertRect              PROTO FAR PASCAL :WORD, :DWORD 



; flags for wFlags parameter of timeSetEvent() function
TIME_ONESHOT    equ    0   ; program timer for single event
TIME_PERIODIC   equ    1   ; program for continuous periodic event
timeSetEvent proto far pascal, :word, :word, :word, :word, :dword, :word
timeKillEvent proto far pascal, :word


gettickcount proto far pascal

;inthand proto far pascal, :word, :word, :dword, :dword, :dword
;dummyinthand proto far pascal, :word, :word, :dword, :dword, :dword


ifdef winnt
ntout proto far pascal
ntin  proto far pascal
endif


service_turbo_mentor             proto far pascal
service_rj45_turbo_mentor        proto far pascal
service_rj45_mentor              proto far pascal
service_turbo_mentor_pulses      proto far pascal
service_rj45_turbo_mentor_pulses proto far pascal
service_rj45_mentor_pulses       proto far pascal
service_mentor_offline           proto far pascal


service_rj45_xboard_pulses       proto far pascal
service_turbo_xboard_pulses       proto far pascal

service_rj45_cncmill_pulses      proto far pascal
service_rj45_mill                proto far pascal
service_mill_offline             proto far pascal

service_rj45_lathe               proto far pascal

service_rj45_gryphon             proto far pascal
service_gryphon_offline          proto far pascal

service_rj45_gryphonslide        proto far pascal
service_gryphonslide_offline     proto far pascal

service_rj45_kestrel             proto far pascal
service_Kestrel_offline          proto far pascal


service_rj45_serpent             proto far pascal
service_turbo_serpent_pulses     proto far pascal
service_turbo_serpent            proto far pascal
service_turbo_serpent_offline    proto far pascal
service_rj45_serpent_offline     proto far pascal

service_neptune1                 proto far pascal
service_neptune1_offline         proto far pascal


service_neptune2                 proto far pascal
service_neptune2_offline         proto far pascal


service_turbo_xboard proto far pascal
service_rj45_xboard proto far pascal
service_xboard_offline           proto far pascal



service_8032_workcell            proto far pascal


initfilters                     proto far pascal
filter                          proto far pascal, channel:word, data:word, default:word, change:word
AxisChanged                     proto far pascal, channel:word
internal_8032_peek              proto far pascal, address:word
peek_8032                       proto far pascal, address:word
deek_8032                       proto far pascal, address:word
poke_8032                       proto far pascal, address:word, data:word
doke_8032                       proto far pascal, address:word, data:word
set8032page                     proto far pascal, millpage:word

xrj45poke                       proto far pascal, :word, :word
xrj45peek                       proto far pascal, :word






getmentorissue proto far pascal


sendrs232 proto far pascal, :word



putoffline proto far pascal 
putonline  proto far pascal 






WC_Struc struc
	DIG_Inputs dw 16 dup(?)
	ANA_Inputs dw 8 dup(?)               ;Expansion board has 8 ip   
	DIG_Output dw 2 dup(255)             ;Two banks of 8 used   
WC_Struc ends


Prom_Struc struc
	PromId db 4 dup(0)
	PromVer db 4 dup(0) 
	PromCopyright db 64 dup(0)
	PromCsum dw 0
Prom_Struc ends

Serpent_Cal_Struc Struc
	CAL_M       DW 3 DUP(1000) 
	CAL_C       DW 3 DUP(0)
Serpent_Cal_Struc Ends




Lathe_Calibration_Struc Struc
	X_Tool dw 4 dup (0)
	Z_Tool dw 4 dup (0)

	X_back dw 0
	Z_back dw 0

	calibrated dw 0
	sendcal dw 0
Lathe_Calibration_Struc Ends



Mill_Calibration_Struc Struc
	X_calib dw 0
	Y_calib dw 0
	Z_calib dw 0
	calibrated dw 0
	sendcal dw 0

	X_back dw 0
	Y_back dw 0
	Z_back dw 0
Mill_Calibration_Struc Ends

	
Serpent_Calibration_Struc Struc
	Cal Serpent_Cal_Struc {}
	Cal1 Serpent_Cal_Struc {}
	Cal2 Serpent_Cal_Struc {}
	Cal3 Serpent_Cal_Struc {}
	
	bump    dw 3 dup(0)

	cal0        dw 3 dup(0)
	cal2000     dw 3 dup(0)

Serpent_Calibration_Struc Ends


Neptune_Calibration_Struc Struc
	CAL_M       DW 6 DUP(1000) 
	CAL_C       DW 6 DUP(0)
	CAL_WIN     DW 6 DUP(10)
	
	CAL_IncFast    DW 6 DUP(10)
	CAL_IncSlow    DW 6 DUP(10)

Neptune_Calibration_Struc Ends


	
common_data struc        
	despos dw 10 dup(?)              ;Type long in BASIC - only actually use lower word
	feedback dw 10 dup(?)            ;Type long in BASIC
	devtype dw NOTPRES                    
	teachmode dw 0                       ;0=off  1=simulator
	online dw FALSE
	simpres dw false            ;Simulator connected
	inpos dw FALSE
	buffer_empty dw 0
	errors dw 0
	power dw 0
	filterenable dw 0
	Insert dw 0
common_data ends

despos_data struc
	despos dw 10 dup(?)
despos_data ends


robot_data_Struc struc
	despos dw 10 dup(?)              ;Type long in BASIC
	feedback dw 10 dup(?)            ;Type long in BASIC
	devtype dw NOTPRES                    
	teachmode dw 0                       ;0=off  1=simulator
	online dw FALSE
	simpres dw false                ;Simulator connected
	inpos dw FALSE
	buffer_empty dw 0
	errors dw 0
	power dw 0
	filterenable dw 0
	Insert dw 0
	
	
	WC WC_Struc {}

	Prom Prom_Struc {}
	
	Union
		MillCalib  Mill_Calibration_Struc {}
		LatheCalib Lathe_Calibration_Struc {}
		SerpCalib  Serpent_Calibration_Struc {}
		NepCalib   Neptune_Calibration_Struc {}
	ends

;    Id dw 0
	
	lastdespos   dw 10 dup(?)
	lastfeedback dw 10 dup (?)
	samefeedbackcnt dw 10 dup (0)


	snap dw false
	
	stop dw 10 dup (false)

	
	pneu        dw 0

	lastinpos dw 0

	csum1 db ?
	csum2 db ?

	mesg     dw ?
	mesgaddr     dw ?
	mesgflag dw ?
	
	write dw ?
	read dw ?
	rj45 dw ?
	learn dw 8 dup(?)
	rawlearn dw 8 dup(?)
	rawFeedback dw 10 dup(?)
	wc_low dw 2 dup(255)
	wc_high dw 2 dup (255)
	pulsestretch dw 0
	offlinecnt dw 0
	pulseop dw 0
	pulsecount dw 0
	rs232data dw 0
	rs232flag dw false

	SerialOP dw 0
	SerialIP dw 0
	SerialFlag dw 0   

;        axislimit dw 0
	LastRead dw 0
	


	resend dw 0
	lastteachmode dw 0
	
	table_page dw 0
	

	Union
		filterdata dw 16*FilterLen dup (0)  ;16 axes ?
		buffer     db 256 dup(?)                ;Only used for mills                        
	Ends

	Union
		startmill dw 0
		startLathe dw 0
	Ends


	mcntrl    db 0      ;last control byte sent

	
	
robot_data_Struc ends




externdef robot:robot_data_Struc

externdef baudcnt:word
externdef rj45id:word
externdef rj45base:word

ifdef ps2build
externdef ps2:word
endif

ifdef oldturbo
externdef turbocnt:word
endif

ifdef winnt
externdef hVDD:word
externdef tmpreg:word
endif

externdef serpent_ramp:word




gettime macro
	mov ah,2ch
	call DOS3Call
	endm




rj45wait macro
;        push cx
;        push ax
	mov dx,rj45base         ;will want dx later - don't save
	mov cx,1000
	.repeat
		PortIn al,dx
		and al,1
	.untilcxz al==0
;       pop ax
;       pop cx
	endm




dlwait macro
	ifndef oldturbo                 ; Old style turbo boards don't
		push ax                         ; have end signal
		push cx                         ; need to put fixed length
		ifdef ps2build                  ; delay in instead    
		.if ps2
			mov cx,1000
			.repeat
				mov al,es:[0200H]
				and al,1
			.untilcxz al!=1
		.else
		endif
			mov cx,1000
			.repeat
				mov al,es:[02000H]
				and al,1
			.untilcxz al==1
		ifdef ps2build
		.endif
		endif
		pop cx
		pop ax
	else
		Push cx
		Mov cx,turbocnt
		.repeat
		.untilcxz
		pop cx
	Endif
	endm


poke macro address,data
	dlwait
	
	ifdif <di>,<address>
		mov di,address
	endif

	ifdif <dx>,<data>
		mov dx,data
	endif
	mov es:[di],dl
	

	endm




rj45poke macro address,data
	PUSH CX
	rj45wait                ;side effect sets dx as base pointer
	   
	mov dx,rj45base
	mov ax,data
	PortOut dx,al

	add dx,2
	mov ax,address
	PortOut dx,al

	add dx,2
	;mov ax,0a0h             ;status - write device
	mov ax,rj45id            ;status - write device
	PortOut dx,al

	add dx,2
	PortOut dx,al               ;send cycle

	add dx,2
	PortOut dx,al               ;start cycle

	POP CX

	endm


rj45peek macro address
	PUSH CX
	rj45wait                ;side effect sets dx as base pointer
	
	add dx,2
	mov ax,address
	PortOut dx,al

	add dx,2
	;mov ax,0a1h             ;status - read device
	
	mov ax,rj45id             ;status - read device
	inc ax
	
	PortOut dx,al

	add dx,2
	PortOut dx,al               ;send cycle

	add dx,2
	PortOut dx,al               ;start cycle

	rj45wait                ;side effect sets dx as base pointer

	add dx,4
	mov ax,254              ;dummy status - read device
	PortOut dx,al

	add dx,4
	PortOut dx,al               ;start cycle

	rj45wait

	add dx,2
	PortIn al,dx
	mov ah,0
	POP CX

	endm






peek macro address
	dlwait
	ifdif <di>,<address>
		mov di,address
	endif
	mov al,es:[di]
	dlwait
	mov al,es:[di]
	mov ah,0
	endm 





settimer2 macro freq
	mov al,010110110b               ;lsb/msb to be loaded - square wave out
	out 043h,al

	mov al,(1193280/(freq/2)) mod 256    ;set rate
	out 042h,al

	mov al,(1193280/(freq/2)) / 256
	out 042h,al

	in al,061h                      ;switch speaker off
	or al,1
	out 061h,al
	
	endm


timer2wait macro
	.repeat                         ;wait for timer2 flag to toggle
		in al,061h
		and al,32
	.until al!=ah
	mov ah,al
	endm




waitrjfree macro
	push ax
	push cx
	mov dx,rj45base         ;Wait til transmission complete
	mov cx,100
	.repeat
		PortIn al,dx
		and al,1
	.untilcxz al==0
	
	;.if cx < minrj
	;        mov minrj,cx
	;.endif
	
	pop cx
	pop ax
	endm


RJout macro addr,data
	ifdif <al>,<data>
		mov al,data
	endif
	mov dx,rj45base
	add dx,addr
	PortOut dx,al
    endm




simulate macro axis,increment
	mov robot[bx].stop[axis*2],false
	mov ax,robot[bx].despos[axis*2]

	.if robot[bx].snap!=0
		mov robot[bx].feedback[axis*2],ax
	
	.elseif ax > robot[bx].feedback[axis*2]
		add robot[bx].feedback[axis*2],increment
		.if robot[bx].feedback[axis*2]>ax
			mov robot[bx].feedback[axis*2],ax
		.else
			mov robot[bx].inpos,FALSE
		.endif
	.elseif ax < robot[bx].feedback[axis*2]
		.if robot[bx].feedback[axis*2]<increment
			mov robot[bx].feedback[axis*2],ax
		.else
			sub robot[bx].feedback[axis*2],increment
			.if ax > robot[bx].feedback[axis*2]
				mov robot[bx].feedback[axis*2],ax
			.else
				mov robot[bx].inpos,FALSE
			.endif
		.endif
	.endif
	endm





commondata macro    

comment*
	Common data

*
robot   robot_data_Struc {}      ;rA4
device1 robot_data_Struc {}      ;rA5  all devices actually
device2 robot_data_Struc {}      ;rA6  addressed by reference
device3 robot_data_Struc {}      ;rA7  to robot
			  
device4 robot_data_Struc {}      ;pA4  Masm won't allow
device5 robot_data_Struc {}      ;pA5  long enough
device6 robot_data_Struc {}      ;pA6  lines to declare
device7 robot_data_Struc {}      ;pA7  this structure as one


device8 robot_data_Struc {}      ;rAW
device9 robot_data_Struc {}      ;rAX
device10 robot_data_Struc {}     ;rAY
device11 robot_data_Struc {}     ;rAZ

device12 robot_data_Struc {}     ;pAW
device13 robot_data_Struc {}     ;pAX
device14 robot_data_Struc {}     ;pAY
device15 robot_data_Struc {}     ;pAZ


include serpent.rmp


	 
endm




;INTERNAL 8031 locations of interest

INTERNAL equ 254
EPROM    equ 255   


workcell_op_copy equ 023h

executing     equ 027h      ;bit 0 executing table
							;bit 1 paused
							;bit 2 homing

MCNTRL        equ 50h 
WCNTRL        equ MCNTRL+1
SCNTRL        equ WCNTRL+1

XPosn         equ SCNTRL+1
YPosn         equ XPosn+2
ZPosn         equ YPosn+2

CurrLine      equ ZPosn+2

rsmesg        equ CurrLine+2


wc_pulses     equ rsmesg+1
rate_wcpulses equ wc_pulses+2

jog_feedrate  equ rate_wcpulses+2

spindle_speed equ jog_feedrate+2

table_used    equ spindle_speed+1
table_update  equ table_used+1 


X_calib equ 068h
y_calib equ X_calib+2
z_calib equ Y_calib+2



scratch       equ 0ffh



workcellip equ 0c600H
workcellop equ 0ca00H


;MCNTRL message constants  

idle            equ 00h
process_table   equ 02h
abort_table     equ 04h
pause_table     equ 06h
continue_table  equ 08h
jogx_Inc        equ 0ah
jogx_dec        equ 0ch
jogy_Inc        equ 0eh
jogy_dec        equ 010h
jogz_Inc        equ 012h
jogz_dec        equ 014h
end_jog         equ 01bh

open_vice       equ 02ch
close_vice      equ 02eh

spindle_cw      equ 030h
spindle_ccw     equ 032h

home_mill       equ 034h
reset_mill      equ 036h


reset_Lathe      equ 036h



;WCNTRL message constants  

air_off         equ 2
air_on          equ 4
spindle_spd     equ 6

set_wc          equ spindle_spd+2

reset_wc        equ set_wc+16

pulse_wc        equ reset_wc+16

send_rs232      equ pulse_wc+16









