Option Explicit
Option Compare Text

Dim points() As pointapi

Function biggEST (A As Single, B As Single, C As Single, D As Single) As Single

Dim i As Single
i = A
If B > i Then i = B
If C > i Then i = C
If D > i Then i = D
biggEST = i

End Function

Sub cleardrawing (Drw As Integer)

    Dim lprect As rect
    
    GetClipBox drawing(Drw).Picture1.hDC, lprect
    xscale(Drw) = lprect.Right / (GraphicsFrmDat.x2(Drw) - GraphicsFrmDat.x1(Drw))
    yscale(Drw) = lprect.bottom / (GraphicsFrmDat.Y2(Drw) - GraphicsFrmDat.y1(Drw))

    If GraphicsFrmDat.Distort(Drw) = 0 Then
        If Abs(xscale(Drw)) > Abs(yscale(Drw)) Then xscale(Drw) = Abs(yscale(Drw)) * Sgn(xscale(Drw))
        If Abs(yscale(Drw)) > Abs(xscale(Drw)) Then yscale(Drw) = Abs(xscale(Drw)) * Sgn(yscale(Drw))
    End If
    
    drawing(Drw).Picture1.BackColor = GraphicsFrmDat.axiscol(8)  ' GraphicsFrmDat.backcolour
    drawing(Drw).Picture1.Cls

End Sub

Sub displaydrawing (Drw As Integer)

    drawing(Drw).AutoRedraw = False
    BitBlt drawing(Drw).hDC, 0, 0, drawing(Drw).Picture1.ScaleWidth, drawing(Drw).Picture1.ScaleHeight, drawing(Drw).Picture1.hDC, 0, 0, SRCCOPY

End Sub

Sub drawcircle (Drw As Integer, Axis As Integer, lppoints() As pointapi_Single)

Dim hpen As Integer
Dim hpen_old As Integer
Dim i As Integer


'xoff(0) = -EditFrmDat(graphicsdevno).x1(0)

ReDim points(1)
For i = 0 To 1
    points(i).X = (lppoints(i).X - GraphicsFrmDat.x1(Drw)) * xscale(Drw)
    points(i).y = (lppoints(i).y - GraphicsFrmDat.y1(Drw)) * yscale(Drw)
Next



    hpen = CreateSolidBrush(GraphicsFrmDat.axiscol(Axis))
    hpen_old = SelectObject(drawing(Drw).Picture1.hDC, hpen)

    drawing(Drw).Picture1.ForeColor = GraphicsFrmDat.axiscol(Axis)
    
    Ellipse drawing(Drw).Picture1.hDC, points(0).X, points(0).y, points(1).X, points(1).y
    
    i = SelectObject(drawing(Drw).Picture1.hDC, hpen_old)
    DeleteObject hpen




End Sub

Sub drawpolygon (Drw As Integer, Axis As Integer, lppoints() As pointapi_Single)

Dim hpen As Integer
Dim hpen_old As Integer
Dim i As Integer

ReDim points(LBound(lppoints) To UBound(lppoints))



'xoff(0) = -EditFrmDat(graphicsdevno).x1(0)

For i = LBound(lppoints) To UBound(lppoints)
    points(i).X = (lppoints(i).X - GraphicsFrmDat.x1(Drw)) * xscale(Drw)
    points(i).y = (lppoints(i).y - GraphicsFrmDat.y1(Drw)) * yscale(Drw)
Next



    hpen = CreateSolidBrush(GraphicsFrmDat.axiscol(Axis))
    hpen_old = SelectObject(drawing(Drw).Picture1.hDC, hpen)

    drawing(Drw).Picture1.ForeColor = 0         'GraphicsFrmDat.axiscol(Axis)
    
    polygon drawing(Drw).Picture1.hDC, points(0), UBound(points) + 1
    
    i = SelectObject(drawing(Drw).Picture1.hDC, hpen_old)
    DeleteObject hpen

End Sub

Sub drawrectangle (Drw As Integer, Axis As Integer, lppoints() As pointapi_Single)



Dim hpen As Integer
Dim hpen_old As Integer
Dim i As Integer

ReDim points(1)
For i = 0 To 1
    points(i).X = (lppoints(i).X - GraphicsFrmDat.x1(Drw)) * xscale(Drw)
    points(i).y = (lppoints(i).y - GraphicsFrmDat.y1(Drw)) * yscale(Drw)
Next

    hpen = CreateSolidBrush(GraphicsFrmDat.axiscol(Axis))
    hpen_old = SelectObject(drawing(Drw).Picture1.hDC, hpen)

    drawing(Drw).Picture1.ForeColor = 0                 'GraphicsFrmDat.axiscol(Axis)
    
    rectangle drawing(Drw).Picture1.hDC, points(0).X, points(0).y, points(1).X, points(1).y
    
    i = SelectObject(drawing(Drw).Picture1.hDC, hpen_old)
    DeleteObject hpen



End Sub

Function HEXRGB (A$) As Long

Dim RED
Dim GREEN
Dim BLUE


A$ = RTrim$(LTrim$(A$))
A$ = UCase$(Right$(String$(6, "0") + A$, 6))

 BLUE = Hexval(Mid$(A$, 1, 1)) * 16 + Hexval(Mid$(A$, 2, 1))
GREEN = Hexval(Mid$(A$, 3, 1)) * 16 + Hexval(Mid$(A$, 4, 1))
  RED = Hexval(Mid$(A$, 5, 1)) * 16 + Hexval(Mid$(A$, 6, 1))

HEXRGB = RGB(RED, GREEN, BLUE)



End Function

Function Hexval (A$)

Select Case A$
Case "0" To "9"
    Hexval = Val(A$)
Case "A"
    Hexval = 10
Case "B"
    Hexval = 11
Case "C"
    Hexval = 12
Case "D"
    Hexval = 13
Case "E"
    Hexval = 14
Case "F"
    Hexval = 15
End Select

End Function

Function largestx (lppoints() As pointapi_Single) As Single
Dim i As Integer
Dim result As Single

result = lppoints(0).X

For i = 1 To UBound(lppoints)
    If lppoints(i).X > result Then
        result = lppoints(i).X
    End If
Next

largestx = result

End Function

Function parse (A$, retval$) As String

If InStr(A$, ",") = 0 Then
    parse = retval
Else
    parse = Left$(A$, InStr(A$, ",") - 1)
    A$ = Right$(A$, Len(A$) - InStr(A$, ","))
End If


End Function

Function readini (Section$, topic$, default)
Dim A$
Dim dummy As Integer


A$ = String$(100, 0)
dummy = GetPrivateProfileString(Section$, ByVal topic$, Str$(default), A$, Len(A$), inifile$)
readini = Val(A$)




End Function

Sub Robot_Drawing (Redrawpic As Integer)

If graphicsdevno = -1 Then Exit Sub

Select Case Editfrmdat(graphicsdevno).DevType
Case Mentor
    Mentor_Drawing Redrawpic
Case Gryphon, GryphonSlide
    Gryphon_drawing Redrawpic
Case Serpent1
    Serpent1_drawing Redrawpic
Case Serpent2
    Serpent2_drawing Redrawpic
Case Kestrel
    kestrel_drawing Redrawpic
Case NEPTUNE2
    Neptune2_Drawing Redrawpic
Case Neptune1
    Neptune1_Drawing Redrawpic
Case SerpentEC1
    SerpentEC1_drawing Redrawpic
Case SerpentEC2
    Serpentec2_drawing Redrawpic

Case Else
    MsgBox "Error with graphics device" + Chr$(13) + "Please report"
    graphicsdevno = -1
End Select

End Sub

Sub Robot_Xyz (RiNdex As Integer, Redrawpic As Integer)



    
    If Position(RiNdex).Cartesian Then
        Select Case RobotFrmDat(RiNdex).DevType
            Case Mentor
                Mentor_XYZ RiNdex, Redrawpic
            Case Gryphon, GryphonSlide
                Gryphon_XYZ RiNdex, Redrawpic
            Case Serpent1
                Serpent1_Xyz RiNdex, Redrawpic
            Case Serpent2
                Serpent2_Xyz RiNdex, Redrawpic
            Case SerpentEC1
                SerpentEC1_Xyz RiNdex, Redrawpic
            Case SerpentEC2
                Serpentec2_Xyz RiNdex, Redrawpic
            Case Kestrel
                Kestrel_Xyz RiNdex, Redrawpic
            Case Neptune1
                Neptune1_xyz RiNdex, Redrawpic
            Case NEPTUNE2
                Neptune2_xyz RiNdex, Redrawpic
        End Select
    End If

End Sub

Sub Rotate (Centre As pointapi_Single, lppoints() As pointapi_Single, ang As Single)


Dim A As Single
Dim L As Single
Dim i As Integer

Dim X As Single
Dim y As Single



While ang > 2 * pi
    ang = ang - 2 * pi
Wend

While ang < 0
    ang = ang + 2 * pi
Wend



For i = 0 To UBound(lppoints)
    L = Sqr(lppoints(i).X ^ 2 + lppoints(i).y ^ 2)
    If lppoints(i).X = 0 Then
        A = pi / 2
    Else
        A = Atn(lppoints(i).y / lppoints(i).X)
    End If
    
    X = Centre.X + L * Sin(ang + A) * Sgn(lppoints(i).X)
    y = Centre.y + L * Cos(ang + A) * Sgn(lppoints(i).X)

    'X = Centre.X + L * Cos(Ang + A) * Sgn(lppoints(i).X)
    'y = Centre.y + L * Sin(Ang + A) * Sgn(lppoints(i).X)
    
    lppoints(i).X = X
    lppoints(i).y = y

Next


End Sub

Sub SaveIni (Section$, topic$, value As Integer)
WritePrivateProfileString ByVal Section$, ByVal topic$, ByVal Format$(value), inifile$
End Sub

Sub setupgraphics ()

Dim A$
Dim dummy
Dim Section$


'WORK NEEDED

    
    Do
    Select Case Editfrmdat(CurrentDevno).DevType
        Case CNCMill, CNCLathe, 0
            CurrentDevno = CurrentDevno + 1
            If CurrentDevno > UBound(Editfrmdat) Then CurrentDevno = 0
        Case Else
            Exit Do
    End Select
    Loop
    
        
    graphicsdevno = CurrentDevno


    Section$ = Editfrmdat(graphicsdevno).name
    Select Case Editfrmdat(graphicsdevno).DevType

        Case Neptune1
            'elevation
            GraphicsFrmDat.x1(0) = readini(Section$, "X1_0", -550)
            GraphicsFrmDat.x2(0) = readini(Section$, "X2_0", 1150)
            GraphicsFrmDat.y1(0) = readini(Section$, "Y1_0", -1500)
            GraphicsFrmDat.Y2(0) = readini(Section$, "Y2_0", 10)
                
            GraphicsFrmDat.x1(1) = readini(Section$, "X1_1", 1150)
            GraphicsFrmDat.x2(1) = readini(Section$, "X2_1", -1150)
            GraphicsFrmDat.y1(1) = readini(Section$, "Y1_1", 1150)
            GraphicsFrmDat.Y2(1) = readini(Section$, "Y2_1", -300)
        
        Case NEPTUNE2
            'elevation
            GraphicsFrmDat.x1(0) = readini(Section$, "X1_0", -550)
            GraphicsFrmDat.x2(0) = readini(Section$, "X2_0", 1150)
            GraphicsFrmDat.y1(0) = readini(Section$, "Y1_0", -1500)
            GraphicsFrmDat.Y2(0) = readini(Section$, "Y2_0", 10)
                
            GraphicsFrmDat.x1(1) = readini(Section$, "X1_1", 1150)
            GraphicsFrmDat.x2(1) = readini(Section$, "X2_1", -1150)
            GraphicsFrmDat.y1(1) = readini(Section$, "Y1_1", 1150)
            GraphicsFrmDat.Y2(1) = readini(Section$, "Y2_1", -300)

        Case Mentor
            'elevation
            GraphicsFrmDat.x1(0) = readini(Section$, "X1_0", -275)
            GraphicsFrmDat.x2(0) = readini(Section$, "X2_0", 525)
            GraphicsFrmDat.y1(0) = readini(Section$, "Y1_0", -825)
            GraphicsFrmDat.Y2(0) = readini(Section$, "Y2_0", 10)
                
            GraphicsFrmDat.x1(1) = readini(Section$, "X1_1", -450)
            GraphicsFrmDat.x2(1) = readini(Section$, "X2_1", 450)
            GraphicsFrmDat.y1(1) = readini(Section$, "Y1_1", 450)
            GraphicsFrmDat.Y2(1) = readini(Section$, "Y2_1", -270)



        Case Gryphon, GryphonSlide
            'elevation
            GraphicsFrmDat.x1(0) = readini(Section$, "X1_0", -300)
            GraphicsFrmDat.x2(0) = readini(Section$, "X2_0", 650)
            GraphicsFrmDat.y1(0) = readini(Section$, "Y1_0", -950)
            GraphicsFrmDat.Y2(0) = readini(Section$, "Y2_0", 10)
            
            GraphicsFrmDat.x1(1) = readini(Section$, "X1_1", -650)
            GraphicsFrmDat.x2(1) = readini(Section$, "X2_1", 650)
            GraphicsFrmDat.y1(1) = readini(Section$, "Y1_1", 650)
            GraphicsFrmDat.Y2(1) = readini(Section$, "Y2_1", -460)

            


        Case Serpent1, SerpentEC1
            GraphicsFrmDat.x1(0) = readini(Section$, "X1_0", -75)
            GraphicsFrmDat.x2(0) = readini(Section$, "X2_0", 600)
            GraphicsFrmDat.y1(0) = readini(Section$, "Y1_0", 670)
            GraphicsFrmDat.Y2(0) = readini(Section$, "Y2_0", -10)
            
            GraphicsFrmDat.x1(1) = readini(Section$, "X1_1", 440)
            GraphicsFrmDat.x2(1) = readini(Section$, "X2_1", -440)
            GraphicsFrmDat.y1(1) = readini(Section$, "Y1_1", 600)
            GraphicsFrmDat.Y2(1) = readini(Section$, "Y2_1", -90)
        
        Case Serpent2, SerpentEC2
            GraphicsFrmDat.x1(0) = readini(Section$, "X1_0", -75)
            GraphicsFrmDat.x2(0) = readini(Section$, "X2_0", 850)
            GraphicsFrmDat.y1(0) = readini(Section$, "Y1_0", 670)
            GraphicsFrmDat.Y2(0) = readini(Section$, "Y2_0", -10)
            
            GraphicsFrmDat.x1(1) = readini(Section$, "X1_1", 700)
            GraphicsFrmDat.x2(1) = readini(Section$, "X2_1", -700)
            GraphicsFrmDat.y1(1) = readini(Section$, "Y1_1", 850)
            GraphicsFrmDat.Y2(1) = readini(Section$, "Y2_1", -100)

        Case Kestrel
            GraphicsFrmDat.x1(0) = readini(Section$, "X1_0", -160)
            GraphicsFrmDat.x2(0) = readini(Section$, "X2_0", 660)
            GraphicsFrmDat.y1(0) = readini(Section$, "Y1_0", 620)
            GraphicsFrmDat.Y2(0) = readini(Section$, "Y2_0", -10)

            GraphicsFrmDat.x1(1) = readini(Section$, "X1_1", -160)
            GraphicsFrmDat.x2(1) = readini(Section$, "X2_1", 660)
            GraphicsFrmDat.y1(1) = readini(Section$, "Y1_1", 480)
            GraphicsFrmDat.Y2(1) = readini(Section$, "Y2_1", -130)
            
        Case Else
            'MsgBox "ERROR:- NO SUCH GRAPHICS DEVICE"
            
      End Select

    GraphicsFrmDat.Distort(0) = readini(Section$, "Distort_0", 0)
    GraphicsFrmDat.Distort(1) = readini(Section$, "Distort_1", 0)
    
    A$ = String$(100, 0)
    dummy = GetPrivateProfileString(Section$, ByVal "PIC", "", A$, Len(A$), inifile$)
    GraphicsFrmDat.axiscol(0) = HEXRGB(parse(A$, "FF"))
    GraphicsFrmDat.axiscol(1) = HEXRGB(parse(A$, "FF"))
    GraphicsFrmDat.axiscol(2) = HEXRGB(parse(A$, "FF"))
    GraphicsFrmDat.axiscol(3) = HEXRGB(parse(A$, "FF"))
    GraphicsFrmDat.axiscol(4) = HEXRGB(parse(A$, "FF"))
    GraphicsFrmDat.axiscol(5) = HEXRGB(parse(A$, "FF"))
    GraphicsFrmDat.axiscol(6) = HEXRGB(parse(A$, "FF"))
    GraphicsFrmDat.axiscol(8) = HEXRGB(parse(A$, "FFFF00"))
    'GraphicsFrmDat.axescolour = hexrgb(parse(a$, "000000"))

    Select Case Editfrmdat(graphicsdevno).DevType
        Case NEPTUNE2
            drawing(0).Caption = Editfrmdat(graphicsdevno).name + " - Elevation (Yaw=2048)"
            drawing(1).Caption = Editfrmdat(graphicsdevno).name + " - Plan (Yaw=2048)"

        Case Else
            drawing(0).Caption = Editfrmdat(graphicsdevno).name + " - Elevation"
            drawing(1).Caption = Editfrmdat(graphicsdevno).name + " - Plan"
    End Select
    

    Robot_Drawing True

    On Local Error Resume Next  'Will cause error when executing
    RobotFrm(Editfrmdat(graphicsdevno).Frmno).SetFocus
    On Error GoTo 0

End Sub

Function SMALLEST (A As Single, B As Single, C As Single, D As Single) As Single
Dim i As Single
i = A
If i > B Then i = B
If i > C Then i = C
If i > D Then i = D
SMALLEST = i
End Function

Function smallestx (lppoints() As pointapi_Single) As Single
Dim i As Integer
Dim result As Single

result = lppoints(0).X

For i = 1 To UBound(lppoints)
    If lppoints(i).X < result Then
        result = lppoints(i).X
    End If
Next


smallestx = result


End Function

