VERSION 2.00
Begin Form NepCal 
   BorderStyle     =   3  'Fixed Double
   Caption         =   "Neptune Calibration"
   ClientHeight    =   2865
   ClientLeft      =   2040
   ClientTop       =   4230
   ClientWidth     =   5460
   FontBold        =   -1  'True
   FontItalic      =   0   'False
   FontName        =   "Arial"
   FontSize        =   9
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   Height          =   3210
   Left            =   2010
   LinkTopic       =   "Form1"
   ScaleHeight     =   2865
   ScaleWidth      =   5460
   Top             =   3915
   Width           =   5520
   Begin TrueGrid Table1 
      AllowArrows     =   -1  'True
      AllowTabs       =   -1  'True
      BorderStyle     =   0  'None
      Editable        =   -1  'True
      EditDropDown    =   -1  'True
      ExposeCellMode  =   0  'Expose upon selection
      FetchMode       =   0  'By cell
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "Arial"
      FontSize        =   9
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      HeadingHeight   =   1
      Height          =   2895
      HorzLines       =   0  'None
      Layout          =   NEPCAL.FRX:0000
      LayoutIndex     =   1
      Left            =   0
      LinesPerRow     =   1
      MarqueeUnique   =   -1  'True
      SplitPropsGlobal=   -1  'True
      SplitTabMode    =   0  'Don't tab across splits
      TabCapture      =   0   'False
      TabIndex        =   0
      Top             =   0
      UseBookmarks    =   -1  'True
      Width           =   5500
      WrapCellPointer =   0   'False
   End
End
Option Explicit
Option Compare Text

Dim Nepcalib As NeptuneCalibType

Dim EditFrm As Integer

Sub Form_Activate ()
               
table1.Rows = 6

EditFrm = tag

readNeptunecalib EditFrm, Nepcalib

End Sub

Sub Table1_Fetch (Row As Long, col As Integer, value As String)


Select Case col
Case 1
    value = Format$(Row - 1)
Case 2
    value = Format$(Nepcalib.cal_m(Row - 1) / 1000, "0.000")
Case 3
    value = Format$(Nepcalib.cal_c(Row - 1))
Case 4
    value = Format$(Nepcalib.cal_w(Row - 1))
Case 5
    value = Format$(Nepcalib.cal_IncFast(Row - 1))
Case 6
    value = Format$(Nepcalib.cal_IncSlow(Row - 1))


End Select




End Sub

Sub Table1_Update (Row As Long, col As Integer, value As String)

Select Case col
Case 2
    Nepcalib.cal_m(Row - 1) = Val(value) * 1000
Case 3
    Nepcalib.cal_c(Row - 1) = Val(value)

Case 4
    Nepcalib.cal_w(Row - 1) = Val(value)

Case 5
    Nepcalib.cal_IncFast(Row - 1) = Val(value)
Case 6
    Nepcalib.cal_IncSlow(Row - 1) = Val(value)

End Select

setNeptunecalib EditFrm, Nepcalib




End Sub

