home:
    setb zeroing            ; show IBM we're zeroing
    clr ibm_mode

home_0:

;    lcall testjams

;    lcall send_pwm 

home_00:
    
    mov a,mcntrl
    jz home_01
    mov mcntrl,#0
    setb ibm_mode
    
    mov dptr,#home_decode
    jmp @a+dptr             ; will return to home_02 or home_0

home_02:
    clr ibm_mode
     
home_01:
    jb ibm_mode,home_0


    mov dptr,#0ce00h
    movx a,@dptr

;    jb acc.7,home_01a           ; power on?
;    jmp home_null

home_01a:    
    mov maxerror,#15        ; assume fast
    jb  acc.5,home_1        ; slow pressed?
    mov maxerror,#2         ; set slow
home_1:    
    anl a,#63
    mov pen_copy,a
    
    anl a,#15
    rl a    
    mov dptr,#hometab
    jmp @a+dptr
hometab:
    ajmp home_0m    ;0
    ajmp home_0p    ;1
    ajmp home_1m    ;2
    ajmp home_1p    ;3
    ajmp home_2m    ;4
    ajmp home_2p    ;5
    ajmp home_null  ;6
    ajmp home_null  ;7
    ajmp home_null  ;8
    ajmp home_null  ;9
    ajmp home_end   ;10
    ajmp home_null  ;11
    ajmp home_null  ;12
    ajmp home_null  ;13
    ajmp home_null  ;14
    ajmp home_null  ;15
    
home_0m:    
    setb pen0
    clr dir0
    jmp home_0

home_0p:    
    Setb pen0
    Setb dir0
    jmp  home_0


home_1m:    
    setb pen1
    clr dir1
    jmp home_0

home_1p:    
    setb pen1
    Setb dir1
    jmp  home_0

home_2m:    
    setb pen2
    clr dir2
    jmp home_0

home_2p:    
    setb pen2
    Setb dir2
    jmp  home_0

home_null:    
    clr a
    clr pen0
    clr pen1
    clr pen2
    jmp home_0


home_end:
    mov a,pen_copy
    jb acc.4,home_null
    jb acc.5,home_null

home_end_ibm:


; send control byte to send each axis to its endstop - wait til stalled

    setb enable_jam             ; arm jams need to be recognised
    mov stallflags,#0
    
he_0:

    clr zeroing             ; show IBM we're ready

    ret






home_nojams:
    clr enable_jam
    ajmp home_02

home_jams:
    setb enable_jam
    ajmp home_02

home_decode:
    ajmp home_02        ; 0 - unused
    ajmp home_nojams    ; 2 - turn arm jam off
    ajmp home_jams      ; 4 - turn arm jams back on
    ajmp home_02        ; 6 - unused
    ajmp home_02        ; 8 - unused
                        
    ajmp home_0m        ; 10 - move axis 0 towards 0   
    ajmp home_0p        ; 12
    ajmp home_1m        ; 14 - move axis 1 towards 0   
    ajmp home_1p        ; 16
    ajmp home_2m        ; 18 - move axis 2 towards 0   
    ajmp home_2p        ; 20
    
    ajmp home_02        ; 22 - move axis 3 towards 0   
    ajmp home_02        ; 24
    ajmp home_02        ; 26 - move axis 4 towards 0   
    ajmp home_02        ; 28
    ajmp home_02        ; 30 - open gripper  
    ajmp home_02        ; 32
    ajmp home_02        ; 34 - move axes 3 and 4 towards 0   
    ajmp home_02        ; 36
    ajmp home_02        ; 38 - move axes 3 towards 0  4 +ve 
    ajmp home_02        ; 40
    ajmp home_02        ; 42 - Speed -ve
    ajmp home_02        ; 44 - Speed +ve  
    
    ajmp home_02        ; 46 - cancel ibm_mode   
    ajmp home_end_ibm   ; 48 - finish it off
    ajmp home_02        ; 50
    ajmp home_02        ; 52
    ajmp home_02        ; 54


waitpower:
    mov dptr,#0ce00h
    movx a,@dptr
    jnb acc.7,waitpower
    ret


